/* THIS FILE IS AUTOGENERATED FROM CacheStorage.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_CacheStorageBinding_h
#define mozilla_dom_CacheStorageBinding_h

#include "CacheBinding.h"
#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

struct MultiCacheQueryOptionsAtoms;
struct NativePropertyHooks;
class ProtoAndIfaceCache;

namespace cache {

class CacheStorage;

} // namespace cache

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

enum class CacheStorageNamespace : uint8_t {
  Content,
  Chrome,
  EndGuard_
};

namespace CacheStorageNamespaceValues {
extern const EnumEntry strings[3];

static constexpr size_t Count = 2;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(CacheStorageNamespace::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(CacheStorageNamespace stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace CacheStorageNamespaceValues

bool
ToJSValue(JSContext* aCx, CacheStorageNamespace aArgument, JS::MutableHandle<JS::Value> aValue);


struct MultiCacheQueryOptions : public CacheQueryOptions
{
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mCacheName;

  MultiCacheQueryOptions();

  explicit inline MultiCacheQueryOptions(const FastDictionaryInitializer& )
    : CacheQueryOptions(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  MultiCacheQueryOptions(MultiCacheQueryOptions&& aOther) = default;

  explicit inline MultiCacheQueryOptions(const MultiCacheQueryOptions& aOther)
    : CacheQueryOptions(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  MultiCacheQueryOptions&
  operator=(const MultiCacheQueryOptions& aOther);

  bool
  operator==(const MultiCacheQueryOptions& aOther) const;

private:
  static bool
  InitIds(JSContext* cx, MultiCacheQueryOptionsAtoms* atomsCache);
};

namespace binding_detail {
struct FastMultiCacheQueryOptions : public MultiCacheQueryOptions
{
  inline FastMultiCacheQueryOptions()
    : MultiCacheQueryOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace CacheStorage_Binding {

  typedef mozilla::dom::cache::CacheStorage NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::cache::CacheStorage* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::CacheStorage,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::CacheStorage,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::CacheStorage,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace CacheStorage_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_CacheStorageBinding_h
