/* THIS FILE IS AUTOGENERATED FROM WebTransportError.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_WebTransportErrorBinding_h
#define mozilla_dom_WebTransportErrorBinding_h

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
class ProtoAndIfaceCache;
class WebTransportError;
struct WebTransportErrorInitAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

enum class WebTransportErrorSource : uint8_t {
  Stream,
  Session,
  EndGuard_
};

namespace WebTransportErrorSourceValues {
extern const EnumEntry strings[3];

static constexpr size_t Count = 2;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(WebTransportErrorSource::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(WebTransportErrorSource stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace WebTransportErrorSourceValues

bool
ToJSValue(JSContext* aCx, WebTransportErrorSource aArgument, JS::MutableHandle<JS::Value> aValue);


struct WebTransportErrorInit : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mMessage;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint8_t> mStreamErrorCode;

  WebTransportErrorInit();

  explicit inline WebTransportErrorInit(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  WebTransportErrorInit(WebTransportErrorInit&& aOther) = default;

  explicit inline WebTransportErrorInit(const WebTransportErrorInit& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  WebTransportErrorInit&
  operator=(const WebTransportErrorInit& aOther);

  bool
  operator==(const WebTransportErrorInit& aOther) const;

private:
  static bool
  InitIds(JSContext* cx, WebTransportErrorInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastWebTransportErrorInit : public WebTransportErrorInit
{
  inline FastWebTransportErrorInit()
    : WebTransportErrorInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace WebTransportError_Binding {

  typedef mozilla::dom::WebTransportError NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::WebTransportError* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::WebTransportError,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::WebTransportError,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::WebTransportError,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace WebTransportError_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_WebTransportErrorBinding_h
