//
// DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/netwerk/protocol/http/nsIBinaryHttp.idl
//


/// `interface nsIBinaryHttpRequest : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct nsIBinaryHttpRequest {
    vtable: *const nsIBinaryHttpRequestVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads, as XPCOM is
    /// generally not threadsafe.
    ///
    /// XPCOM interfaces in general are not safe to send across threads.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by
    // https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for nsIBinaryHttpRequest.
unsafe impl XpCom for nsIBinaryHttpRequest {
    const IID: nsIID = nsID(0xf6f899cc, 0x683a, 0x43da,
        [0x92, 0x06, 0x0e, 0xb0, 0xc0, 0x9c, 0xc7, 0x58]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for nsIBinaryHttpRequest {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from nsIBinaryHttpRequest.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait nsIBinaryHttpRequestCoerce {
    /// Cheaply cast a value of this type from a `nsIBinaryHttpRequest`.
    fn coerce_from(v: &nsIBinaryHttpRequest) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl nsIBinaryHttpRequestCoerce for nsIBinaryHttpRequest {
    #[inline]
    fn coerce_from(v: &nsIBinaryHttpRequest) -> &Self {
        v
    }
}

impl nsIBinaryHttpRequest {
    /// Cast this `nsIBinaryHttpRequest` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: nsIBinaryHttpRequestCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for nsIBinaryHttpRequest {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> nsIBinaryHttpRequestCoerce for T {
    #[inline]
    fn coerce_from(v: &nsIBinaryHttpRequest) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every nsIBinaryHttpRequest
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct nsIBinaryHttpRequestVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* readonly attribute ACString method; */
    pub GetMethod: unsafe extern "system" fn (this: *const nsIBinaryHttpRequest, aMethod: *mut ::nsstring::nsACString) -> ::nserror::nsresult,

    /* readonly attribute ACString scheme; */
    pub GetScheme: unsafe extern "system" fn (this: *const nsIBinaryHttpRequest, aScheme: *mut ::nsstring::nsACString) -> ::nserror::nsresult,

    /* readonly attribute ACString authority; */
    pub GetAuthority: unsafe extern "system" fn (this: *const nsIBinaryHttpRequest, aAuthority: *mut ::nsstring::nsACString) -> ::nserror::nsresult,

    /* readonly attribute ACString path; */
    pub GetPath: unsafe extern "system" fn (this: *const nsIBinaryHttpRequest, aPath: *mut ::nsstring::nsACString) -> ::nserror::nsresult,

    /* readonly attribute Array<ACString> headerNames; */
    pub GetHeaderNames: unsafe extern "system" fn (this: *const nsIBinaryHttpRequest, aHeaderNames: *mut thin_vec::ThinVec<::nsstring::nsCString>) -> ::nserror::nsresult,

    /* readonly attribute Array<ACString> headerValues; */
    pub GetHeaderValues: unsafe extern "system" fn (this: *const nsIBinaryHttpRequest, aHeaderValues: *mut thin_vec::ThinVec<::nsstring::nsCString>) -> ::nserror::nsresult,

    /* readonly attribute Array<octet> content; */
    pub GetContent: unsafe extern "system" fn (this: *const nsIBinaryHttpRequest, aContent: *mut thin_vec::ThinVec<u8>) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl nsIBinaryHttpRequest {


    /// `readonly attribute ACString method;`
    #[inline]
    pub unsafe fn GetMethod(&self, aMethod: *mut ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).GetMethod)(self, aMethod)
    }



    /// `readonly attribute ACString scheme;`
    #[inline]
    pub unsafe fn GetScheme(&self, aScheme: *mut ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).GetScheme)(self, aScheme)
    }



    /// `readonly attribute ACString authority;`
    #[inline]
    pub unsafe fn GetAuthority(&self, aAuthority: *mut ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).GetAuthority)(self, aAuthority)
    }



    /// `readonly attribute ACString path;`
    #[inline]
    pub unsafe fn GetPath(&self, aPath: *mut ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).GetPath)(self, aPath)
    }



    /// `readonly attribute Array<ACString> headerNames;`
    #[inline]
    pub unsafe fn GetHeaderNames(&self, aHeaderNames: *mut thin_vec::ThinVec<::nsstring::nsCString>) -> ::nserror::nsresult {
        ((*self.vtable).GetHeaderNames)(self, aHeaderNames)
    }



    /// `readonly attribute Array<ACString> headerValues;`
    #[inline]
    pub unsafe fn GetHeaderValues(&self, aHeaderValues: *mut thin_vec::ThinVec<::nsstring::nsCString>) -> ::nserror::nsresult {
        ((*self.vtable).GetHeaderValues)(self, aHeaderValues)
    }



    /// `readonly attribute Array<octet> content;`
    #[inline]
    pub unsafe fn GetContent(&self, aContent: *mut thin_vec::ThinVec<u8>) -> ::nserror::nsresult {
        ((*self.vtable).GetContent)(self, aContent)
    }


}


/// `interface nsIBinaryHttpResponse : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct nsIBinaryHttpResponse {
    vtable: *const nsIBinaryHttpResponseVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads, as XPCOM is
    /// generally not threadsafe.
    ///
    /// XPCOM interfaces in general are not safe to send across threads.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by
    // https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for nsIBinaryHttpResponse.
unsafe impl XpCom for nsIBinaryHttpResponse {
    const IID: nsIID = nsID(0x6ca85d9c, 0xcdc5, 0x45d4,
        [0x9a, 0xdc, 0x00, 0x5a, 0xbe, 0xdc, 0xe9, 0xc9]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for nsIBinaryHttpResponse {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from nsIBinaryHttpResponse.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait nsIBinaryHttpResponseCoerce {
    /// Cheaply cast a value of this type from a `nsIBinaryHttpResponse`.
    fn coerce_from(v: &nsIBinaryHttpResponse) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl nsIBinaryHttpResponseCoerce for nsIBinaryHttpResponse {
    #[inline]
    fn coerce_from(v: &nsIBinaryHttpResponse) -> &Self {
        v
    }
}

impl nsIBinaryHttpResponse {
    /// Cast this `nsIBinaryHttpResponse` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: nsIBinaryHttpResponseCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for nsIBinaryHttpResponse {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> nsIBinaryHttpResponseCoerce for T {
    #[inline]
    fn coerce_from(v: &nsIBinaryHttpResponse) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every nsIBinaryHttpResponse
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct nsIBinaryHttpResponseVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* readonly attribute uint16_t status; */
    pub GetStatus: unsafe extern "system" fn (this: *const nsIBinaryHttpResponse, aStatus: *mut uint16_t) -> ::nserror::nsresult,

    /* readonly attribute Array<ACString> headerNames; */
    pub GetHeaderNames: unsafe extern "system" fn (this: *const nsIBinaryHttpResponse, aHeaderNames: *mut thin_vec::ThinVec<::nsstring::nsCString>) -> ::nserror::nsresult,

    /* readonly attribute Array<ACString> headerValues; */
    pub GetHeaderValues: unsafe extern "system" fn (this: *const nsIBinaryHttpResponse, aHeaderValues: *mut thin_vec::ThinVec<::nsstring::nsCString>) -> ::nserror::nsresult,

    /* readonly attribute Array<octet> content; */
    pub GetContent: unsafe extern "system" fn (this: *const nsIBinaryHttpResponse, aContent: *mut thin_vec::ThinVec<u8>) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl nsIBinaryHttpResponse {


    /// `readonly attribute uint16_t status;`
    #[inline]
    pub unsafe fn GetStatus(&self, aStatus: *mut uint16_t) -> ::nserror::nsresult {
        ((*self.vtable).GetStatus)(self, aStatus)
    }



    /// `readonly attribute Array<ACString> headerNames;`
    #[inline]
    pub unsafe fn GetHeaderNames(&self, aHeaderNames: *mut thin_vec::ThinVec<::nsstring::nsCString>) -> ::nserror::nsresult {
        ((*self.vtable).GetHeaderNames)(self, aHeaderNames)
    }



    /// `readonly attribute Array<ACString> headerValues;`
    #[inline]
    pub unsafe fn GetHeaderValues(&self, aHeaderValues: *mut thin_vec::ThinVec<::nsstring::nsCString>) -> ::nserror::nsresult {
        ((*self.vtable).GetHeaderValues)(self, aHeaderValues)
    }



    /// `readonly attribute Array<octet> content;`
    #[inline]
    pub unsafe fn GetContent(&self, aContent: *mut thin_vec::ThinVec<u8>) -> ::nserror::nsresult {
        ((*self.vtable).GetContent)(self, aContent)
    }


}


/// `interface nsIBinaryHttp : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct nsIBinaryHttp {
    vtable: *const nsIBinaryHttpVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads, as XPCOM is
    /// generally not threadsafe.
    ///
    /// XPCOM interfaces in general are not safe to send across threads.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by
    // https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for nsIBinaryHttp.
unsafe impl XpCom for nsIBinaryHttp {
    const IID: nsIID = nsID(0xb43b3f73, 0x8160, 0x4ab2,
        [0x9f, 0x5d, 0x41, 0x29, 0xa9, 0x70, 0x80, 0x81]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for nsIBinaryHttp {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from nsIBinaryHttp.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait nsIBinaryHttpCoerce {
    /// Cheaply cast a value of this type from a `nsIBinaryHttp`.
    fn coerce_from(v: &nsIBinaryHttp) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl nsIBinaryHttpCoerce for nsIBinaryHttp {
    #[inline]
    fn coerce_from(v: &nsIBinaryHttp) -> &Self {
        v
    }
}

impl nsIBinaryHttp {
    /// Cast this `nsIBinaryHttp` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: nsIBinaryHttpCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for nsIBinaryHttp {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> nsIBinaryHttpCoerce for T {
    #[inline]
    fn coerce_from(v: &nsIBinaryHttp) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every nsIBinaryHttp
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct nsIBinaryHttpVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* Array<octet> encodeRequest (in nsIBinaryHttpRequest request); */
    pub EncodeRequest: unsafe extern "system" fn (this: *const nsIBinaryHttp, request: *const nsIBinaryHttpRequest, _retval: *mut thin_vec::ThinVec<u8>) -> ::nserror::nsresult,

    /* nsIBinaryHttpRequest decodeRequest (in Array<octet> request); */
    pub DecodeRequest: unsafe extern "system" fn (this: *const nsIBinaryHttp, request: *const thin_vec::ThinVec<u8>, _retval: *mut *const nsIBinaryHttpRequest) -> ::nserror::nsresult,

    /* nsIBinaryHttpResponse decodeResponse (in Array<octet> response); */
    pub DecodeResponse: unsafe extern "system" fn (this: *const nsIBinaryHttp, response: *const thin_vec::ThinVec<u8>, _retval: *mut *const nsIBinaryHttpResponse) -> ::nserror::nsresult,

    /* Array<octet> encodeResponse (in nsIBinaryHttpResponse response); */
    pub EncodeResponse: unsafe extern "system" fn (this: *const nsIBinaryHttp, response: *const nsIBinaryHttpResponse, _retval: *mut thin_vec::ThinVec<u8>) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl nsIBinaryHttp {


    /// `Array<octet> encodeRequest (in nsIBinaryHttpRequest request);`
    #[inline]
    pub unsafe fn EncodeRequest(&self, request: *const nsIBinaryHttpRequest, _retval: *mut thin_vec::ThinVec<u8>) -> ::nserror::nsresult {
        ((*self.vtable).EncodeRequest)(self, request, _retval)
    }



    /// `nsIBinaryHttpRequest decodeRequest (in Array<octet> request);`
    #[inline]
    pub unsafe fn DecodeRequest(&self, request: *const thin_vec::ThinVec<u8>, _retval: *mut *const nsIBinaryHttpRequest) -> ::nserror::nsresult {
        ((*self.vtable).DecodeRequest)(self, request, _retval)
    }



    /// `nsIBinaryHttpResponse decodeResponse (in Array<octet> response);`
    #[inline]
    pub unsafe fn DecodeResponse(&self, response: *const thin_vec::ThinVec<u8>, _retval: *mut *const nsIBinaryHttpResponse) -> ::nserror::nsresult {
        ((*self.vtable).DecodeResponse)(self, response, _retval)
    }



    /// `Array<octet> encodeResponse (in nsIBinaryHttpResponse response);`
    #[inline]
    pub unsafe fn EncodeResponse(&self, response: *const nsIBinaryHttpResponse, _retval: *mut thin_vec::ThinVec<u8>) -> ::nserror::nsresult {
        ((*self.vtable).EncodeResponse)(self, response, _retval)
    }


}


