/* THIS FILE IS AUTOGENERATED FROM MozFrameLoaderOwner.webidl BY Codegen.py - DO NOT EDIT */

#include <type_traits>
#include "AtomList.h"
#include "MainThreadUtils.h"
#include "MozFrameLoaderOwnerBinding.h"
#include "js/CallAndConstruct.h"
#include "js/Exception.h"
#include "js/MapAndSet.h"
#include "js/Object.h"
#include "js/PropertyAndElement.h"
#include "js/PropertyDescriptor.h"
#include "js/experimental/JitInfo.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "mozilla/dom/SimpleGlobalObject.h"

namespace mozilla::dom {

namespace binding_detail {}; // Just to make sure it's known as a namespace
using namespace mozilla::dom::binding_detail;



RemotenessOptions::RemotenessOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}




bool
RemotenessOptions::InitIds(JSContext* cx, RemotenessOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(reinterpret_cast<jsid*>(atomsCache)->isVoid());

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->switchingInProgressLoad_id.init(cx, "switchingInProgressLoad") ||
      !atomsCache->remoteType_id.init(cx, "remoteType") ||
      !atomsCache->pendingSwitchID_id.init(cx, "pendingSwitchID")) {
    return false;
  }
  return true;
}

bool
RemotenessOptions::Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  RemotenessOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<RemotenessOptionsAtoms>(cx);
    if (reinterpret_cast<jsid*>(atomsCache)->isVoid() &&
        !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return cx.ThrowErrorMessage<MSG_CONVERSION_ERROR>(sourceDescription, "dictionary");
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->pendingSwitchID_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mPendingSwitchID.Construct();
    if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), "'pendingSwitchID' member of RemotenessOptions", &(mPendingSwitchID.Value()))) {
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->remoteType_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, mRemoteType)) {
      return false;
    }
    mIsAnyMemberPresent = true;
  } else if (cx) {
    // Don't error out if we have no cx.  In that
    // situation the caller is default-constructing us and we'll
    // just assume they know what they're doing.
    return cx.ThrowErrorMessage<MSG_MISSING_REQUIRED_DICTIONARY_MEMBER>("'remoteType' member of RemotenessOptions");
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->switchingInProgressLoad_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), "'switchingInProgressLoad' member of RemotenessOptions", &mSwitchingInProgressLoad)) {
      return false;
    }
  } else {
    mSwitchingInProgressLoad = false;
  }
  mIsAnyMemberPresent = true;
  return true;
}

bool
RemotenessOptions::Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // We don't want to use sourceDescription for our context here;
  // that's not really what it's formatted for.
  BindingCallContext cx(cx_, nullptr);
  return Init(cx, val, sourceDescription, passedToJSImpl);
}

void
RemotenessOptions::TraceDictionary(JSTracer* trc)
{
}

RemotenessOptions&
RemotenessOptions::operator=(const RemotenessOptions& aOther)
{
  DictionaryBase::operator=(aOther);
  mPendingSwitchID.Reset();
  if (aOther.mPendingSwitchID.WasPassed()) {
    mPendingSwitchID.Construct(aOther.mPendingSwitchID.Value());
  }
  mRemoteType = aOther.mRemoteType;
  mSwitchingInProgressLoad = aOther.mSwitchingInProgressLoad;
  return *this;
}

bool
RemotenessOptions::operator==(const RemotenessOptions& aOther) const
{
  if (mPendingSwitchID != aOther.mPendingSwitchID) {
      return false;
  }
  if (mRemoteType != aOther.mRemoteType) {
      return false;
  }
  if (mSwitchingInProgressLoad != aOther.mSwitchingInProgressLoad) {
      return false;
  }
  return true;
}


} // namespace mozilla::dom
