//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheStorageParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/FetchIPCTypes.h"
#include "mozilla/dom/cache/CacheStorageParent.h"
#include "mozilla/dom/cache/IPCUtils.h"
#include "mozilla/ipc/TransportSecurityInfoUtils.h"
#include "nsID.h"
#include "nsITransportSecurityInfo.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/cache/PCacheParent.h"
#include "mozilla/dom/cache/PCacheOpParent.h"
#include "mozilla/dom/cache/PCacheStreamControlParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {
namespace cache {


auto PCacheStorageParent::RecvPCacheOpConstructor(
        PCacheOpParent* actor,
        const CacheOpArgs& aOpArgs) -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PCacheStorageParent::PCacheStorageParent() :
    mozilla::ipc::IProtocol(PCacheStorageMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PCacheStorageParent);
}

PCacheStorageParent::~PCacheStorageParent()
{
    MOZ_COUNT_DTOR(PCacheStorageParent);
}

auto PCacheStorageParent::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PCacheStorageParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PCacheStorageParent::ManagedPCacheOpParent(nsTArray<PCacheOpParent*>& aArr) const -> void
{
    mManagedPCacheOpParent.ToArray(aArr);
}

auto PCacheStorageParent::ManagedPCacheOpParent() const -> const ManagedContainer<PCacheOpParent>&
{
    return mManagedPCacheOpParent;
}

auto PCacheStorageParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    total += mManagedPCacheOpParent.Count();
    arr__.SetCapacity(total);

    for (auto* key : mManagedPCacheOpParent) {
        arr__.AppendElement(key->GetLifecycleProxy());
    }

}

auto PCacheStorageParent::OpenPCacheOpEndpoint(PCacheOpParent* aActor) -> ManagedEndpoint<PCacheOpChild>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PCacheOpParent actor");
        return ManagedEndpoint<PCacheOpChild>();
    }

    aActor->SetManagerAndRegister(this);
    mManagedPCacheOpParent.Insert(aActor);

    // Mark our actor as awaiting the other side to be bound. This will
    // be cleared when a `MANAGED_ENDPOINT_{DROPPED,BOUND}` message is
    // received.
    aActor->mAwaitingManagedEndpointBind = true;
    return ManagedEndpoint<PCacheOpChild>(mozilla::ipc::PrivateIPDLInterface(), aActor);
}

auto PCacheStorageParent::BindPCacheOpEndpoint(
        ManagedEndpoint<PCacheOpParent> aEndpoint,
        PCacheOpParent* aActor) -> bool
{
    return aEndpoint.Bind(mozilla::ipc::PrivateIPDLInterface(), aActor, this, mManagedPCacheOpParent);
}

auto PCacheStorageParent::Send__delete__(PCacheStorageParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    UniquePtr<IPC::Message> msg__ = PCacheStorage::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};




    if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PCacheStorageParent",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCacheStorage::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(std::move(msg__));

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PCacheStorageMsgStart, actor);
    return sendok__;
}

auto PCacheStorageParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
{
            PCacheOpParent* actor = static_cast<PCacheOpParent*>(aListener);

            const bool removed = mManagedPCacheOpParent.EnsureRemoved(actor);
            MOZ_RELEASE_ASSERT(removed, "actor not managed by this!");

            auto* proxy = actor->GetLifecycleProxy();
            NS_IF_RELEASE(proxy);
            return;
        }    default:
FatalError("unreached");
        return;    }
}

auto PCacheStorageParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    default:
        FatalError("unreached");
        return;
    }
}

auto PCacheStorageParent::OnMessageReceived(const Message& msg__) -> PCacheStorageParent::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PCacheStorageMsgStart, this);
            return MsgProcessed;
        }
    case PCacheStorage::Msg_PCacheOpConstructor__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStorage::Msg_PCacheOpConstructor", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__handle__ = IPC::ReadParam<ActorHandle>((&(reader__)));
            if (!maybe__handle__) {
                FatalError("Error deserializing 'ActorHandle'");
                return MsgValueError;

            }
            auto& handle__ = *maybe__handle__;
            // Sentinel = 'actor'
            if ((!(((&(reader__)))->ReadSentinel(102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            auto maybe__aOpArgs = IPC::ReadParam<CacheOpArgs>((&(reader__)));
            if (!maybe__aOpArgs) {
                FatalError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;

            }
            auto& aOpArgs = *maybe__aOpArgs;
            // Sentinel = 'aOpArgs'
            if ((!(((&(reader__)))->ReadSentinel(173212334)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            reader__.EndRead();
            RefPtr<PCacheOpParent> actor = (static_cast<CacheStorageParent*>(this))->AllocPCacheOpParent(aOpArgs);
            if (!actor) {
                NS_WARNING("Cannot bind null PCacheOpParent actor");
                return MsgValueError;
            }

            actor->SetManagerAndRegister(this, (handle__).mId);
            mManagedPCacheOpParent.Insert(actor);

            mozilla::ipc::IPCResult __ok = (static_cast<CacheStorageParent*>(this))->RecvPCacheOpConstructor(actor, std::move(aOpArgs));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStorage::Msg_Teardown__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStorage::Msg_Teardown", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<CacheStorageParent*>(this))->RecvTeardown();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStorage::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PCacheStorageParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PCacheStorageParent::Result
{
    return MsgNotKnown;
}

auto PCacheStorageParent::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PCacheStorageParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheStorageParent::ClearSubtree() -> void
{
    for (auto* key : mManagedPCacheOpParent) {
        key->ClearSubtree();
    }
    for (auto* key : mManagedPCacheOpParent) {
        // Recursively releasing mManagedPCacheOpParent kids.
        auto* proxy = key->GetLifecycleProxy();
        NS_IF_RELEASE(proxy);
    }
    mManagedPCacheOpParent.Clear();

}



} // namespace cache
} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::dom::cache::PCacheStorageParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<::mozilla::dom::cache::PCacheStorageParent*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = aReader->GetActor()
        ->ReadActor(aReader, true, "PCacheStorage", PCacheStorageMsgStart);
    if (actor.isSome()) {
        return static_cast<::mozilla::dom::cache::PCacheStorageParent*>(actor.ref());
    }
    return {};
}

} // namespace IPC
