//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/layers/PImageBridgeParent.h"
#include "gfxipc/ShadowLayerUtils.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/gfx/2D.h"
#include "mozilla/ipc/IPCCore.h"
#include "mozilla/layers/CompositorTypes.h"
#include "mozilla/layers/ImageBridgeParent.h"
#include "mozilla/layers/LayersMessageUtils.h"
#include "mozilla/layers/WebRenderMessageUtils.h"
#include "nsID.h"
#include "nsPoint.h"
#include "nsRect.h"

#include "mozilla/layers/PTextureParent.h"
#include "mozilla/media/PMediaSystemResourceManagerParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace layers {


auto PImageBridgeParent::RecvPTextureConstructor(
        PTextureParent* actor,
        const SurfaceDescriptor& aSharedData,
        ReadLockDescriptor&& aReadLock,
        const LayersBackend& aBackend,
        const TextureFlags& aTextureFlags,
        const uint64_t& aSerial,
        const MaybeExternalImageId& aExternalImageId) -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

auto PImageBridgeParent::RecvPMediaSystemResourceManagerConstructor(PMediaSystemResourceManagerParent* actor) -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

auto PImageBridgeParent::ProcessingError(
        Result aCode,
        const char* aReason) -> void
{
}

auto PImageBridgeParent::ShouldContinueFromReplyTimeout() -> bool
{
    return true;
}

MOZ_IMPLICIT PImageBridgeParent::PImageBridgeParent() :
    mozilla::ipc::IToplevelProtocol("PImageBridgeParent", PImageBridgeMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PImageBridgeParent);
}

PImageBridgeParent::~PImageBridgeParent()
{
    MOZ_COUNT_DTOR(PImageBridgeParent);
}

auto PImageBridgeParent::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PImageBridgeParent::ManagedPTextureParent(nsTArray<PTextureParent*>& aArr) const -> void
{
    mManagedPTextureParent.ToArray(aArr);
}

auto PImageBridgeParent::ManagedPTextureParent() const -> const ManagedContainer<PTextureParent>&
{
    return mManagedPTextureParent;
}

auto PImageBridgeParent::ManagedPMediaSystemResourceManagerParent(nsTArray<PMediaSystemResourceManagerParent*>& aArr) const -> void
{
    mManagedPMediaSystemResourceManagerParent.ToArray(aArr);
}

auto PImageBridgeParent::ManagedPMediaSystemResourceManagerParent() const -> const ManagedContainer<PMediaSystemResourceManagerParent>&
{
    return mManagedPMediaSystemResourceManagerParent;
}

auto PImageBridgeParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    total += mManagedPTextureParent.Count();
    total += mManagedPMediaSystemResourceManagerParent.Count();
    arr__.SetCapacity(total);

    for (auto* key : mManagedPTextureParent) {
        arr__.AppendElement(key->GetLifecycleProxy());
    }

    for (auto* key : mManagedPMediaSystemResourceManagerParent) {
        arr__.AppendElement(key->GetLifecycleProxy());
    }

}

auto PImageBridgeParent::OpenPTextureEndpoint(PTextureParent* aActor) -> ManagedEndpoint<PTextureChild>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PTextureParent actor");
        return ManagedEndpoint<PTextureChild>();
    }

    aActor->SetManagerAndRegister(this);
    mManagedPTextureParent.Insert(aActor);

    // Mark our actor as awaiting the other side to be bound. This will
    // be cleared when a `MANAGED_ENDPOINT_{DROPPED,BOUND}` message is
    // received.
    aActor->mAwaitingManagedEndpointBind = true;
    return ManagedEndpoint<PTextureChild>(mozilla::ipc::PrivateIPDLInterface(), aActor);
}

auto PImageBridgeParent::BindPTextureEndpoint(
        ManagedEndpoint<PTextureParent> aEndpoint,
        PTextureParent* aActor) -> bool
{
    return aEndpoint.Bind(mozilla::ipc::PrivateIPDLInterface(), aActor, this, mManagedPTextureParent);
}

auto PImageBridgeParent::OpenPMediaSystemResourceManagerEndpoint(PMediaSystemResourceManagerParent* aActor) -> ManagedEndpoint<PMediaSystemResourceManagerChild>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PMediaSystemResourceManagerParent actor");
        return ManagedEndpoint<PMediaSystemResourceManagerChild>();
    }

    aActor->SetManagerAndRegister(this);
    mManagedPMediaSystemResourceManagerParent.Insert(aActor);

    // Mark our actor as awaiting the other side to be bound. This will
    // be cleared when a `MANAGED_ENDPOINT_{DROPPED,BOUND}` message is
    // received.
    aActor->mAwaitingManagedEndpointBind = true;
    return ManagedEndpoint<PMediaSystemResourceManagerChild>(mozilla::ipc::PrivateIPDLInterface(), aActor);
}

auto PImageBridgeParent::BindPMediaSystemResourceManagerEndpoint(
        ManagedEndpoint<PMediaSystemResourceManagerParent> aEndpoint,
        PMediaSystemResourceManagerParent* aActor) -> bool
{
    return aEndpoint.Bind(mozilla::ipc::PrivateIPDLInterface(), aActor, this, mManagedPMediaSystemResourceManagerParent);
}

auto PImageBridgeParent::SendParentAsyncMessages(mozilla::Span<AsyncParentMessageData const> aMessages) -> bool
{
    UniquePtr<IPC::Message> msg__ = PImageBridge::Msg_ParentAsyncMessages(MSG_ROUTING_CONTROL);
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), aMessages);
    // Sentinel = 'aMessages'
    ((&(writer__)))->WriteSentinel(293864346);




    if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PImageBridgeParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PImageBridge::Msg_ParentAsyncMessages", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PImageBridgeParent::SendDidComposite(mozilla::Span<ImageCompositeNotification const> aNotifications) -> bool
{
    UniquePtr<IPC::Message> msg__ = PImageBridge::Msg_DidComposite(MSG_ROUTING_CONTROL);
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), aNotifications);
    // Sentinel = 'aNotifications'
    ((&(writer__)))->WriteSentinel(704185788);




    if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PImageBridgeParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PImageBridge::Msg_DidComposite", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PImageBridgeParent::SendReportFramesDropped(
        const CompositableHandle& aHandle,
        const uint32_t& aFrames) -> bool
{
    UniquePtr<IPC::Message> msg__ = PImageBridge::Msg_ReportFramesDropped(MSG_ROUTING_CONTROL);
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), aHandle);
    // Sentinel = 'aHandle'
    ((&(writer__)))->WriteSentinel(174326446);
    IPC::WriteParam((&(writer__)), aFrames);
    // Sentinel = 'aFrames'
    ((&(writer__)))->WriteSentinel(177472192);




    if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PImageBridgeParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PImageBridge::Msg_ReportFramesDropped", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PImageBridgeParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PTextureMsgStart:
{
            PTextureParent* actor = static_cast<PTextureParent*>(aListener);

            const bool removed = mManagedPTextureParent.EnsureRemoved(actor);
            MOZ_RELEASE_ASSERT(removed, "actor not managed by this!");

            auto* proxy = actor->GetLifecycleProxy();
            NS_IF_RELEASE(proxy);
            return;
        }    case PMediaSystemResourceManagerMsgStart:
{
            PMediaSystemResourceManagerParent* actor = static_cast<PMediaSystemResourceManagerParent*>(aListener);

            const bool removed = mManagedPMediaSystemResourceManagerParent.EnsureRemoved(actor);
            MOZ_RELEASE_ASSERT(removed, "actor not managed by this!");

            auto* proxy = actor->GetLifecycleProxy();
            NS_IF_RELEASE(proxy);
            return;
        }    default:
FatalError("unreached");
        return;    }
}

auto PImageBridgeParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PTextureMsgStart:
        static_cast<ImageBridgeParent*>(this)->DeallocPTextureParent(static_cast<PTextureParent*>(aListener));
        return;
    case PMediaSystemResourceManagerMsgStart:
        static_cast<ImageBridgeParent*>(this)->DeallocPMediaSystemResourceManagerParent(static_cast<PMediaSystemResourceManagerParent*>(aListener));
        return;
    default:
        FatalError("unreached");
        return;
    }
}

auto PImageBridgeParent::OnMessageReceived(const Message& msg__) -> PImageBridgeParent::Result
{
    int32_t route__ = msg__.routing_id();
    if (MSG_ROUTING_CONTROL != route__) {
        IProtocol* routed__ = Lookup(route__);
        if (!routed__ || !routed__->GetLifecycleProxy()) {
            if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PImageBridgeParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Ignored message for dead actor",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eSending);
            }
            return MsgProcessed;

        }

        RefPtr<mozilla::ipc::ActorLifecycleProxy> proxy__ =
            routed__->GetLifecycleProxy();
        return proxy__->Get()->OnMessageReceived(msg__);
    }

    switch (msg__.type()) {
    case PImageBridge::Msg_Update__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PImageBridgeParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PImageBridge::Msg_Update", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__ops = IPC::ReadParam<nsTArray<CompositableOperation>>((&(reader__)));
            if (!maybe__ops) {
                FatalError("Error deserializing 'CompositableOperation[]'");
                return MsgValueError;

            }
            auto& ops = *maybe__ops;
            // Sentinel = 'ops'
            if ((!(((&(reader__)))->ReadSentinel(44237139)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'CompositableOperation[]'");
                return MsgValueError;
            }
            auto maybe__toDestroy = IPC::ReadParam<nsTArray<OpDestroy>>((&(reader__)));
            if (!maybe__toDestroy) {
                FatalError("Error deserializing 'OpDestroy[]'");
                return MsgValueError;

            }
            auto& toDestroy = *maybe__toDestroy;
            // Sentinel = 'toDestroy'
            if ((!(((&(reader__)))->ReadSentinel(311100366)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'OpDestroy[]'");
                return MsgValueError;
            }
            auto maybe__fwdTransactionId = IPC::ReadParam<uint64_t>((&(reader__)));
            if (!maybe__fwdTransactionId) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;

            }
            auto& fwdTransactionId = *maybe__fwdTransactionId;
            // Sentinel = 'fwdTransactionId'
            if ((!(((&(reader__)))->ReadSentinel(930940533)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<ImageBridgeParent*>(this))->RecvUpdate(std::move(ops), std::move(toDestroy), std::move(fwdTransactionId));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PImageBridge::Msg_WillClose__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PImageBridgeParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PImageBridge::Msg_WillClose", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<ImageBridgeParent*>(this))->RecvWillClose();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PImageBridge::Msg_PTextureConstructor__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PImageBridgeParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PImageBridge::Msg_PTextureConstructor", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__handle__ = IPC::ReadParam<ActorHandle>((&(reader__)));
            if (!maybe__handle__) {
                FatalError("Error deserializing 'ActorHandle'");
                return MsgValueError;

            }
            auto& handle__ = *maybe__handle__;
            // Sentinel = 'actor'
            if ((!(((&(reader__)))->ReadSentinel(102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            auto maybe__aSharedData = IPC::ReadParam<SurfaceDescriptor>((&(reader__)));
            if (!maybe__aSharedData) {
                FatalError("Error deserializing 'SurfaceDescriptor'");
                return MsgValueError;

            }
            auto& aSharedData = *maybe__aSharedData;
            // Sentinel = 'aSharedData'
            if ((!(((&(reader__)))->ReadSentinel(420480051)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'SurfaceDescriptor'");
                return MsgValueError;
            }
            auto maybe__aReadLock = IPC::ReadParam<ReadLockDescriptor>((&(reader__)));
            if (!maybe__aReadLock) {
                FatalError("Error deserializing 'ReadLockDescriptor'");
                return MsgValueError;

            }
            auto& aReadLock = *maybe__aReadLock;
            // Sentinel = 'aReadLock'
            if ((!(((&(reader__)))->ReadSentinel(279774055)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ReadLockDescriptor'");
                return MsgValueError;
            }
            auto maybe__aBackend = IPC::ReadParam<LayersBackend>((&(reader__)));
            if (!maybe__aBackend) {
                FatalError("Error deserializing 'LayersBackend'");
                return MsgValueError;

            }
            auto& aBackend = *maybe__aBackend;
            // Sentinel = 'aBackend'
            if ((!(((&(reader__)))->ReadSentinel(221119242)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'LayersBackend'");
                return MsgValueError;
            }
            auto maybe__aTextureFlags = IPC::ReadParam<TextureFlags>((&(reader__)));
            if (!maybe__aTextureFlags) {
                FatalError("Error deserializing 'TextureFlags'");
                return MsgValueError;

            }
            auto& aTextureFlags = *maybe__aTextureFlags;
            // Sentinel = 'aTextureFlags'
            if ((!(((&(reader__)))->ReadSentinel(614139200)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'TextureFlags'");
                return MsgValueError;
            }
            auto maybe__aSerial = IPC::ReadParam<uint64_t>((&(reader__)));
            if (!maybe__aSerial) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;

            }
            auto& aSerial = *maybe__aSerial;
            // Sentinel = 'aSerial'
            if ((!(((&(reader__)))->ReadSentinel(181011138)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            auto maybe__aExternalImageId = IPC::ReadParam<MaybeExternalImageId>((&(reader__)));
            if (!maybe__aExternalImageId) {
                FatalError("Error deserializing 'MaybeExternalImageId'");
                return MsgValueError;

            }
            auto& aExternalImageId = *maybe__aExternalImageId;
            // Sentinel = 'aExternalImageId'
            if ((!(((&(reader__)))->ReadSentinel(898172469)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'MaybeExternalImageId'");
                return MsgValueError;
            }
            reader__.EndRead();
            PTextureParent* actor = (static_cast<ImageBridgeParent*>(this))->AllocPTextureParent(aSharedData, aReadLock, aBackend, aTextureFlags, aSerial, aExternalImageId);
            if (!actor) {
                NS_WARNING("Cannot bind null PTextureParent actor");
                return MsgValueError;
            }

            actor->SetManagerAndRegister(this, (handle__).mId);
            mManagedPTextureParent.Insert(actor);

            mozilla::ipc::IPCResult __ok = (static_cast<ImageBridgeParent*>(this))->RecvPTextureConstructor(std::move(actor), std::move(aSharedData), std::move(aReadLock), std::move(aBackend), std::move(aTextureFlags), std::move(aSerial), std::move(aExternalImageId));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PImageBridge::Msg_PMediaSystemResourceManagerConstructor__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PImageBridgeParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PImageBridge::Msg_PMediaSystemResourceManagerConstructor", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__handle__ = IPC::ReadParam<ActorHandle>((&(reader__)));
            if (!maybe__handle__) {
                FatalError("Error deserializing 'ActorHandle'");
                return MsgValueError;

            }
            auto& handle__ = *maybe__handle__;
            // Sentinel = 'actor'
            if ((!(((&(reader__)))->ReadSentinel(102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            reader__.EndRead();
            PMediaSystemResourceManagerParent* actor = (static_cast<ImageBridgeParent*>(this))->AllocPMediaSystemResourceManagerParent();
            if (!actor) {
                NS_WARNING("Cannot bind null PMediaSystemResourceManagerParent actor");
                return MsgValueError;
            }

            actor->SetManagerAndRegister(this, (handle__).mId);
            mManagedPMediaSystemResourceManagerParent.Insert(actor);

            mozilla::ipc::IPCResult __ok = (static_cast<ImageBridgeParent*>(this))->RecvPMediaSystemResourceManagerConstructor(std::move(actor));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PImageBridge::Msg_ReleaseCompositable__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PImageBridgeParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PImageBridge::Msg_ReleaseCompositable", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__aHandle = IPC::ReadParam<CompositableHandle>((&(reader__)));
            if (!maybe__aHandle) {
                FatalError("Error deserializing 'CompositableHandle'");
                return MsgValueError;

            }
            auto& aHandle = *maybe__aHandle;
            // Sentinel = 'aHandle'
            if ((!(((&(reader__)))->ReadSentinel(174326446)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'CompositableHandle'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<ImageBridgeParent*>(this))->RecvReleaseCompositable(std::move(aHandle));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    case SHMEM_CREATED_MESSAGE_TYPE:
        {
            if (!ShmemCreated(msg__)) {
                return MsgPayloadError;
            }
            return MsgProcessed;
        }
    case SHMEM_DESTROYED_MESSAGE_TYPE:
        {
            if (!ShmemDestroyed(msg__)) {
                return MsgPayloadError;
            }
            return MsgProcessed;
        }
    }
}

auto PImageBridgeParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PImageBridgeParent::Result
{
    int32_t route__ = msg__.routing_id();
    if (MSG_ROUTING_CONTROL != route__) {
        IProtocol* routed__ = Lookup(route__);
        if (!routed__ || !routed__->GetLifecycleProxy()) {
            return MsgRouteError;

        }

        RefPtr<mozilla::ipc::ActorLifecycleProxy> proxy__ =
            routed__->GetLifecycleProxy();
        return proxy__->Get()->OnMessageReceived(msg__, reply__);
    }

    switch (msg__.type()) {
    case PImageBridge::Msg_NewCompositable__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PImageBridgeParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PImageBridge::Msg_NewCompositable", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__aHandle = IPC::ReadParam<CompositableHandle>((&(reader__)));
            if (!maybe__aHandle) {
                FatalError("Error deserializing 'CompositableHandle'");
                return MsgValueError;

            }
            auto& aHandle = *maybe__aHandle;
            // Sentinel = 'aHandle'
            if ((!(((&(reader__)))->ReadSentinel(174326446)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'CompositableHandle'");
                return MsgValueError;
            }
            auto maybe__aInfo = IPC::ReadParam<TextureInfo>((&(reader__)));
            if (!maybe__aInfo) {
                FatalError("Error deserializing 'TextureInfo'");
                return MsgValueError;

            }
            auto& aInfo = *maybe__aInfo;
            // Sentinel = 'aInfo'
            if ((!(((&(reader__)))->ReadSentinel(93520366)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'TextureInfo'");
                return MsgValueError;
            }
            reader__.EndRead();
            int32_t id__ = MSG_ROUTING_CONTROL;
            mozilla::ipc::IPCResult __ok = (static_cast<ImageBridgeParent*>(this))->RecvNewCompositable(std::move(aHandle), std::move(aInfo));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            reply__ = PImageBridge::Reply_NewCompositable(id__);
            IPC::MessageWriter writer__{
                    (*(reply__)),
                    this};


            if (mozilla::ipc::LoggingEnabledFor("PImageBridgeParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PImageBridgeParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Sending reply ",
                    reply__->type(),
                    mozilla::ipc::MessageDirection::eSending);
            }
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PImageBridgeParent::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PImageBridgeParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PImageBridgeParent::OnChannelClose() -> void
{
    DestroySubtree(NormalShutdown);
    ClearSubtree();
    DeallocShmems();
    if (GetLifecycleProxy()) {
        GetLifecycleProxy()->Release();
    }
}

auto PImageBridgeParent::OnChannelError() -> void
{
    DestroySubtree(AbnormalShutdown);
    ClearSubtree();
    DeallocShmems();
    if (GetLifecycleProxy()) {
        GetLifecycleProxy()->Release();
    }
}

auto PImageBridgeParent::ClearSubtree() -> void
{
    for (auto* key : mManagedPTextureParent) {
        key->ClearSubtree();
    }
    for (auto* key : mManagedPTextureParent) {
        // Recursively releasing mManagedPTextureParent kids.
        auto* proxy = key->GetLifecycleProxy();
        NS_IF_RELEASE(proxy);
    }
    mManagedPTextureParent.Clear();

    for (auto* key : mManagedPMediaSystemResourceManagerParent) {
        key->ClearSubtree();
    }
    for (auto* key : mManagedPMediaSystemResourceManagerParent) {
        // Recursively releasing mManagedPMediaSystemResourceManagerParent kids.
        auto* proxy = key->GetLifecycleProxy();
        NS_IF_RELEASE(proxy);
    }
    mManagedPMediaSystemResourceManagerParent.Clear();

}



} // namespace layers
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::layers::PImageBridgeParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<::mozilla::layers::PImageBridgeParent*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = aReader->GetActor()
        ->ReadActor(aReader, true, "PImageBridge", PImageBridgeMsgStart);
    if (actor.isSome()) {
        return static_cast<::mozilla::layers::PImageBridgeParent*>(actor.ref());
    }
    return {};
}

} // namespace IPC
