//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PVsyncChild.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/dom/VsyncChild.h"
#include "mozilla/layers/LayersMessageUtils.h"

#include "mozilla/ipc/PBackgroundChild.h"
#include "mozilla/dom/PBrowserChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {


MOZ_IMPLICIT PVsyncChild::PVsyncChild() :
    mozilla::ipc::IProtocol(PVsyncMsgStart, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PVsyncChild);
}

PVsyncChild::~PVsyncChild()
{
    MOZ_COUNT_DTOR(PVsyncChild);
}

auto PVsyncChild::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PVsyncChild::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PVsyncChild::SendObserve() -> bool
{
    UniquePtr<IPC::Message> msg__ = PVsync::Msg_Observe(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PVsyncChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PVsyncChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PVsync::Msg_Observe", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PVsyncChild::SendUnobserve() -> bool
{
    UniquePtr<IPC::Message> msg__ = PVsync::Msg_Unobserve(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PVsyncChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PVsyncChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PVsync::Msg_Unobserve", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PVsyncChild::Send__delete__(PVsyncChild* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    UniquePtr<IPC::Message> msg__ = PVsync::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};




    if (mozilla::ipc::LoggingEnabledFor("PVsyncChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PVsyncChild",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PVsync::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(std::move(msg__));

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PVsyncMsgStart, actor);
    return sendok__;
}

auto PVsyncChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PVsyncChild::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PVsyncChild::OnMessageReceived(const Message& msg__) -> PVsyncChild::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PVsyncMsgStart, this);
            return MsgProcessed;
        }
    case PVsync::Msg_Notify__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PVsyncChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PVsyncChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PVsync::Msg_Notify", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};

            auto maybe__aVsync = IPC::ReadParam<VsyncEvent>((&(reader__)));
            if (!maybe__aVsync) {
                FatalError("Error deserializing 'VsyncEvent'");
                return MsgValueError;

            }
            auto& aVsync = *maybe__aVsync;
            // Sentinel = 'aVsync'
            if ((!(((&(reader__)))->ReadSentinel(141558389)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'VsyncEvent'");
                return MsgValueError;
            }
            auto maybe__aVsyncRate = IPC::ReadParam<float>((&(reader__)));
            if (!maybe__aVsyncRate) {
                FatalError("Error deserializing 'float'");
                return MsgValueError;

            }
            auto& aVsyncRate = *maybe__aVsyncRate;
            // Sentinel = 'aVsyncRate'
            if ((!(((&(reader__)))->ReadSentinel(368837633)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'float'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<VsyncChild*>(this))->RecvNotify(std::move(aVsync), std::move(aVsyncRate));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PVsync::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PVsyncChild::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PVsyncChild::Result
{
    return MsgNotKnown;
}

auto PVsyncChild::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PVsyncChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PVsyncChild::ClearSubtree() -> void
{
}



} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<::mozilla::dom::PVsyncChild*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<::mozilla::dom::PVsyncChild*>::Read(IPC::MessageReader* aReader) -> IPC::ReadResult<paramType>
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor = aReader->GetActor()
        ->ReadActor(aReader, true, "PVsync", PVsyncMsgStart);
    if (actor.isSome()) {
        return static_cast<::mozilla::dom::PVsyncChild*>(actor.ref());
    }
    return {};
}

} // namespace IPC
