//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoEncoderParent_h
#define PGMPVideoEncoderParent_h

#include "mozilla/gmp/PGMPVideoEncoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "GMPSanitizedExports.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"
#include "gmp-video-frame-encoded.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPVideoEncoderParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class ::mozilla::gmp::PGMPContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef ::mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef ::mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef ::mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef ::mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    typedef ::cdm::EncryptionScheme EncryptionScheme;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::GMPBufferType GMPBufferType;
    typedef ::GMPErr GMPErr;
    typedef ::mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef ::GMPVideoCodec GMPVideoCodec;
    typedef ::mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef ::GMPVideoFrameType GMPVideoFrameType;
    typedef ::mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::gmp::NodeIdParts NodeIdParts;
    typedef ::mozilla::gmp::NodeIdVariant NodeIdVariant;
    typedef ::mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef ::mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvEncoded(
            const GMPVideoEncodedFrameData& aEncodedFrame,
            nsTArray<uint8_t>&& aCodecSpecificInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvError(const GMPErr& aErr) = 0;
    virtual mozilla::ipc::IPCResult
    RecvShutdown() = 0;
    virtual mozilla::ipc::IPCResult
    RecvParentShmemForPool(Shmem&& aFrameBuffer) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNeedShmem(
            const uint32_t& aEncodedBufferSize,
            Shmem* aMem) = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPVideoEncoderParent();

    virtual ~PGMPVideoEncoderParent();

    NS_INLINE_DECL_PURE_VIRTUAL_REFCOUNTING
protected:
    void ActorAlloc() final { AddRef(); }
    void ActorDealloc() final { Release(); }
public:
    ::base::ProcessId
    OtherPid() const;

    PGMPContentParent*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    [[nodiscard]] bool
    SendInitEncode(
            const GMPVideoCodec& aCodecSettings,
            mozilla::Span<uint8_t const> aCodecSpecific,
            const int32_t& aNumberOfCores,
            const uint32_t& aMaxPayloadSize);

    [[nodiscard]] bool
    SendEncode(
            const GMPVideoi420FrameData& aInputFrame,
            mozilla::Span<uint8_t const> aCodecSpecificInfo,
            mozilla::Span<GMPVideoFrameType const> aFrameTypes);

    [[nodiscard]] bool
    SendSetChannelParameters(
            const uint32_t& aPacketLoss,
            const uint32_t& aRTT);

    [[nodiscard]] bool
    SendSetRates(
            const uint32_t& aNewBitRate,
            const uint32_t& aFrameRate);

    [[nodiscard]] bool
    SendSetPeriodicKeyFrames(const bool& aEnable);

    [[nodiscard]] bool
    SendEncodingComplete();

    [[nodiscard]] bool
    SendChildShmemForPool(Shmem&& aEncodedBuffer);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    void
    ClearSubtree();

    bool mAwaitingManagedEndpointBind = false;

};


} // namespace gmp
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::gmp::PGMPVideoEncoderParent*>
{
    typedef ::mozilla::gmp::PGMPVideoEncoderParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PGMPVideoEncoderParent_h
