//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHalChild_h
#define PHalChild_h

#include "mozilla/hal_sandbox/PHal.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/HalIPCUtils.h"
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"
#include "nsRect.h"
#include "prtime.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {


class PHalChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class ::mozilla::dom::PContentChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::hal::BatteryInformation BatteryInformation;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::hal::NetworkInformation NetworkInformation;
    typedef ::mozilla::dom::PBrowserChild PBrowserChild;
    typedef ::mozilla::dom::PBrowserParent PBrowserParent;
    typedef ::mozilla::dom::PContentChild PContentChild;
    typedef ::mozilla::dom::PContentParent PContentParent;
    typedef ::PRTime PRTime;
    typedef base::ProcessId ProcessId;
    typedef ::mozilla::hal::ProcessPriority ProcessPriority;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::hal::ScreenOrientation ScreenOrientation;
    typedef ::mozilla::hal::SensorData SensorData;
    typedef ::mozilla::hal::SensorType SensorType;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::mozilla::hal::WakeLockControl WakeLockControl;
    typedef ::mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsIntRect nsIntRect;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef MozPromise<nsresult, ResponseRejectReason, true> LockScreenOrientationPromise;

protected:
    virtual mozilla::ipc::IPCResult
    RecvNotifyBatteryChange(const BatteryInformation& aBatteryInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifySensorChange(const SensorData& aSensorData) = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PHalChild();

    virtual ~PHalChild();

public:
    ::base::ProcessId
    OtherPid() const;

    PContentChild*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    bool
    SendVibrate(
            mozilla::Span<uint32_t const> pattern,
            mozilla::Span<uint64_t const> id,
            mozilla::NotNull<PBrowserChild*> browser);

    bool
    SendCancelVibrate(
            mozilla::Span<uint64_t const> id,
            mozilla::NotNull<PBrowserChild*> browser);

    bool
    SendEnableBatteryNotifications();

    bool
    SendDisableBatteryNotifications();

    bool
    SendGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo);

    bool
    SendEnableNetworkNotifications();

    bool
    SendDisableNetworkNotifications();

    bool
    SendGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo);

    bool
    SendModifyWakeLock(
            const nsAString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID);

    bool
    SendEnableWakeLockNotifications();

    bool
    SendDisableWakeLockNotifications();

    bool
    SendGetWakeLockInfo(
            const nsAString& aTopic,
            WakeLockInformation* aWakeLockInfo);

    void
    SendLockScreenOrientation(
            const ScreenOrientation& aOrientation,
            mozilla::ipc::ResolveCallback<nsresult>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<LockScreenOrientationPromise>
    SendLockScreenOrientation(const ScreenOrientation& aOrientation);

    bool
    SendUnlockScreenOrientation();

    bool
    SendEnableSensorNotifications(const SensorType& aSensor);

    bool
    SendDisableSensorNotifications(const SensorType& aSensor);

    static bool
    Send__delete__(PHalChild* actor);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    void
    ClearSubtree();

    bool mAwaitingManagedEndpointBind = false;

};


} // namespace hal_sandbox
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::hal_sandbox::PHalChild*>
{
    typedef ::mozilla::hal_sandbox::PHalChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PHalChild_h
