//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PUtilityProcessParent_h
#define PUtilityProcessParent_h

#include "mozilla/ipc/PUtilityProcess.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
class nsIFile;

// Headers for things that cannot be forward declared
#include "mozilla/TelemetryComms.h"
#include "mozilla/dom/NativeThreadId.h"

namespace mozilla {
class PProfilerParent;
} // namespace mozilla
namespace mozilla {
class PProfilerChild;
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PUtilityAudioDecoderParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PUtilityAudioDecoderChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PJSOracleParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PJSOracleChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
struct null_t;
} // namespace mozilla

namespace mozilla {
namespace ipc {


class PUtilityProcessParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::Telemetry::ChildEventData ChildEventData;
    typedef ::mozilla::Telemetry::DiscardedData DiscardedData;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::Telemetry::HistogramAccumulation HistogramAccumulation;
    typedef ::mozilla::Telemetry::KeyedHistogramAccumulation KeyedHistogramAccumulation;
    typedef ::mozilla::Telemetry::KeyedScalarAction KeyedScalarAction;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::dom::MemoryReport MemoryReport;
    typedef ::mozilla::dom::NativeThreadId NativeThreadId;
    typedef ::mozilla::dom::PJSOracleChild PJSOracleChild;
    typedef ::mozilla::dom::PJSOracleParent PJSOracleParent;
    typedef ::mozilla::PProfilerChild PProfilerChild;
    typedef ::mozilla::PProfilerParent PProfilerParent;
    typedef ::mozilla::ipc::PUtilityAudioDecoderChild PUtilityAudioDecoderChild;
    typedef ::mozilla::ipc::PUtilityAudioDecoderParent PUtilityAudioDecoderParent;
    typedef ::mozilla::dom::Pref Pref;
    typedef ::mozilla::dom::PrefValue PrefValue;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::Telemetry::ScalarAction ScalarAction;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::mozilla::null_t null_t;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;
    typedef ::mozilla::void_t void_t;

public:
    typedef MozPromise<uint32_t, ResponseRejectReason, true> RequestMemoryReportPromise;
    typedef MozPromise<ByteBuf, ResponseRejectReason, true> FlushFOGDataPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> TestTriggerMetricsPromise;

protected:
    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PUtilityProcessParent();

    virtual ~PUtilityProcessParent();

protected:
    void ActorAlloc() final { AddRef(); }
    void ActorDealloc() final { Release(); }
public:
    ::base::ProcessId
    OtherPid() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    [[nodiscard]] bool
    SendInit(
            const mozilla::Maybe<FileDescriptor>& sandboxBroker,
            const bool& canRecordReleaseTelemetry,
            const bool& aIsReadyForBackgroundProcessing);

    [[nodiscard]] bool
    SendInitProfiler(Endpoint<::mozilla::PProfilerChild>&& endpoint);

    void
    SendRequestMemoryReport(
            const uint32_t& generation,
            const bool& anonymize,
            const bool& minimizeMemoryUsage,
            const mozilla::Maybe<FileDescriptor>& DMDFile,
            mozilla::ipc::ResolveCallback<uint32_t>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<RequestMemoryReportPromise>
    SendRequestMemoryReport(
            const uint32_t& generation,
            const bool& anonymize,
            const bool& minimizeMemoryUsage,
            const mozilla::Maybe<FileDescriptor>& DMDFile);

    [[nodiscard]] bool
    SendPreferenceUpdate(const Pref& pref);

    void
    SendFlushFOGData(
            mozilla::ipc::ResolveCallback<ByteBuf>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<FlushFOGDataPromise>
    SendFlushFOGData();

    void
    SendTestTriggerMetrics(
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<TestTriggerMetricsPromise>
    SendTestTriggerMetrics();

    [[nodiscard]] bool
    SendTestTelemetryProbes();

    [[nodiscard]] bool
    SendStartUtilityAudioDecoderService(Endpoint<::mozilla::ipc::PUtilityAudioDecoderParent>&& aEndpoint);

    [[nodiscard]] bool
    SendStartJSOracleService(Endpoint<::mozilla::dom::PJSOracleChild>&& aEndpoint);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    void
    OnChannelClose() override;

    void
    OnChannelError() override;

private:
    void
    ClearSubtree();

};


} // namespace ipc
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::ipc::PUtilityProcessParent*>
{
    typedef ::mozilla::ipc::PUtilityProcessParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PUtilityProcessParent_h
