//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebGPUChild_h
#define PWebGPUChild_h

#include "mozilla/webgpu/PWebGPU.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/dom/WebGPUBinding.h"
#include "mozilla/layers/LayersSurfaces.h"
#include "mozilla/layers/LayersTypes.h"
#include "mozilla/webgpu/WebGPUTypes.h"

namespace mozilla {
namespace gfx {
class PCanvasManagerChild;
} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace gfx {
class PCanvasManagerParent;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class PCanvasManagerChild;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
struct null_t;
} // namespace mozilla

namespace mozilla {
namespace ipc {
class UnsafeSharedMemoryHandle;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace webgpu {


class PWebGPUChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class ::mozilla::gfx::PCanvasManagerChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::webgpu::BufferMapError BufferMapError;
    typedef ::mozilla::webgpu::BufferMapResult BufferMapResult;
    typedef ::mozilla::webgpu::BufferMapSuccess BufferMapSuccess;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::dom::GPUBufferDescriptor GPUBufferDescriptor;
    typedef ::mozilla::dom::GPUCommandBufferDescriptor GPUCommandBufferDescriptor;
    typedef ::mozilla::dom::GPURequestAdapterOptions GPURequestAdapterOptions;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::webgpu::MaybeScopedError MaybeScopedError;
    typedef ::mozilla::gfx::PCanvasManagerChild PCanvasManagerChild;
    typedef ::mozilla::gfx::PCanvasManagerParent PCanvasManagerParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef ::mozilla::layers::RGBDescriptor RGBDescriptor;
    typedef ::mozilla::webgpu::RawId RawId;
    typedef ::mozilla::layers::RemoteTextureId RemoteTextureId;
    typedef ::mozilla::layers::RemoteTextureOwnerId RemoteTextureOwnerId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::mozilla::ipc::UnsafeSharedMemoryHandle UnsafeSharedMemoryHandle;
    typedef ::mozilla::webgpu::WebGPUCompilationMessage WebGPUCompilationMessage;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::mozilla::null_t null_t;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef MozPromise<bool, ResponseRejectReason, true> DeviceActionWithAckPromise;
    typedef MozPromise<ByteBuf, ResponseRejectReason, true> InstanceRequestAdapterPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> AdapterRequestDevicePromise;
    typedef MozPromise<nsTArray<WebGPUCompilationMessage>, ResponseRejectReason, true> DeviceCreateShaderModulePromise;
    typedef MozPromise<BufferMapResult, ResponseRejectReason, true> BufferMapPromise;
    typedef MozPromise<MaybeScopedError, ResponseRejectReason, true> DevicePopErrorScopePromise;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebGPUChild();

    virtual ~PWebGPUChild();

    NS_INLINE_DECL_PURE_VIRTUAL_REFCOUNTING
protected:
    void ActorAlloc() final { AddRef(); }
    void ActorDealloc() final { Release(); }
public:
    ::base::ProcessId
    OtherPid() const;

    PCanvasManagerChild*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    bool
    SendDeviceAction(
            const RawId& selfId,
            ByteBuf&& buf);

    void
    SendDeviceActionWithAck(
            const RawId& selfId,
            ByteBuf&& buf,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<DeviceActionWithAckPromise>
    SendDeviceActionWithAck(
            const RawId& selfId,
            ByteBuf&& buf);

    bool
    SendTextureAction(
            const RawId& selfId,
            const RawId& aDeviceId,
            ByteBuf&& buf);

    bool
    SendCommandEncoderAction(
            const RawId& selfId,
            const RawId& aDeviceId,
            ByteBuf&& buf);

    bool
    SendBumpImplicitBindGroupLayout(
            const RawId& pipelineId,
            const bool& isCompute,
            const uint32_t& index,
            const RawId& assignId);

    bool
    SendCreateBuffer(
            const RawId& deviceId,
            const RawId& bufferId,
            const GPUBufferDescriptor& desc,
            UnsafeSharedMemoryHandle&& shm);

    void
    SendInstanceRequestAdapter(
            const GPURequestAdapterOptions& options,
            mozilla::Span<RawId const> ids,
            mozilla::ipc::ResolveCallback<ByteBuf>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<InstanceRequestAdapterPromise>
    SendInstanceRequestAdapter(
            const GPURequestAdapterOptions& options,
            mozilla::Span<RawId const> ids);

    void
    SendAdapterRequestDevice(
            const RawId& selfId,
            ByteBuf&& buf,
            const RawId& newId,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<AdapterRequestDevicePromise>
    SendAdapterRequestDevice(
            const RawId& selfId,
            ByteBuf&& buf,
            const RawId& newId);

    bool
    SendAdapterDestroy(const RawId& selfId);

    void
    SendDeviceCreateShaderModule(
            const RawId& selfId,
            const RawId& bufferId,
            const nsAString& label,
            const nsACString& code,
            mozilla::ipc::ResolveCallback<nsTArray<WebGPUCompilationMessage>>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<DeviceCreateShaderModulePromise>
    SendDeviceCreateShaderModule(
            const RawId& selfId,
            const RawId& bufferId,
            const nsAString& label,
            const nsACString& code);

    void
    SendBufferMap(
            const RawId& selfId,
            const uint32_t& aMode,
            const uint64_t& offset,
            const uint64_t& size,
            mozilla::ipc::ResolveCallback<BufferMapResult>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<BufferMapPromise>
    SendBufferMap(
            const RawId& selfId,
            const uint32_t& aMode,
            const uint64_t& offset,
            const uint64_t& size);

    bool
    SendBufferUnmap(
            const RawId& deviceId,
            const RawId& bufferId,
            const bool& flush);

    bool
    SendBufferDestroy(const RawId& selfId);

    bool
    SendBufferDrop(const RawId& selfId);

    bool
    SendTextureDestroy(const RawId& selfId);

    bool
    SendTextureViewDestroy(const RawId& selfId);

    bool
    SendSamplerDestroy(const RawId& selfId);

    bool
    SendDeviceDestroy(const RawId& selfId);

    bool
    SendCommandEncoderFinish(
            const RawId& selfId,
            const RawId& deviceId,
            const GPUCommandBufferDescriptor& desc);

    bool
    SendCommandEncoderDestroy(const RawId& selfId);

    bool
    SendCommandBufferDestroy(const RawId& selfId);

    bool
    SendRenderBundleDestroy(const RawId& selfId);

    bool
    SendQueueSubmit(
            const RawId& selfId,
            const RawId& aDeviceId,
            mozilla::Span<RawId const> commandBuffers);

    bool
    SendQueueWriteAction(
            const RawId& selfId,
            const RawId& aDeviceId,
            ByteBuf&& buf,
            UnsafeSharedMemoryHandle&& shmem);

    bool
    SendBindGroupLayoutDestroy(const RawId& selfId);

    bool
    SendPipelineLayoutDestroy(const RawId& selfId);

    bool
    SendBindGroupDestroy(const RawId& selfId);

    bool
    SendShaderModuleDestroy(const RawId& selfId);

    bool
    SendComputePipelineDestroy(const RawId& selfId);

    bool
    SendRenderPipelineDestroy(const RawId& selfId);

    bool
    SendImplicitLayoutDestroy(
            const RawId& implicitPlId,
            mozilla::Span<RawId const> implicitBglIds);

    bool
    SendDeviceCreateSwapChain(
            const RawId& selfId,
            const RawId& queueId,
            const RGBDescriptor& desc,
            mozilla::Span<RawId const> bufferIds,
            const RemoteTextureOwnerId& ownerId);

    bool
    SendSwapChainPresent(
            const RawId& textureId,
            const RawId& commandEncoderId,
            const RemoteTextureId& remoteTextureId,
            const RemoteTextureOwnerId& remoteTextureOwnerId);

    bool
    SendSwapChainDestroy(const RemoteTextureOwnerId& ownerId);

    bool
    SendDevicePushErrorScope(const RawId& selfId);

    void
    SendDevicePopErrorScope(
            const RawId& selfId,
            mozilla::ipc::ResolveCallback<MaybeScopedError>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<DevicePopErrorScopePromise>
    SendDevicePopErrorScope(const RawId& selfId);

    bool
    SendGenerateError(
            const RawId& deviceId,
            const nsACString& message);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    void
    ClearSubtree();

    bool mAwaitingManagedEndpointBind = false;

};


} // namespace webgpu
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::webgpu::PWebGPUChild*>
{
    typedef ::mozilla::webgpu::PWebGPUChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PWebGPUChild_h
