// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

pub enum DynamicLabel { }

pub mod background_update {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons_to_not_update
    ///
    /// Records which error was causing the background updater to fail. This list
    /// supercedes the `background-update.reason` in `mozapps/update/metrics.yaml`
    pub static reasons_to_not_update: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(1.into(), CommonMetricData {
            name: "reasons_to_not_update".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.time_last_update_scheduled
    ///
    /// Last time the background update was triggered.
    pub static time_last_update_scheduled: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(2.into(), CommonMetricData {
            name: "time_last_update_scheduled".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.client_id
    ///
    /// The legacy Telemetry client ID of this installation's default profile.
    /// The default profile is as determined by the Profile Service, namely
    /// `nsIToolkitProfileService.defaultProfile`.  The majority of users have only one
    /// Firefox installation and only one profile, so the default profile is their
    /// regular browsing profile.
    /// It is possible for a Firefox installation to not have a default profile, but in
    /// such cases the background update task will abort before sending any telemetry;
    /// therefore, the legacy Telemetry client ID should always be present.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(3.into(), CommonMetricData {
            name: "client_id".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "baseline".into(), "events".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_exception
    ///
    /// True if the exit code/status of the background update task is 3, which means an
    /// exception was thrown.
    pub static exit_code_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(4.into(), CommonMetricData {
            name: "exit_code_exception".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_success
    ///
    /// True if the exit code/status of the background update task is 0, which means
    /// success.
    pub static exit_code_success: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(5.into(), CommonMetricData {
            name: "exit_code_success".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.final_state
    ///
    /// String description of the final state the update state machine reached.
    pub static final_state: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(6.into(), CommonMetricData {
            name: "final_state".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons
    ///
    /// List of reasons that the background update task did not run.
    pub static reasons: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(7.into(), CommonMetricData {
            name: "reasons".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.states
    ///
    /// Ordered list of string descriptions of the states that the update state machine
    /// reached.
    pub static states: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(8.into(), CommonMetricData {
            name: "states".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_current_date
    ///
    /// The `environment.currentDate` of the default profile's serialized targeting
    /// snapshot.
    pub static targeting_env_current_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(9.into(), CommonMetricData {
            name: "targeting_env_current_date".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_firefox_version
    ///
    /// The `environment.firefoxVersion` of the default profile's serialized targeting
    /// snapshot.  At the time of writing, this version is an integer representing the
    /// Firefox major version, e.g., `109`.
    pub static targeting_env_firefox_version: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(10.into(), CommonMetricData {
            name: "targeting_env_firefox_version".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_profile_age
    ///
    /// The `environment.profileAgeCreated` of the default profile's serialized
    /// targeting snapshot.
    pub static targeting_env_profile_age: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(11.into(), CommonMetricData {
            name: "targeting_env_profile_age".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exception
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, but an
    /// exception was thrown reading it.
    pub static targeting_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(12.into(), CommonMetricData {
            name: "targeting_exception".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exists
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, and
    /// there was no exception thrown reading it.
    pub static targeting_exists: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(13.into(), CommonMetricData {
            name: "targeting_exists".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_version
    ///
    /// If the default profile had a targeting snapshot serialized to disk, the
    /// `version` of the snapshot.
    /// This version number does not have a physical unit: it's only useful to compare
    /// between versions.
    pub static targeting_version: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(14.into(), CommonMetricData {
            name: "targeting_version".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod browser_launched_to_handle {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SystemNotificationExtra {
        pub action: Option<String>,
        pub name: Option<String>,
    }

    impl ExtraKeys for SystemNotificationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.name.and_then(|val| map.insert("name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.launched_to_handle.system_notification
    ///
    /// Recorded when Firefox launches to complete a native notification popped by a
    /// system (chrome privileged) alert.  Windows-only at the time of writing.
    pub static system_notification: Lazy<EventMetric<SystemNotificationExtra>> = Lazy::new(|| {
        EventMetric::new(15.into(), CommonMetricData {
            name: "system_notification".into(),
            category: "browser.launched_to_handle".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod messaging_system {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.action
    ///
    /// What type of action resulted in the event. One of "IMPRESSION" or "DISMISS".
    pub static action: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(16.into(), CommonMetricData {
            name: "action".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.addon_version
    ///
    /// Used to hold the system addon's version, now is almost certainly an echo of the
    /// app's build id.
    pub static addon_version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(17.into(), CommonMetricData {
            name: "addon_version".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.browser_session_id
    ///
    /// The Legacy Telemetry browser "session id". Identifies a specific period from
    /// application start to shutdown. See [the "main" ping docs](https://firefox-
    /// source-docs.mozilla.org/toolkit/components/telemetry/data/main-ping.html) for
    /// details.
    pub static browser_session_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(18.into(), CommonMetricData {
            name: "browser_session_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.bucket_id
    ///
    /// A name shared between multiple messages that may individually be too targetted.
    /// e.g. a message that gets shown on specific websites or a message asking about
    /// personal information.
    pub static bucket_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(19.into(), CommonMetricData {
            name: "bucket_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.cfr_action
    ///
    /// The Contextual Feature Recommender's action.
    pub static cfr_action: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(20.into(), CommonMetricData {
            name: "cfr_action".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to policy around specific types of
    /// ping being sent. Value may be the canary client id
    /// `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Present only in some circumstances (see
    /// [bug 1484035]https://bugzilla.mozilla.org/show_bug.cgi?id=1484035)).
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(21.into(), CommonMetricData {
            name: "client_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event
    ///
    /// The type of event. Any user defined string (e.g. “click”, “share”, “delete”,
    /// “more_items”)
    pub static event: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(22.into(), CommonMetricData {
            name: "event".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_context
    ///
    /// The stringified JSON of `event_context`.
    pub static event_context: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(23.into(), CommonMetricData {
            name: "event_context".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_context_parse_error
    ///
    /// How often we failed to parse event_context as JSON.
    pub static event_context_parse_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(24.into(), CommonMetricData {
            name: "event_context_parse_error".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_page
    ///
    /// The event_context's `page`. Almost always "about:welcome".
    pub static event_page: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(25.into(), CommonMetricData {
            name: "event_page".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_reason
    ///
    /// The event_context's `reason`. Likely something like
    /// "welcome-window-closed" or "app-shut-down",.
    pub static event_reason: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(26.into(), CommonMetricData {
            name: "event_reason".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_source
    ///
    /// The event_context's `source`. Likely something like "primary_button".
    pub static event_source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(27.into(), CommonMetricData {
            name: "event_source".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.glean_ping_for_ping_failures
    ///
    /// How often something went awry within
    /// `AboutWelcome.submitGleanPingForPing`, preventing ping submission.
    pub static glean_ping_for_ping_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(28.into(), CommonMetricData {
            name: "glean_ping_for_ping_failures".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.impression_id
    ///
    /// The unique impression identifier for a specific client.
    pub static impression_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(29.into(), CommonMetricData {
            name: "impression_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.invalid_nested_data
    ///
    /// We received a ping with non-scalar data on a field of this name.
    /// If this is existing pre-PingCentre-replacement data, you may need to
    /// augment the logic in
    /// `AboutWelcome.submitGleanPingForPing` like the other `handledKeys`.
    /// If this is for new, post-PingCentre-replacement data, you should
    /// probably prefer a flat structure.
    /// If you're unsure, please ask in
    /// [the #glean channel](https://chat.mozilla.org/#/room/#glean:mozilla.org).
    pub static invalid_nested_data: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(30.into(), CommonMetricData {
            name: "invalid_nested_data".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.locale
    ///
    /// The locale as supplied to the messaging system by
    /// `Services.locale.appLocaleAsBCP47`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(31.into(), CommonMetricData {
            name: "locale".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.message_id
    ///
    /// A string identifier of the message in Activity Stream Router.
    pub static message_id: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(32.into(), CommonMetricData {
            name: "message_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.page
    ///
    /// One of [”about:newtab”, “about:home”, “about:welcome”, “unknown” (which either
    /// means not-applicable or is a bug)].
    pub static page: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(33.into(), CommonMetricData {
            name: "page".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.ping_type
    ///
    /// Type of event the ping is capturing. e.g. "cfr", "whats-new-panel",
    /// "onboarding"
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(34.into(), CommonMetricData {
            name: "ping_type".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.source
    ///
    /// The source of the interaction described by the other metrics. e.g.
    /// "frecent_links", "newtab", "CFR"
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(35.into(), CommonMetricData {
            name: "source".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.unknown_key_count
    ///
    /// The sum of all unknown keys counted.
    /// Useful for testing.
    /// Can be removed after bug 1600008 is resolved.
    pub static unknown_key_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(36.into(), CommonMetricData {
            name: "unknown_key_count".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.unknown_keys
    ///
    /// Ping keys supplied to the messaging system for which
    /// we did not have a corresponding metric mapped to how often they attempted
    /// to be recorded.
    /// You may have forgotten to define an appropriate metric in
    /// `browser/components/newtab/metrics.yaml`.
    pub static unknown_keys: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(37.into(), CommonMetricData {
            name: "unknown_keys".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

}
pub mod messaging_system_attribution {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.campaign
    ///
    /// Attribution's campaign, possibly derived from the utm parameter of the
    /// same name.
    pub static campaign: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(38.into(), CommonMetricData {
            name: "campaign".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.content
    ///
    /// Attribution's content, possibly derived from the utm parameter of the
    /// same name.
    pub static content: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(39.into(), CommonMetricData {
            name: "content".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.dlsource
    ///
    /// Mozilla-specific download "source" name. Could be something like
    /// "mozillaci" to identify that the installer came from
    /// `{archive|ftp}.mozilla.org`.
    pub static dlsource: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(40.into(), CommonMetricData {
            name: "dlsource".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.dltoken
    ///
    /// String representation of the dltoken identifying the particular
    /// installer used to install this Firefox.
    /// Likely a UUID, if present.
    pub static dltoken: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(41.into(), CommonMetricData {
            name: "dltoken".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.experiment
    ///
    /// Attribution's experiment key.
    pub static experiment: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(42.into(), CommonMetricData {
            name: "experiment".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.medium
    ///
    /// Attribution's medium, possibly derived from the utm parameter of the same
    /// name.
    pub static medium: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(43.into(), CommonMetricData {
            name: "medium".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.msstoresignedin
    ///
    /// Either the string "true" or the string "false" to indicate whether the
    /// attributed install came from the Microsoft store and, if so, whether the
    /// user was signed in at the time.
    pub static msstoresignedin: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(44.into(), CommonMetricData {
            name: "msstoresignedin".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.source
    ///
    /// Attribution's source, possibly derived from the utm parameter of the same
    /// name.
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(45.into(), CommonMetricData {
            name: "source".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.ua
    ///
    /// Attribution's ua key.
    pub static ua: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(46.into(), CommonMetricData {
            name: "ua".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.unknown_keys
    ///
    /// Attribution keys supplied to the messaging system for which
    /// we did not have a corresponding metric, and the count of how
    /// often that happened.
    /// Either add this key to a list of known attribution keys in
    /// `AboutWelcomeTelemetry` to suppress or define an appropriate metric in
    /// `browser/components/newtab/metrics.yaml` to collect.
    pub static unknown_keys: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(47.into(), CommonMetricData {
            name: "unknown_keys".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.variation
    ///
    /// Attribution's variation key.
    pub static variation: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(48.into(), CommonMetricData {
            name: "variation".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.blocked_sponsors
    ///
    /// The advertiser names that have been dismissed by the user.
    pub static blocked_sponsors: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(49.into(), CommonMetricData {
            name: "blocked_sponsors".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClosedExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for ClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.closed
    ///
    /// Recorded when newtab UI is closed by * navigation * closing the tab
    /// Doesn't mean that the newtab was ever visible to a user.
    pub static closed: Lazy<EventMetric<ClosedExtra>> = Lazy::new(|| {
        EventMetric::new(50.into(), CommonMetricData {
            name: "closed".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.homepage_category
    ///
    /// The current setting of the home page. One of ["enabled", "disabled",
    /// "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
    /// media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
    /// `home_url_category`. Sampled once after newtab init.
    pub static homepage_category: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(51.into(), CommonMetricData {
            name: "homepage_category".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.locale
    ///
    /// The application's locale as of when newtab's TelemetryFeed was init. Comes from
    /// `Services.local.appLocaleAsBCP47`. Looks like `en-US`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(52.into(), CommonMetricData {
            name: "locale".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.newtab_category
    ///
    /// The current setting of the newtab page. One of ["enabled", "disabled",
    /// "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
    /// media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
    /// `newtab_url_category`. Sampled once after newtab init.
    pub static newtab_category: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(53.into(), CommonMetricData {
            name: "newtab_category".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenedExtra {
        pub newtab_visit_id: Option<String>,
        pub source: Option<String>,
    }

    impl ExtraKeys for OpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.opened
    ///
    /// Recorded when newtab UI is opened via `about:newtab` or `about:home` or
    /// `about:welcome` and has been made visible (see `visibility_event_rcvd_ts` in
    /// [detect-user-session-start.js](https://searchfox.org/mozilla-
    /// central/source/browser/components/newtab/content-src/lib/detect-user-session-
    /// start.js)).
    pub static opened: Lazy<EventMetric<OpenedExtra>> = Lazy::new(|| {
        EventMetric::new(54.into(), CommonMetricData {
            name: "opened".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab_search {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.enabled
    ///
    /// Whether the search input is enabled on the newtab. Corresponds to the value of
    /// the `browser.newtabpage.activity-stream.showSearch` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(55.into(), CommonMetricData {
            name: "enabled".into(),
            category: "newtab.search".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct IssuedExtra {
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for IssuedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.issued
    ///
    /// When Firefox was asked to issue a search from a Search Access Point (SAP) on a
    /// newtab page. Doesn't record searches in Private Browsing Mode unless
    /// `browser.engagement.search_counts.pbm` is set to `true`.
    pub static issued: Lazy<EventMetric<IssuedExtra>> = Lazy::new(|| {
        EventMetric::new(56.into(), CommonMetricData {
            name: "issued".into(),
            category: "newtab.search".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod pocket {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.click
    ///
    /// Recorded when a pocket tile is clicked. Only happens on click. Not on middle-
    /// click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(57.into(), CommonMetricData {
            name: "click".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.enabled
    ///
    /// Whether Pocket is enabled on the newtab. AKA the "Recommended by Pocket"
    /// section. Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.feeds.section.topstories` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(58.into(), CommonMetricData {
            name: "enabled".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.impression
    ///
    /// Recorded when a pocket tile is visible to the user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(59.into(), CommonMetricData {
            name: "impression".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.is_signed_in
    ///
    /// Whether the Firefox user is signed in to Pocket. Does not correspond to a pref,
    /// so its value is resampled at newtab's component init and whenever there is a
    /// Discovery Stream user event.
    pub static is_signed_in: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(60.into(), CommonMetricData {
            name: "is_signed_in".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SaveExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
    }

    impl ExtraKeys for SaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.save
    ///
    /// Recorded when a user decides to save a pocket tile. Does not mean it ends up
    /// successfully saved. Just that the user clicked on "Save to Pocket" in the
    /// little pocket tile menu.
    pub static save: Lazy<EventMetric<SaveExtra>> = Lazy::new(|| {
        EventMetric::new(61.into(), CommonMetricData {
            name: "save".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.sponsored_stories_enabled
    ///
    /// Whether Pocket sponsored stories are enabled on the newtab. Corresponds to the
    /// value of the `browser.newtabpage.activity-stream.showSponsored` pref. Can be
    /// `true` even if pocket.enabled is `false`.
    pub static sponsored_stories_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(62.into(), CommonMetricData {
            name: "sponsored_stories_enabled".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TopicClickExtra {
        pub newtab_visit_id: Option<String>,
        pub topic: Option<String>,
    }

    impl ExtraKeys for TopicClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.topic_click
    ///
    /// Recorded when a pocket "Popular Topic" is clicked. Only happens on click. Not
    /// on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static topic_click: Lazy<EventMetric<TopicClickExtra>> = Lazy::new(|| {
        EventMetric::new(63.into(), CommonMetricData {
            name: "topic_click".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod topsites {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub advertiser_name: Option<String>,
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub tile_id: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.click
    ///
    /// Recorded when a topsite tile is clicked. Only happens on click. Not on middle-
    /// click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(64.into(), CommonMetricData {
            name: "click".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.enabled
    ///
    /// Whether "topsites" is enabled on the newtab. AKA the "Shortcuts" section.
    /// Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.feeds.topsites` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(65.into(), CommonMetricData {
            name: "enabled".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub advertiser_name: Option<String>,
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub tile_id: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.impression
    ///
    /// Recorded when topsite tiles are loaded.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(66.into(), CommonMetricData {
            name: "impression".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.rows
    ///
    /// The number of topsite tile rows configured to be shown on the newtab page.
    /// Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.topSitesRows` pref. This is not the number of rows actually seen by the
    /// user: if the browser window is partially off-screen, or isn't wide enough to
    /// accommodate eight tiles per row, the actual number of rows may be different.
    pub static rows: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(67.into(), CommonMetricData {
            name: "rows".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_enabled
    ///
    /// Whether sponsored topsites are enabled on the newtab. AKA the "Sponsored
    /// Shortcuts" section. Corresponds to the value of the
    /// `browser.newtabpage.activity-stream.showSponsoredTopSites` pref. Can be `true`
    /// even if topsites.enabled is `false`.
    pub static sponsored_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(68.into(), CommonMetricData {
            name: "sponsored_enabled".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab_search_ad {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub is_follow_on: Option<bool>,
        pub is_tagged: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.click
    ///
    /// Recorded when an ad link is clicked on a Search Engine Result Page (SERP) which
    /// was loaded by a seach that began on a newtab page.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(69.into(), CommonMetricData {
            name: "click".into(),
            category: "newtab.search.ad".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub is_follow_on: Option<bool>,
        pub is_tagged: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.impression
    ///
    /// Recorded when a newtab visit resulted in a search that loaded a Search Engine
    /// Result Page (SERP) that contains an ad link. And the SERP is visible.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(70.into(), CommonMetricData {
            name: "impression".into(),
            category: "newtab.search.ad".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod serp {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AbandonmentExtra {
        pub impression_id: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.abandonment
    ///
    /// Recorded when there is no engagement with the SERP before the tab is closed,
    /// the window is closed, the app is closed, or the tab is navigated away from.
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        EventMetric::new(71.into(), CommonMetricData {
            name: "abandonment".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AdImpressionExtra {
        pub ads_hidden: Option<u32>,
        pub ads_loaded: Option<u32>,
        pub ads_visible: Option<u32>,
        pub component: Option<String>,
        pub impression_id: Option<String>,
    }

    impl ExtraKeys for AdImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["ads_hidden", "ads_loaded", "ads_visible", "component", "impression_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.ads_hidden.and_then(|val| map.insert("ads_hidden".into(), val.to_string()));
          self.ads_loaded.and_then(|val| map.insert("ads_loaded".into(), val.to_string()));
          self.ads_visible.and_then(|val| map.insert("ads_visible".into(), val.to_string()));
          self.component.and_then(|val| map.insert("component".into(), val.to_string()));
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.ad_impression
    ///
    /// Recorded when a user loads a SERP and ads are detected.
    pub static ad_impression: Lazy<EventMetric<AdImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(72.into(), CommonMetricData {
            name: "ad_impression".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization_duration
    ///
    /// The time it takes to categorize elements on a SERP.
    pub static categorization_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(73.into(), CommonMetricData {
            name: "categorization_duration".into(),
            category: "serp".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EngagementExtra {
        pub action: Option<String>,
        pub impression_id: Option<String>,
        pub target: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "impression_id", "target"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.target.and_then(|val| map.insert("target".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.engagement
    ///
    /// Recorded user actions on a SERP.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        EventMetric::new(74.into(), CommonMetricData {
            name: "engagement".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub impression_id: Option<String>,
        pub is_shopping_page: Option<bool>,
        pub partner_code: Option<String>,
        pub provider: Option<String>,
        pub shopping_tab_displayed: Option<bool>,
        pub source: Option<String>,
        pub tagged: Option<bool>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "is_shopping_page", "partner_code", "provider", "shopping_tab_displayed", "source", "tagged"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.is_shopping_page.and_then(|val| map.insert("is_shopping_page".into(), val.to_string()));
          self.partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.shopping_tab_displayed.and_then(|val| map.insert("shopping_tab_displayed".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.tagged.and_then(|val| map.insert("tagged".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.impression
    ///
    /// Recorded when a search engine results page (SERP) is shown to a user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(75.into(), CommonMetricData {
            name: "impression".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod translations_panel {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenExtra {
        pub opened_from: Option<String>,
    }

    impl ExtraKeys for OpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened_from"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.opened_from.and_then(|val| map.insert("opened_from".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open
    ///
    /// Triggers when the translations panel is opened.
    pub static open: Lazy<EventMetric<OpenExtra>> = Lazy::new(|| {
        EventMetric::new(76.into(), CommonMetricData {
            name: "open".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod urlbar {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AbandonmentExtra {
        pub groups: Option<String>,
        pub interaction: Option<String>,
        pub n_chars: Option<u32>,
        pub n_results: Option<u32>,
        pub n_words: Option<u32>,
        pub results: Option<String>,
        pub sap: Option<String>,
        pub search_mode: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["groups", "interaction", "n_chars", "n_results", "n_words", "results", "sap", "search_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.abandonment
    ///
    /// Recorded when the user abandons a search (blurring the urlbar).
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        EventMetric::new(77.into(), CommonMetricData {
            name: "abandonment".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: true,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EngagementExtra {
        pub engagement_type: Option<String>,
        pub groups: Option<String>,
        pub interaction: Option<String>,
        pub n_chars: Option<u32>,
        pub n_results: Option<u32>,
        pub n_words: Option<u32>,
        pub provider: Option<String>,
        pub results: Option<String>,
        pub sap: Option<String>,
        pub search_mode: Option<String>,
        pub selected_result: Option<String>,
        pub selected_result_subtype: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["engagement_type", "groups", "interaction", "n_chars", "n_results", "n_words", "provider", "results", "sap", "search_mode", "selected_result", "selected_result_subtype"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.engagement_type.and_then(|val| map.insert("engagement_type".into(), val.to_string()));
          self.groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          self.selected_result.and_then(|val| map.insert("selected_result".into(), val.to_string()));
          self.selected_result_subtype.and_then(|val| map.insert("selected_result_subtype".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.engagement
    ///
    /// Recorded when the user executes an action on a result.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        EventMetric::new(78.into(), CommonMetricData {
            name: "engagement".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: true,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ExposureExtra {
        pub results: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["results"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.exposure
    ///
    /// Recorded when client is exposed to urlbar experiment results.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        EventMetric::new(79.into(), CommonMetricData {
            name: "exposure".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub groups: Option<String>,
        pub interaction: Option<String>,
        pub n_chars: Option<u32>,
        pub n_results: Option<u32>,
        pub n_words: Option<u32>,
        pub reason: Option<String>,
        pub results: Option<String>,
        pub sap: Option<String>,
        pub search_mode: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["groups", "interaction", "n_chars", "n_results", "n_words", "reason", "results", "sap", "search_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.impression
    ///
    /// Recorded when urlbar results are shown to the user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(80.into(), CommonMetricData {
            name: "impression".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: true,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_max_results
    ///
    /// Maximum results to show in the Address Bar. Corresponds to the value of the
    /// `browser.urlbar.maxRichResults` pref.
    pub static pref_max_results: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(81.into(), CommonMetricData {
            name: "pref_max_results".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_topsites
    ///
    /// Whether topsite results are enabled in the urlbar. Corresponds to the value of
    /// the `browser.urlbar.suggest.topsites` pref.
    pub static pref_suggest_topsites: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(82.into(), CommonMetricData {
            name: "pref_suggest_topsites".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod browser_engagement {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.active_ticks
    ///
    /// The number of five-second intervals ('ticks') the user was considered
    /// 'active'.
    /// 
    /// 'active' means keyboard or mouse interaction with the application.
    /// It doesn't take into account whether or not the window has focus or is in
    /// the foreground, only if it is receiving these interaction events.
    /// 
    /// Migrated from Telemetry's `browser.engagement.active_ticks`.
    pub static active_ticks: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(83.into(), CommonMetricData {
            name: "active_ticks".into(),
            category: "browser.engagement".into(),
            send_in_pings: vec!["baseline".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.profile_count
    ///
    /// Windows only count of the browser profiles on the current system. This
    /// counts profiles that have been used across all Windows user accounts on
    /// machine since this probe was added. The value persists across installs.
    /// A value of 0 is reported if there is an error determining the correct
    /// count. Unset on other platforms.
    pub static profile_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(84.into(), CommonMetricData {
            name: "profile_count".into(),
            category: "browser.engagement".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.uri_count
    ///
    /// The number of total non-unique http(s) URIs visited, including page
    /// reloads, after the session has been restored. URIs on minimized or
    /// background tabs may also be counted. Private browsing uris are included.
    /// 
    /// Migrated from Telemetry's
    /// `browser.engagement.total_uri_count_normal_and_private_mode`.
    pub static uri_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(85.into(), CommonMetricData {
            name: "uri_count".into(),
            category: "browser.engagement".into(),
            send_in_pings: vec!["baseline".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod ping_centre {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from ping.centre.send_failures
    ///
    /// The number of PingCentre send failures.
    pub static send_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(86.into(), CommonMetricData {
            name: "send_failures".into(),
            category: "ping.centre".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum SendFailuresByNamespaceLabel {
        ActivityStream = 0,
        MessagingSystem = 1,
        ContextualServices = 2,
        __Other__,
    }
    impl From<u16> for SendFailuresByNamespaceLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ActivityStream,
                1 => Self::MessagingSystem,
                2 => Self::ContextualServices,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SendFailuresByNamespaceLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ActivityStream => "activity_stream",
                Self::MessagingSystem => "messaging_system",
                Self::ContextualServices => "contextual_services",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from ping.centre.send_failures_by_namespace
    ///
    /// The number of PingCentre send failures,
    /// broken down by structured ingestion namespace.
    pub static send_failures_by_namespace: Lazy<LabeledMetric<LabeledCounterMetric, SendFailuresByNamespaceLabel>> = Lazy::new(|| {
        LabeledMetric::new(87.into(), CommonMetricData {
            name: "send_failures_by_namespace".into(),
            category: "ping.centre".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("activity_stream"), ::std::borrow::Cow::from("contextual_services"), ::std::borrow::Cow::from("messaging_system")]))
    });

    #[repr(u16)]
    pub enum SendSuccessesByNamespaceLabel {
        ActivityStream = 0,
        MessagingSystem = 1,
        ContextualServices = 2,
        __Other__,
    }
    impl From<u16> for SendSuccessesByNamespaceLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ActivityStream,
                1 => Self::MessagingSystem,
                2 => Self::ContextualServices,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SendSuccessesByNamespaceLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ActivityStream => "activity_stream",
                Self::MessagingSystem => "messaging_system",
                Self::ContextualServices => "contextual_services",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from ping.centre.send_successes_by_namespace
    ///
    /// The number of PingCentre send successes,
    /// broken down by structured ingestion namespace.
    pub static send_successes_by_namespace: Lazy<LabeledMetric<LabeledCounterMetric, SendSuccessesByNamespaceLabel>> = Lazy::new(|| {
        LabeledMetric::new(88.into(), CommonMetricData {
            name: "send_successes_by_namespace".into(),
            category: "ping.centre".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("activity_stream"), ::std::borrow::Cow::from("contextual_services"), ::std::borrow::Cow::from("messaging_system")]))
    });

}
pub mod gmp {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[repr(u16)]
    pub enum UpdateXmlFetchResultLabel {
        CertPinSuccess = 0,
        CertPinNetRequestError = 1,
        CertPinNetTimeout = 2,
        CertPinAbort = 3,
        CertPinMissingData = 4,
        CertPinFailed = 5,
        CertPinInvalid = 6,
        CertPinXmlParseError = 7,
        CertPinUnknownError = 8,
        ContentSigSuccess = 9,
        ContentSigNetRequestError = 10,
        ContentSigNetTimeout = 11,
        ContentSigAbort = 12,
        ContentSigMissingData = 13,
        ContentSigFailed = 14,
        ContentSigInvalid = 15,
        ContentSigXmlParseError = 16,
        ContentSigUnknownError = 17,
        __Other__,
    }
    impl From<u16> for UpdateXmlFetchResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::CertPinSuccess,
                1 => Self::CertPinNetRequestError,
                2 => Self::CertPinNetTimeout,
                3 => Self::CertPinAbort,
                4 => Self::CertPinMissingData,
                5 => Self::CertPinFailed,
                6 => Self::CertPinInvalid,
                7 => Self::CertPinXmlParseError,
                8 => Self::CertPinUnknownError,
                9 => Self::ContentSigSuccess,
                10 => Self::ContentSigNetRequestError,
                11 => Self::ContentSigNetTimeout,
                12 => Self::ContentSigAbort,
                13 => Self::ContentSigMissingData,
                14 => Self::ContentSigFailed,
                15 => Self::ContentSigInvalid,
                16 => Self::ContentSigXmlParseError,
                17 => Self::ContentSigUnknownError,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UpdateXmlFetchResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::CertPinSuccess => "cert_pin_success",
                Self::CertPinNetRequestError => "cert_pin_net_request_error",
                Self::CertPinNetTimeout => "cert_pin_net_timeout",
                Self::CertPinAbort => "cert_pin_abort",
                Self::CertPinMissingData => "cert_pin_missing_data",
                Self::CertPinFailed => "cert_pin_failed",
                Self::CertPinInvalid => "cert_pin_invalid",
                Self::CertPinXmlParseError => "cert_pin_xml_parse_error",
                Self::CertPinUnknownError => "cert_pin_unknown_error",
                Self::ContentSigSuccess => "content_sig_success",
                Self::ContentSigNetRequestError => "content_sig_net_request_error",
                Self::ContentSigNetTimeout => "content_sig_net_timeout",
                Self::ContentSigAbort => "content_sig_abort",
                Self::ContentSigMissingData => "content_sig_missing_data",
                Self::ContentSigFailed => "content_sig_failed",
                Self::ContentSigInvalid => "content_sig_invalid",
                Self::ContentSigXmlParseError => "content_sig_xml_parse_error",
                Self::ContentSigUnknownError => "content_sig_unknown_error",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gmp.update_xml_fetch_result
    ///
    /// The result of Gecko fetching an update.xml from Balrog. This captures 3
    /// different data points: success or failure of the request, if cert pinning or
    /// content signatures were used to verify the result, and the reason for failure,
    /// if the request failed.
    pub static update_xml_fetch_result: Lazy<LabeledMetric<LabeledCounterMetric, UpdateXmlFetchResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(89.into(), CommonMetricData {
            name: "update_xml_fetch_result".into(),
            category: "gmp".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("cert_pin_abort"), ::std::borrow::Cow::from("cert_pin_failed"), ::std::borrow::Cow::from("cert_pin_invalid"), ::std::borrow::Cow::from("cert_pin_missing_data"), ::std::borrow::Cow::from("cert_pin_net_request_error"), ::std::borrow::Cow::from("cert_pin_net_timeout"), ::std::borrow::Cow::from("cert_pin_success"), ::std::borrow::Cow::from("cert_pin_unknown_error"), ::std::borrow::Cow::from("cert_pin_xml_parse_error"), ::std::borrow::Cow::from("content_sig_abort"), ::std::borrow::Cow::from("content_sig_failed"), ::std::borrow::Cow::from("content_sig_invalid"), ::std::borrow::Cow::from("content_sig_missing_data"), ::std::borrow::Cow::from("content_sig_net_request_error"), ::std::borrow::Cow::from("content_sig_net_timeout"), ::std::borrow::Cow::from("content_sig_success"), ::std::borrow::Cow::from("content_sig_unknown_error"), ::std::borrow::Cow::from("content_sig_xml_parse_error")]))
    });

}
pub mod rtcrtpsender {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count
    ///
    /// The number of RTCRtpSenders created.
    pub static count: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(90.into(), CommonMetricData {
            name: "count".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "used_sendencodings".into(), category: "rtcrtpsender".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_other".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_rid_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_stale_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count_setparameters_compat
    ///
    /// The number of RTCRtpSenders created that use the compatibility mode for
    /// setParameters.
    pub static count_setparameters_compat: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(91.into(), CommonMetricData {
            name: "count_setparameters_compat".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "fail_no_encodings".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_rid_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_stale_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.used_sendencodings
    ///
    /// The proportion of RTCRtpSenders that were created by an addTransceivers call
    /// that was passed a sendEncodings.
    pub static used_sendencodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(92.into(), CommonMetricData {
            name: "used_sendencodings".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod rtcrtpsender_setparameters {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.blame_length_changed
    ///
    /// The number of RTCRtpSenders that have warned at least once about a
    /// `setParameters` call that attempted to change the number of encodings, broken
    /// down by the eTLD+1 of the site. Collected only on EARLY_BETA_OR_EARLIER.
    pub static blame_length_changed: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(93.into(), CommonMetricData {
            name: "blame_length_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.blame_no_getparameters
    ///
    /// The number of RTCRtpSenders that have warned at least once about a
    /// `setParameters` call because `[[LastReturnedParameters]]` was not set, broken
    /// down by the eTLD+1 of the site. (ie; there was not a recent enough call to
    /// `getParameters`) Collected only on EARLY_BETA_OR_EARLIER.
    pub static blame_no_getparameters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(94.into(), CommonMetricData {
            name: "blame_no_getparameters".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.blame_no_transactionid
    ///
    /// The number of RTCRtpSenders that have warned at least once about a
    /// `setParameters` call that did not set the transactionId field, broken down by
    /// the eTLD+1 of the site. Collected only on EARLY_BETA_OR_EARLIER.
    pub static blame_no_transactionid: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(95.into(), CommonMetricData {
            name: "blame_no_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.blame_stale_transactionid
    ///
    /// The number of RTCRtpSenders that have warned at least once about a
    /// `setParameters` call that used a stale transaction id, broken down by the
    /// eTLD+1 of the site. Collected only on EARLY_BETA_OR_EARLIER.
    pub static blame_stale_transactionid: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(96.into(), CommonMetricData {
            name: "blame_stale_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_length_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that attempted to change the number of encodings.
    pub static fail_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(97.into(), CommonMetricData {
            name: "fail_length_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_encodings
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have thrown an error at least once about a setParameters call that had no
    /// encodings (we do not measure this against the general population of
    /// RTCRtpSenders, since without the compat mode this failure is never observed,
    /// because it fails the length change check).
    pub static fail_no_encodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(98.into(), CommonMetricData {
            name: "fail_no_encodings".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_getparameters
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call because [[LastReturnedParameters]] was not set. (ie; there
    /// was not a recent enough call to getParameters)
    pub static fail_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(99.into(), CommonMetricData {
            name: "fail_no_getparameters".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that did not set the transactionId field.
    pub static fail_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(100.into(), CommonMetricData {
            name: "fail_no_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_other
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that had no encodings.
    pub static fail_other: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(101.into(), CommonMetricData {
            name: "fail_other".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_rid_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that attempted to change the rid on an encoding (note that
    /// we only check this if the encoding count did not change, see
    /// fail_length_changed).
    pub static fail_rid_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(102.into(), CommonMetricData {
            name: "fail_rid_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_stale_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that used a stale transaction id.
    pub static fail_stale_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(103.into(), CommonMetricData {
            name: "fail_stale_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_length_changed
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that attempted to
    /// change the number of encodings.
    pub static warn_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(104.into(), CommonMetricData {
            name: "warn_length_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_getparameters
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call because
    /// [[LastReturnedParameters]] was not set.  (ie; there was not a recent enough
    /// call to getParameters)
    pub static warn_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(105.into(), CommonMetricData {
            name: "warn_no_getparameters".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_transactionid
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that did not set the
    /// transactionId field.
    pub static warn_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(106.into(), CommonMetricData {
            name: "warn_no_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_rid_changed
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that attempted to
    /// change the rid on an encoding (note that we only check this if the encoding
    /// count did not change, see warn_length_changed).
    pub static warn_rid_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(107.into(), CommonMetricData {
            name: "warn_rid_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_stale_transactionid
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that used a stale
    /// transaction id.
    pub static warn_stale_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(108.into(), CommonMetricData {
            name: "warn_stale_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod perf {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PageLoadExtra {
        pub dns_lookup_time: Option<u32>,
        pub fcp_time: Option<u32>,
        pub http_ver: Option<u32>,
        pub js_exec_time: Option<u32>,
        pub load_time: Option<u32>,
        pub load_type: Option<String>,
        pub redirect_count: Option<u32>,
        pub redirect_time: Option<u32>,
        pub response_time: Option<u32>,
        pub same_origin_nav: Option<bool>,
        pub trr_domain: Option<String>,
    }

    impl ExtraKeys for PageLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["dns_lookup_time", "fcp_time", "http_ver", "js_exec_time", "load_time", "load_type", "redirect_count", "redirect_time", "response_time", "same_origin_nav", "trr_domain"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.dns_lookup_time.and_then(|val| map.insert("dns_lookup_time".into(), val.to_string()));
          self.fcp_time.and_then(|val| map.insert("fcp_time".into(), val.to_string()));
          self.http_ver.and_then(|val| map.insert("http_ver".into(), val.to_string()));
          self.js_exec_time.and_then(|val| map.insert("js_exec_time".into(), val.to_string()));
          self.load_time.and_then(|val| map.insert("load_time".into(), val.to_string()));
          self.load_type.and_then(|val| map.insert("load_type".into(), val.to_string()));
          self.redirect_count.and_then(|val| map.insert("redirect_count".into(), val.to_string()));
          self.redirect_time.and_then(|val| map.insert("redirect_time".into(), val.to_string()));
          self.response_time.and_then(|val| map.insert("response_time".into(), val.to_string()));
          self.same_origin_nav.and_then(|val| map.insert("same_origin_nav".into(), val.to_string()));
          self.trr_domain.and_then(|val| map.insert("trr_domain".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from perf.page_load
    ///
    /// Recorded when a top level content document has been loaded.
    pub static page_load: Lazy<EventMetric<PageLoadExtra>> = Lazy::new(|| {
        EventMetric::new(109.into(), CommonMetricData {
            name: "page_load".into(),
            category: "perf".into(),
            send_in_pings: vec!["pageload".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod paint {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from paint.build_displaylist_time
    ///
    /// The time to build a Gecko display list.
    pub static build_displaylist_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(110.into(), CommonMetricData {
            name: "build_displaylist_time".into(),
            category: "paint".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

}
pub mod wr {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from wr.framebuild_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static framebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(111.into(), CommonMetricData {
            name: "framebuild_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.gpu_wait_time
    ///
    /// The time spent waiting for the GPU to complete previously issued drawing
    /// commands.
    pub static gpu_wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(112.into(), CommonMetricData {
            name: "gpu_wait_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_blobs_time
    ///
    /// The time to rasterize blobs for consumption by WebRender.
    pub static rasterize_blobs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(113.into(), CommonMetricData {
            name: "rasterize_blobs_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_glyphs_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static rasterize_glyphs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(114.into(), CommonMetricData {
            name: "rasterize_glyphs_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time
    ///
    /// WebRender renderer time.
    pub static renderer_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(115.into(), CommonMetricData {
            name: "renderer_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time_no_sc
    ///
    /// WebRender renderer time excluding frames in which shader compilation took
    /// place.
    pub static renderer_time_no_sc: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(116.into(), CommonMetricData {
            name: "renderer_time_no_sc".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.scenebuild_time
    ///
    /// WebRender scene build time.
    pub static scenebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(117.into(), CommonMetricData {
            name: "scenebuild_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.sceneswap_time
    ///
    /// WebRender scene swap time.
    pub static sceneswap_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(118.into(), CommonMetricData {
            name: "sceneswap_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.texture_cache_update_time
    ///
    /// Time taken by WebRender to update the texture cache.
    pub static texture_cache_update_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(119.into(), CommonMetricData {
            name: "texture_cache_update_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_frame_build
    ///
    /// Time elapsed between the construction of a transaction and the associated frame
    /// build beginning.
    pub static time_to_frame_build: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(120.into(), CommonMetricData {
            name: "time_to_frame_build".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_render_start
    ///
    /// Time elapsed between the construction of a frame and the start of rendering.
    pub static time_to_render_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(121.into(), CommonMetricData {
            name: "time_to_render_start".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

}
pub mod dotprint {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from dotprint.android_dialog_requested
    ///
    /// Opening the Android print dialog was requested via window.print.
    pub static android_dialog_requested: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(122.into(), CommonMetricData {
            name: "android_dialog_requested".into(),
            category: "dotprint".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum FailureLabel {
        NoSettingsService = 0,
        NoSettings = 1,
        NoCanonicalContext = 2,
        NoActivityContextDelegate = 3,
        NoActivityContext = 4,
        IoError = 5,
        Unknown = 6,
        __Other__,
    }
    impl From<u16> for FailureLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::NoSettingsService,
                1 => Self::NoSettings,
                2 => Self::NoCanonicalContext,
                3 => Self::NoActivityContextDelegate,
                4 => Self::NoActivityContext,
                5 => Self::IoError,
                6 => Self::Unknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FailureLabel {
        fn into(self) -> &'static str {
            match self {
                Self::NoSettingsService => "no_settings_service",
                Self::NoSettings => "no_settings",
                Self::NoCanonicalContext => "no_canonical_context",
                Self::NoActivityContextDelegate => "no_activity_context_delegate",
                Self::NoActivityContext => "no_activity_context",
                Self::IoError => "io_error",
                Self::Unknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dotprint.failure
    ///
    /// An error occured while setting up for printing. Default label is 'unknown'.
    pub static failure: Lazy<LabeledMetric<LabeledCounterMetric, FailureLabel>> = Lazy::new(|| {
        LabeledMetric::new(123.into(), CommonMetricData {
            name: "failure".into(),
            category: "dotprint".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("io_error"), ::std::borrow::Cow::from("no_activity_context"), ::std::borrow::Cow::from("no_activity_context_delegate"), ::std::borrow::Cow::from("no_canonical_context"), ::std::borrow::Cow::from("no_settings"), ::std::borrow::Cow::from("no_settings_service"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from dotprint.requested
    ///
    /// How many times window.print was requested.
    pub static requested: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(124.into(), CommonMetricData {
            name: "requested".into(),
            category: "dotprint".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod networking {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_access_fixup_diff
    ///
    /// If we fix up a cookie lastAccessed timestamp that is in the future this metric
    /// records the number of seconds that timestamp was off from NOW.
    pub static cookie_access_fixup_diff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(125.into(), CommonMetricData {
            name: "cookie_access_fixup_diff".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 315360000000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_creation_fixup_diff
    ///
    /// If we fix up a cookie creation timestamp that is in the future this metric
    /// records the number of seconds that timestamp was off from NOW.
    pub static cookie_creation_fixup_diff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(126.into(), CommonMetricData {
            name: "cookie_creation_fixup_diff".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 315360000000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum CookieTimestampFixedCountLabel {
        Creationtime = 0,
        Lastaccessed = 1,
        __Other__,
    }
    impl From<u16> for CookieTimestampFixedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Creationtime,
                1 => Self::Lastaccessed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CookieTimestampFixedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Creationtime => "creationTime",
                Self::Lastaccessed => "lastAccessed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_timestamp_fixed_count
    ///
    /// Counts the number of times a cookie's invalid timestamp was fixed when reading
    /// it from the DB.
    pub static cookie_timestamp_fixed_count: Lazy<LabeledMetric<LabeledCounterMetric, CookieTimestampFixedCountLabel>> = Lazy::new(|| {
        LabeledMetric::new(127.into(), CommonMetricData {
            name: "cookie_timestamp_fixed_count".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("creationTime"), ::std::borrow::Cow::from("lastAccessed")]))
    });

    #[repr(u16)]
    pub enum SpeculativeConnectOutcomeLabel {
        Successful = 0,
        AbortedSocketLimit = 1,
        AbortedSocketFail = 2,
        AbortedHttpsNotEnabled = 3,
        __Other__,
    }
    impl From<u16> for SpeculativeConnectOutcomeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Successful,
                1 => Self::AbortedSocketLimit,
                2 => Self::AbortedSocketFail,
                3 => Self::AbortedHttpsNotEnabled,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SpeculativeConnectOutcomeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Successful => "successful",
                Self::AbortedSocketLimit => "aborted_socket_limit",
                Self::AbortedSocketFail => "aborted_socket_fail",
                Self::AbortedHttpsNotEnabled => "aborted_https_not_enabled",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.speculative_connect_outcome
    ///
    /// Counts the occurrence of each outcome of a speculative connection
    pub static speculative_connect_outcome: Lazy<LabeledMetric<LabeledCounterMetric, SpeculativeConnectOutcomeLabel>> = Lazy::new(|| {
        LabeledMetric::new(128.into(), CommonMetricData {
            name: "speculative_connect_outcome".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("aborted_https_not_enabled"), ::std::borrow::Cow::from("aborted_socket_fail"), ::std::borrow::Cow::from("aborted_socket_limit"), ::std::borrow::Cow::from("successful")]))
    });

}
pub mod netwerk {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[repr(u16)]
    pub enum EarlyHintsLabel {
        Stylesheet = 0,
        Fonts = 1,
        Scripts = 2,
        Fetch = 3,
        Image = 4,
        Other = 5,
        __Other__,
    }
    impl From<u16> for EarlyHintsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Stylesheet,
                1 => Self::Fonts,
                2 => Self::Scripts,
                3 => Self::Fetch,
                4 => Self::Image,
                5 => Self::Other,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EarlyHintsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Stylesheet => "stylesheet",
                Self::Fonts => "fonts",
                Self::Scripts => "scripts",
                Self::Fetch => "fetch",
                Self::Image => "image",
                Self::Other => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.early_hints
    ///
    /// Counts the different type of resources that are sent for early hints.
    pub static early_hints: Lazy<LabeledMetric<LabeledCounterMetric, EarlyHintsLabel>> = Lazy::new(|| {
        LabeledMetric::new(129.into(), CommonMetricData {
            name: "early_hints".into(),
            category: "netwerk".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("fetch"), ::std::borrow::Cow::from("fonts"), ::std::borrow::Cow::from("image"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("scripts"), ::std::borrow::Cow::from("stylesheet")]))
    });

    #[repr(u16)]
    pub enum EhLinkTypeLabel {
        DnsPrefetch = 0,
        Icon = 1,
        Modulepreload = 2,
        Preconnect = 3,
        Prefetch = 4,
        Preload = 5,
        Prerender = 6,
        Stylesheet = 7,
        Other = 8,
        __Other__,
    }
    impl From<u16> for EhLinkTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::DnsPrefetch,
                1 => Self::Icon,
                2 => Self::Modulepreload,
                3 => Self::Preconnect,
                4 => Self::Prefetch,
                5 => Self::Preload,
                6 => Self::Prerender,
                7 => Self::Stylesheet,
                8 => Self::Other,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EhLinkTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::DnsPrefetch => "dns-prefetch",
                Self::Icon => "icon",
                Self::Modulepreload => "modulepreload",
                Self::Preconnect => "preconnect",
                Self::Prefetch => "prefetch",
                Self::Preload => "preload",
                Self::Prerender => "prerender",
                Self::Stylesheet => "stylesheet",
                Self::Other => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.eh_link_type
    ///
    /// Counts different type of link headers that are sent in early hint
    pub static eh_link_type: Lazy<LabeledMetric<LabeledCounterMetric, EhLinkTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(130.into(), CommonMetricData {
            name: "eh_link_type".into(),
            category: "netwerk".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("dns-prefetch"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("modulepreload"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("preconnect"), ::std::borrow::Cow::from("prefetch"), ::std::borrow::Cow::from("preload"), ::std::borrow::Cow::from("prerender"), ::std::borrow::Cow::from("stylesheet")]))
    });

}
pub mod network {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[repr(u16)]
    pub enum CorsAuthorizationHeaderLabel {
        Allowed = 0,
        Disallowed = 1,
        CoveredByWildcard = 2,
        __Other__,
    }
    impl From<u16> for CorsAuthorizationHeaderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Allowed,
                1 => Self::Disallowed,
                2 => Self::CoveredByWildcard,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CorsAuthorizationHeaderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Allowed => "allowed",
                Self::Disallowed => "disallowed",
                Self::CoveredByWildcard => "covered_by_wildcard",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.cors_authorization_header
    ///
    /// Count how many times we see `Authorization` header in `Access-Control-Request-
    /// Headers` header and the possible outcomes.
    pub static cors_authorization_header: Lazy<LabeledMetric<LabeledCounterMetric, CorsAuthorizationHeaderLabel>> = Lazy::new(|| {
        LabeledMetric::new(131.into(), CommonMetricData {
            name: "cors_authorization_header".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("allowed"), ::std::borrow::Cow::from("covered_by_wildcard"), ::std::borrow::Cow::from("disallowed")]))
    });

    #[repr(u16)]
    pub enum DataSizePbPerTypeLabel {
        TextHtml = 0,
        TextCss = 1,
        TextJson = 2,
        TextPlain = 3,
        TextJavascript = 4,
        TextOther = 5,
        Audio = 6,
        Video = 7,
        Multipart = 8,
        Icon = 9,
        Image = 10,
        Ocsp = 11,
        Xpinstall = 12,
        Wasm = 13,
        Pdf = 14,
        OctetStream = 15,
        Proxy = 16,
        Compressed = 17,
        X509 = 18,
        ApplicationOther = 19,
        __Other__,
    }
    impl From<u16> for DataSizePbPerTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::TextHtml,
                1 => Self::TextCss,
                2 => Self::TextJson,
                3 => Self::TextPlain,
                4 => Self::TextJavascript,
                5 => Self::TextOther,
                6 => Self::Audio,
                7 => Self::Video,
                8 => Self::Multipart,
                9 => Self::Icon,
                10 => Self::Image,
                11 => Self::Ocsp,
                12 => Self::Xpinstall,
                13 => Self::Wasm,
                14 => Self::Pdf,
                15 => Self::OctetStream,
                16 => Self::Proxy,
                17 => Self::Compressed,
                18 => Self::X509,
                19 => Self::ApplicationOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DataSizePbPerTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::TextHtml => "text_html",
                Self::TextCss => "text_css",
                Self::TextJson => "text_json",
                Self::TextPlain => "text_plain",
                Self::TextJavascript => "text_javascript",
                Self::TextOther => "text_other",
                Self::Audio => "audio",
                Self::Video => "video",
                Self::Multipart => "multipart",
                Self::Icon => "icon",
                Self::Image => "image",
                Self::Ocsp => "ocsp",
                Self::Xpinstall => "xpinstall",
                Self::Wasm => "wasm",
                Self::Pdf => "pdf",
                Self::OctetStream => "octet_stream",
                Self::Proxy => "proxy",
                Self::Compressed => "compressed",
                Self::X509 => "x509",
                Self::ApplicationOther => "application_other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.data_size_pb_per_type
    ///
    /// Number of KB we transferred keyed by "contentType"
    pub static data_size_pb_per_type: Lazy<LabeledMetric<LabeledCounterMetric, DataSizePbPerTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(132.into(), CommonMetricData {
            name: "data_size_pb_per_type".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("application_other"), ::std::borrow::Cow::from("audio"), ::std::borrow::Cow::from("compressed"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("image"), ::std::borrow::Cow::from("multipart"), ::std::borrow::Cow::from("ocsp"), ::std::borrow::Cow::from("octet_stream"), ::std::borrow::Cow::from("pdf"), ::std::borrow::Cow::from("proxy"), ::std::borrow::Cow::from("text_css"), ::std::borrow::Cow::from("text_html"), ::std::borrow::Cow::from("text_javascript"), ::std::borrow::Cow::from("text_json"), ::std::borrow::Cow::from("text_other"), ::std::borrow::Cow::from("text_plain"), ::std::borrow::Cow::from("video"), ::std::borrow::Cow::from("wasm"), ::std::borrow::Cow::from("x509"), ::std::borrow::Cow::from("xpinstall")]))
    });

    #[repr(u16)]
    pub enum DataSizePerTypeLabel {
        TextHtml = 0,
        TextCss = 1,
        TextJson = 2,
        TextPlain = 3,
        TextJavascript = 4,
        TextOther = 5,
        Audio = 6,
        Video = 7,
        Multipart = 8,
        Icon = 9,
        Image = 10,
        Ocsp = 11,
        Xpinstall = 12,
        Wasm = 13,
        Pdf = 14,
        OctetStream = 15,
        Proxy = 16,
        Compressed = 17,
        X509 = 18,
        ApplicationOther = 19,
        __Other__,
    }
    impl From<u16> for DataSizePerTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::TextHtml,
                1 => Self::TextCss,
                2 => Self::TextJson,
                3 => Self::TextPlain,
                4 => Self::TextJavascript,
                5 => Self::TextOther,
                6 => Self::Audio,
                7 => Self::Video,
                8 => Self::Multipart,
                9 => Self::Icon,
                10 => Self::Image,
                11 => Self::Ocsp,
                12 => Self::Xpinstall,
                13 => Self::Wasm,
                14 => Self::Pdf,
                15 => Self::OctetStream,
                16 => Self::Proxy,
                17 => Self::Compressed,
                18 => Self::X509,
                19 => Self::ApplicationOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DataSizePerTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::TextHtml => "text_html",
                Self::TextCss => "text_css",
                Self::TextJson => "text_json",
                Self::TextPlain => "text_plain",
                Self::TextJavascript => "text_javascript",
                Self::TextOther => "text_other",
                Self::Audio => "audio",
                Self::Video => "video",
                Self::Multipart => "multipart",
                Self::Icon => "icon",
                Self::Image => "image",
                Self::Ocsp => "ocsp",
                Self::Xpinstall => "xpinstall",
                Self::Wasm => "wasm",
                Self::Pdf => "pdf",
                Self::OctetStream => "octet_stream",
                Self::Proxy => "proxy",
                Self::Compressed => "compressed",
                Self::X509 => "x509",
                Self::ApplicationOther => "application_other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.data_size_per_type
    ///
    /// Number of KB we transferred keyed by "contentType"
    pub static data_size_per_type: Lazy<LabeledMetric<LabeledCounterMetric, DataSizePerTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(133.into(), CommonMetricData {
            name: "data_size_per_type".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("application_other"), ::std::borrow::Cow::from("audio"), ::std::borrow::Cow::from("compressed"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("image"), ::std::borrow::Cow::from("multipart"), ::std::borrow::Cow::from("ocsp"), ::std::borrow::Cow::from("octet_stream"), ::std::borrow::Cow::from("pdf"), ::std::borrow::Cow::from("proxy"), ::std::borrow::Cow::from("text_css"), ::std::borrow::Cow::from("text_html"), ::std::borrow::Cow::from("text_javascript"), ::std::borrow::Cow::from("text_json"), ::std::borrow::Cow::from("text_other"), ::std::borrow::Cow::from("text_plain"), ::std::borrow::Cow::from("video"), ::std::borrow::Cow::from("wasm"), ::std::borrow::Cow::from("x509"), ::std::borrow::Cow::from("xpinstall")]))
    });

}
pub mod background_tasks_rmdir_base {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(134.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(135.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(136.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(137.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(138.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(139.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(140.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(141.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod background_tasks_rmdir_http_cache {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(142.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(143.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(144.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(145.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(146.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(147.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(148.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(149.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod background_tasks_rmdir_quota {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(150.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(151.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(152.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(153.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(154.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(155.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(156.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(157.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod cookie_banners {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[repr(u16)]
    pub enum NormalWindowServiceModeLabel {
        Disabled = 0,
        Reject = 1,
        RejectOrAccept = 2,
        Invalid = 3,
        __Other__,
    }
    impl From<u16> for NormalWindowServiceModeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Disabled,
                1 => Self::Reject,
                2 => Self::RejectOrAccept,
                3 => Self::Invalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NormalWindowServiceModeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Disabled => "disabled",
                Self::Reject => "reject",
                Self::RejectOrAccept => "reject_or_accept",
                Self::Invalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.normal_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for normal windows.
    pub static normal_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric, NormalWindowServiceModeLabel>> = Lazy::new(|| {
        LabeledMetric::new(158.into(), CommonMetricData {
            name: "normal_window_service_mode".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[repr(u16)]
    pub enum PrivateWindowServiceModeLabel {
        Disabled = 0,
        Reject = 1,
        RejectOrAccept = 2,
        Invalid = 3,
        __Other__,
    }
    impl From<u16> for PrivateWindowServiceModeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Disabled,
                1 => Self::Reject,
                2 => Self::RejectOrAccept,
                3 => Self::Invalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PrivateWindowServiceModeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Disabled => "disabled",
                Self::Reject => "reject",
                Self::RejectOrAccept => "reject_or_accept",
                Self::Invalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.private_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for private windows.
    pub static private_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric, PrivateWindowServiceModeLabel>> = Lazy::new(|| {
        LabeledMetric::new(159.into(), CommonMetricData {
            name: "private_window_service_mode".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ReloadExtra {
        pub has_click_rule: Option<bool>,
        pub has_cookie_rule: Option<bool>,
        pub no_rule: Option<bool>,
    }

    impl ExtraKeys for ReloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_click_rule", "has_cookie_rule", "no_rule"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.has_click_rule.and_then(|val| map.insert("has_click_rule".into(), val.to_string()));
          self.has_cookie_rule.and_then(|val| map.insert("has_cookie_rule".into(), val.to_string()));
          self.no_rule.and_then(|val| map.insert("no_rule".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.reload
    ///
    /// Recorded when the top-level page is reloaded. We use this event metric to know
    /// whether or not the reloading domain has cookie banner rule.
    pub static reload: Lazy<EventMetric<ReloadExtra>> = Lazy::new(|| {
        EventMetric::new(160.into(), CommonMetricData {
            name: "reload".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum RuleLookupByDomainLabel {
        TopHit = 0,
        TopHitOptIn = 1,
        TopHitOptOut = 2,
        TopMiss = 3,
        IframeHit = 4,
        IframeHitOptIn = 5,
        IframeHitOptOut = 6,
        IframeMiss = 7,
        TopCookieHit = 8,
        TopCookieHitOptIn = 9,
        TopCookieHitOptOut = 10,
        TopCookieMiss = 11,
        IframeCookieHit = 12,
        IframeCookieHitOptIn = 13,
        IframeCookieHitOptOut = 14,
        IframeCookieMiss = 15,
        TopClickHit = 16,
        TopClickHitOptIn = 17,
        TopClickHitOptOut = 18,
        TopClickMiss = 19,
        IframeClickHit = 20,
        IframeClickHitOptIn = 21,
        IframeClickHitOptOut = 22,
        IframeClickMiss = 23,
        __Other__,
    }
    impl From<u16> for RuleLookupByDomainLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::TopHit,
                1 => Self::TopHitOptIn,
                2 => Self::TopHitOptOut,
                3 => Self::TopMiss,
                4 => Self::IframeHit,
                5 => Self::IframeHitOptIn,
                6 => Self::IframeHitOptOut,
                7 => Self::IframeMiss,
                8 => Self::TopCookieHit,
                9 => Self::TopCookieHitOptIn,
                10 => Self::TopCookieHitOptOut,
                11 => Self::TopCookieMiss,
                12 => Self::IframeCookieHit,
                13 => Self::IframeCookieHitOptIn,
                14 => Self::IframeCookieHitOptOut,
                15 => Self::IframeCookieMiss,
                16 => Self::TopClickHit,
                17 => Self::TopClickHitOptIn,
                18 => Self::TopClickHitOptOut,
                19 => Self::TopClickMiss,
                20 => Self::IframeClickHit,
                21 => Self::IframeClickHitOptIn,
                22 => Self::IframeClickHitOptOut,
                23 => Self::IframeClickMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RuleLookupByDomainLabel {
        fn into(self) -> &'static str {
            match self {
                Self::TopHit => "top_hit",
                Self::TopHitOptIn => "top_hit_opt_in",
                Self::TopHitOptOut => "top_hit_opt_out",
                Self::TopMiss => "top_miss",
                Self::IframeHit => "iframe_hit",
                Self::IframeHitOptIn => "iframe_hit_opt_in",
                Self::IframeHitOptOut => "iframe_hit_opt_out",
                Self::IframeMiss => "iframe_miss",
                Self::TopCookieHit => "top_cookie_hit",
                Self::TopCookieHitOptIn => "top_cookie_hit_opt_in",
                Self::TopCookieHitOptOut => "top_cookie_hit_opt_out",
                Self::TopCookieMiss => "top_cookie_miss",
                Self::IframeCookieHit => "iframe_cookie_hit",
                Self::IframeCookieHitOptIn => "iframe_cookie_hit_opt_in",
                Self::IframeCookieHitOptOut => "iframe_cookie_hit_opt_out",
                Self::IframeCookieMiss => "iframe_cookie_miss",
                Self::TopClickHit => "top_click_hit",
                Self::TopClickHitOptIn => "top_click_hit_opt_in",
                Self::TopClickHitOptOut => "top_click_hit_opt_out",
                Self::TopClickMiss => "top_click_miss",
                Self::IframeClickHit => "iframe_click_hit",
                Self::IframeClickHitOptIn => "iframe_click_hit_opt_in",
                Self::IframeClickHitOptOut => "iframe_click_hit_opt_out",
                Self::IframeClickMiss => "iframe_click_miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.rule_lookup_by_domain
    ///
    /// Counts the number of hit/miss of cookie banner rule lookups for domain. We
    /// collect three types of counters, including counters for overall rule lookup,
    /// counters for cookie rule lookup and counters for click rule lookup. We also
    /// divide the counter by top-level loads and iframe loads. For each domain, we
    /// will only collect once.
    pub static rule_lookup_by_domain: Lazy<LabeledMetric<LabeledCounterMetric, RuleLookupByDomainLabel>> = Lazy::new(|| {
        LabeledMetric::new(161.into(), CommonMetricData {
            name: "rule_lookup_by_domain".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("iframe_click_hit"), ::std::borrow::Cow::from("iframe_click_hit_opt_in"), ::std::borrow::Cow::from("iframe_click_hit_opt_out"), ::std::borrow::Cow::from("iframe_click_miss"), ::std::borrow::Cow::from("iframe_cookie_hit"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_in"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_out"), ::std::borrow::Cow::from("iframe_cookie_miss"), ::std::borrow::Cow::from("iframe_hit"), ::std::borrow::Cow::from("iframe_hit_opt_in"), ::std::borrow::Cow::from("iframe_hit_opt_out"), ::std::borrow::Cow::from("iframe_miss"), ::std::borrow::Cow::from("top_click_hit"), ::std::borrow::Cow::from("top_click_hit_opt_in"), ::std::borrow::Cow::from("top_click_hit_opt_out"), ::std::borrow::Cow::from("top_click_miss"), ::std::borrow::Cow::from("top_cookie_hit"), ::std::borrow::Cow::from("top_cookie_hit_opt_in"), ::std::borrow::Cow::from("top_cookie_hit_opt_out"), ::std::borrow::Cow::from("top_cookie_miss"), ::std::borrow::Cow::from("top_hit"), ::std::borrow::Cow::from("top_hit_opt_in"), ::std::borrow::Cow::from("top_hit_opt_out"), ::std::borrow::Cow::from("top_miss")]))
    });

    #[repr(u16)]
    pub enum RuleLookupByLoadLabel {
        TopHit = 0,
        TopHitOptIn = 1,
        TopHitOptOut = 2,
        TopMiss = 3,
        IframeHit = 4,
        IframeHitOptIn = 5,
        IframeHitOptOut = 6,
        IframeMiss = 7,
        TopCookieHit = 8,
        TopCookieHitOptIn = 9,
        TopCookieHitOptOut = 10,
        TopCookieMiss = 11,
        IframeCookieHit = 12,
        IframeCookieHitOptIn = 13,
        IframeCookieHitOptOut = 14,
        IframeCookieMiss = 15,
        TopClickHit = 16,
        TopClickHitOptIn = 17,
        TopClickHitOptOut = 18,
        TopClickMiss = 19,
        IframeClickHit = 20,
        IframeClickHitOptIn = 21,
        IframeClickHitOptOut = 22,
        IframeClickMiss = 23,
        __Other__,
    }
    impl From<u16> for RuleLookupByLoadLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::TopHit,
                1 => Self::TopHitOptIn,
                2 => Self::TopHitOptOut,
                3 => Self::TopMiss,
                4 => Self::IframeHit,
                5 => Self::IframeHitOptIn,
                6 => Self::IframeHitOptOut,
                7 => Self::IframeMiss,
                8 => Self::TopCookieHit,
                9 => Self::TopCookieHitOptIn,
                10 => Self::TopCookieHitOptOut,
                11 => Self::TopCookieMiss,
                12 => Self::IframeCookieHit,
                13 => Self::IframeCookieHitOptIn,
                14 => Self::IframeCookieHitOptOut,
                15 => Self::IframeCookieMiss,
                16 => Self::TopClickHit,
                17 => Self::TopClickHitOptIn,
                18 => Self::TopClickHitOptOut,
                19 => Self::TopClickMiss,
                20 => Self::IframeClickHit,
                21 => Self::IframeClickHitOptIn,
                22 => Self::IframeClickHitOptOut,
                23 => Self::IframeClickMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RuleLookupByLoadLabel {
        fn into(self) -> &'static str {
            match self {
                Self::TopHit => "top_hit",
                Self::TopHitOptIn => "top_hit_opt_in",
                Self::TopHitOptOut => "top_hit_opt_out",
                Self::TopMiss => "top_miss",
                Self::IframeHit => "iframe_hit",
                Self::IframeHitOptIn => "iframe_hit_opt_in",
                Self::IframeHitOptOut => "iframe_hit_opt_out",
                Self::IframeMiss => "iframe_miss",
                Self::TopCookieHit => "top_cookie_hit",
                Self::TopCookieHitOptIn => "top_cookie_hit_opt_in",
                Self::TopCookieHitOptOut => "top_cookie_hit_opt_out",
                Self::TopCookieMiss => "top_cookie_miss",
                Self::IframeCookieHit => "iframe_cookie_hit",
                Self::IframeCookieHitOptIn => "iframe_cookie_hit_opt_in",
                Self::IframeCookieHitOptOut => "iframe_cookie_hit_opt_out",
                Self::IframeCookieMiss => "iframe_cookie_miss",
                Self::TopClickHit => "top_click_hit",
                Self::TopClickHitOptIn => "top_click_hit_opt_in",
                Self::TopClickHitOptOut => "top_click_hit_opt_out",
                Self::TopClickMiss => "top_click_miss",
                Self::IframeClickHit => "iframe_click_hit",
                Self::IframeClickHitOptIn => "iframe_click_hit_opt_in",
                Self::IframeClickHitOptOut => "iframe_click_hit_opt_out",
                Self::IframeClickMiss => "iframe_click_miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.rule_lookup_by_load
    ///
    /// Counts the number of hit/miss of cookie banner rule lookups for every load. We
    /// collect three types of counters, including counters for overall rule lookup,
    /// counters for cookie rule lookup and counters for click rule lookup. We also
    /// divide the counter by top-level loads and iframe loads.
    pub static rule_lookup_by_load: Lazy<LabeledMetric<LabeledCounterMetric, RuleLookupByLoadLabel>> = Lazy::new(|| {
        LabeledMetric::new(162.into(), CommonMetricData {
            name: "rule_lookup_by_load".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("iframe_click_hit"), ::std::borrow::Cow::from("iframe_click_hit_opt_in"), ::std::borrow::Cow::from("iframe_click_hit_opt_out"), ::std::borrow::Cow::from("iframe_click_miss"), ::std::borrow::Cow::from("iframe_cookie_hit"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_in"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_out"), ::std::borrow::Cow::from("iframe_cookie_miss"), ::std::borrow::Cow::from("iframe_hit"), ::std::borrow::Cow::from("iframe_hit_opt_in"), ::std::borrow::Cow::from("iframe_hit_opt_out"), ::std::borrow::Cow::from("iframe_miss"), ::std::borrow::Cow::from("top_click_hit"), ::std::borrow::Cow::from("top_click_hit_opt_in"), ::std::borrow::Cow::from("top_click_hit_opt_out"), ::std::borrow::Cow::from("top_click_miss"), ::std::borrow::Cow::from("top_cookie_hit"), ::std::borrow::Cow::from("top_cookie_hit_opt_in"), ::std::borrow::Cow::from("top_cookie_hit_opt_out"), ::std::borrow::Cow::from("top_cookie_miss"), ::std::borrow::Cow::from("top_hit"), ::std::borrow::Cow::from("top_hit_opt_in"), ::std::borrow::Cow::from("top_hit_opt_out"), ::std::borrow::Cow::from("top_miss")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.service_detect_only
    ///
    /// Tracks the value of the cookiebanners.service.detectOnly pref.
    pub static service_detect_only: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(163.into(), CommonMetricData {
            name: "service_detect_only".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod cookie_banners_click {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.handle_duration
    ///
    /// Counts how long it takes to handle cookie banners successfully from
    /// DOMContentLoaded until click.
    pub static handle_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(164.into(), CommonMetricData {
            name: "handle_duration".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum ResultLabel {
        Success = 0,
        SuccessCookieInjected = 1,
        SuccessDomContentLoaded = 2,
        SuccessMutationPreLoad = 3,
        SuccessMutationPostLoad = 4,
        Fail = 5,
        FailBannerNotFound = 6,
        FailBannerNotVisible = 7,
        FailButtonNotFound = 8,
        FailNoRuleForMode = 9,
        FailActorDestroyed = 10,
        __Other__,
    }
    impl From<u16> for ResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Success,
                1 => Self::SuccessCookieInjected,
                2 => Self::SuccessDomContentLoaded,
                3 => Self::SuccessMutationPreLoad,
                4 => Self::SuccessMutationPostLoad,
                5 => Self::Fail,
                6 => Self::FailBannerNotFound,
                7 => Self::FailBannerNotVisible,
                8 => Self::FailButtonNotFound,
                9 => Self::FailNoRuleForMode,
                10 => Self::FailActorDestroyed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Success => "success",
                Self::SuccessCookieInjected => "success_cookie_injected",
                Self::SuccessDomContentLoaded => "success_dom_content_loaded",
                Self::SuccessMutationPreLoad => "success_mutation_pre_load",
                Self::SuccessMutationPostLoad => "success_mutation_post_load",
                Self::Fail => "fail",
                Self::FailBannerNotFound => "fail_banner_not_found",
                Self::FailBannerNotVisible => "fail_banner_not_visible",
                Self::FailButtonNotFound => "fail_button_not_found",
                Self::FailNoRuleForMode => "fail_no_rule_for_mode",
                Self::FailActorDestroyed => "fail_actor_destroyed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.result
    ///
    /// Given a matching cookie banner rule, how often do we handle or fail to handle
    /// cookie banners, labelled by reason. The 'success' and 'fail' counters count the
    /// total numbers independently of the reason counters. Counters are incremented
    /// after the content window has been destroyed. This metric additionally reports
    /// cookie injections after which we didn't see a banner as
    /// "success_cookie_injected".
    pub static result: Lazy<LabeledMetric<LabeledCounterMetric, ResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(165.into(), CommonMetricData {
            name: "result".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("fail"), ::std::borrow::Cow::from("fail_actor_destroyed"), ::std::borrow::Cow::from("fail_banner_not_found"), ::std::borrow::Cow::from("fail_banner_not_visible"), ::std::borrow::Cow::from("fail_button_not_found"), ::std::borrow::Cow::from("fail_no_rule_for_mode"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("success_cookie_injected"), ::std::borrow::Cow::from("success_dom_content_loaded"), ::std::borrow::Cow::from("success_mutation_post_load"), ::std::borrow::Cow::from("success_mutation_pre_load")]))
    });

}
pub mod crash {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from crash.process_type
    ///
    /// The type of process that experienced a crash. See the full list of options
    /// [here](https://firefox-source-
    /// docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-
    /// types).
    pub static process_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(166.into(), CommonMetricData {
            name: "process_type".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.startup
    ///
    /// If true, the crash occurred during process startup.
    pub static startup: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(167.into(), CommonMetricData {
            name: "startup".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.time
    ///
    /// The time at which the crash occurred.
    pub static time: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(168.into(), CommonMetricData {
            name: "time".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Minute)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.uptime
    ///
    /// The application uptime. This is equivalent to the legacy crash ping's
    /// `UptimeTS` field.
    pub static uptime: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(169.into(), CommonMetricData {
            name: "uptime".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod extensions {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_load_time
    ///
    /// Time to load and deserialize the extensions startupCache data.
    pub static startup_cache_load_time: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(170.into(), CommonMetricData {
            name: "startup_cache_load_time".into(),
            category: "extensions".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod extensions_apis_dnr {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.evaluate_rules_count_max
    ///
    /// Max amount of DNR rules being evaluated.
    pub static evaluate_rules_count_max: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(171.into(), CommonMetricData {
            name: "evaluate_rules_count_max".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.evaluate_rules_time
    ///
    /// Amount of time it takes to evaluate DNR rules for one network request.
    pub static evaluate_rules_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(172.into(), CommonMetricData {
            name: "evaluate_rules_time".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum StartupCacheEntriesLabel {
        Hit = 0,
        Miss = 1,
        __Other__,
    }
    impl From<u16> for StartupCacheEntriesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Hit,
                1 => Self::Miss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StartupCacheEntriesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Hit => "hit",
                Self::Miss => "miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_entries
    ///
    /// Counters for startup cache data hits or misses on initializating
    /// DNR rules for extensions loaded on application startup.
    pub static startup_cache_entries: Lazy<LabeledMetric<LabeledCounterMetric, StartupCacheEntriesLabel>> = Lazy::new(|| {
        LabeledMetric::new(173.into(), CommonMetricData {
            name: "startup_cache_entries".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("hit"), ::std::borrow::Cow::from("miss")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_read_size
    ///
    /// Amount of data read from the DNR startup cache file.
    pub static startup_cache_read_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(174.into(), CommonMetricData {
            name: "startup_cache_read_size".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_read_time
    ///
    /// Amount of time it takes to read data into the DNR startup cache file.
    pub static startup_cache_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(175.into(), CommonMetricData {
            name: "startup_cache_read_time".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_write_size
    ///
    /// Amount of data written to the DNR startup cache file.
    pub static startup_cache_write_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(176.into(), CommonMetricData {
            name: "startup_cache_write_size".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_write_time
    ///
    /// Amount of time it takes to write data into the DNR startup cache file.
    pub static startup_cache_write_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(177.into(), CommonMetricData {
            name: "startup_cache_write_time".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.validate_rules_time
    ///
    /// Amount of time it takes to validate DNR rules of individual ruleset
    /// when dynamic or static rulesets have been loaded from disk.
    pub static validate_rules_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(178.into(), CommonMetricData {
            name: "validate_rules_time".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod fog {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from fog.failed_idle_registration
    ///
    /// True if we failed to register with the idle service. Absent otherwise.
    /// Means IPC probably isn't working well.
    /// Child-process data will likely be absent, or incomplete.
    pub static failed_idle_registration: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(179.into(), CommonMetricData {
            name: "failed_idle_registration".into(),
            category: "fog".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.initialization
    ///
    /// Time the FOG initialization takes.
    pub static initialization: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(180.into(), CommonMetricData {
            name: "initialization".into(),
            category: "fog".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

}
pub mod fog_ipc {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.buffer_sizes
    ///
    /// The number and size of the IPC buffers being received over FOG IPC.
    pub static buffer_sizes: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(181.into(), CommonMetricData {
            name: "buffer_sizes".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_durations
    ///
    /// The length of time between asking the child processes for their
    /// IPC buffers and all of them being received by the parent.
    pub static flush_durations: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(182.into(), CommonMetricData {
            name: "flush_durations".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_failures
    ///
    /// The number of times we failed to flush all non-parent-process data,
    /// throwing even partial results into the trash.
    /// If this number is high, we might consider writing custom `MozPromise`-
    /// handling code instead of using `MozPromise::All`.
    pub static flush_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(183.into(), CommonMetricData {
            name: "flush_failures".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.replay_failures
    ///
    /// The number of times the ipc buffer failed to be replayed in the
    /// parent process.
    pub static replay_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(184.into(), CommonMetricData {
            name: "replay_failures".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.shutdown_registration_failures
    ///
    /// The number of times we tried to register shutdown flush routines for
    /// content child processes, and failed (probably because there was no main
    /// thread).
    /// As a result there may be data loss from content child processes.
    /// Large or rising number of clients experiencing this indicates we should
    /// perhaps refactor content child shutdown in FOG to try harder to register
    /// flush operations.
    /// Will likely be obsoleted by bug 1641989.
    pub static shutdown_registration_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(185.into(), CommonMetricData {
            name: "shutdown_registration_failures".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod test_only {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.bad_code
    ///
    /// Number of times we encountered bad code.
    /// This is a test-only metric.
    pub static bad_code: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(186.into(), CommonMetricData {
            name: "bad_code".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_flag_it
    ///
    /// Test metric for a boolean.
    /// This is a test-only metric.
    pub static can_we_flag_it: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(187.into(), CommonMetricData {
            name: "can_we_flag_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_time_it
    ///
    /// Test metric for a timespan.
    /// This is a test-only metric.
    pub static can_we_time_it: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(188.into(), CommonMetricData {
            name: "can_we_time_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string
    ///
    /// Only the cheesiest of strings.
    /// This is a test-only metric.
    pub static cheesy_string: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(189.into(), CommonMetricData {
            name: "cheesy_string".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string_list
    ///
    /// Only the cheesiest of strings. In list form!
    /// This is a test-only metric.
    pub static cheesy_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(190.into(), CommonMetricData {
            name: "cheesy_string_list".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.do_you_remember
    ///
    /// They say it's the second thing to go.
    /// This is a test-only metric.
    pub static do_you_remember: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(191.into(), CommonMetricData {
            name: "do_you_remember".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Megabyte)
    });

    #[repr(u16)]
    pub enum MabelsBalloonLabelsLabel {
        Celebratory = 0,
        CelebratoryAndSnarky = 1,
        __Other__,
    }
    impl From<u16> for MabelsBalloonLabelsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Celebratory,
                1 => Self::CelebratoryAndSnarky,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsBalloonLabelsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Celebratory => "celebratory",
                Self::CelebratoryAndSnarky => "celebratory_and_snarky",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_labels
    ///
    /// How does Mabel label her balloons?
    /// This is a test-only metric.
    pub static mabels_balloon_labels: Lazy<LabeledMetric<LabeledStringMetric, MabelsBalloonLabelsLabel>> = Lazy::new(|| {
        LabeledMetric::new(192.into(), CommonMetricData {
            name: "mabels_balloon_labels".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("celebratory"), ::std::borrow::Cow::from("celebratory_and_snarky")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_strings
    ///
    /// What do the labeled Mabel's liked balloons' strings say?
    /// This is a test-only metric.
    pub static mabels_balloon_strings: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(193.into(), CommonMetricData {
            name: "mabels_balloon_strings".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_bathroom_counters
    ///
    /// Counts Mabels labeled by their bathroom counters.
    /// This is a test-only metric.
    pub static mabels_bathroom_counters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(194.into(), CommonMetricData {
            name: "mabels_bathroom_counters".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_kitchen_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// This is a test-only metric.
    pub static mabels_kitchen_counters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(195.into(), CommonMetricData {
            name: "mabels_kitchen_counters".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_label_maker
    ///
    /// Mabel just got a label maker and wants to party like it's
    /// 1999.
    /// This is a test-only metric.
    pub static mabels_label_maker: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(196.into(), CommonMetricData {
            name: "mabels_label_maker".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[repr(u16)]
    pub enum MabelsLabeledCountersLabel {
        NextToTheFridge = 0,
        Clean = 1,
        __Other__,
    }
    impl From<u16> for MabelsLabeledCountersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::NextToTheFridge,
                1 => Self::Clean,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsLabeledCountersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::NextToTheFridge => "next_to_the_fridge",
                Self::Clean => "clean",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_labeled_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// Now with static labels.
    /// This is a test-only metric.
    pub static mabels_labeled_counters: Lazy<LabeledMetric<LabeledCounterMetric, MabelsLabeledCountersLabel>> = Lazy::new(|| {
        LabeledMetric::new(197.into(), CommonMetricData {
            name: "mabels_labeled_counters".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("clean"), ::std::borrow::Cow::from("next_to_the_fridge")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_balloons: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(198.into(), CommonMetricData {
            name: "mabels_like_balloons".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[repr(u16)]
    pub enum MabelsLikeLabeledBalloonsLabel {
        Water = 0,
        BirthdayParty = 1,
        __Other__,
    }
    impl From<u16> for MabelsLikeLabeledBalloonsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Water,
                1 => Self::BirthdayParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsLikeLabeledBalloonsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Water => "water",
                Self::BirthdayParty => "birthday_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_labeled_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_labeled_balloons: Lazy<LabeledMetric<LabeledBooleanMetric, MabelsLikeLabeledBalloonsLabel>> = Lazy::new(|| {
        LabeledMetric::new(199.into(), CommonMetricData {
            name: "mabels_like_labeled_balloons".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("birthday_party"), ::std::borrow::Cow::from("water")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.meaning_of_life
    ///
    /// Measures the one true answer to the Ultimate Question of Life,
    /// the Universe, and Everything.
    /// Approximately.
    /// This is a test-only metric.
    pub static meaning_of_life: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(200.into(), CommonMetricData {
            name: "meaning_of_life".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(201.into(), CommonMetricData {
            name: "mirror_time".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time_nanos
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time_nanos: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(202.into(), CommonMetricData {
            name: "mirror_time_nanos".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirrors_for_labeled_bools
    ///
    /// Mirrored metric.
    /// This is a test-only metric.
    pub static mirrors_for_labeled_bools: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(203.into(), CommonMetricData {
            name: "mirrors_for_labeled_bools".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.one_ping_one_bool
    ///
    /// One bool for one ping only.
    /// This is a test-only metric.
    pub static one_ping_one_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(204.into(), CommonMetricData {
            name: "one_ping_one_bool".into(),
            category: "test_only".into(),
            send_in_pings: vec!["one-ping-only".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_a_date
    ///
    /// ...To be writing FOG code. This is a test-only metric.
    pub static what_a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(205.into(), CommonMetricData {
            name: "what_a_date".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_id_it
    ///
    /// Just a UUID.
    /// This is a test-only metric.
    pub static what_id_it: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(206.into(), CommonMetricData {
            name: "what_id_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_time_is_it
    ///
    /// Adheres to at least two of the top ten fallacies programmers believe
    /// about time.
    /// This is a test-only metric.
    pub static what_time_is_it: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(207.into(), CommonMetricData {
            name: "what_time_is_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

}
pub mod test_only_ipc {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_bool
    ///
    /// This is a test-only metric.
    /// Just flagging things.
    pub static a_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(208.into(), CommonMetricData {
            name: "a_bool".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(209.into(), CommonMetricData {
            name: "a_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_custom_dist
    ///
    /// This is a test-only metric.
    /// Just measuring samples.
    pub static a_custom_dist: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(210.into(), CommonMetricData {
            name: "a_custom_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 2147483646, 10, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_date
    ///
    /// This is a test-only metric.
    /// Just putting things on the calendar.
    pub static a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(211.into(), CommonMetricData {
            name: "a_date".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just counting labeled things.
    pub static a_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(212.into(), CommonMetricData {
            name: "a_labeled_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_memory_dist
    ///
    /// This is a test-only metric.
    /// Just measuring memory.
    pub static a_memory_dist: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(213.into(), CommonMetricData {
            name: "a_memory_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_quantity
    ///
    /// This is a test-only metric.
    /// Just quantifying things.
    pub static a_quantity: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(214.into(), CommonMetricData {
            name: "a_quantity".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string
    ///
    /// This is a test-only metric.
    /// Just setting some strings.
    pub static a_string: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(215.into(), CommonMetricData {
            name: "a_string".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string_list
    ///
    /// This is a test-only metric.
    /// Just appending some strings.
    pub static a_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(216.into(), CommonMetricData {
            name: "a_string_list".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_text
    ///
    /// This is a test-only metric.
    /// For holding Text data.
    pub static a_text: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(217.into(), CommonMetricData {
            name: "a_text".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_timing_dist
    ///
    /// This is a test-only metric.
    /// Just measuring time.
    pub static a_timing_dist: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(218.into(), CommonMetricData {
            name: "a_timing_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_url
    ///
    /// This is a test-only metric.
    /// Just setting some Urls.
    pub static a_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(219.into(), CommonMetricData {
            name: "a_url".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_uuid
    ///
    /// This is a test-only metric.
    /// Just recording some unique identifiers.
    pub static a_uuid: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(220.into(), CommonMetricData {
            name: "a_uuid".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AnEventExtra {
        pub extra1: Option<String>,
        pub extra2: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        EventMetric::new(221.into(), CommonMetricData {
            name: "an_event".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_external_denominator
    ///
    /// This is a test-only metric.
    /// A denominator not from around here.
    pub static an_external_denominator: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(222.into(), CommonMetricData {
            name: "an_external_denominator".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "rate_with_external_denominator".into(), category: "test_only.ipc".into(), send_in_pings: vec!["store1".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.another_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just another metric counting labeled things.
    pub static another_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(223.into(), CommonMetricData {
            name: "another_labeled_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EventWithExtraExtra {
        pub extra1: Option<String>,
        pub extra2: Option<u32>,
        pub extra3_longer_name: Option<bool>,
    }

    impl ExtraKeys for EventWithExtraExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2", "extra3_longer_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          self.extra3_longer_name.and_then(|val| map.insert("extra3_longer_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.event_with_extra
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static event_with_extra: Lazy<EventMetric<EventWithExtraExtra>> = Lazy::new(|| {
        EventMetric::new(224.into(), CommonMetricData {
            name: "event_with_extra".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.irate
    ///
    /// This is a test-only metric.
    /// A rate that isn't happy about it.
    pub static irate: Lazy<RateMetric> = Lazy::new(|| {
        RateMetric::new(225.into(), CommonMetricData {
            name: "irate".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.no_extra_event
    ///
    /// This is a test-only metric.
    /// Just recording some events without the extra fuss.
    pub static no_extra_event: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(226.into(), CommonMetricData {
            name: "no_extra_event".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.rate_with_external_denominator
    ///
    /// This is a test-only metric.
    /// A rate with a denominator that is Out There.
    pub static rate_with_external_denominator: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(227.into(), CommonMetricData {
            name: "rate_with_external_denominator".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod test_only_jog {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    /// Tied closely to test_jog_name_collision.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(228.into(), CommonMetricData {
            name: "a_counter".into(),
            category: "test_only.jog".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AnEventExtra {
        pub extra1: Option<String>,
        pub extra2: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    /// Tied closely to test_jog_name_collision.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        EventMetric::new(229.into(), CommonMetricData {
            name: "an_event".into(),
            category: "test_only.jog".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod nimbus_events {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnrollFailedExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for EnrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enroll_failed
    ///
    /// Recorded when an enrollment fails, including the reason for the failure.
    pub static enroll_failed: Lazy<EventMetric<EnrollFailedExtra>> = Lazy::new(|| {
        EventMetric::new(230.into(), CommonMetricData {
            name: "enroll_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnrollmentExtra {
        pub branch: Option<String>,
        pub enrollment_id: Option<String>,
        pub experiment: Option<String>,
        pub experiment_type: Option<String>,
    }

    impl ExtraKeys for EnrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "enrollment_id", "experiment", "experiment_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.enrollment_id.and_then(|val| map.insert("enrollment_id".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.experiment_type.and_then(|val| map.insert("experiment_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enrollment
    ///
    /// Recorded when a user has met the conditions and is first bucketed into an
    /// experiment (i.e. targeting matched and they were randomized into a bucket and
    /// branch of the experiment). Expected a maximum of once per experiment per user.
    pub static enrollment: Lazy<EventMetric<EnrollmentExtra>> = Lazy::new(|| {
        EventMetric::new(231.into(), CommonMetricData {
            name: "enrollment".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ExposureExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub feature_id: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.feature_id.and_then(|val| map.insert("feature_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.exposure
    ///
    /// Recorded when a user actually observes an experimental treatment, or would have
    /// observed an experimental treatment if they had been in a branch that would have
    /// shown one.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        EventMetric::new(232.into(), CommonMetricData {
            name: "exposure".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UnenrollFailedExtra {
        pub experiment: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenroll_failed
    ///
    /// Recorded when an unenrollment fails, including the reason for the failure.
    pub static unenroll_failed: Lazy<EventMetric<UnenrollFailedExtra>> = Lazy::new(|| {
        EventMetric::new(233.into(), CommonMetricData {
            name: "unenroll_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UnenrollmentExtra {
        pub branch: Option<String>,
        pub enrollment_id: Option<String>,
        pub experiment: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for UnenrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "enrollment_id", "experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.enrollment_id.and_then(|val| map.insert("enrollment_id".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenrollment
    ///
    /// Recorded when either telemetry is disabled, or the experiment has run for its
    /// designed duration (i.e. it is no longer present in the Nimbus Remote Settings
    /// collection)
    pub static unenrollment: Lazy<EventMetric<UnenrollmentExtra>> = Lazy::new(|| {
        EventMetric::new(234.into(), CommonMetricData {
            name: "unenrollment".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ValidationFailedExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub feature: Option<String>,
        pub l10n_ids: Option<String>,
        pub locale: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for ValidationFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature", "l10n_ids", "locale", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.feature.and_then(|val| map.insert("feature".into(), val.to_string()));
          self.l10n_ids.and_then(|val| map.insert("l10n_ids".into(), val.to_string()));
          self.locale.and_then(|val| map.insert("locale".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.validation_failed
    ///
    /// This records when validation of a recipe fails.
    pub static validation_failed: Lazy<EventMetric<ValidationFailedExtra>> = Lazy::new(|| {
        EventMetric::new(235.into(), CommonMetricData {
            name: "validation_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod pdfjs {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[repr(u16)]
    pub enum ButtonsLabel {
        PresentationMode = 0,
        PresentationModeKeyboard = 1,
        ViewBookmark = 2,
        FirstPage = 3,
        LastPage = 4,
        PageRotateCw = 5,
        PageRotateCcw = 6,
        CursorSelectTool = 7,
        CursorHandTool = 8,
        ScrollPage = 9,
        ScrollVertical = 10,
        ScrollHorizontal = 11,
        ScrollWrapped = 12,
        SpreadNone = 13,
        SpreadOdd = 14,
        SpreadEven = 15,
        DocumentProperties = 16,
        __Other__,
    }
    impl From<u16> for ButtonsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::PresentationMode,
                1 => Self::PresentationModeKeyboard,
                2 => Self::ViewBookmark,
                3 => Self::FirstPage,
                4 => Self::LastPage,
                5 => Self::PageRotateCw,
                6 => Self::PageRotateCcw,
                7 => Self::CursorSelectTool,
                8 => Self::CursorHandTool,
                9 => Self::ScrollPage,
                10 => Self::ScrollVertical,
                11 => Self::ScrollHorizontal,
                12 => Self::ScrollWrapped,
                13 => Self::SpreadNone,
                14 => Self::SpreadOdd,
                15 => Self::SpreadEven,
                16 => Self::DocumentProperties,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ButtonsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::PresentationMode => "presentation_mode",
                Self::PresentationModeKeyboard => "presentation_mode_keyboard",
                Self::ViewBookmark => "view_bookmark",
                Self::FirstPage => "first_page",
                Self::LastPage => "last_page",
                Self::PageRotateCw => "page_rotate_cw",
                Self::PageRotateCcw => "page_rotate_ccw",
                Self::CursorSelectTool => "cursor_select_tool",
                Self::CursorHandTool => "cursor_hand_tool",
                Self::ScrollPage => "scroll_page",
                Self::ScrollVertical => "scroll_vertical",
                Self::ScrollHorizontal => "scroll_horizontal",
                Self::ScrollWrapped => "scroll_wrapped",
                Self::SpreadNone => "spread_none",
                Self::SpreadOdd => "spread_odd",
                Self::SpreadEven => "spread_even",
                Self::DocumentProperties => "document_properties",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.buttons
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static buttons: Lazy<LabeledMetric<LabeledCounterMetric, ButtonsLabel>> = Lazy::new(|| {
        LabeledMetric::new(236.into(), CommonMetricData {
            name: "buttons".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("cursor_hand_tool"), ::std::borrow::Cow::from("cursor_select_tool"), ::std::borrow::Cow::from("document_properties"), ::std::borrow::Cow::from("first_page"), ::std::borrow::Cow::from("last_page"), ::std::borrow::Cow::from("page_rotate_ccw"), ::std::borrow::Cow::from("page_rotate_cw"), ::std::borrow::Cow::from("presentation_mode"), ::std::borrow::Cow::from("presentation_mode_keyboard"), ::std::borrow::Cow::from("scroll_horizontal"), ::std::borrow::Cow::from("scroll_page"), ::std::borrow::Cow::from("scroll_vertical"), ::std::borrow::Cow::from("scroll_wrapped"), ::std::borrow::Cow::from("spread_even"), ::std::borrow::Cow::from("spread_none"), ::std::borrow::Cow::from("spread_odd"), ::std::borrow::Cow::from("view_bookmark")]))
    });

    #[repr(u16)]
    pub enum EditingLabel {
        Ink = 0,
        Freetext = 1,
        Save = 2,
        Print = 3,
        __Other__,
    }
    impl From<u16> for EditingLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Ink,
                1 => Self::Freetext,
                2 => Self::Save,
                3 => Self::Print,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EditingLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Ink => "ink",
                Self::Freetext => "freetext",
                Self::Save => "save",
                Self::Print => "print",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing
    ///
    /// Counts the number of times some PDF editing features are used.
    pub static editing: Lazy<LabeledMetric<LabeledCounterMetric, EditingLabel>> = Lazy::new(|| {
        LabeledMetric::new(237.into(), CommonMetricData {
            name: "editing".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("freetext"), ::std::borrow::Cow::from("ink"), ::std::borrow::Cow::from("print"), ::std::borrow::Cow::from("save")]))
    });

    #[repr(u16)]
    pub enum GeckoviewLabel {
        DownloadTapped = 0,
        OpenInAppTapped = 1,
        OpenInAppJustOnce = 2,
        OpenInAppAlways = 3,
        DownloadFailed = 4,
        DownloadSucceeded = 5,
        SaveAsPdfTapped = 6,
        __Other__,
    }
    impl From<u16> for GeckoviewLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::DownloadTapped,
                1 => Self::OpenInAppTapped,
                2 => Self::OpenInAppJustOnce,
                3 => Self::OpenInAppAlways,
                4 => Self::DownloadFailed,
                5 => Self::DownloadSucceeded,
                6 => Self::SaveAsPdfTapped,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GeckoviewLabel {
        fn into(self) -> &'static str {
            match self {
                Self::DownloadTapped => "download_tapped",
                Self::OpenInAppTapped => "open_in_app_tapped",
                Self::OpenInAppJustOnce => "open_in_app_just_once",
                Self::OpenInAppAlways => "open_in_app_always",
                Self::DownloadFailed => "download_failed",
                Self::DownloadSucceeded => "download_succeeded",
                Self::SaveAsPdfTapped => "save_as_pdf_tapped",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.geckoview
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static geckoview: Lazy<LabeledMetric<LabeledCounterMetric, GeckoviewLabel>> = Lazy::new(|| {
        LabeledMetric::new(238.into(), CommonMetricData {
            name: "geckoview".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("download_failed"), ::std::borrow::Cow::from("download_succeeded"), ::std::borrow::Cow::from("download_tapped"), ::std::borrow::Cow::from("open_in_app_always"), ::std::borrow::Cow::from("open_in_app_just_once"), ::std::borrow::Cow::from("open_in_app_tapped"), ::std::borrow::Cow::from("save_as_pdf_tapped")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.time_to_view
    ///
    /// Time spent to display first page in PDF Viewer (ms).
    pub static time_to_view: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(239.into(), CommonMetricData {
            name: "time_to_view".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 10000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.used
    ///
    /// How many times PDF Viewer was used.
    pub static used: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(240.into(), CommonMetricData {
            name: "used".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod power {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_bogus_values
    ///
    /// Impossibly large CPU time values that were discarded.
    pub static cpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(241.into(), CommonMetricData {
            name: "cpu_time_bogus_values".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum CpuTimePerProcessTypeMsLabel {
        ParentActive = 0,
        ParentActivePlayingAudio = 1,
        ParentActivePlayingVideo = 2,
        ParentInactive = 3,
        ParentInactivePlayingAudio = 4,
        ParentInactivePlayingVideo = 5,
        Prealloc = 6,
        Privilegedabout = 7,
        Rdd = 8,
        Socket = 9,
        WebBackground = 10,
        WebBackgroundPerceivable = 11,
        WebForeground = 12,
        Extension = 13,
        Gpu = 14,
        Gmplugin = 15,
        Utility = 16,
        __Other__,
    }
    impl From<u16> for CpuTimePerProcessTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ParentActive,
                1 => Self::ParentActivePlayingAudio,
                2 => Self::ParentActivePlayingVideo,
                3 => Self::ParentInactive,
                4 => Self::ParentInactivePlayingAudio,
                5 => Self::ParentInactivePlayingVideo,
                6 => Self::Prealloc,
                7 => Self::Privilegedabout,
                8 => Self::Rdd,
                9 => Self::Socket,
                10 => Self::WebBackground,
                11 => Self::WebBackgroundPerceivable,
                12 => Self::WebForeground,
                13 => Self::Extension,
                14 => Self::Gpu,
                15 => Self::Gmplugin,
                16 => Self::Utility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CpuTimePerProcessTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ParentActive => "parent.active",
                Self::ParentActivePlayingAudio => "parent.active.playing-audio",
                Self::ParentActivePlayingVideo => "parent.active.playing-video",
                Self::ParentInactive => "parent.inactive",
                Self::ParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::ParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::Prealloc => "prealloc",
                Self::Privilegedabout => "privilegedabout",
                Self::Rdd => "rdd",
                Self::Socket => "socket",
                Self::WebBackground => "web.background",
                Self::WebBackgroundPerceivable => "web.background-perceivable",
                Self::WebForeground => "web.foreground",
                Self::Extension => "extension",
                Self::Gpu => "gpu",
                Self::Gmplugin => "gmplugin",
                Self::Utility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_process_type_ms
    ///
    /// CPU time used by each process type in ms.
    pub static cpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, CpuTimePerProcessTypeMsLabel>> = Lazy::new(|| {
        LabeledMetric::new(242.into(), CommonMetricData {
            name: "cpu_time_per_process_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[repr(u16)]
    pub enum CpuTimePerTrackerTypeMsLabel {
        Ad = 0,
        Analytics = 1,
        Cryptomining = 2,
        Fingerprinting = 3,
        Social = 4,
        Unknown = 5,
        __Other__,
    }
    impl From<u16> for CpuTimePerTrackerTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Ad,
                1 => Self::Analytics,
                2 => Self::Cryptomining,
                3 => Self::Fingerprinting,
                4 => Self::Social,
                5 => Self::Unknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CpuTimePerTrackerTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Ad => "ad",
                Self::Analytics => "analytics",
                Self::Cryptomining => "cryptomining",
                Self::Fingerprinting => "fingerprinting",
                Self::Social => "social",
                Self::Unknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_tracker_type_ms
    ///
    /// CPU time used by content processes used only for tracking resources, labeled by
    /// the category of the tracker.
    pub static cpu_time_per_tracker_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, CpuTimePerTrackerTypeMsLabel>> = Lazy::new(|| {
        LabeledMetric::new(243.into(), CommonMetricData {
            name: "cpu_time_per_tracker_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("ad"), ::std::borrow::Cow::from("analytics"), ::std::borrow::Cow::from("cryptomining"), ::std::borrow::Cow::from("fingerprinting"), ::std::borrow::Cow::from("social"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_bogus_values
    ///
    /// Impossibly large GPU time values that were discarded.
    pub static gpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(244.into(), CommonMetricData {
            name: "gpu_time_bogus_values".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum GpuTimePerProcessTypeMsLabel {
        ParentActive = 0,
        ParentActivePlayingAudio = 1,
        ParentActivePlayingVideo = 2,
        ParentInactive = 3,
        ParentInactivePlayingAudio = 4,
        ParentInactivePlayingVideo = 5,
        Prealloc = 6,
        Privilegedabout = 7,
        Rdd = 8,
        Socket = 9,
        WebBackground = 10,
        WebBackgroundPerceivable = 11,
        WebForeground = 12,
        Extension = 13,
        Gpu = 14,
        Gmplugin = 15,
        Utility = 16,
        __Other__,
    }
    impl From<u16> for GpuTimePerProcessTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ParentActive,
                1 => Self::ParentActivePlayingAudio,
                2 => Self::ParentActivePlayingVideo,
                3 => Self::ParentInactive,
                4 => Self::ParentInactivePlayingAudio,
                5 => Self::ParentInactivePlayingVideo,
                6 => Self::Prealloc,
                7 => Self::Privilegedabout,
                8 => Self::Rdd,
                9 => Self::Socket,
                10 => Self::WebBackground,
                11 => Self::WebBackgroundPerceivable,
                12 => Self::WebForeground,
                13 => Self::Extension,
                14 => Self::Gpu,
                15 => Self::Gmplugin,
                16 => Self::Utility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuTimePerProcessTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ParentActive => "parent.active",
                Self::ParentActivePlayingAudio => "parent.active.playing-audio",
                Self::ParentActivePlayingVideo => "parent.active.playing-video",
                Self::ParentInactive => "parent.inactive",
                Self::ParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::ParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::Prealloc => "prealloc",
                Self::Privilegedabout => "privilegedabout",
                Self::Rdd => "rdd",
                Self::Socket => "socket",
                Self::WebBackground => "web.background",
                Self::WebBackgroundPerceivable => "web.background-perceivable",
                Self::WebForeground => "web.foreground",
                Self::Extension => "extension",
                Self::Gpu => "gpu",
                Self::Gmplugin => "gmplugin",
                Self::Utility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_per_process_type_ms
    ///
    /// GPU time used by each process type in ms.
    pub static gpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, GpuTimePerProcessTypeMsLabel>> = Lazy::new(|| {
        LabeledMetric::new(245.into(), CommonMetricData {
            name: "gpu_time_per_process_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_cpu_time_ms
    ///
    /// Total CPU time used by all processes in ms.
    pub static total_cpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(246.into(), CommonMetricData {
            name: "total_cpu_time_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_gpu_time_ms
    ///
    /// Total GPU time used by all processes in ms.
    pub static total_gpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(247.into(), CommonMetricData {
            name: "total_gpu_time_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_thread_wakeups
    ///
    /// How many times threads woke up and could have woken up a CPU core.
    pub static total_thread_wakeups: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(248.into(), CommonMetricData {
            name: "total_thread_wakeups".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum WakeupsPerProcessTypeLabel {
        ParentActive = 0,
        ParentActivePlayingAudio = 1,
        ParentActivePlayingVideo = 2,
        ParentInactive = 3,
        ParentInactivePlayingAudio = 4,
        ParentInactivePlayingVideo = 5,
        Prealloc = 6,
        Privilegedabout = 7,
        Rdd = 8,
        Socket = 9,
        WebBackground = 10,
        WebBackgroundPerceivable = 11,
        WebForeground = 12,
        Extension = 13,
        Gpu = 14,
        Gmplugin = 15,
        Utility = 16,
        __Other__,
    }
    impl From<u16> for WakeupsPerProcessTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ParentActive,
                1 => Self::ParentActivePlayingAudio,
                2 => Self::ParentActivePlayingVideo,
                3 => Self::ParentInactive,
                4 => Self::ParentInactivePlayingAudio,
                5 => Self::ParentInactivePlayingVideo,
                6 => Self::Prealloc,
                7 => Self::Privilegedabout,
                8 => Self::Rdd,
                9 => Self::Socket,
                10 => Self::WebBackground,
                11 => Self::WebBackgroundPerceivable,
                12 => Self::WebForeground,
                13 => Self::Extension,
                14 => Self::Gpu,
                15 => Self::Gmplugin,
                16 => Self::Utility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WakeupsPerProcessTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ParentActive => "parent.active",
                Self::ParentActivePlayingAudio => "parent.active.playing-audio",
                Self::ParentActivePlayingVideo => "parent.active.playing-video",
                Self::ParentInactive => "parent.inactive",
                Self::ParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::ParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::Prealloc => "prealloc",
                Self::Privilegedabout => "privilegedabout",
                Self::Rdd => "rdd",
                Self::Socket => "socket",
                Self::WebBackground => "web.background",
                Self::WebBackgroundPerceivable => "web.background-perceivable",
                Self::WebForeground => "web.foreground",
                Self::Extension => "extension",
                Self::Gpu => "gpu",
                Self::Gmplugin => "gmplugin",
                Self::Utility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_process_type
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by process type.
    pub static wakeups_per_process_type: Lazy<LabeledMetric<LabeledCounterMetric, WakeupsPerProcessTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(249.into(), CommonMetricData {
            name: "wakeups_per_process_type".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

}
pub mod power_battery {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from power.battery.percentage_when_user_active
    ///
    /// Records how many percent of battery was available for each period of user
    /// activity.
    pub static percentage_when_user_active: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(250.into(), CommonMetricData {
            name: "percentage_when_user_active".into(),
            category: "power.battery".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 100, 100, HistogramType::Linear)
    });

}
pub mod power_cpu_ms_per_thread {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[repr(u16)]
    pub enum ContentBackgroundLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ContentBackgroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentBackgroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_background
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric, ContentBackgroundLabel>> = Lazy::new(|| {
        LabeledMetric::new(251.into(), CommonMetricData {
            name: "content_background".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ContentForegroundLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ContentForegroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentForegroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_foreground
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric, ContentForegroundLabel>> = Lazy::new(|| {
        LabeledMetric::new(252.into(), CommonMetricData {
            name: "content_foreground".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum GpuProcessLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for GpuProcessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuProcessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.gpu_process
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric, GpuProcessLabel>> = Lazy::new(|| {
        LabeledMetric::new(253.into(), CommonMetricData {
            name: "gpu_process".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentActiveLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ParentActiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentActiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_active
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric, ParentActiveLabel>> = Lazy::new(|| {
        LabeledMetric::new(254.into(), CommonMetricData {
            name: "parent_active".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentInactiveLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ParentInactiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentInactiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_inactive
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric, ParentInactiveLabel>> = Lazy::new(|| {
        LabeledMetric::new(255.into(), CommonMetricData {
            name: "parent_inactive".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

}
pub mod power_wakeups_per_thread {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[repr(u16)]
    pub enum ContentBackgroundLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ContentBackgroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentBackgroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_background
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric, ContentBackgroundLabel>> = Lazy::new(|| {
        LabeledMetric::new(256.into(), CommonMetricData {
            name: "content_background".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ContentForegroundLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ContentForegroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentForegroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_foreground
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric, ContentForegroundLabel>> = Lazy::new(|| {
        LabeledMetric::new(257.into(), CommonMetricData {
            name: "content_foreground".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum GpuProcessLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for GpuProcessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuProcessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.gpu_process
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric, GpuProcessLabel>> = Lazy::new(|| {
        LabeledMetric::new(258.into(), CommonMetricData {
            name: "gpu_process".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentActiveLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ParentActiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentActiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_active
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric, ParentActiveLabel>> = Lazy::new(|| {
        LabeledMetric::new(259.into(), CommonMetricData {
            name: "parent_active".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentInactiveLabel {
        Asynclogger = 0,
        Audioipc = 1,
        AudioipcCallbackRpc = 2,
        AudioipcClientCallback = 3,
        AudioipcClientRpc = 4,
        AudioipcDevicecollectionRpc = 5,
        AudioipcServerCallback = 6,
        AudioipcServerRpc = 7,
        Backgroundthreadpool = 8,
        Bgiothreadpool = 9,
        Bgreadurls = 10,
        BhmgrMonitor = 11,
        BhmgrProcessor = 12,
        CamerasIpc = 13,
        Capturethread = 14,
        ClassifierUpdate = 15,
        ComMta = 16,
        Compositor = 17,
        Cookie = 18,
        Cubeboperation = 19,
        DatachannelIo = 20,
        DnsResolver = 21,
        DomWorker = 22,
        Domcachethread = 23,
        Extensionprotocolhandler = 24,
        FontLoader = 25,
        Fontenumthread = 26,
        FsBroker = 27,
        Geckomain = 28,
        Gmpthread = 29,
        Graphrunner = 30,
        Html5Parser = 31,
        Imagebridgechld = 32,
        Imageio = 33,
        Indexeddb = 34,
        Initfontlist = 35,
        Inotifyeventthread = 36,
        IpcIOChild = 37,
        IpcIOParent = 38,
        IpcLaunch = 39,
        IpdlBackground = 40,
        JsWatchdog = 41,
        JumpList = 42,
        Libwebrtcmodulethread = 43,
        LinkMonitor = 44,
        LsThread = 45,
        Mediacache = 46,
        Mediadecoderstatemachine = 47,
        Mediapdecoder = 48,
        Mediasupervisor = 49,
        Mediatimer = 50,
        Mediatrackgrph = 51,
        Memorypoller = 52,
        Mozstorage = 53,
        Mtransport = 54,
        NetlinkMonitor = 55,
        Pacerthread = 56,
        Permission = 57,
        Playeventsound = 58,
        Processhangmon = 59,
        Profilerchild = 60,
        Proxyresolution = 61,
        QuotamanagerIo = 62,
        Registerfonts = 63,
        Remotebackbuffer = 64,
        Remotelzystream = 65,
        Remvidchild = 66,
        Renderer = 67,
        Sandboxreporter = 68,
        Savescripts = 69,
        SocketThread = 70,
        Softwarevsyncthread = 71,
        SslCert = 72,
        Startupcache = 73,
        Streamtrans = 74,
        Stylethread = 75,
        Swcomposite = 76,
        Taskcontroller = 77,
        Timer = 78,
        Toastbgthread = 79,
        TrrBackground = 80,
        UntrustedModules = 81,
        UrlClassifier = 82,
        Videocapture = 83,
        Vsynciothread = 84,
        Webrtccallthread = 85,
        Webrtcworker = 86,
        Wincompositor = 87,
        Windowsvsyncthread = 88,
        Winwindowocclusioncalc = 89,
        WorkerLauncher = 90,
        Wrrenderbackend = 91,
        Wrscenebuilder = 92,
        Wrscenebuilderlp = 93,
        Wrworker = 94,
        Wrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ParentInactiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Asynclogger,
                1 => Self::Audioipc,
                2 => Self::AudioipcCallbackRpc,
                3 => Self::AudioipcClientCallback,
                4 => Self::AudioipcClientRpc,
                5 => Self::AudioipcDevicecollectionRpc,
                6 => Self::AudioipcServerCallback,
                7 => Self::AudioipcServerRpc,
                8 => Self::Backgroundthreadpool,
                9 => Self::Bgiothreadpool,
                10 => Self::Bgreadurls,
                11 => Self::BhmgrMonitor,
                12 => Self::BhmgrProcessor,
                13 => Self::CamerasIpc,
                14 => Self::Capturethread,
                15 => Self::ClassifierUpdate,
                16 => Self::ComMta,
                17 => Self::Compositor,
                18 => Self::Cookie,
                19 => Self::Cubeboperation,
                20 => Self::DatachannelIo,
                21 => Self::DnsResolver,
                22 => Self::DomWorker,
                23 => Self::Domcachethread,
                24 => Self::Extensionprotocolhandler,
                25 => Self::FontLoader,
                26 => Self::Fontenumthread,
                27 => Self::FsBroker,
                28 => Self::Geckomain,
                29 => Self::Gmpthread,
                30 => Self::Graphrunner,
                31 => Self::Html5Parser,
                32 => Self::Imagebridgechld,
                33 => Self::Imageio,
                34 => Self::Indexeddb,
                35 => Self::Initfontlist,
                36 => Self::Inotifyeventthread,
                37 => Self::IpcIOChild,
                38 => Self::IpcIOParent,
                39 => Self::IpcLaunch,
                40 => Self::IpdlBackground,
                41 => Self::JsWatchdog,
                42 => Self::JumpList,
                43 => Self::Libwebrtcmodulethread,
                44 => Self::LinkMonitor,
                45 => Self::LsThread,
                46 => Self::Mediacache,
                47 => Self::Mediadecoderstatemachine,
                48 => Self::Mediapdecoder,
                49 => Self::Mediasupervisor,
                50 => Self::Mediatimer,
                51 => Self::Mediatrackgrph,
                52 => Self::Memorypoller,
                53 => Self::Mozstorage,
                54 => Self::Mtransport,
                55 => Self::NetlinkMonitor,
                56 => Self::Pacerthread,
                57 => Self::Permission,
                58 => Self::Playeventsound,
                59 => Self::Processhangmon,
                60 => Self::Profilerchild,
                61 => Self::Proxyresolution,
                62 => Self::QuotamanagerIo,
                63 => Self::Registerfonts,
                64 => Self::Remotebackbuffer,
                65 => Self::Remotelzystream,
                66 => Self::Remvidchild,
                67 => Self::Renderer,
                68 => Self::Sandboxreporter,
                69 => Self::Savescripts,
                70 => Self::SocketThread,
                71 => Self::Softwarevsyncthread,
                72 => Self::SslCert,
                73 => Self::Startupcache,
                74 => Self::Streamtrans,
                75 => Self::Stylethread,
                76 => Self::Swcomposite,
                77 => Self::Taskcontroller,
                78 => Self::Timer,
                79 => Self::Toastbgthread,
                80 => Self::TrrBackground,
                81 => Self::UntrustedModules,
                82 => Self::UrlClassifier,
                83 => Self::Videocapture,
                84 => Self::Vsynciothread,
                85 => Self::Webrtccallthread,
                86 => Self::Webrtcworker,
                87 => Self::Wincompositor,
                88 => Self::Windowsvsyncthread,
                89 => Self::Winwindowocclusioncalc,
                90 => Self::WorkerLauncher,
                91 => Self::Wrrenderbackend,
                92 => Self::Wrscenebuilder,
                93 => Self::Wrscenebuilderlp,
                94 => Self::Wrworker,
                95 => Self::Wrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentInactiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Asynclogger => "asynclogger",
                Self::Audioipc => "audioipc",
                Self::AudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::AudioipcClientCallback => "audioipc_client_callback",
                Self::AudioipcClientRpc => "audioipc_client_rpc",
                Self::AudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::AudioipcServerCallback => "audioipc_server_callback",
                Self::AudioipcServerRpc => "audioipc_server_rpc",
                Self::Backgroundthreadpool => "backgroundthreadpool",
                Self::Bgiothreadpool => "bgiothreadpool",
                Self::Bgreadurls => "bgreadurls",
                Self::BhmgrMonitor => "bhmgr_monitor",
                Self::BhmgrProcessor => "bhmgr_processor",
                Self::CamerasIpc => "cameras_ipc",
                Self::Capturethread => "capturethread",
                Self::ClassifierUpdate => "classifier_update",
                Self::ComMta => "com_mta",
                Self::Compositor => "compositor",
                Self::Cookie => "cookie",
                Self::Cubeboperation => "cubeboperation",
                Self::DatachannelIo => "datachannel_io",
                Self::DnsResolver => "dns_resolver",
                Self::DomWorker => "dom_worker",
                Self::Domcachethread => "domcachethread",
                Self::Extensionprotocolhandler => "extensionprotocolhandler",
                Self::FontLoader => "font_loader",
                Self::Fontenumthread => "fontenumthread",
                Self::FsBroker => "fs_broker",
                Self::Geckomain => "geckomain",
                Self::Gmpthread => "gmpthread",
                Self::Graphrunner => "graphrunner",
                Self::Html5Parser => "html5_parser",
                Self::Imagebridgechld => "imagebridgechld",
                Self::Imageio => "imageio",
                Self::Indexeddb => "indexeddb",
                Self::Initfontlist => "initfontlist",
                Self::Inotifyeventthread => "inotifyeventthread",
                Self::IpcIOChild => "ipc_i_o_child",
                Self::IpcIOParent => "ipc_i_o_parent",
                Self::IpcLaunch => "ipc_launch",
                Self::IpdlBackground => "ipdl_background",
                Self::JsWatchdog => "js_watchdog",
                Self::JumpList => "jump_list",
                Self::Libwebrtcmodulethread => "libwebrtcmodulethread",
                Self::LinkMonitor => "link_monitor",
                Self::LsThread => "ls_thread",
                Self::Mediacache => "mediacache",
                Self::Mediadecoderstatemachine => "mediadecoderstatemachine",
                Self::Mediapdecoder => "mediapdecoder",
                Self::Mediasupervisor => "mediasupervisor",
                Self::Mediatimer => "mediatimer",
                Self::Mediatrackgrph => "mediatrackgrph",
                Self::Memorypoller => "memorypoller",
                Self::Mozstorage => "mozstorage",
                Self::Mtransport => "mtransport",
                Self::NetlinkMonitor => "netlink_monitor",
                Self::Pacerthread => "pacerthread",
                Self::Permission => "permission",
                Self::Playeventsound => "playeventsound",
                Self::Processhangmon => "processhangmon",
                Self::Profilerchild => "profilerchild",
                Self::Proxyresolution => "proxyresolution",
                Self::QuotamanagerIo => "quotamanager_io",
                Self::Registerfonts => "registerfonts",
                Self::Remotebackbuffer => "remotebackbuffer",
                Self::Remotelzystream => "remotelzystream",
                Self::Remvidchild => "remvidchild",
                Self::Renderer => "renderer",
                Self::Sandboxreporter => "sandboxreporter",
                Self::Savescripts => "savescripts",
                Self::SocketThread => "socket_thread",
                Self::Softwarevsyncthread => "softwarevsyncthread",
                Self::SslCert => "ssl_cert",
                Self::Startupcache => "startupcache",
                Self::Streamtrans => "streamtrans",
                Self::Stylethread => "stylethread",
                Self::Swcomposite => "swcomposite",
                Self::Taskcontroller => "taskcontroller",
                Self::Timer => "timer",
                Self::Toastbgthread => "toastbgthread",
                Self::TrrBackground => "trr_background",
                Self::UntrustedModules => "untrusted_modules",
                Self::UrlClassifier => "url_classifier",
                Self::Videocapture => "videocapture",
                Self::Vsynciothread => "vsynciothread",
                Self::Webrtccallthread => "webrtccallthread",
                Self::Webrtcworker => "webrtcworker",
                Self::Wincompositor => "wincompositor",
                Self::Windowsvsyncthread => "windowsvsyncthread",
                Self::Winwindowocclusioncalc => "winwindowocclusioncalc",
                Self::WorkerLauncher => "worker_launcher",
                Self::Wrrenderbackend => "wrrenderbackend",
                Self::Wrscenebuilder => "wrscenebuilder",
                Self::Wrscenebuilderlp => "wrscenebuilderlp",
                Self::Wrworker => "wrworker",
                Self::Wrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_inactive
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric, ParentInactiveLabel>> = Lazy::new(|| {
        LabeledMetric::new(260.into(), CommonMetricData {
            name: "parent_inactive".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

}
pub mod search_engine_default {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangedExtra {
        pub change_source: Option<String>,
        pub new_display_name: Option<String>,
        pub new_engine_id: Option<String>,
        pub new_load_path: Option<String>,
        pub new_submission_url: Option<String>,
        pub previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_source", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.change_source.and_then(|val| map.insert("change_source".into(), val.to_string()));
          self.new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.changed
    ///
    /// Recorded when the default search engine is changed.
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        EventMetric::new(261.into(), CommonMetricData {
            name: "changed".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.display_name
    ///
    /// The display name of the user's default engine.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(262.into(), CommonMetricData {
            name: "display_name".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.engine_id
    ///
    /// The telemetry id of the search engine.
    /// For application provided engines, this is either supplied by the
    /// configuration or from the first part of the associated WebExtension Id.
    /// For other engines, this is `other-<extensionName>`.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(263.into(), CommonMetricData {
            name: "engine_id".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[addon]<extension id>` for a WebExtension based
    ///   engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
    ///   engine.
    /// Note: this metric is truncated at 100 characters.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(264.into(), CommonMetricData {
            name: "load_path".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(265.into(), CommonMetricData {
            name: "submission_url".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.verified
    ///
    /// The verified status of the search engine.
    /// For application provided engines, this will always be `default`.
    /// For other engines this will either be `verified` or `unverified` depending
    /// on if the loadPathHash is valid.
    pub static verified: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(266.into(), CommonMetricData {
            name: "verified".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod search_engine_private {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangedExtra {
        pub change_source: Option<String>,
        pub new_display_name: Option<String>,
        pub new_engine_id: Option<String>,
        pub new_load_path: Option<String>,
        pub new_submission_url: Option<String>,
        pub previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_source", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.change_source.and_then(|val| map.insert("change_source".into(), val.to_string()));
          self.new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.changed
    ///
    /// Recorded when the default search engine is changed
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        EventMetric::new(267.into(), CommonMetricData {
            name: "changed".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.display_name
    ///
    /// The display name of the user's default engine.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(268.into(), CommonMetricData {
            name: "display_name".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.engine_id
    ///
    /// The telemetry id of the search engine.
    /// For application provided engines, this is either supplied by the
    /// configuration or from the first part of the associated WebExtension Id.
    /// For other engines, this is `other-<extensionName>`.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(269.into(), CommonMetricData {
            name: "engine_id".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[addon]<extension id>` for a WebExtension based
    ///   engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
    ///   engine.
    /// Note: this metric is truncated at 100 characters.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(270.into(), CommonMetricData {
            name: "load_path".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(271.into(), CommonMetricData {
            name: "submission_url".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.verified
    ///
    /// The verified status of the search engine.
    /// For application provided engines, this will always be `default`.
    /// For other engines this will either be `verified` or `unverified` depending
    /// on if the loadPathHash is valid.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static verified: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(272.into(), CommonMetricData {
            name: "verified".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod search_service {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from search.service.startup_time
    ///
    /// The time duration it takes for the search service to start up.
    pub static startup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(273.into(), CommonMetricData {
            name: "startup_time".into(),
            category: "search.service".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

}
pub mod dap {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[repr(u16)]
    pub enum ReportGenerationStatusLabel {
        Success = 0,
        Failure = 1,
        __Other__,
    }
    impl From<u16> for ReportGenerationStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Success,
                1 => Self::Failure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReportGenerationStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Success => "success",
                Self::Failure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dap.report_generation_status
    ///
    /// The result of trying to generate a DAP report.
    pub static report_generation_status: Lazy<LabeledMetric<LabeledCounterMetric, ReportGenerationStatusLabel>> = Lazy::new(|| {
        LabeledMetric::new(274.into(), CommonMetricData {
            name: "report_generation_status".into(),
            category: "dap".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[repr(u16)]
    pub enum UploadStatusLabel {
        Success = 0,
        Failure = 1,
        __Other__,
    }
    impl From<u16> for UploadStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::Success,
                1 => Self::Failure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UploadStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::Success => "success",
                Self::Failure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dap.upload_status
    ///
    /// The result of trying to upload a report to the DAP server.
    pub static upload_status: Lazy<LabeledMetric<LabeledCounterMetric, UploadStatusLabel>> = Lazy::new(|| {
        LabeledMetric::new(275.into(), CommonMetricData {
            name: "upload_status".into(),
            category: "dap".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

}
pub mod legacy_telemetry {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from legacy.telemetry.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to being too early for it to have
    /// loaded.
    /// Value may be the canary client id `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Does not need to be sent in the Glean "deletion-request" ping.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(276.into(), CommonMetricData {
            name: "client_id".into(),
            category: "legacy.telemetry".into(),
            send_in_pings: vec!["baseline".into(), "events".into(), "metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod translations {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ErrorExtra {
        pub reason: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.error
    ///
    /// The specific translations error that caused a full-page translation failure.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        EventMetric::new(277.into(), CommonMetricData {
            name: "error".into(),
            category: "translations".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from translations.error_rate
    ///
    /// The rate of failed translations requests.
    pub static error_rate: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(278.into(), CommonMetricData {
            name: "error_rate".into(),
            category: "translations".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from translations.requests_count
    ///
    /// The count of translation requests.
    pub static requests_count: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(279.into(), CommonMetricData {
            name: "requests_count".into(),
            category: "translations".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "error_rate".into(), category: "translations".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TranslationRequestExtra {
        pub auto_translate: Option<bool>,
        pub from_language: Option<String>,
        pub to_language: Option<String>,
    }

    impl ExtraKeys for TranslationRequestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_translate", "from_language", "to_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.auto_translate.and_then(|val| map.insert("auto_translate".into(), val.to_string()));
          self.from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.translation_request
    ///
    /// Triggers when a full-page translation request is sent.
    pub static translation_request: Lazy<EventMetric<TranslationRequestExtra>> = Lazy::new(|| {
        EventMetric::new(280.into(), CommonMetricData {
            name: "translation_request".into(),
            category: "translations".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod first_startup {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.elapsed
    ///
    /// Number of milliseconds the FirstStartup service took to run.
    pub static elapsed: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(281.into(), CommonMetricData {
            name: "elapsed".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.status_code
    ///
    /// Status of the FirstStartup service, which runs
    /// post-install/early-startup in Firefox.
    pub static status_code: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(282.into(), CommonMetricData {
            name: "status_code".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod blocklist {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddonBlockChangeExtra {
        pub addon_version: Option<String>,
        pub blocklist_state: Option<String>,
        pub hours_since: Option<String>,
        pub mlbf_generation: Option<String>,
        pub mlbf_last_time: Option<String>,
        pub mlbf_source: Option<String>,
        pub object: Option<String>,
        pub signed_date: Option<String>,
        pub value: Option<String>,
    }

    impl ExtraKeys for AddonBlockChangeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_version", "blocklist_state", "hours_since", "mlbf_generation", "mlbf_last_time", "mlbf_source", "object", "signed_date", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.hours_since.and_then(|val| map.insert("hours_since".into(), val.to_string()));
          self.mlbf_generation.and_then(|val| map.insert("mlbf_generation".into(), val.to_string()));
          self.mlbf_last_time.and_then(|val| map.insert("mlbf_last_time".into(), val.to_string()));
          self.mlbf_source.and_then(|val| map.insert("mlbf_source".into(), val.to_string()));
          self.object.and_then(|val| map.insert("object".into(), val.to_string()));
          self.signed_date.and_then(|val| map.insert("signed_date".into(), val.to_string()));
          self.value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from blocklist.addon_block_change
    ///
    /// An add-on is blocked, or an installed add-on is unblocked. When an add-on
    /// install/update is blocked, its installation is aborted and the add-on is no
    /// longer listed in the activeAddons field of TelemetryEnvironment.
    pub static addon_block_change: Lazy<EventMetric<AddonBlockChangeExtra>> = Lazy::new(|| {
        EventMetric::new(283.into(), CommonMetricData {
            name: "addon_block_change".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.last_modified_rs_addons_mblf
    ///
    /// Keep track of the last time the "addons-bloomfilters" remotesetting blocklist
    /// has been successfully updated.
    pub static last_modified_rs_addons_mblf: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(284.into(), CommonMetricData {
            name: "last_modified_rs_addons_mblf".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_generation_time
    ///
    /// Keep track of the generation time of the addon blocklist's bloom filter. This
    /// marks the point in time until which signed add-ons are recognized by the
    /// selected bloom filter from the addons-bloomfilters collection.
    pub static mlbf_generation_time: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(285.into(), CommonMetricData {
            name: "mlbf_generation_time".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_source
    ///
    /// The source of the RemoteSettings attachment that holds the bloom filter.
    /// Possible values are "dump_match", "cache_match",
    /// "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match",
    /// "cache_match" and "remote_match" are expected known-good values, and means that
    /// the loaded bloomfilter matches the blocklist record in the RemoteSettings
    /// collection. The prefix denotes the immediate source of the loaded data: "dump"
    /// means packaged with the application, "remote" means a freshly downloaded
    /// bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback"
    /// and "cache_fallback" means that the last known bloomfilter was used, despite it
    /// not matching the latest record in the RemoteSettings collection. In this case
    /// the outdated bloomfilter is used as a fallback (e.g. because the latest version
    /// cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded
    /// at all. This can happen if the blocklist is disabled via preferences or
    /// enterprise policies.
    pub static mlbf_source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(286.into(), CommonMetricData {
            name: "mlbf_source".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_stash_time_newest
    ///
    /// Keep track of the timestamp of the most recent stash of the addons blocklist.
    /// Only meaningful when mlbf_enabled is true.
    pub static mlbf_stash_time_newest: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(287.into(), CommonMetricData {
            name: "mlbf_stash_time_newest".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_stash_time_oldest
    ///
    /// Keep track of the timestamp of the oldest stash of the addons blocklist. Only
    /// meaningful when mlbf_enabled is true.
    pub static mlbf_stash_time_oldest: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(288.into(), CommonMetricData {
            name: "mlbf_stash_time_oldest".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod update {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from update.auto_download
    ///
    /// Per-installation preference "app.update.auto": whether to fetch and install
    /// updates without user intervention.
    pub static auto_download: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(289.into(), CommonMetricData {
            name: "auto_download".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.background_update
    ///
    /// Per-installation preference "app.update.background.enabled": whether to fetch
    /// and install updates in the background when Firefox is not running.
    pub static background_update: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(290.into(), CommonMetricData {
            name: "background_update".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_apply_updates
    ///
    /// Whether or not the Update Service can usually download and install updates. See
    /// `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_apply_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(291.into(), CommonMetricData {
            name: "can_usually_apply_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_check_for_updates
    ///
    /// Whether or not the Update Service can usually check for updates. See
    /// `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_check_for_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(292.into(), CommonMetricData {
            name: "can_usually_check_for_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_stage_updates
    ///
    /// Whether the Update Service is usually able to stage updates. See
    /// `canUsuallyStageUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_stage_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(293.into(), CommonMetricData {
            name: "can_usually_stage_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_use_bits
    ///
    /// On Windows, whether the Update Service can usually use BITS. See
    /// `canUsuallyUseBits` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_use_bits: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(294.into(), CommonMetricData {
            name: "can_usually_use_bits".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.channel
    ///
    /// The update channel.
    pub static channel: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(295.into(), CommonMetricData {
            name: "channel".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.enabled
    ///
    /// True when policies are disabled or when the "DisableAppUpdate" is not in
    /// effect.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(296.into(), CommonMetricData {
            name: "enabled".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.service_enabled
    ///
    /// Preference "app.update.service.enabled": whether the Mozilla Maintenance
    /// Service is enabled.
    pub static service_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(297.into(), CommonMetricData {
            name: "service_enabled".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod startup {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from startup.is_restored_by_macos
    ///
    /// Recorded on every launch of a Firefox install on macOS, with a boolean value
    /// indicating whether Firefox was restored by macOS or if it was manually launched
    /// by a user.
    pub static is_restored_by_macos: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(298.into(), CommonMetricData {
            name: "is_restored_by_macos".into(),
            category: "startup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod timer_thread {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from timer_thread.timers_fired_per_wakeup
    ///
    /// How many timers were processed in a single wake-up of the Timer Thread.
    pub static timers_fired_per_wakeup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(299.into(), CommonMetricData {
            name: "timers_fired_per_wakeup".into(),
            category: "timer_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 80, 20, HistogramType::Exponential)
    });

}

#[allow(dead_code)]
pub(crate) mod __glean_metric_maps {
    use std::collections::HashMap;

    use crate::metrics::extra_keys_len;
    use crate::private::*;
    use once_cell::sync::Lazy;

    pub static STRING_LIST_MAP: Lazy<HashMap<MetricId, &Lazy<StringListMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(6);
        map.insert(1.into(), &super::background_update::reasons_to_not_update);
        map.insert(7.into(), &super::background_update::reasons);
        map.insert(8.into(), &super::background_update::states);
        map.insert(49.into(), &super::newtab::blocked_sponsors);
        map.insert(190.into(), &super::test_only::cheesy_string_list);
        map.insert(216.into(), &super::test_only_ipc::a_string_list);
        map
    });

    pub static DATETIME_MAP: Lazy<HashMap<MetricId, &Lazy<DatetimeMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(10);
        map.insert(2.into(), &super::background_update::time_last_update_scheduled);
        map.insert(9.into(), &super::background_update::targeting_env_current_date);
        map.insert(11.into(), &super::background_update::targeting_env_profile_age);
        map.insert(168.into(), &super::crash::time);
        map.insert(205.into(), &super::test_only::what_a_date);
        map.insert(211.into(), &super::test_only_ipc::a_date);
        map.insert(284.into(), &super::blocklist::last_modified_rs_addons_mblf);
        map.insert(285.into(), &super::blocklist::mlbf_generation_time);
        map.insert(287.into(), &super::blocklist::mlbf_stash_time_newest);
        map.insert(288.into(), &super::blocklist::mlbf_stash_time_oldest);
        map
    });

    pub static UUID_MAP: Lazy<HashMap<MetricId, &Lazy<UuidMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(7);
        map.insert(3.into(), &super::background_update::client_id);
        map.insert(18.into(), &super::messaging_system::browser_session_id);
        map.insert(21.into(), &super::messaging_system::client_id);
        map.insert(29.into(), &super::messaging_system::impression_id);
        map.insert(206.into(), &super::test_only::what_id_it);
        map.insert(220.into(), &super::test_only_ipc::a_uuid);
        map.insert(276.into(), &super::legacy_telemetry::client_id);
        map
    });

    pub static BOOLEAN_MAP: Lazy<HashMap<MetricId, &Lazy<BooleanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(35);
        map.insert(4.into(), &super::background_update::exit_code_exception);
        map.insert(5.into(), &super::background_update::exit_code_success);
        map.insert(12.into(), &super::background_update::targeting_exception);
        map.insert(13.into(), &super::background_update::targeting_exists);
        map.insert(55.into(), &super::newtab_search::enabled);
        map.insert(58.into(), &super::pocket::enabled);
        map.insert(60.into(), &super::pocket::is_signed_in);
        map.insert(62.into(), &super::pocket::sponsored_stories_enabled);
        map.insert(65.into(), &super::topsites::enabled);
        map.insert(68.into(), &super::topsites::sponsored_enabled);
        map.insert(82.into(), &super::urlbar::pref_suggest_topsites);
        map.insert(138.into(), &super::background_tasks_rmdir_base::succeeded);
        map.insert(139.into(), &super::background_tasks_rmdir_base::suffix_ever_failed);
        map.insert(141.into(), &super::background_tasks_rmdir_base::was_first);
        map.insert(146.into(), &super::background_tasks_rmdir_http_cache::succeeded);
        map.insert(147.into(), &super::background_tasks_rmdir_http_cache::suffix_ever_failed);
        map.insert(149.into(), &super::background_tasks_rmdir_http_cache::was_first);
        map.insert(154.into(), &super::background_tasks_rmdir_quota::succeeded);
        map.insert(155.into(), &super::background_tasks_rmdir_quota::suffix_ever_failed);
        map.insert(157.into(), &super::background_tasks_rmdir_quota::was_first);
        map.insert(163.into(), &super::cookie_banners::service_detect_only);
        map.insert(167.into(), &super::crash::startup);
        map.insert(179.into(), &super::fog::failed_idle_registration);
        map.insert(187.into(), &super::test_only::can_we_flag_it);
        map.insert(204.into(), &super::test_only::one_ping_one_bool);
        map.insert(208.into(), &super::test_only_ipc::a_bool);
        map.insert(289.into(), &super::update::auto_download);
        map.insert(290.into(), &super::update::background_update);
        map.insert(291.into(), &super::update::can_usually_apply_updates);
        map.insert(292.into(), &super::update::can_usually_check_for_updates);
        map.insert(293.into(), &super::update::can_usually_stage_updates);
        map.insert(294.into(), &super::update::can_usually_use_bits);
        map.insert(296.into(), &super::update::enabled);
        map.insert(297.into(), &super::update::service_enabled);
        map.insert(298.into(), &super::startup::is_restored_by_macos);
        map
    });

    pub static STRING_MAP: Lazy<HashMap<MetricId, &Lazy<StringMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(38);
        map.insert(6.into(), &super::background_update::final_state);
        map.insert(16.into(), &super::messaging_system::action);
        map.insert(17.into(), &super::messaging_system::addon_version);
        map.insert(19.into(), &super::messaging_system::bucket_id);
        map.insert(22.into(), &super::messaging_system::event);
        map.insert(25.into(), &super::messaging_system::event_page);
        map.insert(26.into(), &super::messaging_system::event_reason);
        map.insert(27.into(), &super::messaging_system::event_source);
        map.insert(31.into(), &super::messaging_system::locale);
        map.insert(33.into(), &super::messaging_system::page);
        map.insert(34.into(), &super::messaging_system::ping_type);
        map.insert(35.into(), &super::messaging_system::source);
        map.insert(38.into(), &super::messaging_system_attribution::campaign);
        map.insert(39.into(), &super::messaging_system_attribution::content);
        map.insert(40.into(), &super::messaging_system_attribution::dlsource);
        map.insert(41.into(), &super::messaging_system_attribution::dltoken);
        map.insert(42.into(), &super::messaging_system_attribution::experiment);
        map.insert(43.into(), &super::messaging_system_attribution::medium);
        map.insert(44.into(), &super::messaging_system_attribution::msstoresignedin);
        map.insert(45.into(), &super::messaging_system_attribution::source);
        map.insert(46.into(), &super::messaging_system_attribution::ua);
        map.insert(48.into(), &super::messaging_system_attribution::variation);
        map.insert(51.into(), &super::newtab::homepage_category);
        map.insert(52.into(), &super::newtab::locale);
        map.insert(53.into(), &super::newtab::newtab_category);
        map.insert(166.into(), &super::crash::process_type);
        map.insert(189.into(), &super::test_only::cheesy_string);
        map.insert(215.into(), &super::test_only_ipc::a_string);
        map.insert(262.into(), &super::search_engine_default::display_name);
        map.insert(263.into(), &super::search_engine_default::engine_id);
        map.insert(264.into(), &super::search_engine_default::load_path);
        map.insert(266.into(), &super::search_engine_default::verified);
        map.insert(268.into(), &super::search_engine_private::display_name);
        map.insert(269.into(), &super::search_engine_private::engine_id);
        map.insert(270.into(), &super::search_engine_private::load_path);
        map.insert(272.into(), &super::search_engine_private::verified);
        map.insert(286.into(), &super::blocklist::mlbf_source);
        map.insert(295.into(), &super::update::channel);
        map
    });

    pub static QUANTITY_MAP: Lazy<HashMap<MetricId, &Lazy<QuantityMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(22);
        map.insert(10.into(), &super::background_update::targeting_env_firefox_version);
        map.insert(14.into(), &super::background_update::targeting_version);
        map.insert(67.into(), &super::topsites::rows);
        map.insert(81.into(), &super::urlbar::pref_max_results);
        map.insert(84.into(), &super::browser_engagement::profile_count);
        map.insert(134.into(), &super::background_tasks_rmdir_base::elapsed_ms);
        map.insert(136.into(), &super::background_tasks_rmdir_base::removal_count);
        map.insert(137.into(), &super::background_tasks_rmdir_base::retry_count);
        map.insert(140.into(), &super::background_tasks_rmdir_base::suffix_removal_count);
        map.insert(142.into(), &super::background_tasks_rmdir_http_cache::elapsed_ms);
        map.insert(144.into(), &super::background_tasks_rmdir_http_cache::removal_count);
        map.insert(145.into(), &super::background_tasks_rmdir_http_cache::retry_count);
        map.insert(148.into(), &super::background_tasks_rmdir_http_cache::suffix_removal_count);
        map.insert(150.into(), &super::background_tasks_rmdir_quota::elapsed_ms);
        map.insert(152.into(), &super::background_tasks_rmdir_quota::removal_count);
        map.insert(153.into(), &super::background_tasks_rmdir_quota::retry_count);
        map.insert(156.into(), &super::background_tasks_rmdir_quota::suffix_removal_count);
        map.insert(171.into(), &super::extensions_apis_dnr::evaluate_rules_count_max);
        map.insert(200.into(), &super::test_only::meaning_of_life);
        map.insert(214.into(), &super::test_only_ipc::a_quantity);
        map.insert(281.into(), &super::first_startup::elapsed);
        map.insert(282.into(), &super::first_startup::status_code);
        map
    });

    pub static TEXT_MAP: Lazy<HashMap<MetricId, &Lazy<TextMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(4);
        map.insert(20.into(), &super::messaging_system::cfr_action);
        map.insert(23.into(), &super::messaging_system::event_context);
        map.insert(32.into(), &super::messaging_system::message_id);
        map.insert(217.into(), &super::test_only_ipc::a_text);
        map
    });

    pub static COUNTER_MAP: Lazy<HashMap<MetricId, &Lazy<CounterMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(20);
        map.insert(24.into(), &super::messaging_system::event_context_parse_error);
        map.insert(28.into(), &super::messaging_system::glean_ping_for_ping_failures);
        map.insert(36.into(), &super::messaging_system::unknown_key_count);
        map.insert(83.into(), &super::browser_engagement::active_ticks);
        map.insert(85.into(), &super::browser_engagement::uri_count);
        map.insert(86.into(), &super::ping_centre::send_failures);
        map.insert(122.into(), &super::dotprint::android_dialog_requested);
        map.insert(124.into(), &super::dotprint::requested);
        map.insert(183.into(), &super::fog_ipc::flush_failures);
        map.insert(184.into(), &super::fog_ipc::replay_failures);
        map.insert(185.into(), &super::fog_ipc::shutdown_registration_failures);
        map.insert(186.into(), &super::test_only::bad_code);
        map.insert(209.into(), &super::test_only_ipc::a_counter);
        map.insert(228.into(), &super::test_only_jog::a_counter);
        map.insert(240.into(), &super::pdfjs::used);
        map.insert(241.into(), &super::power::cpu_time_bogus_values);
        map.insert(244.into(), &super::power::gpu_time_bogus_values);
        map.insert(246.into(), &super::power::total_cpu_time_ms);
        map.insert(247.into(), &super::power::total_gpu_time_ms);
        map.insert(248.into(), &super::power::total_thread_wakeups);
        map
    });

    pub static TIMING_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<TimingDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(22);
        map.insert(73.into(), &super::serp::categorization_duration);
        map.insert(110.into(), &super::paint::build_displaylist_time);
        map.insert(111.into(), &super::wr::framebuild_time);
        map.insert(112.into(), &super::wr::gpu_wait_time);
        map.insert(113.into(), &super::wr::rasterize_blobs_time);
        map.insert(114.into(), &super::wr::rasterize_glyphs_time);
        map.insert(115.into(), &super::wr::renderer_time);
        map.insert(116.into(), &super::wr::renderer_time_no_sc);
        map.insert(117.into(), &super::wr::scenebuild_time);
        map.insert(118.into(), &super::wr::sceneswap_time);
        map.insert(119.into(), &super::wr::texture_cache_update_time);
        map.insert(120.into(), &super::wr::time_to_frame_build);
        map.insert(121.into(), &super::wr::time_to_render_start);
        map.insert(164.into(), &super::cookie_banners_click::handle_duration);
        map.insert(172.into(), &super::extensions_apis_dnr::evaluate_rules_time);
        map.insert(175.into(), &super::extensions_apis_dnr::startup_cache_read_time);
        map.insert(177.into(), &super::extensions_apis_dnr::startup_cache_write_time);
        map.insert(178.into(), &super::extensions_apis_dnr::validate_rules_time);
        map.insert(182.into(), &super::fog_ipc::flush_durations);
        map.insert(207.into(), &super::test_only::what_time_is_it);
        map.insert(218.into(), &super::test_only_ipc::a_timing_dist);
        map.insert(273.into(), &super::search_service::startup_time);
        map
    });

    pub static DENOMINATOR_MAP: Lazy<HashMap<MetricId, &Lazy<DenominatorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(4);
        map.insert(90.into(), &super::rtcrtpsender::count);
        map.insert(91.into(), &super::rtcrtpsender::count_setparameters_compat);
        map.insert(222.into(), &super::test_only_ipc::an_external_denominator);
        map.insert(279.into(), &super::translations::requests_count);
        map
    });

    pub static NUMERATOR_MAP: Lazy<HashMap<MetricId, &Lazy<NumeratorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(15);
        map.insert(92.into(), &super::rtcrtpsender::used_sendencodings);
        map.insert(97.into(), &super::rtcrtpsender_setparameters::fail_length_changed);
        map.insert(98.into(), &super::rtcrtpsender_setparameters::fail_no_encodings);
        map.insert(99.into(), &super::rtcrtpsender_setparameters::fail_no_getparameters);
        map.insert(100.into(), &super::rtcrtpsender_setparameters::fail_no_transactionid);
        map.insert(101.into(), &super::rtcrtpsender_setparameters::fail_other);
        map.insert(102.into(), &super::rtcrtpsender_setparameters::fail_rid_changed);
        map.insert(103.into(), &super::rtcrtpsender_setparameters::fail_stale_transactionid);
        map.insert(104.into(), &super::rtcrtpsender_setparameters::warn_length_changed);
        map.insert(105.into(), &super::rtcrtpsender_setparameters::warn_no_getparameters);
        map.insert(106.into(), &super::rtcrtpsender_setparameters::warn_no_transactionid);
        map.insert(107.into(), &super::rtcrtpsender_setparameters::warn_rid_changed);
        map.insert(108.into(), &super::rtcrtpsender_setparameters::warn_stale_transactionid);
        map.insert(227.into(), &super::test_only_ipc::rate_with_external_denominator);
        map.insert(278.into(), &super::translations::error_rate);
        map
    });

    pub static CUSTOM_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<CustomDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(6);
        map.insert(125.into(), &super::networking::cookie_access_fixup_diff);
        map.insert(126.into(), &super::networking::cookie_creation_fixup_diff);
        map.insert(210.into(), &super::test_only_ipc::a_custom_dist);
        map.insert(239.into(), &super::pdfjs::time_to_view);
        map.insert(250.into(), &super::power_battery::percentage_when_user_active);
        map.insert(299.into(), &super::timer_thread::timers_fired_per_wakeup);
        map
    });

    pub static TIMESPAN_MAP: Lazy<HashMap<MetricId, &Lazy<TimespanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(6);
        map.insert(169.into(), &super::crash::uptime);
        map.insert(170.into(), &super::extensions::startup_cache_load_time);
        map.insert(180.into(), &super::fog::initialization);
        map.insert(188.into(), &super::test_only::can_we_time_it);
        map.insert(201.into(), &super::test_only::mirror_time);
        map.insert(202.into(), &super::test_only::mirror_time_nanos);
        map
    });

    pub static MEMORY_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<MemoryDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(5);
        map.insert(174.into(), &super::extensions_apis_dnr::startup_cache_read_size);
        map.insert(176.into(), &super::extensions_apis_dnr::startup_cache_write_size);
        map.insert(181.into(), &super::fog_ipc::buffer_sizes);
        map.insert(191.into(), &super::test_only::do_you_remember);
        map.insert(213.into(), &super::test_only_ipc::a_memory_dist);
        map
    });

    pub static URL_MAP: Lazy<HashMap<MetricId, &Lazy<UrlMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(3);
        map.insert(219.into(), &super::test_only_ipc::a_url);
        map.insert(265.into(), &super::search_engine_default::submission_url);
        map.insert(271.into(), &super::search_engine_private::submission_url);
        map
    });

    pub static RATE_MAP: Lazy<HashMap<MetricId, &Lazy<RateMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(1);
        map.insert(225.into(), &super::test_only_ipc::irate);
        map
    });


    /// Wrapper to record an event based on its metric ID.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the `extra` map could not be deserialized.
    pub(crate) fn record_event_by_id(metric_id: u32, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          15 => {
              assert!(
                  extra_keys_len(&super::browser_launched_to_handle::system_notification) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::browser_launched_to_handle::system_notification.record_raw(extra);
              Ok(())
          }
          50 => {
              assert!(
                  extra_keys_len(&super::newtab::closed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::closed.record_raw(extra);
              Ok(())
          }
          54 => {
              assert!(
                  extra_keys_len(&super::newtab::opened) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::opened.record_raw(extra);
              Ok(())
          }
          56 => {
              assert!(
                  extra_keys_len(&super::newtab_search::issued) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search::issued.record_raw(extra);
              Ok(())
          }
          57 => {
              assert!(
                  extra_keys_len(&super::pocket::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::click.record_raw(extra);
              Ok(())
          }
          59 => {
              assert!(
                  extra_keys_len(&super::pocket::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::impression.record_raw(extra);
              Ok(())
          }
          61 => {
              assert!(
                  extra_keys_len(&super::pocket::save) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::save.record_raw(extra);
              Ok(())
          }
          63 => {
              assert!(
                  extra_keys_len(&super::pocket::topic_click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::topic_click.record_raw(extra);
              Ok(())
          }
          64 => {
              assert!(
                  extra_keys_len(&super::topsites::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::click.record_raw(extra);
              Ok(())
          }
          66 => {
              assert!(
                  extra_keys_len(&super::topsites::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::impression.record_raw(extra);
              Ok(())
          }
          69 => {
              assert!(
                  extra_keys_len(&super::newtab_search_ad::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search_ad::click.record_raw(extra);
              Ok(())
          }
          70 => {
              assert!(
                  extra_keys_len(&super::newtab_search_ad::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search_ad::impression.record_raw(extra);
              Ok(())
          }
          71 => {
              assert!(
                  extra_keys_len(&super::serp::abandonment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::abandonment.record_raw(extra);
              Ok(())
          }
          72 => {
              assert!(
                  extra_keys_len(&super::serp::ad_impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::ad_impression.record_raw(extra);
              Ok(())
          }
          74 => {
              assert!(
                  extra_keys_len(&super::serp::engagement) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::engagement.record_raw(extra);
              Ok(())
          }
          75 => {
              assert!(
                  extra_keys_len(&super::serp::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::impression.record_raw(extra);
              Ok(())
          }
          76 => {
              assert!(
                  extra_keys_len(&super::translations_panel::open) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::open.record_raw(extra);
              Ok(())
          }
          77 => {
              assert!(
                  extra_keys_len(&super::urlbar::abandonment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::abandonment.record_raw(extra);
              Ok(())
          }
          78 => {
              assert!(
                  extra_keys_len(&super::urlbar::engagement) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::engagement.record_raw(extra);
              Ok(())
          }
          79 => {
              assert!(
                  extra_keys_len(&super::urlbar::exposure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::exposure.record_raw(extra);
              Ok(())
          }
          80 => {
              assert!(
                  extra_keys_len(&super::urlbar::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::impression.record_raw(extra);
              Ok(())
          }
          109 => {
              assert!(
                  extra_keys_len(&super::perf::page_load) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::perf::page_load.record_raw(extra);
              Ok(())
          }
          135 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_base::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_base::metric_base.record_raw(extra);
              Ok(())
          }
          143 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_http_cache::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_http_cache::metric_base.record_raw(extra);
              Ok(())
          }
          151 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_quota::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_quota::metric_base.record_raw(extra);
              Ok(())
          }
          160 => {
              assert!(
                  extra_keys_len(&super::cookie_banners::reload) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::cookie_banners::reload.record_raw(extra);
              Ok(())
          }
          221 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::an_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::an_event.record_raw(extra);
              Ok(())
          }
          224 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::event_with_extra) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::event_with_extra.record_raw(extra);
              Ok(())
          }
          226 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::no_extra_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::no_extra_event.record_raw(extra);
              Ok(())
          }
          229 => {
              assert!(
                  extra_keys_len(&super::test_only_jog::an_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_jog::an_event.record_raw(extra);
              Ok(())
          }
          230 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::enroll_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::enroll_failed.record_raw(extra);
              Ok(())
          }
          231 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::enrollment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::enrollment.record_raw(extra);
              Ok(())
          }
          232 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::exposure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::exposure.record_raw(extra);
              Ok(())
          }
          233 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::unenroll_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::unenroll_failed.record_raw(extra);
              Ok(())
          }
          234 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::unenrollment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::unenrollment.record_raw(extra);
              Ok(())
          }
          235 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::validation_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::validation_failed.record_raw(extra);
              Ok(())
          }
          261 => {
              assert!(
                  extra_keys_len(&super::search_engine_default::changed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::search_engine_default::changed.record_raw(extra);
              Ok(())
          }
          267 => {
              assert!(
                  extra_keys_len(&super::search_engine_private::changed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::search_engine_private::changed.record_raw(extra);
              Ok(())
          }
          277 => {
              assert!(
                  extra_keys_len(&super::translations::error) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations::error.record_raw(extra);
              Ok(())
          }
          280 => {
              assert!(
                  extra_keys_len(&super::translations::translation_request) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations::translation_request.record_raw(extra);
              Ok(())
          }
          283 => {
              assert!(
                  extra_keys_len(&super::blocklist::addon_block_change) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::blocklist::addon_block_change.record_raw(extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to record an event based on its metric ID, with a provided timestamp.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `timestamp` - The time at which this event was recorded.
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the event doesn't take extra pairs,
    /// but some are passed in.
    pub(crate) fn record_event_by_id_with_time(metric_id: MetricId, timestamp: u64, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          MetricId(15) => {
              if extra_keys_len(&super::browser_launched_to_handle::system_notification) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_launched_to_handle::system_notification.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(50) => {
              if extra_keys_len(&super::newtab::closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::closed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(54) => {
              if extra_keys_len(&super::newtab::opened) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::opened.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(56) => {
              if extra_keys_len(&super::newtab_search::issued) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search::issued.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(57) => {
              if extra_keys_len(&super::pocket::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(59) => {
              if extra_keys_len(&super::pocket::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(61) => {
              if extra_keys_len(&super::pocket::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::save.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(63) => {
              if extra_keys_len(&super::pocket::topic_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::topic_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(64) => {
              if extra_keys_len(&super::topsites::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(66) => {
              if extra_keys_len(&super::topsites::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(69) => {
              if extra_keys_len(&super::newtab_search_ad::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(70) => {
              if extra_keys_len(&super::newtab_search_ad::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(71) => {
              if extra_keys_len(&super::serp::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(72) => {
              if extra_keys_len(&super::serp::ad_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::ad_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(74) => {
              if extra_keys_len(&super::serp::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(75) => {
              if extra_keys_len(&super::serp::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(76) => {
              if extra_keys_len(&super::translations_panel::open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(77) => {
              if extra_keys_len(&super::urlbar::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(78) => {
              if extra_keys_len(&super::urlbar::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(79) => {
              if extra_keys_len(&super::urlbar::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(80) => {
              if extra_keys_len(&super::urlbar::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(109) => {
              if extra_keys_len(&super::perf::page_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::perf::page_load.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(135) => {
              if extra_keys_len(&super::background_tasks_rmdir_base::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_base::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(143) => {
              if extra_keys_len(&super::background_tasks_rmdir_http_cache::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_http_cache::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(151) => {
              if extra_keys_len(&super::background_tasks_rmdir_quota::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_quota::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(160) => {
              if extra_keys_len(&super::cookie_banners::reload) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::reload.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(221) => {
              if extra_keys_len(&super::test_only_ipc::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(224) => {
              if extra_keys_len(&super::test_only_ipc::event_with_extra) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::event_with_extra.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(226) => {
              if extra_keys_len(&super::test_only_ipc::no_extra_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::no_extra_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(229) => {
              if extra_keys_len(&super::test_only_jog::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_jog::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(230) => {
              if extra_keys_len(&super::nimbus_events::enroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(231) => {
              if extra_keys_len(&super::nimbus_events::enrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(232) => {
              if extra_keys_len(&super::nimbus_events::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(233) => {
              if extra_keys_len(&super::nimbus_events::unenroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(234) => {
              if extra_keys_len(&super::nimbus_events::unenrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(235) => {
              if extra_keys_len(&super::nimbus_events::validation_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::validation_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(261) => {
              if extra_keys_len(&super::search_engine_default::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_default::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(267) => {
              if extra_keys_len(&super::search_engine_private::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_private::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(277) => {
              if extra_keys_len(&super::translations::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(280) => {
              if extra_keys_len(&super::translations::translation_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::translation_request.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(283) => {
              if extra_keys_len(&super::blocklist::addon_block_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::blocklist::addon_block_change.record_with_time(timestamp, extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to get the currently stored events for event metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns the recorded events or `None` if nothing stored.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    pub(crate) fn event_test_get_value_wrapper(metric_id: u32, ping_name: Option<String>) -> Option<Vec<RecordedEvent>> {
        match metric_id {
           15 => super::browser_launched_to_handle::system_notification.test_get_value(ping_name.as_deref()),
           50 => super::newtab::closed.test_get_value(ping_name.as_deref()),
           54 => super::newtab::opened.test_get_value(ping_name.as_deref()),
           56 => super::newtab_search::issued.test_get_value(ping_name.as_deref()),
           57 => super::pocket::click.test_get_value(ping_name.as_deref()),
           59 => super::pocket::impression.test_get_value(ping_name.as_deref()),
           61 => super::pocket::save.test_get_value(ping_name.as_deref()),
           63 => super::pocket::topic_click.test_get_value(ping_name.as_deref()),
           64 => super::topsites::click.test_get_value(ping_name.as_deref()),
           66 => super::topsites::impression.test_get_value(ping_name.as_deref()),
           69 => super::newtab_search_ad::click.test_get_value(ping_name.as_deref()),
           70 => super::newtab_search_ad::impression.test_get_value(ping_name.as_deref()),
           71 => super::serp::abandonment.test_get_value(ping_name.as_deref()),
           72 => super::serp::ad_impression.test_get_value(ping_name.as_deref()),
           74 => super::serp::engagement.test_get_value(ping_name.as_deref()),
           75 => super::serp::impression.test_get_value(ping_name.as_deref()),
           76 => super::translations_panel::open.test_get_value(ping_name.as_deref()),
           77 => super::urlbar::abandonment.test_get_value(ping_name.as_deref()),
           78 => super::urlbar::engagement.test_get_value(ping_name.as_deref()),
           79 => super::urlbar::exposure.test_get_value(ping_name.as_deref()),
           80 => super::urlbar::impression.test_get_value(ping_name.as_deref()),
           109 => super::perf::page_load.test_get_value(ping_name.as_deref()),
           135 => super::background_tasks_rmdir_base::metric_base.test_get_value(ping_name.as_deref()),
           143 => super::background_tasks_rmdir_http_cache::metric_base.test_get_value(ping_name.as_deref()),
           151 => super::background_tasks_rmdir_quota::metric_base.test_get_value(ping_name.as_deref()),
           160 => super::cookie_banners::reload.test_get_value(ping_name.as_deref()),
           221 => super::test_only_ipc::an_event.test_get_value(ping_name.as_deref()),
           224 => super::test_only_ipc::event_with_extra.test_get_value(ping_name.as_deref()),
           226 => super::test_only_ipc::no_extra_event.test_get_value(ping_name.as_deref()),
           229 => super::test_only_jog::an_event.test_get_value(ping_name.as_deref()),
           230 => super::nimbus_events::enroll_failed.test_get_value(ping_name.as_deref()),
           231 => super::nimbus_events::enrollment.test_get_value(ping_name.as_deref()),
           232 => super::nimbus_events::exposure.test_get_value(ping_name.as_deref()),
           233 => super::nimbus_events::unenroll_failed.test_get_value(ping_name.as_deref()),
           234 => super::nimbus_events::unenrollment.test_get_value(ping_name.as_deref()),
           235 => super::nimbus_events::validation_failed.test_get_value(ping_name.as_deref()),
           261 => super::search_engine_default::changed.test_get_value(ping_name.as_deref()),
           267 => super::search_engine_private::changed.test_get_value(ping_name.as_deref()),
           277 => super::translations::error.test_get_value(ping_name.as_deref()),
           280 => super::translations::translation_request.test_get_value(ping_name.as_deref()),
           283 => super::blocklist::addon_block_change.test_get_value(ping_name.as_deref()),
           _ => panic!("No event for metric id {}", metric_id),
        }
    }

    /// Check the provided event for errors.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns a string for the recorded error or `None`.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn event_test_get_error(metric_id: u32) -> Option<String> {
        #[cfg(feature = "with_gecko")]
        match metric_id {
           15 => test_get_errors!(super::browser_launched_to_handle::system_notification),
           50 => test_get_errors!(super::newtab::closed),
           54 => test_get_errors!(super::newtab::opened),
           56 => test_get_errors!(super::newtab_search::issued),
           57 => test_get_errors!(super::pocket::click),
           59 => test_get_errors!(super::pocket::impression),
           61 => test_get_errors!(super::pocket::save),
           63 => test_get_errors!(super::pocket::topic_click),
           64 => test_get_errors!(super::topsites::click),
           66 => test_get_errors!(super::topsites::impression),
           69 => test_get_errors!(super::newtab_search_ad::click),
           70 => test_get_errors!(super::newtab_search_ad::impression),
           71 => test_get_errors!(super::serp::abandonment),
           72 => test_get_errors!(super::serp::ad_impression),
           74 => test_get_errors!(super::serp::engagement),
           75 => test_get_errors!(super::serp::impression),
           76 => test_get_errors!(super::translations_panel::open),
           77 => test_get_errors!(super::urlbar::abandonment),
           78 => test_get_errors!(super::urlbar::engagement),
           79 => test_get_errors!(super::urlbar::exposure),
           80 => test_get_errors!(super::urlbar::impression),
           109 => test_get_errors!(super::perf::page_load),
           135 => test_get_errors!(super::background_tasks_rmdir_base::metric_base),
           143 => test_get_errors!(super::background_tasks_rmdir_http_cache::metric_base),
           151 => test_get_errors!(super::background_tasks_rmdir_quota::metric_base),
           160 => test_get_errors!(super::cookie_banners::reload),
           221 => test_get_errors!(super::test_only_ipc::an_event),
           224 => test_get_errors!(super::test_only_ipc::event_with_extra),
           226 => test_get_errors!(super::test_only_ipc::no_extra_event),
           229 => test_get_errors!(super::test_only_jog::an_event),
           230 => test_get_errors!(super::nimbus_events::enroll_failed),
           231 => test_get_errors!(super::nimbus_events::enrollment),
           232 => test_get_errors!(super::nimbus_events::exposure),
           233 => test_get_errors!(super::nimbus_events::unenroll_failed),
           234 => test_get_errors!(super::nimbus_events::unenrollment),
           235 => test_get_errors!(super::nimbus_events::validation_failed),
           261 => test_get_errors!(super::search_engine_default::changed),
           267 => test_get_errors!(super::search_engine_private::changed),
           277 => test_get_errors!(super::translations::error),
           280 => test_get_errors!(super::translations::translation_request),
           283 => test_get_errors!(super::blocklist::addon_block_change),
           _ => panic!("No event for metric id {}", metric_id),
        }

        #[cfg(not(feature = "with_gecko"))]
        {
            return None;
        }
    }

    /// Gets the submetric from the specified labeled_counter metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the counter submetric.
    ///
    /// # Returns
    ///
    /// Returns the counter submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_counter by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_counter_get(metric_id: u32, label: &str) -> LabeledCounterMetric {
        match metric_id {
            30 => super::messaging_system::invalid_nested_data.get(label),
            37 => super::messaging_system::unknown_keys.get(label),
            47 => super::messaging_system_attribution::unknown_keys.get(label),
            87 => super::ping_centre::send_failures_by_namespace.get(label),
            88 => super::ping_centre::send_successes_by_namespace.get(label),
            89 => super::gmp::update_xml_fetch_result.get(label),
            93 => super::rtcrtpsender_setparameters::blame_length_changed.get(label),
            94 => super::rtcrtpsender_setparameters::blame_no_getparameters.get(label),
            95 => super::rtcrtpsender_setparameters::blame_no_transactionid.get(label),
            96 => super::rtcrtpsender_setparameters::blame_stale_transactionid.get(label),
            123 => super::dotprint::failure.get(label),
            127 => super::networking::cookie_timestamp_fixed_count.get(label),
            128 => super::networking::speculative_connect_outcome.get(label),
            129 => super::netwerk::early_hints.get(label),
            130 => super::netwerk::eh_link_type.get(label),
            131 => super::network::cors_authorization_header.get(label),
            132 => super::network::data_size_pb_per_type.get(label),
            133 => super::network::data_size_per_type.get(label),
            161 => super::cookie_banners::rule_lookup_by_domain.get(label),
            162 => super::cookie_banners::rule_lookup_by_load.get(label),
            165 => super::cookie_banners_click::result.get(label),
            173 => super::extensions_apis_dnr::startup_cache_entries.get(label),
            194 => super::test_only::mabels_bathroom_counters.get(label),
            195 => super::test_only::mabels_kitchen_counters.get(label),
            197 => super::test_only::mabels_labeled_counters.get(label),
            212 => super::test_only_ipc::a_labeled_counter.get(label),
            223 => super::test_only_ipc::another_labeled_counter.get(label),
            236 => super::pdfjs::buttons.get(label),
            237 => super::pdfjs::editing.get(label),
            238 => super::pdfjs::geckoview.get(label),
            242 => super::power::cpu_time_per_process_type_ms.get(label),
            243 => super::power::cpu_time_per_tracker_type_ms.get(label),
            245 => super::power::gpu_time_per_process_type_ms.get(label),
            249 => super::power::wakeups_per_process_type.get(label),
            251 => super::power_cpu_ms_per_thread::content_background.get(label),
            252 => super::power_cpu_ms_per_thread::content_foreground.get(label),
            253 => super::power_cpu_ms_per_thread::gpu_process.get(label),
            254 => super::power_cpu_ms_per_thread::parent_active.get(label),
            255 => super::power_cpu_ms_per_thread::parent_inactive.get(label),
            256 => super::power_wakeups_per_thread::content_background.get(label),
            257 => super::power_wakeups_per_thread::content_foreground.get(label),
            258 => super::power_wakeups_per_thread::gpu_process.get(label),
            259 => super::power_wakeups_per_thread::parent_active.get(label),
            260 => super::power_wakeups_per_thread::parent_inactive.get(label),
            274 => super::dap::report_generation_status.get(label),
            275 => super::dap::upload_status.get(label),
            _ => panic!("No labeled_counter for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_counter metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the counter submetric.
    ///
    /// # Returns
    ///
    /// Returns the counter submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_counter by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_counter_enum_get(metric_id: u32, label_enum: u16) -> LabeledCounterMetric {
        match metric_id {
            87 => super::ping_centre::send_failures_by_namespace.get(labeled_enum_to_str(metric_id, label_enum)),
            88 => super::ping_centre::send_successes_by_namespace.get(labeled_enum_to_str(metric_id, label_enum)),
            89 => super::gmp::update_xml_fetch_result.get(labeled_enum_to_str(metric_id, label_enum)),
            123 => super::dotprint::failure.get(labeled_enum_to_str(metric_id, label_enum)),
            127 => super::networking::cookie_timestamp_fixed_count.get(labeled_enum_to_str(metric_id, label_enum)),
            128 => super::networking::speculative_connect_outcome.get(labeled_enum_to_str(metric_id, label_enum)),
            129 => super::netwerk::early_hints.get(labeled_enum_to_str(metric_id, label_enum)),
            130 => super::netwerk::eh_link_type.get(labeled_enum_to_str(metric_id, label_enum)),
            131 => super::network::cors_authorization_header.get(labeled_enum_to_str(metric_id, label_enum)),
            132 => super::network::data_size_pb_per_type.get(labeled_enum_to_str(metric_id, label_enum)),
            133 => super::network::data_size_per_type.get(labeled_enum_to_str(metric_id, label_enum)),
            161 => super::cookie_banners::rule_lookup_by_domain.get(labeled_enum_to_str(metric_id, label_enum)),
            162 => super::cookie_banners::rule_lookup_by_load.get(labeled_enum_to_str(metric_id, label_enum)),
            165 => super::cookie_banners_click::result.get(labeled_enum_to_str(metric_id, label_enum)),
            173 => super::extensions_apis_dnr::startup_cache_entries.get(labeled_enum_to_str(metric_id, label_enum)),
            197 => super::test_only::mabels_labeled_counters.get(labeled_enum_to_str(metric_id, label_enum)),
            236 => super::pdfjs::buttons.get(labeled_enum_to_str(metric_id, label_enum)),
            237 => super::pdfjs::editing.get(labeled_enum_to_str(metric_id, label_enum)),
            238 => super::pdfjs::geckoview.get(labeled_enum_to_str(metric_id, label_enum)),
            242 => super::power::cpu_time_per_process_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            243 => super::power::cpu_time_per_tracker_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            245 => super::power::gpu_time_per_process_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            249 => super::power::wakeups_per_process_type.get(labeled_enum_to_str(metric_id, label_enum)),
            251 => super::power_cpu_ms_per_thread::content_background.get(labeled_enum_to_str(metric_id, label_enum)),
            252 => super::power_cpu_ms_per_thread::content_foreground.get(labeled_enum_to_str(metric_id, label_enum)),
            253 => super::power_cpu_ms_per_thread::gpu_process.get(labeled_enum_to_str(metric_id, label_enum)),
            254 => super::power_cpu_ms_per_thread::parent_active.get(labeled_enum_to_str(metric_id, label_enum)),
            255 => super::power_cpu_ms_per_thread::parent_inactive.get(labeled_enum_to_str(metric_id, label_enum)),
            256 => super::power_wakeups_per_thread::content_background.get(labeled_enum_to_str(metric_id, label_enum)),
            257 => super::power_wakeups_per_thread::content_foreground.get(labeled_enum_to_str(metric_id, label_enum)),
            258 => super::power_wakeups_per_thread::gpu_process.get(labeled_enum_to_str(metric_id, label_enum)),
            259 => super::power_wakeups_per_thread::parent_active.get(labeled_enum_to_str(metric_id, label_enum)),
            260 => super::power_wakeups_per_thread::parent_inactive.get(labeled_enum_to_str(metric_id, label_enum)),
            274 => super::dap::report_generation_status.get(labeled_enum_to_str(metric_id, label_enum)),
            275 => super::dap::upload_status.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_counter for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_boolean metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the boolean submetric.
    ///
    /// # Returns
    ///
    /// Returns the boolean submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_boolean by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_boolean_get(metric_id: u32, label: &str) -> LabeledBooleanMetric {
        match metric_id {
            158 => super::cookie_banners::normal_window_service_mode.get(label),
            159 => super::cookie_banners::private_window_service_mode.get(label),
            198 => super::test_only::mabels_like_balloons.get(label),
            199 => super::test_only::mabels_like_labeled_balloons.get(label),
            203 => super::test_only::mirrors_for_labeled_bools.get(label),
            _ => panic!("No labeled_boolean for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_boolean metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the boolean submetric.
    ///
    /// # Returns
    ///
    /// Returns the boolean submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_boolean by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_boolean_enum_get(metric_id: u32, label_enum: u16) -> LabeledBooleanMetric {
        match metric_id {
            158 => super::cookie_banners::normal_window_service_mode.get(labeled_enum_to_str(metric_id, label_enum)),
            159 => super::cookie_banners::private_window_service_mode.get(labeled_enum_to_str(metric_id, label_enum)),
            199 => super::test_only::mabels_like_labeled_balloons.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_boolean for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_string metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the string submetric.
    ///
    /// # Returns
    ///
    /// Returns the string submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_string by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_string_get(metric_id: u32, label: &str) -> LabeledStringMetric {
        match metric_id {
            192 => super::test_only::mabels_balloon_labels.get(label),
            193 => super::test_only::mabels_balloon_strings.get(label),
            196 => super::test_only::mabels_label_maker.get(label),
            _ => panic!("No labeled_string for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_string metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the string submetric.
    ///
    /// # Returns
    ///
    /// Returns the string submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_string by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_string_enum_get(metric_id: u32, label_enum: u16) -> LabeledStringMetric {
        match metric_id {
            192 => super::test_only::mabels_balloon_labels.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_string for metric id {}", metric_id),
        }
    }

    pub(crate) fn labeled_enum_to_str(metric_id: u32, label: u16) -> &'static str {
        match metric_id {
            87 => super::ping_centre::SendFailuresByNamespaceLabel::from(label).into(),
            88 => super::ping_centre::SendSuccessesByNamespaceLabel::from(label).into(),
            89 => super::gmp::UpdateXmlFetchResultLabel::from(label).into(),
            123 => super::dotprint::FailureLabel::from(label).into(),
            127 => super::networking::CookieTimestampFixedCountLabel::from(label).into(),
            128 => super::networking::SpeculativeConnectOutcomeLabel::from(label).into(),
            129 => super::netwerk::EarlyHintsLabel::from(label).into(),
            130 => super::netwerk::EhLinkTypeLabel::from(label).into(),
            131 => super::network::CorsAuthorizationHeaderLabel::from(label).into(),
            132 => super::network::DataSizePbPerTypeLabel::from(label).into(),
            133 => super::network::DataSizePerTypeLabel::from(label).into(),
            158 => super::cookie_banners::NormalWindowServiceModeLabel::from(label).into(),
            159 => super::cookie_banners::PrivateWindowServiceModeLabel::from(label).into(),
            161 => super::cookie_banners::RuleLookupByDomainLabel::from(label).into(),
            162 => super::cookie_banners::RuleLookupByLoadLabel::from(label).into(),
            165 => super::cookie_banners_click::ResultLabel::from(label).into(),
            173 => super::extensions_apis_dnr::StartupCacheEntriesLabel::from(label).into(),
            192 => super::test_only::MabelsBalloonLabelsLabel::from(label).into(),
            197 => super::test_only::MabelsLabeledCountersLabel::from(label).into(),
            199 => super::test_only::MabelsLikeLabeledBalloonsLabel::from(label).into(),
            236 => super::pdfjs::ButtonsLabel::from(label).into(),
            237 => super::pdfjs::EditingLabel::from(label).into(),
            238 => super::pdfjs::GeckoviewLabel::from(label).into(),
            242 => super::power::CpuTimePerProcessTypeMsLabel::from(label).into(),
            243 => super::power::CpuTimePerTrackerTypeMsLabel::from(label).into(),
            245 => super::power::GpuTimePerProcessTypeMsLabel::from(label).into(),
            249 => super::power::WakeupsPerProcessTypeLabel::from(label).into(),
            251 => super::power_cpu_ms_per_thread::ContentBackgroundLabel::from(label).into(),
            252 => super::power_cpu_ms_per_thread::ContentForegroundLabel::from(label).into(),
            253 => super::power_cpu_ms_per_thread::GpuProcessLabel::from(label).into(),
            254 => super::power_cpu_ms_per_thread::ParentActiveLabel::from(label).into(),
            255 => super::power_cpu_ms_per_thread::ParentInactiveLabel::from(label).into(),
            256 => super::power_wakeups_per_thread::ContentBackgroundLabel::from(label).into(),
            257 => super::power_wakeups_per_thread::ContentForegroundLabel::from(label).into(),
            258 => super::power_wakeups_per_thread::GpuProcessLabel::from(label).into(),
            259 => super::power_wakeups_per_thread::ParentActiveLabel::from(label).into(),
            260 => super::power_wakeups_per_thread::ParentInactiveLabel::from(label).into(),
            274 => super::dap::ReportGenerationStatusLabel::from(label).into(),
            275 => super::dap::UploadStatusLabel::from(label).into(),
            _ => panic!("Can't turn label enum to string for metric {} which isn't a labeled metric with static labels", metric_id),
        }
    }

    pub(crate) mod submetric_maps {
        use std::sync::{
          atomic::AtomicU32,
          RwLock,
        };
        use super::*;

        pub(crate) const SUBMETRIC_BIT: u32 = 25;
        pub(crate) static NEXT_LABELED_SUBMETRIC_ID: AtomicU32 = AtomicU32::new((1 << SUBMETRIC_BIT) + 1);
        pub(crate) static LABELED_METRICS_TO_IDS: Lazy<RwLock<HashMap<(u32, String), u32>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub(crate) static LABELED_ENUMS_TO_IDS: Lazy<RwLock<HashMap<(u32, u16), u32>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );

        pub static BOOLEAN_MAP: Lazy<RwLock<HashMap<MetricId, LabeledBooleanMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static STRING_MAP: Lazy<RwLock<HashMap<MetricId, LabeledStringMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static COUNTER_MAP: Lazy<RwLock<HashMap<MetricId, LabeledCounterMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
    }
}

