/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */

// `data` comes from components/style/properties.mako.rs; see build.rs for more details.




use crate::Atom;
use app_units::Au;
use crate::computed_value_flags::*;
use crate::custom_properties::CustomPropertiesMap;
use crate::gecko_bindings::bindings;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePage;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePage;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePage;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_CopyCounterStyle;
use crate::gecko_bindings::bindings::Gecko_EnsureImageLayersLength;
use crate::gecko_bindings::bindings::Gecko_nsStyleFont_SetLang;
use crate::gecko_bindings::bindings::Gecko_nsStyleFont_CopyLangFrom;
use crate::gecko_bindings::structs;
use crate::gecko_bindings::structs::nsCSSPropertyID;
use crate::gecko_bindings::structs::mozilla::PseudoStyleType;
use crate::gecko::data::PerDocumentStyleData;
use crate::logical_geometry::WritingMode;
use crate::media_queries::Device;
use crate::properties::longhands;
use crate::rule_tree::StrongRuleNode;
use crate::selector_parser::PseudoElement;
use servo_arc::{Arc, UniqueArc};
use std::mem::{forget, MaybeUninit, ManuallyDrop};
use std::{cmp, ops, ptr};
use crate::values::{self, CustomIdent, KeyframesName};
use crate::values::computed::{BorderStyle, Percentage, Time, TransitionProperty};
use crate::values::computed::font::FontSize;
use crate::values::generics::column::ColumnCount;


pub mod style_structs {
    pub use super::GeckoBackground as Background;

    unsafe impl Send for Background {}
    unsafe impl Sync for Background {}
    pub use super::GeckoBorder as Border;

    unsafe impl Send for Border {}
    unsafe impl Sync for Border {}
    pub use super::GeckoBox as Box;

    unsafe impl Send for Box {}
    unsafe impl Sync for Box {}
    pub use super::GeckoColumn as Column;

    unsafe impl Send for Column {}
    unsafe impl Sync for Column {}
    pub use super::GeckoCounters as Counters;

    unsafe impl Send for Counters {}
    unsafe impl Sync for Counters {}
    pub use super::GeckoEffects as Effects;

    unsafe impl Send for Effects {}
    unsafe impl Sync for Effects {}
    pub use super::GeckoFont as Font;

    unsafe impl Send for Font {}
    unsafe impl Sync for Font {}
    pub use super::GeckoInheritedBox as InheritedBox;

    unsafe impl Send for InheritedBox {}
    unsafe impl Sync for InheritedBox {}
    pub use super::GeckoInheritedSVG as InheritedSVG;

    unsafe impl Send for InheritedSVG {}
    unsafe impl Sync for InheritedSVG {}
    pub use super::GeckoInheritedTable as InheritedTable;

    unsafe impl Send for InheritedTable {}
    unsafe impl Sync for InheritedTable {}
    pub use super::GeckoInheritedText as InheritedText;

    unsafe impl Send for InheritedText {}
    unsafe impl Sync for InheritedText {}
    pub use super::GeckoInheritedUI as InheritedUI;

    unsafe impl Send for InheritedUI {}
    unsafe impl Sync for InheritedUI {}
    pub use super::GeckoList as List;

    unsafe impl Send for List {}
    unsafe impl Sync for List {}
    pub use super::GeckoMargin as Margin;

    unsafe impl Send for Margin {}
    unsafe impl Sync for Margin {}
    pub use super::GeckoOutline as Outline;

    unsafe impl Send for Outline {}
    unsafe impl Sync for Outline {}
    pub use super::GeckoPage as Page;

    unsafe impl Send for Page {}
    unsafe impl Sync for Page {}
    pub use super::GeckoPadding as Padding;

    unsafe impl Send for Padding {}
    unsafe impl Sync for Padding {}
    pub use super::GeckoPosition as Position;

    unsafe impl Send for Position {}
    unsafe impl Sync for Position {}
    pub use super::GeckoSVG as SVG;

    unsafe impl Send for SVG {}
    unsafe impl Sync for SVG {}
    pub use super::GeckoTable as Table;

    unsafe impl Send for Table {}
    unsafe impl Sync for Table {}
    pub use super::GeckoText as Text;

    unsafe impl Send for Text {}
    unsafe impl Sync for Text {}
    pub use super::GeckoUI as UI;

    unsafe impl Send for UI {}
    unsafe impl Sync for UI {}
    pub use super::GeckoXUL as XUL;

    unsafe impl Send for XUL {}
    unsafe impl Sync for XUL {}
}

/// FIXME(emilio): This is completely duplicated with the other properties code.
pub type ComputedValuesInner = structs::ServoComputedData;

#[repr(C)]
pub struct ComputedValues(structs::mozilla::ComputedStyle);

impl ComputedValues {
    #[inline]
    pub (crate) fn as_gecko_computed_style(&self) -> &structs::ComputedStyle {
        &self.0
    }

    pub fn new(
        pseudo: Option<&PseudoElement>,
        custom_properties: Option<Arc<CustomPropertiesMap>>,
        writing_mode: WritingMode,
        flags: ComputedValueFlags,
        rules: Option<StrongRuleNode>,
        visited_style: Option<Arc<ComputedValues>>,
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        page: Arc<style_structs::Page>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        svg: Arc<style_structs::SVG>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        xul: Arc<style_structs::XUL>,
    ) -> Arc<Self> {
        ComputedValuesInner::new(
            custom_properties,
            writing_mode,
            flags,
            rules,
            visited_style,
            background,
            border,
            box_,
            column,
            counters,
            effects,
            font,
            inherited_box,
            inherited_svg,
            inherited_table,
            inherited_text,
            inherited_ui,
            list,
            margin,
            outline,
            page,
            padding,
            position,
            svg,
            table,
            text,
            ui,
            xul,
        ).to_outer(pseudo)
    }

    pub fn default_values(doc: &structs::Document) -> Arc<Self> {
        ComputedValuesInner::new(
            /* custom_properties = */ None,
            /* writing_mode = */ WritingMode::empty(), // FIXME(bz): This seems dubious
            ComputedValueFlags::empty(),
            /* rules = */ None,
            /* visited_style = */ None,
            style_structs::Background::default(doc),
            style_structs::Border::default(doc),
            style_structs::Box::default(doc),
            style_structs::Column::default(doc),
            style_structs::Counters::default(doc),
            style_structs::Effects::default(doc),
            style_structs::Font::default(doc),
            style_structs::InheritedBox::default(doc),
            style_structs::InheritedSVG::default(doc),
            style_structs::InheritedTable::default(doc),
            style_structs::InheritedText::default(doc),
            style_structs::InheritedUI::default(doc),
            style_structs::List::default(doc),
            style_structs::Margin::default(doc),
            style_structs::Outline::default(doc),
            style_structs::Page::default(doc),
            style_structs::Padding::default(doc),
            style_structs::Position::default(doc),
            style_structs::SVG::default(doc),
            style_structs::Table::default(doc),
            style_structs::Text::default(doc),
            style_structs::UI::default(doc),
            style_structs::XUL::default(doc),
        ).to_outer(None)
    }

    /// Converts the computed values to an Arc<> from a reference.
    pub fn to_arc(&self) -> Arc<Self> {
        // SAFETY: We're guaranteed to be allocated as an Arc<> since the
        // functions above are the only ones that create ComputedValues
        // instances in Gecko (and that must be the case since ComputedValues'
        // member is private).
        unsafe { Arc::from_raw_addrefed(self) }
    }

    #[inline]
    pub fn is_pseudo_style(&self) -> bool {
        self.0.mPseudoType != PseudoStyleType::NotPseudo
    }

    #[inline]
    pub fn pseudo(&self) -> Option<PseudoElement> {
        if !self.is_pseudo_style() {
            return None;
        }
        PseudoElement::from_pseudo_type(self.0.mPseudoType)
    }

    #[inline]
    pub fn is_first_line_style(&self) -> bool {
        self.pseudo() == Some(PseudoElement::FirstLine)
    }

    /// Returns true if the display property is changed from 'none' to others.
    pub fn is_display_property_changed_from_none(
        &self,
        old_values: Option<&ComputedValues>
    ) -> bool {
        use crate::properties::longhands::display::computed_value::T as Display;

        old_values.map_or(false, |old| {
            let old_display_style = old.get_box().clone_display();
            let new_display_style = self.get_box().clone_display();
            old_display_style == Display::None &&
            new_display_style != Display::None
        })
    }

}

impl Drop for ComputedValues {
    fn drop(&mut self) {
        // XXX this still relies on the destructor of ComputedValuesInner to run on the rust side,
        // that's pretty wild.
        unsafe {
            bindings::Gecko_ComputedStyle_Destroy(&mut self.0);
        }
    }
}

unsafe impl Sync for ComputedValues {}
unsafe impl Send for ComputedValues {}

impl Clone for ComputedValues {
    fn clone(&self) -> Self {
        unreachable!()
    }
}

impl Clone for ComputedValuesInner {
    fn clone(&self) -> Self {
        ComputedValuesInner {
            Background: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.background_ptr()) }) as *const _,
            Border: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.border_ptr()) }) as *const _,
            Display: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.box_ptr()) }) as *const _,
            Column: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.column_ptr()) }) as *const _,
            Content: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.counters_ptr()) }) as *const _,
            Effects: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.effects_ptr()) }) as *const _,
            Font: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.font_ptr()) }) as *const _,
            Visibility: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.inherited_box_ptr()) }) as *const _,
            SVG: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.inherited_svg_ptr()) }) as *const _,
            TableBorder: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.inherited_table_ptr()) }) as *const _,
            Text: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.inherited_text_ptr()) }) as *const _,
            UI: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.inherited_ui_ptr()) }) as *const _,
            List: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.list_ptr()) }) as *const _,
            Margin: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.margin_ptr()) }) as *const _,
            Outline: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.outline_ptr()) }) as *const _,
            Page: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.page_ptr()) }) as *const _,
            Padding: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.padding_ptr()) }) as *const _,
            Position: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.position_ptr()) }) as *const _,
            SVGReset: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.svg_ptr()) }) as *const _,
            Table: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.table_ptr()) }) as *const _,
            TextReset: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.text_ptr()) }) as *const _,
            UIReset: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.ui_ptr()) }) as *const _,
            XUL: Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.xul_ptr()) }) as *const _,
            custom_properties: self.custom_properties.clone(),
            writing_mode: self.writing_mode.clone(),
            flags: self.flags.clone(),
            rules: self.rules.clone(),
            visited_style: if self.visited_style.is_null() {
                ptr::null()
            } else {
                Arc::into_raw(unsafe { Arc::from_raw_addrefed(self.visited_style_ptr()) }) as *const _
            },
        }
    }
}


impl Drop for ComputedValuesInner {
    fn drop(&mut self) {
        let _ = unsafe { Arc::from_raw(self.background_ptr()) };
        let _ = unsafe { Arc::from_raw(self.border_ptr()) };
        let _ = unsafe { Arc::from_raw(self.box_ptr()) };
        let _ = unsafe { Arc::from_raw(self.column_ptr()) };
        let _ = unsafe { Arc::from_raw(self.counters_ptr()) };
        let _ = unsafe { Arc::from_raw(self.effects_ptr()) };
        let _ = unsafe { Arc::from_raw(self.font_ptr()) };
        let _ = unsafe { Arc::from_raw(self.inherited_box_ptr()) };
        let _ = unsafe { Arc::from_raw(self.inherited_svg_ptr()) };
        let _ = unsafe { Arc::from_raw(self.inherited_table_ptr()) };
        let _ = unsafe { Arc::from_raw(self.inherited_text_ptr()) };
        let _ = unsafe { Arc::from_raw(self.inherited_ui_ptr()) };
        let _ = unsafe { Arc::from_raw(self.list_ptr()) };
        let _ = unsafe { Arc::from_raw(self.margin_ptr()) };
        let _ = unsafe { Arc::from_raw(self.outline_ptr()) };
        let _ = unsafe { Arc::from_raw(self.page_ptr()) };
        let _ = unsafe { Arc::from_raw(self.padding_ptr()) };
        let _ = unsafe { Arc::from_raw(self.position_ptr()) };
        let _ = unsafe { Arc::from_raw(self.svg_ptr()) };
        let _ = unsafe { Arc::from_raw(self.table_ptr()) };
        let _ = unsafe { Arc::from_raw(self.text_ptr()) };
        let _ = unsafe { Arc::from_raw(self.ui_ptr()) };
        let _ = unsafe { Arc::from_raw(self.xul_ptr()) };
        if !self.visited_style.is_null() {
            let _ = unsafe { Arc::from_raw(self.visited_style_ptr()) };
        }
    }
}

impl ComputedValuesInner {
    pub fn new(
        custom_properties: Option<Arc<CustomPropertiesMap>>,
        writing_mode: WritingMode,
        flags: ComputedValueFlags,
        rules: Option<StrongRuleNode>,
        visited_style: Option<Arc<ComputedValues>>,
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        page: Arc<style_structs::Page>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        svg: Arc<style_structs::SVG>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        xul: Arc<style_structs::XUL>,
    ) -> Self {
        Self {
            custom_properties,
            writing_mode,
            rules,
            visited_style: visited_style.map_or(ptr::null(), |p| Arc::into_raw(p)) as *const _,
            flags,
            Background: Arc::into_raw(background) as *const _,
            Border: Arc::into_raw(border) as *const _,
            Display: Arc::into_raw(box_) as *const _,
            Column: Arc::into_raw(column) as *const _,
            Content: Arc::into_raw(counters) as *const _,
            Effects: Arc::into_raw(effects) as *const _,
            Font: Arc::into_raw(font) as *const _,
            Visibility: Arc::into_raw(inherited_box) as *const _,
            SVG: Arc::into_raw(inherited_svg) as *const _,
            TableBorder: Arc::into_raw(inherited_table) as *const _,
            Text: Arc::into_raw(inherited_text) as *const _,
            UI: Arc::into_raw(inherited_ui) as *const _,
            List: Arc::into_raw(list) as *const _,
            Margin: Arc::into_raw(margin) as *const _,
            Outline: Arc::into_raw(outline) as *const _,
            Page: Arc::into_raw(page) as *const _,
            Padding: Arc::into_raw(padding) as *const _,
            Position: Arc::into_raw(position) as *const _,
            SVGReset: Arc::into_raw(svg) as *const _,
            Table: Arc::into_raw(table) as *const _,
            TextReset: Arc::into_raw(text) as *const _,
            UIReset: Arc::into_raw(ui) as *const _,
            XUL: Arc::into_raw(xul) as *const _,
        }
    }

    fn to_outer(self, pseudo: Option<&PseudoElement>) -> Arc<ComputedValues> {
        let pseudo_ty = match pseudo {
            Some(p) => p.pseudo_type(),
            None => structs::PseudoStyleType::NotPseudo,
        };
        unsafe {
            let mut arc = UniqueArc::<ComputedValues>::new_uninit();
            bindings::Gecko_ComputedStyle_Init(
                arc.as_mut_ptr() as *mut _,
                &self,
                pseudo_ty,
            );
            // We're simulating move semantics by having C++ do a memcpy and
            // then forgetting it on this end.
            forget(self);
            UniqueArc::assume_init(arc).shareable()
        }
    }
}

impl ops::Deref for ComputedValues {
    type Target = ComputedValuesInner;
    #[inline]
    fn deref(&self) -> &ComputedValuesInner {
        &self.0.mSource
    }
}

impl ops::DerefMut for ComputedValues {
    #[inline]
    fn deref_mut(&mut self) -> &mut ComputedValuesInner {
        &mut self.0.mSource
    }
}

impl ComputedValuesInner {
    /// Returns true if the value of the `content` property would make a
    /// pseudo-element not rendered.
    #[inline]
    pub fn ineffective_content_property(&self) -> bool {
        self.get_counters().ineffective_content_property()
    }

    #[inline]
    fn visited_style_ptr(&self) -> *const ComputedValues {
        self.visited_style as *const _
    }

    /// Returns the visited style, if any.
    pub fn visited_style(&self) -> Option<&ComputedValues> {
        unsafe { self.visited_style_ptr().as_ref() }
    }

    #[inline]
    fn background_ptr(&self) -> *const style_structs::Background {
        // This is sound because the wrapper we create is repr(transparent).
        self.Background as *const _
    }

    #[inline]
    pub fn clone_background(&self) -> Arc<style_structs::Background> {
        unsafe { Arc::from_raw_addrefed(self.background_ptr()) }
    }
    #[inline]
    pub fn get_background(&self) -> &style_structs::Background {
        unsafe { &*self.background_ptr() }
    }

    #[inline]
    pub fn mutate_background(&mut self) -> &mut style_structs::Background {
        unsafe {
            let mut arc = Arc::from_raw(self.background_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Background = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn border_ptr(&self) -> *const style_structs::Border {
        // This is sound because the wrapper we create is repr(transparent).
        self.Border as *const _
    }

    #[inline]
    pub fn clone_border(&self) -> Arc<style_structs::Border> {
        unsafe { Arc::from_raw_addrefed(self.border_ptr()) }
    }
    #[inline]
    pub fn get_border(&self) -> &style_structs::Border {
        unsafe { &*self.border_ptr() }
    }

    #[inline]
    pub fn mutate_border(&mut self) -> &mut style_structs::Border {
        unsafe {
            let mut arc = Arc::from_raw(self.border_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Border = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn box_ptr(&self) -> *const style_structs::Box {
        // This is sound because the wrapper we create is repr(transparent).
        self.Display as *const _
    }

    #[inline]
    pub fn clone_box(&self) -> Arc<style_structs::Box> {
        unsafe { Arc::from_raw_addrefed(self.box_ptr()) }
    }
    #[inline]
    pub fn get_box(&self) -> &style_structs::Box {
        unsafe { &*self.box_ptr() }
    }

    #[inline]
    pub fn mutate_box(&mut self) -> &mut style_structs::Box {
        unsafe {
            let mut arc = Arc::from_raw(self.box_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Display = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn column_ptr(&self) -> *const style_structs::Column {
        // This is sound because the wrapper we create is repr(transparent).
        self.Column as *const _
    }

    #[inline]
    pub fn clone_column(&self) -> Arc<style_structs::Column> {
        unsafe { Arc::from_raw_addrefed(self.column_ptr()) }
    }
    #[inline]
    pub fn get_column(&self) -> &style_structs::Column {
        unsafe { &*self.column_ptr() }
    }

    #[inline]
    pub fn mutate_column(&mut self) -> &mut style_structs::Column {
        unsafe {
            let mut arc = Arc::from_raw(self.column_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Column = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn counters_ptr(&self) -> *const style_structs::Counters {
        // This is sound because the wrapper we create is repr(transparent).
        self.Content as *const _
    }

    #[inline]
    pub fn clone_counters(&self) -> Arc<style_structs::Counters> {
        unsafe { Arc::from_raw_addrefed(self.counters_ptr()) }
    }
    #[inline]
    pub fn get_counters(&self) -> &style_structs::Counters {
        unsafe { &*self.counters_ptr() }
    }

    #[inline]
    pub fn mutate_counters(&mut self) -> &mut style_structs::Counters {
        unsafe {
            let mut arc = Arc::from_raw(self.counters_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Content = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn effects_ptr(&self) -> *const style_structs::Effects {
        // This is sound because the wrapper we create is repr(transparent).
        self.Effects as *const _
    }

    #[inline]
    pub fn clone_effects(&self) -> Arc<style_structs::Effects> {
        unsafe { Arc::from_raw_addrefed(self.effects_ptr()) }
    }
    #[inline]
    pub fn get_effects(&self) -> &style_structs::Effects {
        unsafe { &*self.effects_ptr() }
    }

    #[inline]
    pub fn mutate_effects(&mut self) -> &mut style_structs::Effects {
        unsafe {
            let mut arc = Arc::from_raw(self.effects_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Effects = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn font_ptr(&self) -> *const style_structs::Font {
        // This is sound because the wrapper we create is repr(transparent).
        self.Font as *const _
    }

    #[inline]
    pub fn clone_font(&self) -> Arc<style_structs::Font> {
        unsafe { Arc::from_raw_addrefed(self.font_ptr()) }
    }
    #[inline]
    pub fn get_font(&self) -> &style_structs::Font {
        unsafe { &*self.font_ptr() }
    }

    #[inline]
    pub fn mutate_font(&mut self) -> &mut style_structs::Font {
        unsafe {
            let mut arc = Arc::from_raw(self.font_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Font = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn inherited_box_ptr(&self) -> *const style_structs::InheritedBox {
        // This is sound because the wrapper we create is repr(transparent).
        self.Visibility as *const _
    }

    #[inline]
    pub fn clone_inherited_box(&self) -> Arc<style_structs::InheritedBox> {
        unsafe { Arc::from_raw_addrefed(self.inherited_box_ptr()) }
    }
    #[inline]
    pub fn get_inherited_box(&self) -> &style_structs::InheritedBox {
        unsafe { &*self.inherited_box_ptr() }
    }

    #[inline]
    pub fn mutate_inherited_box(&mut self) -> &mut style_structs::InheritedBox {
        unsafe {
            let mut arc = Arc::from_raw(self.inherited_box_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Visibility = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn inherited_svg_ptr(&self) -> *const style_structs::InheritedSVG {
        // This is sound because the wrapper we create is repr(transparent).
        self.SVG as *const _
    }

    #[inline]
    pub fn clone_inherited_svg(&self) -> Arc<style_structs::InheritedSVG> {
        unsafe { Arc::from_raw_addrefed(self.inherited_svg_ptr()) }
    }
    #[inline]
    pub fn get_inherited_svg(&self) -> &style_structs::InheritedSVG {
        unsafe { &*self.inherited_svg_ptr() }
    }

    #[inline]
    pub fn mutate_inherited_svg(&mut self) -> &mut style_structs::InheritedSVG {
        unsafe {
            let mut arc = Arc::from_raw(self.inherited_svg_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.SVG = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn inherited_table_ptr(&self) -> *const style_structs::InheritedTable {
        // This is sound because the wrapper we create is repr(transparent).
        self.TableBorder as *const _
    }

    #[inline]
    pub fn clone_inherited_table(&self) -> Arc<style_structs::InheritedTable> {
        unsafe { Arc::from_raw_addrefed(self.inherited_table_ptr()) }
    }
    #[inline]
    pub fn get_inherited_table(&self) -> &style_structs::InheritedTable {
        unsafe { &*self.inherited_table_ptr() }
    }

    #[inline]
    pub fn mutate_inherited_table(&mut self) -> &mut style_structs::InheritedTable {
        unsafe {
            let mut arc = Arc::from_raw(self.inherited_table_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.TableBorder = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn inherited_text_ptr(&self) -> *const style_structs::InheritedText {
        // This is sound because the wrapper we create is repr(transparent).
        self.Text as *const _
    }

    #[inline]
    pub fn clone_inherited_text(&self) -> Arc<style_structs::InheritedText> {
        unsafe { Arc::from_raw_addrefed(self.inherited_text_ptr()) }
    }
    #[inline]
    pub fn get_inherited_text(&self) -> &style_structs::InheritedText {
        unsafe { &*self.inherited_text_ptr() }
    }

    #[inline]
    pub fn mutate_inherited_text(&mut self) -> &mut style_structs::InheritedText {
        unsafe {
            let mut arc = Arc::from_raw(self.inherited_text_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Text = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn inherited_ui_ptr(&self) -> *const style_structs::InheritedUI {
        // This is sound because the wrapper we create is repr(transparent).
        self.UI as *const _
    }

    #[inline]
    pub fn clone_inherited_ui(&self) -> Arc<style_structs::InheritedUI> {
        unsafe { Arc::from_raw_addrefed(self.inherited_ui_ptr()) }
    }
    #[inline]
    pub fn get_inherited_ui(&self) -> &style_structs::InheritedUI {
        unsafe { &*self.inherited_ui_ptr() }
    }

    #[inline]
    pub fn mutate_inherited_ui(&mut self) -> &mut style_structs::InheritedUI {
        unsafe {
            let mut arc = Arc::from_raw(self.inherited_ui_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.UI = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn list_ptr(&self) -> *const style_structs::List {
        // This is sound because the wrapper we create is repr(transparent).
        self.List as *const _
    }

    #[inline]
    pub fn clone_list(&self) -> Arc<style_structs::List> {
        unsafe { Arc::from_raw_addrefed(self.list_ptr()) }
    }
    #[inline]
    pub fn get_list(&self) -> &style_structs::List {
        unsafe { &*self.list_ptr() }
    }

    #[inline]
    pub fn mutate_list(&mut self) -> &mut style_structs::List {
        unsafe {
            let mut arc = Arc::from_raw(self.list_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.List = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn margin_ptr(&self) -> *const style_structs::Margin {
        // This is sound because the wrapper we create is repr(transparent).
        self.Margin as *const _
    }

    #[inline]
    pub fn clone_margin(&self) -> Arc<style_structs::Margin> {
        unsafe { Arc::from_raw_addrefed(self.margin_ptr()) }
    }
    #[inline]
    pub fn get_margin(&self) -> &style_structs::Margin {
        unsafe { &*self.margin_ptr() }
    }

    #[inline]
    pub fn mutate_margin(&mut self) -> &mut style_structs::Margin {
        unsafe {
            let mut arc = Arc::from_raw(self.margin_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Margin = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn outline_ptr(&self) -> *const style_structs::Outline {
        // This is sound because the wrapper we create is repr(transparent).
        self.Outline as *const _
    }

    #[inline]
    pub fn clone_outline(&self) -> Arc<style_structs::Outline> {
        unsafe { Arc::from_raw_addrefed(self.outline_ptr()) }
    }
    #[inline]
    pub fn get_outline(&self) -> &style_structs::Outline {
        unsafe { &*self.outline_ptr() }
    }

    #[inline]
    pub fn mutate_outline(&mut self) -> &mut style_structs::Outline {
        unsafe {
            let mut arc = Arc::from_raw(self.outline_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Outline = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn page_ptr(&self) -> *const style_structs::Page {
        // This is sound because the wrapper we create is repr(transparent).
        self.Page as *const _
    }

    #[inline]
    pub fn clone_page(&self) -> Arc<style_structs::Page> {
        unsafe { Arc::from_raw_addrefed(self.page_ptr()) }
    }
    #[inline]
    pub fn get_page(&self) -> &style_structs::Page {
        unsafe { &*self.page_ptr() }
    }

    #[inline]
    pub fn mutate_page(&mut self) -> &mut style_structs::Page {
        unsafe {
            let mut arc = Arc::from_raw(self.page_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Page = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn padding_ptr(&self) -> *const style_structs::Padding {
        // This is sound because the wrapper we create is repr(transparent).
        self.Padding as *const _
    }

    #[inline]
    pub fn clone_padding(&self) -> Arc<style_structs::Padding> {
        unsafe { Arc::from_raw_addrefed(self.padding_ptr()) }
    }
    #[inline]
    pub fn get_padding(&self) -> &style_structs::Padding {
        unsafe { &*self.padding_ptr() }
    }

    #[inline]
    pub fn mutate_padding(&mut self) -> &mut style_structs::Padding {
        unsafe {
            let mut arc = Arc::from_raw(self.padding_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Padding = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn position_ptr(&self) -> *const style_structs::Position {
        // This is sound because the wrapper we create is repr(transparent).
        self.Position as *const _
    }

    #[inline]
    pub fn clone_position(&self) -> Arc<style_structs::Position> {
        unsafe { Arc::from_raw_addrefed(self.position_ptr()) }
    }
    #[inline]
    pub fn get_position(&self) -> &style_structs::Position {
        unsafe { &*self.position_ptr() }
    }

    #[inline]
    pub fn mutate_position(&mut self) -> &mut style_structs::Position {
        unsafe {
            let mut arc = Arc::from_raw(self.position_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Position = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn svg_ptr(&self) -> *const style_structs::SVG {
        // This is sound because the wrapper we create is repr(transparent).
        self.SVGReset as *const _
    }

    #[inline]
    pub fn clone_svg(&self) -> Arc<style_structs::SVG> {
        unsafe { Arc::from_raw_addrefed(self.svg_ptr()) }
    }
    #[inline]
    pub fn get_svg(&self) -> &style_structs::SVG {
        unsafe { &*self.svg_ptr() }
    }

    #[inline]
    pub fn mutate_svg(&mut self) -> &mut style_structs::SVG {
        unsafe {
            let mut arc = Arc::from_raw(self.svg_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.SVGReset = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn table_ptr(&self) -> *const style_structs::Table {
        // This is sound because the wrapper we create is repr(transparent).
        self.Table as *const _
    }

    #[inline]
    pub fn clone_table(&self) -> Arc<style_structs::Table> {
        unsafe { Arc::from_raw_addrefed(self.table_ptr()) }
    }
    #[inline]
    pub fn get_table(&self) -> &style_structs::Table {
        unsafe { &*self.table_ptr() }
    }

    #[inline]
    pub fn mutate_table(&mut self) -> &mut style_structs::Table {
        unsafe {
            let mut arc = Arc::from_raw(self.table_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.Table = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn text_ptr(&self) -> *const style_structs::Text {
        // This is sound because the wrapper we create is repr(transparent).
        self.TextReset as *const _
    }

    #[inline]
    pub fn clone_text(&self) -> Arc<style_structs::Text> {
        unsafe { Arc::from_raw_addrefed(self.text_ptr()) }
    }
    #[inline]
    pub fn get_text(&self) -> &style_structs::Text {
        unsafe { &*self.text_ptr() }
    }

    #[inline]
    pub fn mutate_text(&mut self) -> &mut style_structs::Text {
        unsafe {
            let mut arc = Arc::from_raw(self.text_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.TextReset = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn ui_ptr(&self) -> *const style_structs::UI {
        // This is sound because the wrapper we create is repr(transparent).
        self.UIReset as *const _
    }

    #[inline]
    pub fn clone_ui(&self) -> Arc<style_structs::UI> {
        unsafe { Arc::from_raw_addrefed(self.ui_ptr()) }
    }
    #[inline]
    pub fn get_ui(&self) -> &style_structs::UI {
        unsafe { &*self.ui_ptr() }
    }

    #[inline]
    pub fn mutate_ui(&mut self) -> &mut style_structs::UI {
        unsafe {
            let mut arc = Arc::from_raw(self.ui_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.UIReset = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
    #[inline]
    fn xul_ptr(&self) -> *const style_structs::XUL {
        // This is sound because the wrapper we create is repr(transparent).
        self.XUL as *const _
    }

    #[inline]
    pub fn clone_xul(&self) -> Arc<style_structs::XUL> {
        unsafe { Arc::from_raw_addrefed(self.xul_ptr()) }
    }
    #[inline]
    pub fn get_xul(&self) -> &style_structs::XUL {
        unsafe { &*self.xul_ptr() }
    }

    #[inline]
    pub fn mutate_xul(&mut self) -> &mut style_structs::XUL {
        unsafe {
            let mut arc = Arc::from_raw(self.xul_ptr());
            let ptr = Arc::make_mut(&mut arc) as *mut _;
            // Sound for the same reason _ptr() is sound.
            self.XUL = Arc::into_raw(arc) as *const _;
            &mut *ptr
        }
    }
}





































#[allow(dead_code)]
fn static_assert() {
    // Note: using the above technique with an enum hits a rust bug when |structs| is in a different crate.
    { const DETAIL: u32 = [0][(structs::Side::eSideTop as usize != 0) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideRight as usize != 1) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideBottom as usize != 2) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideLeft as usize != 3) as usize]; let _ = DETAIL; }
}






impl GeckoBorder {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_border_top_style(&mut self, v: BorderStyle) {
        self.mBorderStyle[0] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.mComputedBorder.top = self.mBorder.top;
    }

    pub fn copy_border_top_style_from(&mut self, other: &Self) {
        self.set_border_top_style(other.mBorderStyle[0]);
    }

    pub fn reset_border_top_style(&mut self, other: &Self) {
        self.copy_border_top_style_from(other);
    }

    #[inline]
    pub fn clone_border_top_style(&self) -> BorderStyle {
        self.mBorderStyle[0]
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_width(&mut self, v: Au) {
        let value = v.0;
        self.mBorder.top = value;
        self.mComputedBorder.top = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_top_width_from(&mut self, other: &Self) {
        self.mBorder.top = other.mBorder.top;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.mComputedBorder.top = other.mBorder.top;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_top_width(&mut self, other: &Self) {
        self.copy_border_top_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_top_width(&self) -> Au {
        Au(self.mComputedBorder.top)
    }


    pub fn border_top_has_nonzero_width(&self) -> bool {
        self.mComputedBorder.top != 0
    }
    pub fn set_border_right_style(&mut self, v: BorderStyle) {
        self.mBorderStyle[1] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.mComputedBorder.right = self.mBorder.right;
    }

    pub fn copy_border_right_style_from(&mut self, other: &Self) {
        self.set_border_right_style(other.mBorderStyle[1]);
    }

    pub fn reset_border_right_style(&mut self, other: &Self) {
        self.copy_border_right_style_from(other);
    }

    #[inline]
    pub fn clone_border_right_style(&self) -> BorderStyle {
        self.mBorderStyle[1]
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_right_width(&mut self, v: Au) {
        let value = v.0;
        self.mBorder.right = value;
        self.mComputedBorder.right = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_right_width_from(&mut self, other: &Self) {
        self.mBorder.right = other.mBorder.right;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.mComputedBorder.right = other.mBorder.right;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_right_width(&mut self, other: &Self) {
        self.copy_border_right_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_right_width(&self) -> Au {
        Au(self.mComputedBorder.right)
    }


    pub fn border_right_has_nonzero_width(&self) -> bool {
        self.mComputedBorder.right != 0
    }
    pub fn set_border_bottom_style(&mut self, v: BorderStyle) {
        self.mBorderStyle[2] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.mComputedBorder.bottom = self.mBorder.bottom;
    }

    pub fn copy_border_bottom_style_from(&mut self, other: &Self) {
        self.set_border_bottom_style(other.mBorderStyle[2]);
    }

    pub fn reset_border_bottom_style(&mut self, other: &Self) {
        self.copy_border_bottom_style_from(other);
    }

    #[inline]
    pub fn clone_border_bottom_style(&self) -> BorderStyle {
        self.mBorderStyle[2]
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_width(&mut self, v: Au) {
        let value = v.0;
        self.mBorder.bottom = value;
        self.mComputedBorder.bottom = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_bottom_width_from(&mut self, other: &Self) {
        self.mBorder.bottom = other.mBorder.bottom;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.mComputedBorder.bottom = other.mBorder.bottom;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_bottom_width(&mut self, other: &Self) {
        self.copy_border_bottom_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_bottom_width(&self) -> Au {
        Au(self.mComputedBorder.bottom)
    }


    pub fn border_bottom_has_nonzero_width(&self) -> bool {
        self.mComputedBorder.bottom != 0
    }
    pub fn set_border_left_style(&mut self, v: BorderStyle) {
        self.mBorderStyle[3] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.mComputedBorder.left = self.mBorder.left;
    }

    pub fn copy_border_left_style_from(&mut self, other: &Self) {
        self.set_border_left_style(other.mBorderStyle[3]);
    }

    pub fn reset_border_left_style(&mut self, other: &Self) {
        self.copy_border_left_style_from(other);
    }

    #[inline]
    pub fn clone_border_left_style(&self) -> BorderStyle {
        self.mBorderStyle[3]
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_left_width(&mut self, v: Au) {
        let value = v.0;
        self.mBorder.left = value;
        self.mComputedBorder.left = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_left_width_from(&mut self, other: &Self) {
        self.mBorder.left = other.mBorder.left;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.mComputedBorder.left = other.mBorder.left;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_left_width(&mut self, other: &Self) {
        self.copy_border_left_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_left_width(&self) -> Au {
        Au(self.mComputedBorder.left)
    }


    pub fn border_left_has_nonzero_width(&self) -> bool {
        self.mComputedBorder.left != 0
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_left_radius(&mut self, v: longhands::border_top_left_radius::computed_value::T) {
        self.mBorderRadius.top_left = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_top_left_radius_from(&mut self, other: &Self) {
        self.mBorderRadius.top_left =
            other.mBorderRadius.top_left.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_border_top_left_radius(&mut self, other: &Self) {
        self.copy_border_top_left_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_top_left_radius(&self) -> longhands::border_top_left_radius::computed_value::T {
        self.mBorderRadius.top_left.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_right_radius(&mut self, v: longhands::border_top_right_radius::computed_value::T) {
        self.mBorderRadius.top_right = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_top_right_radius_from(&mut self, other: &Self) {
        self.mBorderRadius.top_right =
            other.mBorderRadius.top_right.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_border_top_right_radius(&mut self, other: &Self) {
        self.copy_border_top_right_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_top_right_radius(&self) -> longhands::border_top_right_radius::computed_value::T {
        self.mBorderRadius.top_right.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_right_radius(&mut self, v: longhands::border_bottom_right_radius::computed_value::T) {
        self.mBorderRadius.bottom_right = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_bottom_right_radius_from(&mut self, other: &Self) {
        self.mBorderRadius.bottom_right =
            other.mBorderRadius.bottom_right.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_border_bottom_right_radius(&mut self, other: &Self) {
        self.copy_border_bottom_right_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_right_radius(&self) -> longhands::border_bottom_right_radius::computed_value::T {
        self.mBorderRadius.bottom_right.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_left_radius(&mut self, v: longhands::border_bottom_left_radius::computed_value::T) {
        self.mBorderRadius.bottom_left = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_bottom_left_radius_from(&mut self, other: &Self) {
        self.mBorderRadius.bottom_left =
            other.mBorderRadius.bottom_left.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_border_bottom_left_radius(&mut self, other: &Self) {
        self.copy_border_bottom_left_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_left_radius(&self) -> longhands::border_bottom_left_radius::computed_value::T {
        self.mBorderRadius.bottom_left.clone()
    }


    

    pub fn set_border_image_repeat(&mut self, v: longhands::border_image_repeat::computed_value::T) {
        use crate::values::specified::border::BorderImageRepeatKeyword;
        use crate::gecko_bindings::structs::StyleBorderImageRepeat;

            self.mBorderImageRepeatH = match v.0 {
                BorderImageRepeatKeyword::Stretch => StyleBorderImageRepeat::Stretch,
                BorderImageRepeatKeyword::Repeat => StyleBorderImageRepeat::Repeat,
                BorderImageRepeatKeyword::Round => StyleBorderImageRepeat::Round,
                BorderImageRepeatKeyword::Space => StyleBorderImageRepeat::Space,
            };
            self.mBorderImageRepeatV = match v.1 {
                BorderImageRepeatKeyword::Stretch => StyleBorderImageRepeat::Stretch,
                BorderImageRepeatKeyword::Repeat => StyleBorderImageRepeat::Repeat,
                BorderImageRepeatKeyword::Round => StyleBorderImageRepeat::Round,
                BorderImageRepeatKeyword::Space => StyleBorderImageRepeat::Space,
            };
    }

    pub fn copy_border_image_repeat_from(&mut self, other: &Self) {
        self.mBorderImageRepeatH = other.mBorderImageRepeatH;
        self.mBorderImageRepeatV = other.mBorderImageRepeatV;
    }

    pub fn reset_border_image_repeat(&mut self, other: &Self) {
        self.copy_border_image_repeat_from(other)
    }

    pub fn clone_border_image_repeat(&self) -> longhands::border_image_repeat::computed_value::T {
        use crate::values::specified::border::BorderImageRepeatKeyword;
        use crate::gecko_bindings::structs::StyleBorderImageRepeat;

        let servo_h = match self.mBorderImageRepeatH {
            StyleBorderImageRepeat::Stretch => BorderImageRepeatKeyword::Stretch,
            StyleBorderImageRepeat::Repeat => BorderImageRepeatKeyword::Repeat,
            StyleBorderImageRepeat::Round => BorderImageRepeatKeyword::Round,
            StyleBorderImageRepeat::Space => BorderImageRepeatKeyword::Space,
        };
        let servo_v = match self.mBorderImageRepeatV {
            StyleBorderImageRepeat::Stretch => BorderImageRepeatKeyword::Stretch,
            StyleBorderImageRepeat::Repeat => BorderImageRepeatKeyword::Repeat,
            StyleBorderImageRepeat::Round => BorderImageRepeatKeyword::Round,
            StyleBorderImageRepeat::Space => BorderImageRepeatKeyword::Space,
        };
        longhands::border_image_repeat::computed_value::T(servo_h, servo_v)
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_border_top_color(&mut self, v: longhands::border_top_color::computed_value::T) {
        self.mBorderTopColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_top_color_from(&mut self, other: &Self) {
        self.mBorderTopColor = other.mBorderTopColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_top_color(&mut self, other: &Self) {
        self.copy_border_top_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_top_color(&self) -> longhands::border_top_color::computed_value::T {
        From::from(self.mBorderTopColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_right_color(&mut self, v: longhands::border_right_color::computed_value::T) {
        self.mBorderRightColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_right_color_from(&mut self, other: &Self) {
        self.mBorderRightColor = other.mBorderRightColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_right_color(&mut self, other: &Self) {
        self.copy_border_right_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_right_color(&self) -> longhands::border_right_color::computed_value::T {
        From::from(self.mBorderRightColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_bottom_color(&mut self, v: longhands::border_bottom_color::computed_value::T) {
        self.mBorderBottomColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_bottom_color_from(&mut self, other: &Self) {
        self.mBorderBottomColor = other.mBorderBottomColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_bottom_color(&mut self, other: &Self) {
        self.copy_border_bottom_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_bottom_color(&self) -> longhands::border_bottom_color::computed_value::T {
        From::from(self.mBorderBottomColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_left_color(&mut self, v: longhands::border_left_color::computed_value::T) {
        self.mBorderLeftColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_left_color_from(&mut self, other: &Self) {
        self.mBorderLeftColor = other.mBorderLeftColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_left_color(&mut self, other: &Self) {
        self.copy_border_left_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_left_color(&self) -> longhands::border_left_color::computed_value::T {
        From::from(self.mBorderLeftColor.clone())
    }


    
    /// Set the appropriate physical property for border-block-start-color given a writing mode.
    pub fn set_border_block_start_color(&mut self,
                                      v: longhands::border_block_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn copy_border_block_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn reset_border_block_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-color given a writing mode.
    pub fn clone_border_block_start_color(&self, wm: WritingMode)
        -> longhands::border_block_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-start-style given a writing mode.
    pub fn set_border_block_start_style(&mut self,
                                      v: longhands::border_block_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn copy_border_block_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn reset_border_block_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-style given a writing mode.
    pub fn clone_border_block_start_style(&self, wm: WritingMode)
        -> longhands::border_block_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-start-width given a writing mode.
    pub fn set_border_block_start_width(&mut self,
                                      v: longhands::border_block_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn copy_border_block_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn reset_border_block_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-width given a writing mode.
    pub fn clone_border_block_start_width(&self, wm: WritingMode)
        -> longhands::border_block_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-color given a writing mode.
    pub fn set_border_block_end_color(&mut self,
                                      v: longhands::border_block_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn copy_border_block_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn reset_border_block_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-color given a writing mode.
    pub fn clone_border_block_end_color(&self, wm: WritingMode)
        -> longhands::border_block_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-style given a writing mode.
    pub fn set_border_block_end_style(&mut self,
                                      v: longhands::border_block_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn copy_border_block_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn reset_border_block_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-style given a writing mode.
    pub fn clone_border_block_end_style(&self, wm: WritingMode)
        -> longhands::border_block_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-width given a writing mode.
    pub fn set_border_block_end_width(&mut self,
                                      v: longhands::border_block_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn copy_border_block_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn reset_border_block_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-width given a writing mode.
    pub fn clone_border_block_end_width(&self, wm: WritingMode)
        -> longhands::border_block_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-color given a writing mode.
    pub fn set_border_inline_start_color(&mut self,
                                      v: longhands::border_inline_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn copy_border_inline_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn reset_border_inline_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-color given a writing mode.
    pub fn clone_border_inline_start_color(&self, wm: WritingMode)
        -> longhands::border_inline_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-style given a writing mode.
    pub fn set_border_inline_start_style(&mut self,
                                      v: longhands::border_inline_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn copy_border_inline_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn reset_border_inline_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-style given a writing mode.
    pub fn clone_border_inline_start_style(&self, wm: WritingMode)
        -> longhands::border_inline_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-width given a writing mode.
    pub fn set_border_inline_start_width(&mut self,
                                      v: longhands::border_inline_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn copy_border_inline_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn reset_border_inline_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-width given a writing mode.
    pub fn clone_border_inline_start_width(&self, wm: WritingMode)
        -> longhands::border_inline_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-color given a writing mode.
    pub fn set_border_inline_end_color(&mut self,
                                      v: longhands::border_inline_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn copy_border_inline_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn reset_border_inline_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-color given a writing mode.
    pub fn clone_border_inline_end_color(&self, wm: WritingMode)
        -> longhands::border_inline_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-style given a writing mode.
    pub fn set_border_inline_end_style(&mut self,
                                      v: longhands::border_inline_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn copy_border_inline_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn reset_border_inline_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-style given a writing mode.
    pub fn clone_border_inline_end_style(&self, wm: WritingMode)
        -> longhands::border_inline_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-width given a writing mode.
    pub fn set_border_inline_end_width(&mut self,
                                      v: longhands::border_inline_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn copy_border_inline_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn reset_border_inline_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-width given a writing mode.
    pub fn clone_border_inline_end_width(&self, wm: WritingMode)
        -> longhands::border_inline_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-start-start-radius given a writing mode.
    pub fn set_border_start_start_radius(&mut self,
                                      v: longhands::border_start_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn copy_border_start_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn reset_border_start_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-start-radius given a writing mode.
    pub fn clone_border_start_start_radius(&self, wm: WritingMode)
        -> longhands::border_start_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-start-end-radius given a writing mode.
    pub fn set_border_start_end_radius(&mut self,
                                      v: longhands::border_start_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn copy_border_start_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn reset_border_start_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-end-radius given a writing mode.
    pub fn clone_border_start_end_radius(&self, wm: WritingMode)
        -> longhands::border_start_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-end-start-radius given a writing mode.
    pub fn set_border_end_start_radius(&mut self,
                                      v: longhands::border_end_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn copy_border_end_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn reset_border_end_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-start-radius given a writing mode.
    pub fn clone_border_end_start_radius(&self, wm: WritingMode)
        -> longhands::border_end_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-end-end-radius given a writing mode.
    pub fn set_border_end_end_radius(&mut self,
                                      v: longhands::border_end_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn copy_border_end_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn reset_border_end_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-end-radius given a writing mode.
    pub fn clone_border_end_end_radius(&self, wm: WritingMode)
        -> longhands::border_end_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_box_decoration_break(&mut self, v: longhands::box_decoration_break::computed_value::T) {
        use crate::properties::longhands::box_decoration_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Slice =>
                    structs::StyleBoxDecorationBreak::Slice ,
                Keyword::Clone =>
                    structs::StyleBoxDecorationBreak::Clone ,
        };
        self.mBoxDecorationBreak = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_box_decoration_break_from(&mut self, other: &Self) {
        self.mBoxDecorationBreak = other.mBoxDecorationBreak.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_decoration_break(&mut self, other: &Self) {
        self.copy_box_decoration_break_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_box_decoration_break(&self) -> longhands::box_decoration_break::computed_value::T {
        use crate::properties::longhands::box_decoration_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mBoxDecorationBreak {
            structs::StyleBoxDecorationBreak::Slice => Keyword::Slice,
            structs::StyleBoxDecorationBreak::Clone => Keyword::Clone,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_float_edge(&mut self, v: longhands::_moz_float_edge::computed_value::T) {
        use crate::properties::longhands::_moz_float_edge::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ContentBox =>
                    structs::StyleFloatEdge::ContentBox ,
                Keyword::MarginBox =>
                    structs::StyleFloatEdge::MarginBox ,
        };
        self.mFloatEdge = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_float_edge_from(&mut self, other: &Self) {
        self.mFloatEdge = other.mFloatEdge.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_float_edge(&mut self, other: &Self) {
        self.copy__moz_float_edge_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_float_edge(&self) -> longhands::_moz_float_edge::computed_value::T {
        use crate::properties::longhands::_moz_float_edge::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mFloatEdge {
            structs::StyleFloatEdge::ContentBox => Keyword::ContentBox,
            structs::StyleFloatEdge::MarginBox => Keyword::MarginBox,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_source(&mut self, v: longhands::border_image_source::computed_value::T) {
        self.mBorderImageSource = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_source_from(&mut self, other: &Self) {
        self.mBorderImageSource = other.mBorderImageSource.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_source(&mut self, other: &Self) {
        self.copy_border_image_source_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_source(&self) -> longhands::border_image_source::computed_value::T {
        From::from(self.mBorderImageSource.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_outset(&mut self, v: longhands::border_image_outset::computed_value::T) {
        self.mBorderImageOutset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_outset_from(&mut self, other: &Self) {
        self.mBorderImageOutset = other.mBorderImageOutset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_outset(&mut self, other: &Self) {
        self.copy_border_image_outset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_outset(&self) -> longhands::border_image_outset::computed_value::T {
        From::from(self.mBorderImageOutset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_width(&mut self, v: longhands::border_image_width::computed_value::T) {
        self.mBorderImageWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_width_from(&mut self, other: &Self) {
        self.mBorderImageWidth = other.mBorderImageWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_width(&mut self, other: &Self) {
        self.copy_border_image_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_width(&self) -> longhands::border_image_width::computed_value::T {
        From::from(self.mBorderImageWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_slice(&mut self, v: longhands::border_image_slice::computed_value::T) {
        self.mBorderImageSlice = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_slice_from(&mut self, other: &Self) {
        self.mBorderImageSlice = other.mBorderImageSlice.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_slice(&mut self, other: &Self) {
        self.copy_border_image_slice_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_slice(&self) -> longhands::border_image_slice::computed_value::T {
        From::from(self.mBorderImageSlice.clone())
    }


}






impl GeckoMargin {
    /*
     * Manually-Implemented Methods.
     */
    
    
    #[allow(non_snake_case)]
    pub fn set_margin_top(&mut self, v: longhands::margin_top::computed_value::T) {
        self.mMargin.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_top_from(&mut self, other: &Self) {
        self.mMargin.0 =
            other.mMargin.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_top(&mut self, other: &Self) {
        self.copy_margin_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_top(&self) -> longhands::margin_top::computed_value::T {
        self.mMargin.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_top(&mut self, v: longhands::scroll_margin_top::computed_value::T) {
        self.mScrollMargin.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_top_from(&mut self, other: &Self) {
        self.mScrollMargin.0 =
            other.mScrollMargin.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_top(&mut self, other: &Self) {
        self.copy_scroll_margin_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_top(&self) -> longhands::scroll_margin_top::computed_value::T {
        self.mScrollMargin.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_right(&mut self, v: longhands::margin_right::computed_value::T) {
        self.mMargin.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_right_from(&mut self, other: &Self) {
        self.mMargin.1 =
            other.mMargin.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_right(&mut self, other: &Self) {
        self.copy_margin_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_right(&self) -> longhands::margin_right::computed_value::T {
        self.mMargin.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_right(&mut self, v: longhands::scroll_margin_right::computed_value::T) {
        self.mScrollMargin.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_right_from(&mut self, other: &Self) {
        self.mScrollMargin.1 =
            other.mScrollMargin.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_right(&mut self, other: &Self) {
        self.copy_scroll_margin_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_right(&self) -> longhands::scroll_margin_right::computed_value::T {
        self.mScrollMargin.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_bottom(&mut self, v: longhands::margin_bottom::computed_value::T) {
        self.mMargin.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_bottom_from(&mut self, other: &Self) {
        self.mMargin.2 =
            other.mMargin.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_bottom(&mut self, other: &Self) {
        self.copy_margin_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_bottom(&self) -> longhands::margin_bottom::computed_value::T {
        self.mMargin.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_bottom(&mut self, v: longhands::scroll_margin_bottom::computed_value::T) {
        self.mScrollMargin.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_bottom_from(&mut self, other: &Self) {
        self.mScrollMargin.2 =
            other.mScrollMargin.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_bottom(&mut self, other: &Self) {
        self.copy_scroll_margin_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_bottom(&self) -> longhands::scroll_margin_bottom::computed_value::T {
        self.mScrollMargin.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_left(&mut self, v: longhands::margin_left::computed_value::T) {
        self.mMargin.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_left_from(&mut self, other: &Self) {
        self.mMargin.3 =
            other.mMargin.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_left(&mut self, other: &Self) {
        self.copy_margin_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_left(&self) -> longhands::margin_left::computed_value::T {
        self.mMargin.3.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_left(&mut self, v: longhands::scroll_margin_left::computed_value::T) {
        self.mScrollMargin.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_left_from(&mut self, other: &Self) {
        self.mScrollMargin.3 =
            other.mScrollMargin.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_left(&mut self, other: &Self) {
        self.copy_scroll_margin_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_left(&self) -> longhands::scroll_margin_left::computed_value::T {
        self.mScrollMargin.3.clone()
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for margin-block-start given a writing mode.
    pub fn set_margin_block_start(&mut self,
                                      v: longhands::margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn copy_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn reset_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-start given a writing mode.
    pub fn clone_margin_block_start(&self, wm: WritingMode)
        -> longhands::margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-block-end given a writing mode.
    pub fn set_margin_block_end(&mut self,
                                      v: longhands::margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn copy_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn reset_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-end given a writing mode.
    pub fn clone_margin_block_end(&self, wm: WritingMode)
        -> longhands::margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-inline-start given a writing mode.
    pub fn set_margin_inline_start(&mut self,
                                      v: longhands::margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn copy_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn reset_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-start given a writing mode.
    pub fn clone_margin_inline_start(&self, wm: WritingMode)
        -> longhands::margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-inline-end given a writing mode.
    pub fn set_margin_inline_end(&mut self,
                                      v: longhands::margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn copy_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn reset_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-end given a writing mode.
    pub fn clone_margin_inline_end(&self, wm: WritingMode)
        -> longhands::margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_margin(&mut self, v: longhands::overflow_clip_margin::computed_value::T) {
        self.mOverflowClipMargin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_margin_from(&mut self, other: &Self) {
        self.mOverflowClipMargin = other.mOverflowClipMargin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_margin(&mut self, other: &Self) {
        self.copy_overflow_clip_margin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_margin(&self) -> longhands::overflow_clip_margin::computed_value::T {
        From::from(self.mOverflowClipMargin.clone())
    }


    
    /// Set the appropriate physical property for scroll-margin-block-start given a writing mode.
    pub fn set_scroll_margin_block_start(&mut self,
                                      v: longhands::scroll_margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-start
    /// given a writing mode.
    pub fn copy_scroll_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-start
    /// given a writing mode.
    pub fn reset_scroll_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-block-start given a writing mode.
    pub fn clone_scroll_margin_block_start(&self, wm: WritingMode)
        -> longhands::scroll_margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-block-end given a writing mode.
    pub fn set_scroll_margin_block_end(&mut self,
                                      v: longhands::scroll_margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-end
    /// given a writing mode.
    pub fn copy_scroll_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-end
    /// given a writing mode.
    pub fn reset_scroll_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-block-end given a writing mode.
    pub fn clone_scroll_margin_block_end(&self, wm: WritingMode)
        -> longhands::scroll_margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-inline-start given a writing mode.
    pub fn set_scroll_margin_inline_start(&mut self,
                                      v: longhands::scroll_margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-start
    /// given a writing mode.
    pub fn copy_scroll_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-start
    /// given a writing mode.
    pub fn reset_scroll_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-inline-start given a writing mode.
    pub fn clone_scroll_margin_inline_start(&self, wm: WritingMode)
        -> longhands::scroll_margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-inline-end given a writing mode.
    pub fn set_scroll_margin_inline_end(&mut self,
                                      v: longhands::scroll_margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-end
    /// given a writing mode.
    pub fn copy_scroll_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-end
    /// given a writing mode.
    pub fn reset_scroll_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-inline-end given a writing mode.
    pub fn clone_scroll_margin_inline_end(&self, wm: WritingMode)
        -> longhands::scroll_margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


}






impl GeckoPadding {
    /*
     * Manually-Implemented Methods.
     */
    

    
    #[allow(non_snake_case)]
    pub fn set_padding_top(&mut self, v: longhands::padding_top::computed_value::T) {
        self.mPadding.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_top_from(&mut self, other: &Self) {
        self.mPadding.0 =
            other.mPadding.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_top(&mut self, other: &Self) {
        self.copy_padding_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_top(&self) -> longhands::padding_top::computed_value::T {
        self.mPadding.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_top(&mut self, v: longhands::scroll_padding_top::computed_value::T) {
        self.mScrollPadding.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_top_from(&mut self, other: &Self) {
        self.mScrollPadding.0 =
            other.mScrollPadding.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_top(&mut self, other: &Self) {
        self.copy_scroll_padding_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_top(&self) -> longhands::scroll_padding_top::computed_value::T {
        self.mScrollPadding.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_right(&mut self, v: longhands::padding_right::computed_value::T) {
        self.mPadding.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_right_from(&mut self, other: &Self) {
        self.mPadding.1 =
            other.mPadding.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_right(&mut self, other: &Self) {
        self.copy_padding_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_right(&self) -> longhands::padding_right::computed_value::T {
        self.mPadding.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_right(&mut self, v: longhands::scroll_padding_right::computed_value::T) {
        self.mScrollPadding.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_right_from(&mut self, other: &Self) {
        self.mScrollPadding.1 =
            other.mScrollPadding.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_right(&mut self, other: &Self) {
        self.copy_scroll_padding_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_right(&self) -> longhands::scroll_padding_right::computed_value::T {
        self.mScrollPadding.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_bottom(&mut self, v: longhands::padding_bottom::computed_value::T) {
        self.mPadding.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_bottom_from(&mut self, other: &Self) {
        self.mPadding.2 =
            other.mPadding.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_bottom(&mut self, other: &Self) {
        self.copy_padding_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_bottom(&self) -> longhands::padding_bottom::computed_value::T {
        self.mPadding.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_bottom(&mut self, v: longhands::scroll_padding_bottom::computed_value::T) {
        self.mScrollPadding.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_bottom_from(&mut self, other: &Self) {
        self.mScrollPadding.2 =
            other.mScrollPadding.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_bottom(&mut self, other: &Self) {
        self.copy_scroll_padding_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_bottom(&self) -> longhands::scroll_padding_bottom::computed_value::T {
        self.mScrollPadding.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_left(&mut self, v: longhands::padding_left::computed_value::T) {
        self.mPadding.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_left_from(&mut self, other: &Self) {
        self.mPadding.3 =
            other.mPadding.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_left(&mut self, other: &Self) {
        self.copy_padding_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_left(&self) -> longhands::padding_left::computed_value::T {
        self.mPadding.3.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_left(&mut self, v: longhands::scroll_padding_left::computed_value::T) {
        self.mScrollPadding.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_left_from(&mut self, other: &Self) {
        self.mScrollPadding.3 =
            other.mScrollPadding.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_left(&mut self, other: &Self) {
        self.copy_scroll_padding_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_left(&self) -> longhands::scroll_padding_left::computed_value::T {
        self.mScrollPadding.3.clone()
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for padding-block-start given a writing mode.
    pub fn set_padding_block_start(&mut self,
                                      v: longhands::padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn copy_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn reset_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-start given a writing mode.
    pub fn clone_padding_block_start(&self, wm: WritingMode)
        -> longhands::padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-block-end given a writing mode.
    pub fn set_padding_block_end(&mut self,
                                      v: longhands::padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn copy_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn reset_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-end given a writing mode.
    pub fn clone_padding_block_end(&self, wm: WritingMode)
        -> longhands::padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-inline-start given a writing mode.
    pub fn set_padding_inline_start(&mut self,
                                      v: longhands::padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn copy_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn reset_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-start given a writing mode.
    pub fn clone_padding_inline_start(&self, wm: WritingMode)
        -> longhands::padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-inline-end given a writing mode.
    pub fn set_padding_inline_end(&mut self,
                                      v: longhands::padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn copy_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn reset_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-end given a writing mode.
    pub fn clone_padding_inline_end(&self, wm: WritingMode)
        -> longhands::padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-block-start given a writing mode.
    pub fn set_scroll_padding_block_start(&mut self,
                                      v: longhands::scroll_padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-start
    /// given a writing mode.
    pub fn copy_scroll_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-start
    /// given a writing mode.
    pub fn reset_scroll_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-block-start given a writing mode.
    pub fn clone_scroll_padding_block_start(&self, wm: WritingMode)
        -> longhands::scroll_padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-block-end given a writing mode.
    pub fn set_scroll_padding_block_end(&mut self,
                                      v: longhands::scroll_padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-end
    /// given a writing mode.
    pub fn copy_scroll_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-end
    /// given a writing mode.
    pub fn reset_scroll_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-block-end given a writing mode.
    pub fn clone_scroll_padding_block_end(&self, wm: WritingMode)
        -> longhands::scroll_padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-inline-start given a writing mode.
    pub fn set_scroll_padding_inline_start(&mut self,
                                      v: longhands::scroll_padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-start
    /// given a writing mode.
    pub fn copy_scroll_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-start
    /// given a writing mode.
    pub fn reset_scroll_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-inline-start given a writing mode.
    pub fn clone_scroll_padding_inline_start(&self, wm: WritingMode)
        -> longhands::scroll_padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-inline-end given a writing mode.
    pub fn set_scroll_padding_inline_end(&mut self,
                                      v: longhands::scroll_padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-end
    /// given a writing mode.
    pub fn copy_scroll_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-end
    /// given a writing mode.
    pub fn reset_scroll_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-inline-end given a writing mode.
    pub fn clone_scroll_padding_inline_end(&self, wm: WritingMode)
        -> longhands::scroll_padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


}




impl GeckoPage {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_size(&mut self, v: longhands::size::computed_value::T) {
        self.mSize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_size_from(&mut self, other: &Self) {
        self.mSize = other.mSize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_size(&mut self, other: &Self) {
        self.copy_size_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_size(&self) -> longhands::size::computed_value::T {
        From::from(self.mSize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_page(&mut self, v: longhands::page::computed_value::T) {
        self.mPage = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_page_from(&mut self, other: &Self) {
        self.mPage = other.mPage.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_page(&mut self, other: &Self) {
        self.copy_page_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_page(&self) -> longhands::page::computed_value::T {
        From::from(self.mPage.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_page_orientation(&mut self, v: longhands::page_orientation::computed_value::T) {
        self.mPageOrientation = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_page_orientation_from(&mut self, other: &Self) {
        self.mPageOrientation = other.mPageOrientation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_page_orientation(&mut self, other: &Self) {
        self.copy_page_orientation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_page_orientation(&self) -> longhands::page_orientation::computed_value::T {
        From::from(self.mPageOrientation.clone())
    }


}





impl GeckoPosition {
    /*
     * Manually-Implemented Methods.
     */
    
    
    #[allow(non_snake_case)]
    pub fn set_top(&mut self, v: longhands::top::computed_value::T) {
        self.mOffset.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_top_from(&mut self, other: &Self) {
        self.mOffset.0 =
            other.mOffset.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_top(&mut self, other: &Self) {
        self.copy_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_top(&self) -> longhands::top::computed_value::T {
        self.mOffset.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_right(&mut self, v: longhands::right::computed_value::T) {
        self.mOffset.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_right_from(&mut self, other: &Self) {
        self.mOffset.1 =
            other.mOffset.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_right(&mut self, other: &Self) {
        self.copy_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_right(&self) -> longhands::right::computed_value::T {
        self.mOffset.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_bottom(&mut self, v: longhands::bottom::computed_value::T) {
        self.mOffset.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_bottom_from(&mut self, other: &Self) {
        self.mOffset.2 =
            other.mOffset.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_bottom(&mut self, other: &Self) {
        self.copy_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_bottom(&self) -> longhands::bottom::computed_value::T {
        self.mOffset.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_left(&mut self, v: longhands::left::computed_value::T) {
        self.mOffset.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_left_from(&mut self, other: &Self) {
        self.mOffset.3 =
            other.mOffset.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_left(&mut self, other: &Self) {
        self.copy_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_left(&self) -> longhands::left::computed_value::T {
        self.mOffset.3.clone()
    }

    pub fn set_computed_justify_items(&mut self, v: values::specified::JustifyItems) {
        debug_assert_ne!(v.0, crate::values::specified::align::AlignFlags::LEGACY);
        self.mJustifyItems.computed = v;
    }

    
    #[allow(non_snake_case)]
    pub fn set_masonry_auto_flow(&mut self, v: longhands::masonry_auto_flow::computed_value::T) {
        self.mMasonryAutoFlow = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_masonry_auto_flow_from(&mut self, other: &Self) {
        self.mMasonryAutoFlow = other.mMasonryAutoFlow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_masonry_auto_flow(&mut self, other: &Self) {
        self.copy_masonry_auto_flow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_masonry_auto_flow(&self) -> longhands::masonry_auto_flow::computed_value::T {
        From::from(self.mMasonryAutoFlow)
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for inset-block-start given a writing mode.
    pub fn set_inset_block_start(&mut self,
                                      v: longhands::inset_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn copy_inset_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn reset_inset_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-start given a writing mode.
    pub fn clone_inset_block_start(&self, wm: WritingMode)
        -> longhands::inset_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-block-end given a writing mode.
    pub fn set_inset_block_end(&mut self,
                                      v: longhands::inset_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn copy_inset_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn reset_inset_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-end given a writing mode.
    pub fn clone_inset_block_end(&self, wm: WritingMode)
        -> longhands::inset_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-inline-start given a writing mode.
    pub fn set_inset_inline_start(&mut self,
                                      v: longhands::inset_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn copy_inset_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn reset_inset_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-start given a writing mode.
    pub fn clone_inset_inline_start(&self, wm: WritingMode)
        -> longhands::inset_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-inline-end given a writing mode.
    pub fn set_inset_inline_end(&mut self,
                                      v: longhands::inset_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn copy_inset_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn reset_inset_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-end given a writing mode.
    pub fn clone_inset_inline_end(&self, wm: WritingMode)
        -> longhands::inset_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_z_index(&mut self, v: longhands::z_index::computed_value::T) {
        self.mZIndex = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_z_index_from(&mut self, other: &Self) {
        self.mZIndex = other.mZIndex.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_z_index(&mut self, other: &Self) {
        self.copy_z_index_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_z_index(&self) -> longhands::z_index::computed_value::T {
        From::from(self.mZIndex.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_direction(&mut self, v: longhands::flex_direction::computed_value::T) {
        use crate::properties::longhands::flex_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Row =>
                    structs::StyleFlexDirection::Row ,
                Keyword::RowReverse =>
                    structs::StyleFlexDirection::RowReverse ,
                Keyword::Column =>
                    structs::StyleFlexDirection::Column ,
                Keyword::ColumnReverse =>
                    structs::StyleFlexDirection::ColumnReverse ,
        };
        self.mFlexDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_direction_from(&mut self, other: &Self) {
        self.mFlexDirection = other.mFlexDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_direction(&mut self, other: &Self) {
        self.copy_flex_direction_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_direction(&self) -> longhands::flex_direction::computed_value::T {
        use crate::properties::longhands::flex_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mFlexDirection {
            structs::StyleFlexDirection::Row => Keyword::Row,
            structs::StyleFlexDirection::RowReverse => Keyword::RowReverse,
            structs::StyleFlexDirection::Column => Keyword::Column,
            structs::StyleFlexDirection::ColumnReverse => Keyword::ColumnReverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_flex_wrap(&mut self, v: longhands::flex_wrap::computed_value::T) {
        use crate::properties::longhands::flex_wrap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Nowrap =>
                    structs::StyleFlexWrap::Nowrap ,
                Keyword::Wrap =>
                    structs::StyleFlexWrap::Wrap ,
                Keyword::WrapReverse =>
                    structs::StyleFlexWrap::WrapReverse ,
        };
        self.mFlexWrap = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_wrap_from(&mut self, other: &Self) {
        self.mFlexWrap = other.mFlexWrap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_wrap(&mut self, other: &Self) {
        self.copy_flex_wrap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_wrap(&self) -> longhands::flex_wrap::computed_value::T {
        use crate::properties::longhands::flex_wrap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mFlexWrap {
            structs::StyleFlexWrap::Nowrap => Keyword::Nowrap,
            structs::StyleFlexWrap::Wrap => Keyword::Wrap,
            structs::StyleFlexWrap::WrapReverse => Keyword::WrapReverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_justify_content(&mut self, v: longhands::justify_content::computed_value::T) {
        self.mJustifyContent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_justify_content_from(&mut self, other: &Self) {
        self.mJustifyContent = other.mJustifyContent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_content(&mut self, other: &Self) {
        self.copy_justify_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_content(&self) -> longhands::justify_content::computed_value::T {
        From::from(self.mJustifyContent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_justify_tracks(&mut self, v: longhands::justify_tracks::computed_value::T) {
        self.mJustifyTracks = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_justify_tracks_from(&mut self, other: &Self) {
        self.mJustifyTracks = other.mJustifyTracks.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_tracks(&mut self, other: &Self) {
        self.copy_justify_tracks_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_tracks(&self) -> longhands::justify_tracks::computed_value::T {
        From::from(self.mJustifyTracks.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_align_content(&mut self, v: longhands::align_content::computed_value::T) {
        self.mAlignContent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_align_content_from(&mut self, other: &Self) {
        self.mAlignContent = other.mAlignContent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_content(&mut self, other: &Self) {
        self.copy_align_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_content(&self) -> longhands::align_content::computed_value::T {
        From::from(self.mAlignContent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_align_tracks(&mut self, v: longhands::align_tracks::computed_value::T) {
        self.mAlignTracks = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_align_tracks_from(&mut self, other: &Self) {
        self.mAlignTracks = other.mAlignTracks.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_tracks(&mut self, other: &Self) {
        self.copy_align_tracks_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_tracks(&self) -> longhands::align_tracks::computed_value::T {
        From::from(self.mAlignTracks.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_align_items(&mut self, v: longhands::align_items::computed_value::T) {
        self.mAlignItems = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_align_items_from(&mut self, other: &Self) {
        self.mAlignItems = other.mAlignItems.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_items(&mut self, other: &Self) {
        self.copy_align_items_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_items(&self) -> longhands::align_items::computed_value::T {
        From::from(self.mAlignItems.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_justify_items(&mut self, v: longhands::justify_items::computed_value::T) {
        self.mJustifyItems = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_justify_items_from(&mut self, other: &Self) {
        self.mJustifyItems = other.mJustifyItems.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_items(&mut self, other: &Self) {
        self.copy_justify_items_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_items(&self) -> longhands::justify_items::computed_value::T {
        From::from(self.mJustifyItems.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_grow(&mut self, v: longhands::flex_grow::computed_value::T) {
        self.mFlexGrow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_grow_from(&mut self, other: &Self) {
        self.mFlexGrow = other.mFlexGrow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_grow(&mut self, other: &Self) {
        self.copy_flex_grow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_grow(&self) -> longhands::flex_grow::computed_value::T {
        From::from(self.mFlexGrow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_shrink(&mut self, v: longhands::flex_shrink::computed_value::T) {
        self.mFlexShrink = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_shrink_from(&mut self, other: &Self) {
        self.mFlexShrink = other.mFlexShrink.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_shrink(&mut self, other: &Self) {
        self.copy_flex_shrink_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_shrink(&self) -> longhands::flex_shrink::computed_value::T {
        From::from(self.mFlexShrink.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_align_self(&mut self, v: longhands::align_self::computed_value::T) {
        self.mAlignSelf = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_align_self_from(&mut self, other: &Self) {
        self.mAlignSelf = other.mAlignSelf.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_self(&mut self, other: &Self) {
        self.copy_align_self_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_self(&self) -> longhands::align_self::computed_value::T {
        From::from(self.mAlignSelf.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_justify_self(&mut self, v: longhands::justify_self::computed_value::T) {
        self.mJustifySelf = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_justify_self_from(&mut self, other: &Self) {
        self.mJustifySelf = other.mJustifySelf.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_self(&mut self, other: &Self) {
        self.copy_justify_self_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_self(&self) -> longhands::justify_self::computed_value::T {
        From::from(self.mJustifySelf.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_order(&mut self, v: longhands::order::computed_value::T) {
        self.mOrder = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_order_from(&mut self, other: &Self) {
        self.mOrder = other.mOrder.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_order(&mut self, other: &Self) {
        self.copy_order_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_order(&self) -> longhands::order::computed_value::T {
        From::from(self.mOrder.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_basis(&mut self, v: longhands::flex_basis::computed_value::T) {
        self.mFlexBasis = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_basis_from(&mut self, other: &Self) {
        self.mFlexBasis = other.mFlexBasis.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_basis(&mut self, other: &Self) {
        self.copy_flex_basis_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_basis(&self) -> longhands::flex_basis::computed_value::T {
        From::from(self.mFlexBasis.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_width(&mut self, v: longhands::width::computed_value::T) {
        self.mWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_width_from(&mut self, other: &Self) {
        self.mWidth = other.mWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_width(&mut self, other: &Self) {
        self.copy_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_width(&self) -> longhands::width::computed_value::T {
        From::from(self.mWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_min_width(&mut self, v: longhands::min_width::computed_value::T) {
        self.mMinWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_min_width_from(&mut self, other: &Self) {
        self.mMinWidth = other.mMinWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_min_width(&mut self, other: &Self) {
        self.copy_min_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_min_width(&self) -> longhands::min_width::computed_value::T {
        From::from(self.mMinWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_max_width(&mut self, v: longhands::max_width::computed_value::T) {
        self.mMaxWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_max_width_from(&mut self, other: &Self) {
        self.mMaxWidth = other.mMaxWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_max_width(&mut self, other: &Self) {
        self.copy_max_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_max_width(&self) -> longhands::max_width::computed_value::T {
        From::from(self.mMaxWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_height(&mut self, v: longhands::height::computed_value::T) {
        self.mHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_height_from(&mut self, other: &Self) {
        self.mHeight = other.mHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_height(&mut self, other: &Self) {
        self.copy_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_height(&self) -> longhands::height::computed_value::T {
        From::from(self.mHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_min_height(&mut self, v: longhands::min_height::computed_value::T) {
        self.mMinHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_min_height_from(&mut self, other: &Self) {
        self.mMinHeight = other.mMinHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_min_height(&mut self, other: &Self) {
        self.copy_min_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_min_height(&self) -> longhands::min_height::computed_value::T {
        From::from(self.mMinHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_max_height(&mut self, v: longhands::max_height::computed_value::T) {
        self.mMaxHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_max_height_from(&mut self, other: &Self) {
        self.mMaxHeight = other.mMaxHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_max_height(&mut self, other: &Self) {
        self.copy_max_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_max_height(&self) -> longhands::max_height::computed_value::T {
        From::from(self.mMaxHeight.clone())
    }


    
    /// Set the appropriate physical property for block-size given a writing mode.
    pub fn set_block_size(&mut self,
                                      v: longhands::block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_width(v)
            
        } else {
            
                self.set_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn copy_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_width_from(other)
            
        } else {
            
                self.copy_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn reset_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// block-size given a writing mode.
    pub fn clone_block_size(&self, wm: WritingMode)
        -> longhands::block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_width()
        
        } else {
            
            self.clone_height()
        
        }

    }


    
    /// Set the appropriate physical property for min-block-size given a writing mode.
    pub fn set_min_block_size(&mut self,
                                      v: longhands::min_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_width(v)
            
        } else {
            
                self.set_min_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn copy_min_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_width_from(other)
            
        } else {
            
                self.copy_min_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn reset_min_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-block-size given a writing mode.
    pub fn clone_min_block_size(&self, wm: WritingMode)
        -> longhands::min_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_width()
        
        } else {
            
            self.clone_min_height()
        
        }

    }


    
    /// Set the appropriate physical property for max-block-size given a writing mode.
    pub fn set_max_block_size(&mut self,
                                      v: longhands::max_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_width(v)
            
        } else {
            
                self.set_max_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn copy_max_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_width_from(other)
            
        } else {
            
                self.copy_max_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn reset_max_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-block-size given a writing mode.
    pub fn clone_max_block_size(&self, wm: WritingMode)
        -> longhands::max_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_width()
        
        } else {
            
            self.clone_max_height()
        
        }

    }


    
    /// Set the appropriate physical property for inline-size given a writing mode.
    pub fn set_inline_size(&mut self,
                                      v: longhands::inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_height(v)
            
        } else {
            
                self.set_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn copy_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_height_from(other)
            
        } else {
            
                self.copy_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn reset_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inline-size given a writing mode.
    pub fn clone_inline_size(&self, wm: WritingMode)
        -> longhands::inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_height()
        
        } else {
            
            self.clone_width()
        
        }

    }


    
    /// Set the appropriate physical property for min-inline-size given a writing mode.
    pub fn set_min_inline_size(&mut self,
                                      v: longhands::min_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_height(v)
            
        } else {
            
                self.set_min_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn copy_min_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_height_from(other)
            
        } else {
            
                self.copy_min_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn reset_min_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-inline-size given a writing mode.
    pub fn clone_min_inline_size(&self, wm: WritingMode)
        -> longhands::min_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_height()
        
        } else {
            
            self.clone_min_width()
        
        }

    }


    
    /// Set the appropriate physical property for max-inline-size given a writing mode.
    pub fn set_max_inline_size(&mut self,
                                      v: longhands::max_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_height(v)
            
        } else {
            
                self.set_max_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn copy_max_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_height_from(other)
            
        } else {
            
                self.copy_max_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn reset_max_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-inline-size given a writing mode.
    pub fn clone_max_inline_size(&self, wm: WritingMode)
        -> longhands::max_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_height()
        
        } else {
            
            self.clone_max_width()
        
        }

    }



    #[allow(non_snake_case)]
    pub fn set_box_sizing(&mut self, v: longhands::box_sizing::computed_value::T) {
        use crate::properties::longhands::box_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ContentBox =>
                    structs::StyleBoxSizing::Content ,
                Keyword::BorderBox =>
                    structs::StyleBoxSizing::Border ,
        };
        self.mBoxSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_box_sizing_from(&mut self, other: &Self) {
        self.mBoxSizing = other.mBoxSizing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_sizing(&mut self, other: &Self) {
        self.copy_box_sizing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_box_sizing(&self) -> longhands::box_sizing::computed_value::T {
        use crate::properties::longhands::box_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mBoxSizing {
            structs::StyleBoxSizing::Content => Keyword::ContentBox,
            structs::StyleBoxSizing::Border => Keyword::BorderBox,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_object_fit(&mut self, v: longhands::object_fit::computed_value::T) {
        use crate::properties::longhands::object_fit::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Fill =>
                    structs::StyleObjectFit::Fill ,
                Keyword::Contain =>
                    structs::StyleObjectFit::Contain ,
                Keyword::Cover =>
                    structs::StyleObjectFit::Cover ,
                Keyword::None =>
                    structs::StyleObjectFit::None ,
                Keyword::ScaleDown =>
                    structs::StyleObjectFit::ScaleDown ,
        };
        self.mObjectFit = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_object_fit_from(&mut self, other: &Self) {
        self.mObjectFit = other.mObjectFit.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_object_fit(&mut self, other: &Self) {
        self.copy_object_fit_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_object_fit(&self) -> longhands::object_fit::computed_value::T {
        use crate::properties::longhands::object_fit::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mObjectFit {
            structs::StyleObjectFit::Fill => Keyword::Fill,
            structs::StyleObjectFit::Contain => Keyword::Contain,
            structs::StyleObjectFit::Cover => Keyword::Cover,
            structs::StyleObjectFit::None => Keyword::None,
            structs::StyleObjectFit::ScaleDown => Keyword::ScaleDown,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_object_position(&mut self, v: longhands::object_position::computed_value::T) {
        self.mObjectPosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_object_position_from(&mut self, other: &Self) {
        self.mObjectPosition = other.mObjectPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_object_position(&mut self, other: &Self) {
        self.copy_object_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_object_position(&self) -> longhands::object_position::computed_value::T {
        From::from(self.mObjectPosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_row_start(&mut self, v: longhands::grid_row_start::computed_value::T) {
        self.mGridRowStart = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_row_start_from(&mut self, other: &Self) {
        self.mGridRowStart = other.mGridRowStart.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_row_start(&mut self, other: &Self) {
        self.copy_grid_row_start_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_row_start(&self) -> longhands::grid_row_start::computed_value::T {
        From::from(self.mGridRowStart.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_row_end(&mut self, v: longhands::grid_row_end::computed_value::T) {
        self.mGridRowEnd = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_row_end_from(&mut self, other: &Self) {
        self.mGridRowEnd = other.mGridRowEnd.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_row_end(&mut self, other: &Self) {
        self.copy_grid_row_end_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_row_end(&self) -> longhands::grid_row_end::computed_value::T {
        From::from(self.mGridRowEnd.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_auto_rows(&mut self, v: longhands::grid_auto_rows::computed_value::T) {
        self.mGridAutoRows = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_auto_rows_from(&mut self, other: &Self) {
        self.mGridAutoRows = other.mGridAutoRows.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_auto_rows(&mut self, other: &Self) {
        self.copy_grid_auto_rows_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_auto_rows(&self) -> longhands::grid_auto_rows::computed_value::T {
        From::from(self.mGridAutoRows.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_template_rows(&mut self, v: longhands::grid_template_rows::computed_value::T) {
        self.mGridTemplateRows = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_template_rows_from(&mut self, other: &Self) {
        self.mGridTemplateRows = other.mGridTemplateRows.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_template_rows(&mut self, other: &Self) {
        self.copy_grid_template_rows_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_template_rows(&self) -> longhands::grid_template_rows::computed_value::T {
        From::from(self.mGridTemplateRows.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_column_start(&mut self, v: longhands::grid_column_start::computed_value::T) {
        self.mGridColumnStart = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_column_start_from(&mut self, other: &Self) {
        self.mGridColumnStart = other.mGridColumnStart.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_column_start(&mut self, other: &Self) {
        self.copy_grid_column_start_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_column_start(&self) -> longhands::grid_column_start::computed_value::T {
        From::from(self.mGridColumnStart.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_column_end(&mut self, v: longhands::grid_column_end::computed_value::T) {
        self.mGridColumnEnd = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_column_end_from(&mut self, other: &Self) {
        self.mGridColumnEnd = other.mGridColumnEnd.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_column_end(&mut self, other: &Self) {
        self.copy_grid_column_end_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_column_end(&self) -> longhands::grid_column_end::computed_value::T {
        From::from(self.mGridColumnEnd.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_auto_columns(&mut self, v: longhands::grid_auto_columns::computed_value::T) {
        self.mGridAutoColumns = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_auto_columns_from(&mut self, other: &Self) {
        self.mGridAutoColumns = other.mGridAutoColumns.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_auto_columns(&mut self, other: &Self) {
        self.copy_grid_auto_columns_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_auto_columns(&self) -> longhands::grid_auto_columns::computed_value::T {
        From::from(self.mGridAutoColumns.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_template_columns(&mut self, v: longhands::grid_template_columns::computed_value::T) {
        self.mGridTemplateColumns = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_template_columns_from(&mut self, other: &Self) {
        self.mGridTemplateColumns = other.mGridTemplateColumns.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_template_columns(&mut self, other: &Self) {
        self.copy_grid_template_columns_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_template_columns(&self) -> longhands::grid_template_columns::computed_value::T {
        From::from(self.mGridTemplateColumns.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_auto_flow(&mut self, v: longhands::grid_auto_flow::computed_value::T) {
        self.mGridAutoFlow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_auto_flow_from(&mut self, other: &Self) {
        self.mGridAutoFlow = other.mGridAutoFlow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_auto_flow(&mut self, other: &Self) {
        self.copy_grid_auto_flow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_auto_flow(&self) -> longhands::grid_auto_flow::computed_value::T {
        From::from(self.mGridAutoFlow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_template_areas(&mut self, v: longhands::grid_template_areas::computed_value::T) {
        self.mGridTemplateAreas = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_template_areas_from(&mut self, other: &Self) {
        self.mGridTemplateAreas = other.mGridTemplateAreas.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_template_areas(&mut self, other: &Self) {
        self.copy_grid_template_areas_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_template_areas(&self) -> longhands::grid_template_areas::computed_value::T {
        From::from(self.mGridTemplateAreas.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_gap(&mut self, v: longhands::column_gap::computed_value::T) {
        self.mColumnGap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_gap_from(&mut self, other: &Self) {
        self.mColumnGap = other.mColumnGap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_gap(&mut self, other: &Self) {
        self.copy_column_gap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_gap(&self) -> longhands::column_gap::computed_value::T {
        From::from(self.mColumnGap.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_row_gap(&mut self, v: longhands::row_gap::computed_value::T) {
        self.mRowGap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_row_gap_from(&mut self, other: &Self) {
        self.mRowGap = other.mRowGap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_row_gap(&mut self, other: &Self) {
        self.copy_row_gap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_row_gap(&self) -> longhands::row_gap::computed_value::T {
        From::from(self.mRowGap.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_aspect_ratio(&mut self, v: longhands::aspect_ratio::computed_value::T) {
        self.mAspectRatio = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_aspect_ratio_from(&mut self, other: &Self) {
        self.mAspectRatio = other.mAspectRatio.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_aspect_ratio(&mut self, other: &Self) {
        self.copy_aspect_ratio_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_aspect_ratio(&self) -> longhands::aspect_ratio::computed_value::T {
        From::from(self.mAspectRatio.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_contain_intrinsic_width(&mut self, v: longhands::contain_intrinsic_width::computed_value::T) {
        self.mContainIntrinsicWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_contain_intrinsic_width_from(&mut self, other: &Self) {
        self.mContainIntrinsicWidth = other.mContainIntrinsicWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_contain_intrinsic_width(&mut self, other: &Self) {
        self.copy_contain_intrinsic_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_contain_intrinsic_width(&self) -> longhands::contain_intrinsic_width::computed_value::T {
        From::from(self.mContainIntrinsicWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_contain_intrinsic_height(&mut self, v: longhands::contain_intrinsic_height::computed_value::T) {
        self.mContainIntrinsicHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_contain_intrinsic_height_from(&mut self, other: &Self) {
        self.mContainIntrinsicHeight = other.mContainIntrinsicHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_contain_intrinsic_height(&mut self, other: &Self) {
        self.copy_contain_intrinsic_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_contain_intrinsic_height(&self) -> longhands::contain_intrinsic_height::computed_value::T {
        From::from(self.mContainIntrinsicHeight.clone())
    }


    
    /// Set the appropriate physical property for contain-intrinsic-block-size given a writing mode.
    pub fn set_contain_intrinsic_block_size(&mut self,
                                      v: longhands::contain_intrinsic_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_contain_intrinsic_width(v)
            
        } else {
            
                self.set_contain_intrinsic_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for contain-intrinsic-block-size
    /// given a writing mode.
    pub fn copy_contain_intrinsic_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_contain_intrinsic_width_from(other)
            
        } else {
            
                self.copy_contain_intrinsic_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for contain-intrinsic-block-size
    /// given a writing mode.
    pub fn reset_contain_intrinsic_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_contain_intrinsic_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// contain-intrinsic-block-size given a writing mode.
    pub fn clone_contain_intrinsic_block_size(&self, wm: WritingMode)
        -> longhands::contain_intrinsic_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_contain_intrinsic_width()
        
        } else {
            
            self.clone_contain_intrinsic_height()
        
        }

    }


    
    /// Set the appropriate physical property for contain-intrinsic-inline-size given a writing mode.
    pub fn set_contain_intrinsic_inline_size(&mut self,
                                      v: longhands::contain_intrinsic_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_contain_intrinsic_height(v)
            
        } else {
            
                self.set_contain_intrinsic_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for contain-intrinsic-inline-size
    /// given a writing mode.
    pub fn copy_contain_intrinsic_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_contain_intrinsic_height_from(other)
            
        } else {
            
                self.copy_contain_intrinsic_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for contain-intrinsic-inline-size
    /// given a writing mode.
    pub fn reset_contain_intrinsic_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_contain_intrinsic_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// contain-intrinsic-inline-size given a writing mode.
    pub fn clone_contain_intrinsic_inline_size(&self, wm: WritingMode)
        -> longhands::contain_intrinsic_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_contain_intrinsic_height()
        
        } else {
            
            self.clone_contain_intrinsic_width()
        
        }

    }


}




impl GeckoOutline {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_outline_style(&mut self, v: longhands::outline_style::computed_value::T) {
        self.mOutlineStyle = v;
        // NB: This is needed to correctly handling the initial value of
        // outline-width when outline-style changes, see the
        // update_border_left comment for more details.
        self.mActualOutlineWidth = self.mOutlineWidth;
    }

    pub fn copy_outline_style_from(&mut self, other: &Self) {
        self.set_outline_style(other.mOutlineStyle);
    }

    pub fn reset_outline_style(&mut self, other: &Self) {
        self.copy_outline_style_from(other)
    }

    pub fn clone_outline_style(&self) -> longhands::outline_style::computed_value::T {
        self.mOutlineStyle.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_outline_width(&mut self, v: Au) {
        let value = v.0;
        self.mOutlineWidth = value;
        self.mActualOutlineWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_outline_width_from(&mut self, other: &Self) {
        self.mOutlineWidth = other.mOutlineWidth;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.mActualOutlineWidth = other.mOutlineWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_width(&mut self, other: &Self) {
        self.copy_outline_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_outline_width(&self) -> Au {
        Au(self.mActualOutlineWidth)
    }


    pub fn outline_has_nonzero_width(&self) -> bool {
        self.mActualOutlineWidth != 0
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_outline_color(&mut self, v: longhands::outline_color::computed_value::T) {
        self.mOutlineColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_outline_color_from(&mut self, other: &Self) {
        self.mOutlineColor = other.mOutlineColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_color(&mut self, other: &Self) {
        self.copy_outline_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_outline_color(&self) -> longhands::outline_color::computed_value::T {
        From::from(self.mOutlineColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_outline_offset(&mut self, v: longhands::outline_offset::computed_value::T) {
        self.mOutlineOffset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_outline_offset_from(&mut self, other: &Self) {
        self.mOutlineOffset = other.mOutlineOffset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_offset(&mut self, other: &Self) {
        self.copy_outline_offset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_outline_offset(&self) -> longhands::outline_offset::computed_value::T {
        From::from(self.mOutlineOffset.clone())
    }


}





impl GeckoFont {
    /*
     * Manually-Implemented Methods.
     */
    

    // Negative numbers are invalid at parse time, but <integer> is still an
    // i32.
    
    

    pub fn set_font_feature_settings(&mut self, v: longhands::font_feature_settings::computed_value::T) {
        let iter = v.0.iter().map(|other| structs::gfxFontFeature {
            mTag: other.tag.0,
            mValue: other.value as u32,
        });
        self.mFont.fontFeatureSettings.assign_from_iter_pod(iter);
    }

    pub fn copy_font_feature_settings_from(&mut self, other: &Self) {
        let iter = other.mFont.fontFeatureSettings.iter().map(|s| *s);
        self.mFont.fontFeatureSettings.assign_from_iter_pod(iter);
    }

    pub fn reset_font_feature_settings(&mut self, other: &Self) {
        self.copy_font_feature_settings_from(other)
    }

    pub fn clone_font_feature_settings(&self) -> longhands::font_feature_settings::computed_value::T {
        use crate::values::generics::font::{FontSettings, FontTag, FeatureTagValue};

        FontSettings(
            self.mFont.fontFeatureSettings.iter().map(|gecko_font_setting| {
                FeatureTagValue {
                    tag: FontTag(gecko_font_setting.mTag),
                    value: gecko_font_setting.mValue as i32,
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }

    
    

    pub fn set_font_variation_settings(&mut self, v: longhands::font_variation_settings::computed_value::T) {
        let iter = v.0.iter().map(|other| structs::gfxFontVariation {
            mTag: other.tag.0,
            mValue: other.value as f32,
        });
        self.mFont.fontVariationSettings.assign_from_iter_pod(iter);
    }

    pub fn copy_font_variation_settings_from(&mut self, other: &Self) {
        let iter = other.mFont.fontVariationSettings.iter().map(|s| *s);
        self.mFont.fontVariationSettings.assign_from_iter_pod(iter);
    }

    pub fn reset_font_variation_settings(&mut self, other: &Self) {
        self.copy_font_variation_settings_from(other)
    }

    pub fn clone_font_variation_settings(&self) -> longhands::font_variation_settings::computed_value::T {
        use crate::values::generics::font::{FontSettings, FontTag, VariationValue};

        FontSettings(
            self.mFont.fontVariationSettings.iter().map(|gecko_font_setting| {
                VariationValue {
                    tag: FontTag(gecko_font_setting.mTag),
                    value: gecko_font_setting.mValue as f32,
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }


    pub fn unzoom_fonts(&mut self, device: &Device) {
        use crate::values::generics::NonNegative;
        self.mSize = NonNegative(device.unzoom_text(self.mSize.0));
        self.mScriptUnconstrainedSize = NonNegative(device.unzoom_text(self.mScriptUnconstrainedSize.0));
        self.mFont.size = NonNegative(device.unzoom_text(self.mFont.size.0));
    }

    pub fn copy_font_size_from(&mut self, other: &Self) {
        self.mScriptUnconstrainedSize = other.mScriptUnconstrainedSize;

        self.mSize = other.mScriptUnconstrainedSize;
        // NOTE: Intentionally not copying from mFont.size. The cascade process
        // recomputes the used size as needed.
        self.mFont.size = other.mSize;
        self.mFontSizeKeyword = other.mFontSizeKeyword;

        // TODO(emilio): Should we really copy over these two?
        self.mFontSizeFactor = other.mFontSizeFactor;
        self.mFontSizeOffset = other.mFontSizeOffset;
    }

    pub fn reset_font_size(&mut self, other: &Self) {
        self.copy_font_size_from(other)
    }

    pub fn set_font_size(&mut self, v: FontSize) {
        let computed_size = v.computed_size;
        self.mScriptUnconstrainedSize = computed_size;

        // These two may be changed from Cascade::fixup_font_stuff.
        self.mSize = computed_size;
        // NOTE: Intentionally not copying from used_size. The cascade process
        // recomputes the used size as needed.
        self.mFont.size = computed_size;

        self.mFontSizeKeyword = v.keyword_info.kw;
        self.mFontSizeFactor = v.keyword_info.factor;
        self.mFontSizeOffset = v.keyword_info.offset;
    }

    pub fn clone_font_size(&self) -> FontSize {
        use crate::values::specified::font::KeywordInfo;

        FontSize {
            computed_size: self.mSize,
            used_size: self.mFont.size,
            keyword_info: KeywordInfo {
                kw: self.mFontSizeKeyword,
                factor: self.mFontSizeFactor,
                offset: self.mFontSizeOffset,
            }
        }
    }

    

    #[allow(non_snake_case)]
    pub fn set_font_weight(&mut self, v: longhands::font_weight::computed_value::T) {
        self.mFont.weight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_weight_from(&mut self, other: &Self) {
        self.mFont.weight = other.mFont.weight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_weight(&mut self, other: &Self) {
        self.copy_font_weight_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_weight(&self) -> longhands::font_weight::computed_value::T {
        From::from(self.mFont.weight.clone())
    }


    

    #[allow(non_snake_case)]
    pub fn set_font_stretch(&mut self, v: longhands::font_stretch::computed_value::T) {
        self.mFont.stretch = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_stretch_from(&mut self, other: &Self) {
        self.mFont.stretch = other.mFont.stretch.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_stretch(&mut self, other: &Self) {
        self.copy_font_stretch_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_stretch(&self) -> longhands::font_stretch::computed_value::T {
        From::from(self.mFont.stretch.clone())
    }


    

    #[allow(non_snake_case)]
    pub fn set_font_style(&mut self, v: longhands::font_style::computed_value::T) {
        self.mFont.style = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_style_from(&mut self, other: &Self) {
        self.mFont.style = other.mFont.style.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_style(&mut self, other: &Self) {
        self.copy_font_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_style(&self) -> longhands::font_style::computed_value::T {
        From::from(self.mFont.style.clone())
    }



    

    #[allow(non_snake_case)]
    pub fn set_font_variant_alternates(&mut self, v: longhands::font_variant_alternates::computed_value::T) {
        self.mFont.variantAlternates = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_alternates_from(&mut self, other: &Self) {
        self.mFont.variantAlternates = other.mFont.variantAlternates.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_alternates(&mut self, other: &Self) {
        self.copy_font_variant_alternates_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_alternates(&self) -> longhands::font_variant_alternates::computed_value::T {
        From::from(self.mFont.variantAlternates.clone())
    }



    

    #[allow(non_snake_case)]
    pub fn set_font_size_adjust(&mut self, v: longhands::font_size_adjust::computed_value::T) {
        self.mFont.sizeAdjust = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_size_adjust_from(&mut self, other: &Self) {
        self.mFont.sizeAdjust = other.mFont.sizeAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_size_adjust(&mut self, other: &Self) {
        self.copy_font_size_adjust_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_size_adjust(&self) -> longhands::font_size_adjust::computed_value::T {
        From::from(self.mFont.sizeAdjust.clone())
    }



    

    #[allow(non_snake_case)]
    pub fn set_font_family(&mut self, v: longhands::font_family::computed_value::T) {
        self.mFont.family = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_family_from(&mut self, other: &Self) {
        self.mFont.family = other.mFont.family.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_family(&mut self, other: &Self) {
        self.copy_font_family_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_family(&self) -> longhands::font_family::computed_value::T {
        From::from(self.mFont.family.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__x_lang(&mut self, v: longhands::_x_lang::computed_value::T) {
        let ptr = v.0.as_ptr();
        forget(v);
        unsafe {
            Gecko_nsStyleFont_SetLang(&mut **self, ptr);
        }
    }

    #[allow(non_snake_case)]
    pub fn copy__x_lang_from(&mut self, other: &Self) {
        unsafe {
            Gecko_nsStyleFont_CopyLangFrom(&mut **self, &**other);
        }
    }

    #[allow(non_snake_case)]
    pub fn reset__x_lang(&mut self, other: &Self) {
        self.copy__x_lang_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__x_lang(&self) -> longhands::_x_lang::computed_value::T {
        longhands::_x_lang::computed_value::T(unsafe {
            Atom::from_raw(self.mLanguage.mRawPtr)
        })
    }


    
    #[allow(non_snake_case)]
    pub fn set_font_language_override(&mut self, v: longhands::font_language_override::computed_value::T) {
        self.mFont.languageOverride = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_language_override_from(&mut self, other: &Self) {
        self.mFont.languageOverride = other.mFont.languageOverride.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_language_override(&mut self, other: &Self) {
        self.copy_font_language_override_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_language_override(&self) -> longhands::font_language_override::computed_value::T {
        From::from(self.mFont.languageOverride)
    }

    
    #[allow(non_snake_case)]
    pub fn set_font_variant_ligatures(&mut self, v: longhands::font_variant_ligatures::computed_value::T) {
        self.mFont.variantLigatures = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_ligatures_from(&mut self, other: &Self) {
        self.mFont.variantLigatures = other.mFont.variantLigatures.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_ligatures(&mut self, other: &Self) {
        self.copy_font_variant_ligatures_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_ligatures(&self) -> longhands::font_variant_ligatures::computed_value::T {
        From::from(self.mFont.variantLigatures)
    }

    
    #[allow(non_snake_case)]
    pub fn set_font_variant_east_asian(&mut self, v: longhands::font_variant_east_asian::computed_value::T) {
        self.mFont.variantEastAsian = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_east_asian_from(&mut self, other: &Self) {
        self.mFont.variantEastAsian = other.mFont.variantEastAsian.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_east_asian(&mut self, other: &Self) {
        self.copy_font_variant_east_asian_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_east_asian(&self) -> longhands::font_variant_east_asian::computed_value::T {
        From::from(self.mFont.variantEastAsian)
    }

    
    #[allow(non_snake_case)]
    pub fn set_font_variant_numeric(&mut self, v: longhands::font_variant_numeric::computed_value::T) {
        self.mFont.variantNumeric = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_numeric_from(&mut self, other: &Self) {
        self.mFont.variantNumeric = other.mFont.variantNumeric.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_numeric(&mut self, other: &Self) {
        self.copy_font_variant_numeric_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_numeric(&self) -> longhands::font_variant_numeric::computed_value::T {
        From::from(self.mFont.variantNumeric)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_min_font_size_ratio(
        &self,
    ) -> longhands::_moz_min_font_size_ratio::computed_value::T {
        Percentage(self.mMinFontSizeRatio as f32 / 100.)
    }

    #[allow(non_snake_case)]
    pub fn set__moz_min_font_size_ratio(&mut self, v: longhands::_moz_min_font_size_ratio::computed_value::T) {
        let scaled = v.0 * 100.;
        let percentage = if scaled > 255. {
            255.
        } else if scaled < 0. {
            0.
        } else {
            scaled
        };

        self.mMinFontSizeRatio = percentage as u8;
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_min_font_size_ratio_from(&mut self, other: &Self) {
        self.mMinFontSizeRatio = other.mMinFontSizeRatio.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_min_font_size_ratio(&mut self, other: &Self) {
        self.copy__moz_min_font_size_ratio_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_caps(&mut self, v: longhands::font_variant_caps::computed_value::T) {
        use crate::properties::longhands::font_variant_caps::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_FONT_VARIANT_CAPS_NORMAL as u8,
                Keyword::SmallCaps =>
                    structs::NS_FONT_VARIANT_CAPS_SMALLCAPS as u8,
                Keyword::AllSmallCaps =>
                    structs::NS_FONT_VARIANT_CAPS_ALLSMALL as u8,
                Keyword::PetiteCaps =>
                    structs::NS_FONT_VARIANT_CAPS_PETITECAPS as u8,
                Keyword::AllPetiteCaps =>
                    structs::NS_FONT_VARIANT_CAPS_ALLPETITE as u8,
                Keyword::Unicase =>
                    structs::NS_FONT_VARIANT_CAPS_UNICASE as u8,
                Keyword::TitlingCaps =>
                    structs::NS_FONT_VARIANT_CAPS_TITLING as u8,
        };
        self.mFont.variantCaps = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_caps_from(&mut self, other: &Self) {
        self.mFont.variantCaps = other.mFont.variantCaps.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_caps(&mut self, other: &Self) {
        self.copy_font_variant_caps_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_caps(&self) -> longhands::font_variant_caps::computed_value::T {
        use crate::properties::longhands::font_variant_caps::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_VARIANT_CAPS_NORMAL : u8 =
            structs::NS_FONT_VARIANT_CAPS_NORMAL as u8;
        const U8_NS_FONT_VARIANT_CAPS_SMALLCAPS : u8 =
            structs::NS_FONT_VARIANT_CAPS_SMALLCAPS as u8;
        const U8_NS_FONT_VARIANT_CAPS_ALLSMALL : u8 =
            structs::NS_FONT_VARIANT_CAPS_ALLSMALL as u8;
        const U8_NS_FONT_VARIANT_CAPS_PETITECAPS : u8 =
            structs::NS_FONT_VARIANT_CAPS_PETITECAPS as u8;
        const U8_NS_FONT_VARIANT_CAPS_ALLPETITE : u8 =
            structs::NS_FONT_VARIANT_CAPS_ALLPETITE as u8;
        const U8_NS_FONT_VARIANT_CAPS_UNICASE : u8 =
            structs::NS_FONT_VARIANT_CAPS_UNICASE as u8;
        const U8_NS_FONT_VARIANT_CAPS_TITLING : u8 =
            structs::NS_FONT_VARIANT_CAPS_TITLING as u8;

        match self.mFont.variantCaps as u8 {
            U8_NS_FONT_VARIANT_CAPS_NORMAL => Keyword::Normal,
            U8_NS_FONT_VARIANT_CAPS_SMALLCAPS => Keyword::SmallCaps,
            U8_NS_FONT_VARIANT_CAPS_ALLSMALL => Keyword::AllSmallCaps,
            U8_NS_FONT_VARIANT_CAPS_PETITECAPS => Keyword::PetiteCaps,
            U8_NS_FONT_VARIANT_CAPS_ALLPETITE => Keyword::AllPetiteCaps,
            U8_NS_FONT_VARIANT_CAPS_UNICASE => Keyword::Unicase,
            U8_NS_FONT_VARIANT_CAPS_TITLING => Keyword::TitlingCaps,
            _ => panic!("Found unexpected value in style struct for font_variant_caps property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_synthesis_weight(&mut self, v: longhands::font_synthesis_weight::computed_value::T) {
        self.mFont.synthesisWeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_synthesis_weight_from(&mut self, other: &Self) {
        self.mFont.synthesisWeight = other.mFont.synthesisWeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_synthesis_weight(&mut self, other: &Self) {
        self.copy_font_synthesis_weight_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_synthesis_weight(&self) -> longhands::font_synthesis_weight::computed_value::T {
        From::from(self.mFont.synthesisWeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_font_synthesis_style(&mut self, v: longhands::font_synthesis_style::computed_value::T) {
        self.mFont.synthesisStyle = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_synthesis_style_from(&mut self, other: &Self) {
        self.mFont.synthesisStyle = other.mFont.synthesisStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_synthesis_style(&mut self, other: &Self) {
        self.copy_font_synthesis_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_synthesis_style(&self) -> longhands::font_synthesis_style::computed_value::T {
        From::from(self.mFont.synthesisStyle.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_font_synthesis_small_caps(&mut self, v: longhands::font_synthesis_small_caps::computed_value::T) {
        self.mFont.synthesisSmallCaps = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_synthesis_small_caps_from(&mut self, other: &Self) {
        self.mFont.synthesisSmallCaps = other.mFont.synthesisSmallCaps.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_synthesis_small_caps(&mut self, other: &Self) {
        self.copy_font_synthesis_small_caps_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_synthesis_small_caps(&self) -> longhands::font_synthesis_small_caps::computed_value::T {
        From::from(self.mFont.synthesisSmallCaps.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_font_kerning(&mut self, v: longhands::font_kerning::computed_value::T) {
        use crate::properties::longhands::font_kerning::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_KERNING_AUTO as u8,
                Keyword::None =>
                    structs::NS_FONT_KERNING_NONE as u8,
                Keyword::Normal =>
                    structs::NS_FONT_KERNING_NORMAL as u8,
        };
        self.mFont.kerning = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_kerning_from(&mut self, other: &Self) {
        self.mFont.kerning = other.mFont.kerning.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_kerning(&mut self, other: &Self) {
        self.copy_font_kerning_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_kerning(&self) -> longhands::font_kerning::computed_value::T {
        use crate::properties::longhands::font_kerning::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_KERNING_AUTO : u8 =
            structs::NS_FONT_KERNING_AUTO as u8;
        const U8_NS_FONT_KERNING_NONE : u8 =
            structs::NS_FONT_KERNING_NONE as u8;
        const U8_NS_FONT_KERNING_NORMAL : u8 =
            structs::NS_FONT_KERNING_NORMAL as u8;

        match self.mFont.kerning as u8 {
            U8_NS_FONT_KERNING_AUTO => Keyword::Auto,
            U8_NS_FONT_KERNING_NONE => Keyword::None,
            U8_NS_FONT_KERNING_NORMAL => Keyword::Normal,
            _ => panic!("Found unexpected value in style struct for font_kerning property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_variant_emoji(&mut self, v: longhands::font_variant_emoji::computed_value::T) {
        use crate::properties::longhands::font_variant_emoji::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleFontVariantEmoji::Normal ,
                Keyword::Text =>
                    structs::StyleFontVariantEmoji::Text ,
                Keyword::Emoji =>
                    structs::StyleFontVariantEmoji::Emoji ,
                Keyword::Unicode =>
                    structs::StyleFontVariantEmoji::Unicode ,
        };
        self.mFont.variantEmoji = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_emoji_from(&mut self, other: &Self) {
        self.mFont.variantEmoji = other.mFont.variantEmoji.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_emoji(&mut self, other: &Self) {
        self.copy_font_variant_emoji_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_emoji(&self) -> longhands::font_variant_emoji::computed_value::T {
        use crate::properties::longhands::font_variant_emoji::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mFont.variantEmoji {
            structs::StyleFontVariantEmoji::Normal => Keyword::Normal,
            structs::StyleFontVariantEmoji::Text => Keyword::Text,
            structs::StyleFontVariantEmoji::Emoji => Keyword::Emoji,
            structs::StyleFontVariantEmoji::Unicode => Keyword::Unicode,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_variant_position(&mut self, v: longhands::font_variant_position::computed_value::T) {
        use crate::properties::longhands::font_variant_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_FONT_VARIANT_POSITION_NORMAL as u8,
                Keyword::Sub =>
                    structs::NS_FONT_VARIANT_POSITION_SUB as u8,
                Keyword::Super =>
                    structs::NS_FONT_VARIANT_POSITION_SUPER as u8,
        };
        self.mFont.variantPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_position_from(&mut self, other: &Self) {
        self.mFont.variantPosition = other.mFont.variantPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_position(&mut self, other: &Self) {
        self.copy_font_variant_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_position(&self) -> longhands::font_variant_position::computed_value::T {
        use crate::properties::longhands::font_variant_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_VARIANT_POSITION_NORMAL : u8 =
            structs::NS_FONT_VARIANT_POSITION_NORMAL as u8;
        const U8_NS_FONT_VARIANT_POSITION_SUB : u8 =
            structs::NS_FONT_VARIANT_POSITION_SUB as u8;
        const U8_NS_FONT_VARIANT_POSITION_SUPER : u8 =
            structs::NS_FONT_VARIANT_POSITION_SUPER as u8;

        match self.mFont.variantPosition as u8 {
            U8_NS_FONT_VARIANT_POSITION_NORMAL => Keyword::Normal,
            U8_NS_FONT_VARIANT_POSITION_SUB => Keyword::Sub,
            U8_NS_FONT_VARIANT_POSITION_SUPER => Keyword::Super,
            _ => panic!("Found unexpected value in style struct for font_variant_position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_optical_sizing(&mut self, v: longhands::font_optical_sizing::computed_value::T) {
        use crate::properties::longhands::font_optical_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_OPTICAL_SIZING_AUTO as u8,
                Keyword::None =>
                    structs::NS_FONT_OPTICAL_SIZING_NONE as u8,
        };
        self.mFont.opticalSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_optical_sizing_from(&mut self, other: &Self) {
        self.mFont.opticalSizing = other.mFont.opticalSizing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_optical_sizing(&mut self, other: &Self) {
        self.copy_font_optical_sizing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_optical_sizing(&self) -> longhands::font_optical_sizing::computed_value::T {
        use crate::properties::longhands::font_optical_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_OPTICAL_SIZING_AUTO : u8 =
            structs::NS_FONT_OPTICAL_SIZING_AUTO as u8;
        const U8_NS_FONT_OPTICAL_SIZING_NONE : u8 =
            structs::NS_FONT_OPTICAL_SIZING_NONE as u8;

        match self.mFont.opticalSizing as u8 {
            U8_NS_FONT_OPTICAL_SIZING_AUTO => Keyword::Auto,
            U8_NS_FONT_OPTICAL_SIZING_NONE => Keyword::None,
            _ => panic!("Found unexpected value in style struct for font_optical_sizing property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_palette(&mut self, v: longhands::font_palette::computed_value::T) {
        self.mFontPalette = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_palette_from(&mut self, other: &Self) {
        self.mFontPalette = other.mFontPalette.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_palette(&mut self, other: &Self) {
        self.copy_font_palette_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_palette(&self) -> longhands::font_palette::computed_value::T {
        From::from(self.mFontPalette.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_script_size_multiplier(&mut self, v: longhands::_moz_script_size_multiplier::computed_value::T) {
        self.mScriptSizeMultiplier = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_script_size_multiplier_from(&mut self, other: &Self) {
        self.mScriptSizeMultiplier = other.mScriptSizeMultiplier.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_size_multiplier(&mut self, other: &Self) {
        self.copy__moz_script_size_multiplier_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_script_size_multiplier(&self) -> longhands::_moz_script_size_multiplier::computed_value::T {
        From::from(self.mScriptSizeMultiplier.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_math_depth(&mut self, v: longhands::math_depth::computed_value::T) {
        self.mMathDepth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_math_depth_from(&mut self, other: &Self) {
        self.mMathDepth = other.mMathDepth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_math_depth(&mut self, other: &Self) {
        self.copy_math_depth_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_math_depth(&self) -> longhands::math_depth::computed_value::T {
        From::from(self.mMathDepth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_math_style(&mut self, v: longhands::math_style::computed_value::T) {
        use crate::properties::longhands::math_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleMathStyle::Normal ,
                Keyword::Compact =>
                    structs::StyleMathStyle::Compact ,
        };
        self.mMathStyle = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_math_style_from(&mut self, other: &Self) {
        self.mMathStyle = other.mMathStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_math_style(&mut self, other: &Self) {
        self.copy_math_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_math_style(&self) -> longhands::math_style::computed_value::T {
        use crate::properties::longhands::math_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mMathStyle {
            structs::StyleMathStyle::Normal => Keyword::Normal,
            structs::StyleMathStyle::Compact => Keyword::Compact,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_math_variant(&mut self, v: longhands::_moz_math_variant::computed_value::T) {
        use crate::properties::longhands::_moz_math_variant::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleMathVariant::None ,
                Keyword::Normal =>
                    structs::StyleMathVariant::Normal ,
                Keyword::Bold =>
                    structs::StyleMathVariant::Bold ,
                Keyword::Italic =>
                    structs::StyleMathVariant::Italic ,
                Keyword::BoldItalic =>
                    structs::StyleMathVariant::BoldItalic ,
                Keyword::Script =>
                    structs::StyleMathVariant::Script ,
                Keyword::BoldScript =>
                    structs::StyleMathVariant::BoldScript ,
                Keyword::Fraktur =>
                    structs::StyleMathVariant::Fraktur ,
                Keyword::DoubleStruck =>
                    structs::StyleMathVariant::DoubleStruck ,
                Keyword::BoldFraktur =>
                    structs::StyleMathVariant::BoldFraktur ,
                Keyword::SansSerif =>
                    structs::StyleMathVariant::SansSerif ,
                Keyword::BoldSansSerif =>
                    structs::StyleMathVariant::BoldSansSerif ,
                Keyword::SansSerifItalic =>
                    structs::StyleMathVariant::SansSerifItalic ,
                Keyword::SansSerifBoldItalic =>
                    structs::StyleMathVariant::SansSerifBoldItalic ,
                Keyword::Monospace =>
                    structs::StyleMathVariant::Monospace ,
                Keyword::Initial =>
                    structs::StyleMathVariant::Initial ,
                Keyword::Tailed =>
                    structs::StyleMathVariant::Tailed ,
                Keyword::Looped =>
                    structs::StyleMathVariant::Looped ,
                Keyword::Stretched =>
                    structs::StyleMathVariant::Stretched ,
        };
        self.mMathVariant = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_math_variant_from(&mut self, other: &Self) {
        self.mMathVariant = other.mMathVariant.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_math_variant(&mut self, other: &Self) {
        self.copy__moz_math_variant_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_math_variant(&self) -> longhands::_moz_math_variant::computed_value::T {
        use crate::properties::longhands::_moz_math_variant::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mMathVariant {
            structs::StyleMathVariant::None => Keyword::None,
            structs::StyleMathVariant::Normal => Keyword::Normal,
            structs::StyleMathVariant::Bold => Keyword::Bold,
            structs::StyleMathVariant::Italic => Keyword::Italic,
            structs::StyleMathVariant::BoldItalic => Keyword::BoldItalic,
            structs::StyleMathVariant::Script => Keyword::Script,
            structs::StyleMathVariant::BoldScript => Keyword::BoldScript,
            structs::StyleMathVariant::Fraktur => Keyword::Fraktur,
            structs::StyleMathVariant::DoubleStruck => Keyword::DoubleStruck,
            structs::StyleMathVariant::BoldFraktur => Keyword::BoldFraktur,
            structs::StyleMathVariant::SansSerif => Keyword::SansSerif,
            structs::StyleMathVariant::BoldSansSerif => Keyword::BoldSansSerif,
            structs::StyleMathVariant::SansSerifItalic => Keyword::SansSerifItalic,
            structs::StyleMathVariant::SansSerifBoldItalic => Keyword::SansSerifBoldItalic,
            structs::StyleMathVariant::Monospace => Keyword::Monospace,
            structs::StyleMathVariant::Initial => Keyword::Initial,
            structs::StyleMathVariant::Tailed => Keyword::Tailed,
            structs::StyleMathVariant::Looped => Keyword::Looped,
            structs::StyleMathVariant::Stretched => Keyword::Stretched,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_script_min_size(&mut self, v: longhands::_moz_script_min_size::computed_value::T) {
        self.mScriptMinSize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_script_min_size_from(&mut self, other: &Self) {
        self.mScriptMinSize = other.mScriptMinSize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_min_size(&mut self, other: &Self) {
        self.copy__moz_script_min_size_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_script_min_size(&self) -> longhands::_moz_script_min_size::computed_value::T {
        From::from(self.mScriptMinSize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__x_text_scale(&mut self, v: longhands::_x_text_scale::computed_value::T) {
        self.mXTextScale = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__x_text_scale_from(&mut self, other: &Self) {
        self.mXTextScale = other.mXTextScale.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__x_text_scale(&mut self, other: &Self) {
        self.copy__x_text_scale_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__x_text_scale(&self) -> longhands::_x_text_scale::computed_value::T {
        From::from(self.mXTextScale.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_osx_font_smoothing(&mut self, v: longhands::_moz_osx_font_smoothing::computed_value::T) {
        use crate::properties::longhands::_moz_osx_font_smoothing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_SMOOTHING_AUTO as u8,
                Keyword::Grayscale =>
                    structs::NS_FONT_SMOOTHING_GRAYSCALE as u8,
        };
        self.mFont.smoothing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_osx_font_smoothing_from(&mut self, other: &Self) {
        self.mFont.smoothing = other.mFont.smoothing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_osx_font_smoothing(&mut self, other: &Self) {
        self.copy__moz_osx_font_smoothing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_osx_font_smoothing(&self) -> longhands::_moz_osx_font_smoothing::computed_value::T {
        use crate::properties::longhands::_moz_osx_font_smoothing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_SMOOTHING_AUTO : u8 =
            structs::NS_FONT_SMOOTHING_AUTO as u8;
        const U8_NS_FONT_SMOOTHING_GRAYSCALE : u8 =
            structs::NS_FONT_SMOOTHING_GRAYSCALE as u8;

        match self.mFont.smoothing as u8 {
            U8_NS_FONT_SMOOTHING_AUTO => Keyword::Auto,
            U8_NS_FONT_SMOOTHING_GRAYSCALE => Keyword::Grayscale,
            _ => panic!("Found unexpected value in style struct for _moz_osx_font_smoothing property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_font_smoothing_background_color(&mut self, v: longhands::_moz_font_smoothing_background_color::computed_value::T) {
        self.mFont.fontSmoothingBackgroundColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_font_smoothing_background_color_from(&mut self, other: &Self) {
        self.mFont.fontSmoothingBackgroundColor = other.mFont.fontSmoothingBackgroundColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_font_smoothing_background_color(&mut self, other: &Self) {
        self.copy__moz_font_smoothing_background_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_font_smoothing_background_color(&self) -> longhands::_moz_font_smoothing_background_color::computed_value::T {
        From::from(self.mFont.fontSmoothingBackgroundColor.clone())
    }


}













impl GeckoBox {
    /*
     * Manually-Implemented Methods.
     */
    
    #[inline]
    pub fn set_display(&mut self, v: longhands::display::computed_value::T) {
        self.mDisplay = v;
        self.mOriginalDisplay = v;
    }

    #[inline]
    pub fn copy_display_from(&mut self, other: &Self) {
        self.set_display(other.mDisplay);
    }

    #[inline]
    pub fn reset_display(&mut self, other: &Self) {
        self.copy_display_from(other)
    }

    #[inline]
    pub fn set_adjusted_display(
        &mut self,
        v: longhands::display::computed_value::T,
        _is_item_or_root: bool
    ) {
        self.mDisplay = v;
    }

    #[inline]
    pub fn clone_display(&self) -> longhands::display::computed_value::T {
        self.mDisplay
    }

    #[inline]
    pub fn set_contain(&mut self, v: longhands::contain::computed_value::T) {
        self.mContain = v;
        self.mEffectiveContainment = v;
    }

    #[inline]
    pub fn copy_contain_from(&mut self, other: &Self) {
        self.set_contain(other.mContain);
    }

    #[inline]
    pub fn reset_contain(&mut self, other: &Self) {
        self.copy_contain_from(other)
    }

    #[inline]
    pub fn clone_contain(&self) -> longhands::contain::computed_value::T {
        self.mContain
    }

    #[inline]
    pub fn set_effective_containment(
        &mut self,
        v: longhands::contain::computed_value::T
    ) {
        self.mEffectiveContainment = v;
    }

    #[inline]
    pub fn clone_effective_containment(&self) -> longhands::contain::computed_value::T {
        self.mEffectiveContainment
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set__moz_top_layer(&mut self, v: longhands::_moz_top_layer::computed_value::T) {
        use crate::properties::longhands::_moz_top_layer::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleTopLayer::None ,
                Keyword::Top =>
                    structs::StyleTopLayer::Top ,
        };
        self.mTopLayer = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_top_layer_from(&mut self, other: &Self) {
        self.mTopLayer = other.mTopLayer.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_top_layer(&mut self, other: &Self) {
        self.copy__moz_top_layer_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_top_layer(&self) -> longhands::_moz_top_layer::computed_value::T {
        use crate::properties::longhands::_moz_top_layer::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mTopLayer {
            structs::StyleTopLayer::None => Keyword::None,
            structs::StyleTopLayer::Top => Keyword::Top,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_position(&mut self, v: longhands::position::computed_value::T) {
        use crate::properties::longhands::position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Static =>
                    structs::StylePositionProperty::Static ,
                Keyword::Absolute =>
                    structs::StylePositionProperty::Absolute ,
                Keyword::Relative =>
                    structs::StylePositionProperty::Relative ,
                Keyword::Fixed =>
                    structs::StylePositionProperty::Fixed ,
                Keyword::Sticky =>
                    structs::StylePositionProperty::Sticky ,
        };
        self.mPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_position_from(&mut self, other: &Self) {
        self.mPosition = other.mPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_position(&mut self, other: &Self) {
        self.copy_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_position(&self) -> longhands::position::computed_value::T {
        use crate::properties::longhands::position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mPosition {
            structs::StylePositionProperty::Static => Keyword::Static,
            structs::StylePositionProperty::Absolute => Keyword::Absolute,
            structs::StylePositionProperty::Relative => Keyword::Relative,
            structs::StylePositionProperty::Fixed => Keyword::Fixed,
            structs::StylePositionProperty::Sticky => Keyword::Sticky,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_float(&mut self, v: longhands::float::computed_value::T) {
        self.mFloat = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_float_from(&mut self, other: &Self) {
        self.mFloat = other.mFloat.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_float(&mut self, other: &Self) {
        self.copy_float_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_float(&self) -> longhands::float::computed_value::T {
        From::from(self.mFloat.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_clear(&mut self, v: longhands::clear::computed_value::T) {
        self.mClear = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clear_from(&mut self, other: &Self) {
        self.mClear = other.mClear.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clear(&mut self, other: &Self) {
        self.copy_clear_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clear(&self) -> longhands::clear::computed_value::T {
        From::from(self.mClear.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_vertical_align(&mut self, v: longhands::vertical_align::computed_value::T) {
        self.mVerticalAlign = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_vertical_align_from(&mut self, other: &Self) {
        self.mVerticalAlign = other.mVerticalAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_vertical_align(&mut self, other: &Self) {
        self.copy_vertical_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_vertical_align(&self) -> longhands::vertical_align::computed_value::T {
        From::from(self.mVerticalAlign.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_baseline_source(&mut self, v: longhands::baseline_source::computed_value::T) {
        self.mBaselineSource = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_baseline_source_from(&mut self, other: &Self) {
        self.mBaselineSource = other.mBaselineSource.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_baseline_source(&mut self, other: &Self) {
        self.copy_baseline_source_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_baseline_source(&self) -> longhands::baseline_source::computed_value::T {
        From::from(self.mBaselineSource.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_inline(&mut self, v: longhands::overflow_clip_box_inline::computed_value::T) {
        self.mOverflowClipBoxInline = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_box_inline_from(&mut self, other: &Self) {
        self.mOverflowClipBoxInline = other.mOverflowClipBoxInline.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_box_inline(&mut self, other: &Self) {
        self.copy_overflow_clip_box_inline_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_inline(&self) -> longhands::overflow_clip_box_inline::computed_value::T {
        From::from(self.mOverflowClipBoxInline.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_block(&mut self, v: longhands::overflow_clip_box_block::computed_value::T) {
        self.mOverflowClipBoxBlock = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_box_block_from(&mut self, other: &Self) {
        self.mOverflowClipBoxBlock = other.mOverflowClipBoxBlock.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_box_block(&mut self, other: &Self) {
        self.copy_overflow_clip_box_block_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_block(&self) -> longhands::overflow_clip_box_block::computed_value::T {
        From::from(self.mOverflowClipBoxBlock.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_x(&mut self, v: longhands::overflow_x::computed_value::T) {
        self.mOverflowX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_x_from(&mut self, other: &Self) {
        self.mOverflowX = other.mOverflowX.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_x(&mut self, other: &Self) {
        self.copy_overflow_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_x(&self) -> longhands::overflow_x::computed_value::T {
        From::from(self.mOverflowX.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_y(&mut self, v: longhands::overflow_y::computed_value::T) {
        self.mOverflowY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_y_from(&mut self, other: &Self) {
        self.mOverflowY = other.mOverflowY.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_y(&mut self, other: &Self) {
        self.copy_overflow_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_y(&self) -> longhands::overflow_y::computed_value::T {
        From::from(self.mOverflowY.clone())
    }


    
    /// Set the appropriate physical property for overflow-inline given a writing mode.
    pub fn set_overflow_inline(&mut self,
                                      v: longhands::overflow_inline::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_overflow_y(v)
            
        } else {
            
                self.set_overflow_x(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overflow-inline
    /// given a writing mode.
    pub fn copy_overflow_inline_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_overflow_y_from(other)
            
        } else {
            
                self.copy_overflow_x_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overflow-inline
    /// given a writing mode.
    pub fn reset_overflow_inline(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_overflow_inline_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// overflow-inline given a writing mode.
    pub fn clone_overflow_inline(&self, wm: WritingMode)
        -> longhands::overflow_inline::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_overflow_y()
        
        } else {
            
            self.clone_overflow_x()
        
        }

    }


    
    /// Set the appropriate physical property for overflow-block given a writing mode.
    pub fn set_overflow_block(&mut self,
                                      v: longhands::overflow_block::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_overflow_x(v)
            
        } else {
            
                self.set_overflow_y(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overflow-block
    /// given a writing mode.
    pub fn copy_overflow_block_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_overflow_x_from(other)
            
        } else {
            
                self.copy_overflow_y_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overflow-block
    /// given a writing mode.
    pub fn reset_overflow_block(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_overflow_block_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// overflow-block given a writing mode.
    pub fn clone_overflow_block(&self, wm: WritingMode)
        -> longhands::overflow_block::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_overflow_x()
        
        } else {
            
            self.clone_overflow_y()
        
        }

    }



    #[allow(non_snake_case)]
    pub fn set_overflow_anchor(&mut self, v: longhands::overflow_anchor::computed_value::T) {
        self.mOverflowAnchor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_anchor_from(&mut self, other: &Self) {
        self.mOverflowAnchor = other.mOverflowAnchor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_anchor(&mut self, other: &Self) {
        self.copy_overflow_anchor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_anchor(&self) -> longhands::overflow_anchor::computed_value::T {
        From::from(self.mOverflowAnchor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_transform(&mut self, v: longhands::transform::computed_value::T) {
        self.mTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_from(&mut self, other: &Self) {
        self.mTransform = other.mTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform(&mut self, other: &Self) {
        self.copy_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform(&self) -> longhands::transform::computed_value::T {
        From::from(self.mTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_rotate(&mut self, v: longhands::rotate::computed_value::T) {
        self.mRotate = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_rotate_from(&mut self, other: &Self) {
        self.mRotate = other.mRotate.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_rotate(&mut self, other: &Self) {
        self.copy_rotate_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_rotate(&self) -> longhands::rotate::computed_value::T {
        From::from(self.mRotate.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scale(&mut self, v: longhands::scale::computed_value::T) {
        self.mScale = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scale_from(&mut self, other: &Self) {
        self.mScale = other.mScale.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scale(&mut self, other: &Self) {
        self.copy_scale_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scale(&self) -> longhands::scale::computed_value::T {
        From::from(self.mScale.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_translate(&mut self, v: longhands::translate::computed_value::T) {
        self.mTranslate = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_translate_from(&mut self, other: &Self) {
        self.mTranslate = other.mTranslate.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_translate(&mut self, other: &Self) {
        self.copy_translate_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_translate(&self) -> longhands::translate::computed_value::T {
        From::from(self.mTranslate.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_path(&mut self, v: longhands::offset_path::computed_value::T) {
        self.mOffsetPath = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_path_from(&mut self, other: &Self) {
        self.mOffsetPath = other.mOffsetPath.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_path(&mut self, other: &Self) {
        self.copy_offset_path_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_path(&self) -> longhands::offset_path::computed_value::T {
        From::from(self.mOffsetPath.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_distance(&mut self, v: longhands::offset_distance::computed_value::T) {
        self.mOffsetDistance = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_distance_from(&mut self, other: &Self) {
        self.mOffsetDistance = other.mOffsetDistance.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_distance(&mut self, other: &Self) {
        self.copy_offset_distance_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_distance(&self) -> longhands::offset_distance::computed_value::T {
        From::from(self.mOffsetDistance.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_rotate(&mut self, v: longhands::offset_rotate::computed_value::T) {
        self.mOffsetRotate = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_rotate_from(&mut self, other: &Self) {
        self.mOffsetRotate = other.mOffsetRotate.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_rotate(&mut self, other: &Self) {
        self.copy_offset_rotate_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_rotate(&self) -> longhands::offset_rotate::computed_value::T {
        From::from(self.mOffsetRotate.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_anchor(&mut self, v: longhands::offset_anchor::computed_value::T) {
        self.mOffsetAnchor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_anchor_from(&mut self, other: &Self) {
        self.mOffsetAnchor = other.mOffsetAnchor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_anchor(&mut self, other: &Self) {
        self.copy_offset_anchor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_anchor(&self) -> longhands::offset_anchor::computed_value::T {
        From::from(self.mOffsetAnchor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_position(&mut self, v: longhands::offset_position::computed_value::T) {
        self.mOffsetPosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_position_from(&mut self, other: &Self) {
        self.mOffsetPosition = other.mOffsetPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_position(&mut self, other: &Self) {
        self.copy_offset_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_position(&self) -> longhands::offset_position::computed_value::T {
        From::from(self.mOffsetPosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_behavior(&mut self, v: longhands::scroll_behavior::computed_value::T) {
        use crate::properties::longhands::scroll_behavior::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleScrollBehavior::Auto ,
                Keyword::Smooth =>
                    structs::StyleScrollBehavior::Smooth ,
        };
        self.mScrollBehavior = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_behavior_from(&mut self, other: &Self) {
        self.mScrollBehavior = other.mScrollBehavior.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_behavior(&mut self, other: &Self) {
        self.copy_scroll_behavior_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_behavior(&self) -> longhands::scroll_behavior::computed_value::T {
        use crate::properties::longhands::scroll_behavior::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mScrollBehavior {
            structs::StyleScrollBehavior::Auto => Keyword::Auto,
            structs::StyleScrollBehavior::Smooth => Keyword::Smooth,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_align(&mut self, v: longhands::scroll_snap_align::computed_value::T) {
        self.mScrollSnapAlign = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_align_from(&mut self, other: &Self) {
        self.mScrollSnapAlign = other.mScrollSnapAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_align(&mut self, other: &Self) {
        self.copy_scroll_snap_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_align(&self) -> longhands::scroll_snap_align::computed_value::T {
        From::from(self.mScrollSnapAlign.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_type(&mut self, v: longhands::scroll_snap_type::computed_value::T) {
        self.mScrollSnapType = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_type_from(&mut self, other: &Self) {
        self.mScrollSnapType = other.mScrollSnapType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_type(&mut self, other: &Self) {
        self.copy_scroll_snap_type_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_type(&self) -> longhands::scroll_snap_type::computed_value::T {
        From::from(self.mScrollSnapType.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_stop(&mut self, v: longhands::scroll_snap_stop::computed_value::T) {
        self.mScrollSnapStop = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_stop_from(&mut self, other: &Self) {
        self.mScrollSnapStop = other.mScrollSnapStop.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_stop(&mut self, other: &Self) {
        self.copy_scroll_snap_stop_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_stop(&self) -> longhands::scroll_snap_stop::computed_value::T {
        From::from(self.mScrollSnapStop.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_x(&mut self, v: longhands::overscroll_behavior_x::computed_value::T) {
        self.mOverscrollBehaviorX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overscroll_behavior_x_from(&mut self, other: &Self) {
        self.mOverscrollBehaviorX = other.mOverscrollBehaviorX.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overscroll_behavior_x(&mut self, other: &Self) {
        self.copy_overscroll_behavior_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_x(&self) -> longhands::overscroll_behavior_x::computed_value::T {
        From::from(self.mOverscrollBehaviorX.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_y(&mut self, v: longhands::overscroll_behavior_y::computed_value::T) {
        self.mOverscrollBehaviorY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overscroll_behavior_y_from(&mut self, other: &Self) {
        self.mOverscrollBehaviorY = other.mOverscrollBehaviorY.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overscroll_behavior_y(&mut self, other: &Self) {
        self.copy_overscroll_behavior_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_y(&self) -> longhands::overscroll_behavior_y::computed_value::T {
        From::from(self.mOverscrollBehaviorY.clone())
    }


    
    /// Set the appropriate physical property for overscroll-behavior-inline given a writing mode.
    pub fn set_overscroll_behavior_inline(&mut self,
                                      v: longhands::overscroll_behavior_inline::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_overscroll_behavior_y(v)
            
        } else {
            
                self.set_overscroll_behavior_x(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overscroll-behavior-inline
    /// given a writing mode.
    pub fn copy_overscroll_behavior_inline_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_overscroll_behavior_y_from(other)
            
        } else {
            
                self.copy_overscroll_behavior_x_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overscroll-behavior-inline
    /// given a writing mode.
    pub fn reset_overscroll_behavior_inline(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_overscroll_behavior_inline_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// overscroll-behavior-inline given a writing mode.
    pub fn clone_overscroll_behavior_inline(&self, wm: WritingMode)
        -> longhands::overscroll_behavior_inline::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_overscroll_behavior_y()
        
        } else {
            
            self.clone_overscroll_behavior_x()
        
        }

    }


    
    /// Set the appropriate physical property for overscroll-behavior-block given a writing mode.
    pub fn set_overscroll_behavior_block(&mut self,
                                      v: longhands::overscroll_behavior_block::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_overscroll_behavior_x(v)
            
        } else {
            
                self.set_overscroll_behavior_y(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overscroll-behavior-block
    /// given a writing mode.
    pub fn copy_overscroll_behavior_block_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_overscroll_behavior_x_from(other)
            
        } else {
            
                self.copy_overscroll_behavior_y_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overscroll-behavior-block
    /// given a writing mode.
    pub fn reset_overscroll_behavior_block(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_overscroll_behavior_block_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// overscroll-behavior-block given a writing mode.
    pub fn clone_overscroll_behavior_block(&self, wm: WritingMode)
        -> longhands::overscroll_behavior_block::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_overscroll_behavior_x()
        
        } else {
            
            self.clone_overscroll_behavior_y()
        
        }

    }



    #[allow(non_snake_case)]
    pub fn set_isolation(&mut self, v: longhands::isolation::computed_value::T) {
        use crate::properties::longhands::isolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleIsolation::Auto ,
                Keyword::Isolate =>
                    structs::StyleIsolation::Isolate ,
        };
        self.mIsolation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_isolation_from(&mut self, other: &Self) {
        self.mIsolation = other.mIsolation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_isolation(&mut self, other: &Self) {
        self.copy_isolation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_isolation(&self) -> longhands::isolation::computed_value::T {
        use crate::properties::longhands::isolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mIsolation {
            structs::StyleIsolation::Auto => Keyword::Auto,
            structs::StyleIsolation::Isolate => Keyword::Isolate,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_break_after(&mut self, v: longhands::break_after::computed_value::T) {
        self.mBreakAfter = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_after_from(&mut self, other: &Self) {
        self.mBreakAfter = other.mBreakAfter.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_after(&mut self, other: &Self) {
        self.copy_break_after_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_after(&self) -> longhands::break_after::computed_value::T {
        From::from(self.mBreakAfter.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_break_before(&mut self, v: longhands::break_before::computed_value::T) {
        self.mBreakBefore = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_before_from(&mut self, other: &Self) {
        self.mBreakBefore = other.mBreakBefore.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_before(&mut self, other: &Self) {
        self.copy_break_before_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_before(&self) -> longhands::break_before::computed_value::T {
        From::from(self.mBreakBefore.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_break_inside(&mut self, v: longhands::break_inside::computed_value::T) {
        self.mBreakInside = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_inside_from(&mut self, other: &Self) {
        self.mBreakInside = other.mBreakInside.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_inside(&mut self, other: &Self) {
        self.copy_break_inside_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_inside(&self) -> longhands::break_inside::computed_value::T {
        From::from(self.mBreakInside.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_resize(&mut self, v: longhands::resize::computed_value::T) {
        self.mResize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_resize_from(&mut self, other: &Self) {
        self.mResize = other.mResize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_resize(&mut self, other: &Self) {
        self.copy_resize_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_resize(&self) -> longhands::resize::computed_value::T {
        From::from(self.mResize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_perspective(&mut self, v: longhands::perspective::computed_value::T) {
        self.mChildPerspective = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_perspective_from(&mut self, other: &Self) {
        self.mChildPerspective = other.mChildPerspective.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_perspective(&mut self, other: &Self) {
        self.copy_perspective_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_perspective(&self) -> longhands::perspective::computed_value::T {
        From::from(self.mChildPerspective.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_perspective_origin(&mut self, v: longhands::perspective_origin::computed_value::T) {
        self.mPerspectiveOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_perspective_origin_from(&mut self, other: &Self) {
        self.mPerspectiveOrigin = other.mPerspectiveOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_perspective_origin(&mut self, other: &Self) {
        self.copy_perspective_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_perspective_origin(&self) -> longhands::perspective_origin::computed_value::T {
        From::from(self.mPerspectiveOrigin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_backface_visibility(&mut self, v: longhands::backface_visibility::computed_value::T) {
        use crate::properties::longhands::backface_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Visible =>
                    structs::StyleBackfaceVisibility::Visible ,
                Keyword::Hidden =>
                    structs::StyleBackfaceVisibility::Hidden ,
        };
        self.mBackfaceVisibility = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_backface_visibility_from(&mut self, other: &Self) {
        self.mBackfaceVisibility = other.mBackfaceVisibility.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_backface_visibility(&mut self, other: &Self) {
        self.copy_backface_visibility_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_backface_visibility(&self) -> longhands::backface_visibility::computed_value::T {
        use crate::properties::longhands::backface_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mBackfaceVisibility {
            structs::StyleBackfaceVisibility::Visible => Keyword::Visible,
            structs::StyleBackfaceVisibility::Hidden => Keyword::Hidden,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_transform_box(&mut self, v: longhands::transform_box::computed_value::T) {
        use crate::properties::longhands::transform_box::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::BorderBox =>
                    structs::StyleGeometryBox::BorderBox ,
                Keyword::FillBox =>
                    structs::StyleGeometryBox::FillBox ,
                Keyword::ViewBox =>
                    structs::StyleGeometryBox::ViewBox ,
        };
        self.mTransformBox = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_box_from(&mut self, other: &Self) {
        self.mTransformBox = other.mTransformBox.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_box(&mut self, other: &Self) {
        self.copy_transform_box_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform_box(&self) -> longhands::transform_box::computed_value::T {
        use crate::properties::longhands::transform_box::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mTransformBox {
            structs::StyleGeometryBox::BorderBox => Keyword::BorderBox,
            structs::StyleGeometryBox::FillBox => Keyword::FillBox,
            structs::StyleGeometryBox::ViewBox => Keyword::ViewBox,
            _ => panic!("Found unexpected value in style struct for transform_box property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_transform_style(&mut self, v: longhands::transform_style::computed_value::T) {
        self.mTransformStyle = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_style_from(&mut self, other: &Self) {
        self.mTransformStyle = other.mTransformStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_style(&mut self, other: &Self) {
        self.copy_transform_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform_style(&self) -> longhands::transform_style::computed_value::T {
        From::from(self.mTransformStyle.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_transform_origin(&mut self, v: longhands::transform_origin::computed_value::T) {
        self.mTransformOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_origin_from(&mut self, other: &Self) {
        self.mTransformOrigin = other.mTransformOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_origin(&mut self, other: &Self) {
        self.copy_transform_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform_origin(&self) -> longhands::transform_origin::computed_value::T {
        From::from(self.mTransformOrigin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_content_visibility(&mut self, v: longhands::content_visibility::computed_value::T) {
        self.mContentVisibility = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_content_visibility_from(&mut self, other: &Self) {
        self.mContentVisibility = other.mContentVisibility.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_content_visibility(&mut self, other: &Self) {
        self.copy_content_visibility_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_content_visibility(&self) -> longhands::content_visibility::computed_value::T {
        From::from(self.mContentVisibility.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_container_type(&mut self, v: longhands::container_type::computed_value::T) {
        self.mContainerType = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_container_type_from(&mut self, other: &Self) {
        self.mContainerType = other.mContainerType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_container_type(&mut self, other: &Self) {
        self.copy_container_type_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_container_type(&self) -> longhands::container_type::computed_value::T {
        From::from(self.mContainerType.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_container_name(&mut self, v: longhands::container_name::computed_value::T) {
        self.mContainerName = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_container_name_from(&mut self, other: &Self) {
        self.mContainerName = other.mContainerName.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_container_name(&mut self, other: &Self) {
        self.copy_container_name_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_container_name(&self) -> longhands::container_name::computed_value::T {
        From::from(self.mContainerName.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_appearance(&mut self, v: longhands::appearance::computed_value::T) {
        self.mAppearance = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_appearance_from(&mut self, other: &Self) {
        self.mAppearance = other.mAppearance.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_appearance(&mut self, other: &Self) {
        self.copy_appearance_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_appearance(&self) -> longhands::appearance::computed_value::T {
        From::from(self.mAppearance.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_default_appearance(&mut self, v: longhands::_moz_default_appearance::computed_value::T) {
        self.mDefaultAppearance = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_default_appearance_from(&mut self, other: &Self) {
        self.mDefaultAppearance = other.mDefaultAppearance.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_default_appearance(&mut self, other: &Self) {
        self.copy__moz_default_appearance_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_default_appearance(&self) -> longhands::_moz_default_appearance::computed_value::T {
        From::from(self.mDefaultAppearance.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_orient(&mut self, v: longhands::_moz_orient::computed_value::T) {
        use crate::properties::longhands::_moz_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Inline =>
                    structs::StyleOrient::Inline ,
                Keyword::Block =>
                    structs::StyleOrient::Block ,
                Keyword::Horizontal =>
                    structs::StyleOrient::Horizontal ,
                Keyword::Vertical =>
                    structs::StyleOrient::Vertical ,
        };
        self.mOrient = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_orient_from(&mut self, other: &Self) {
        self.mOrient = other.mOrient.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_orient(&mut self, other: &Self) {
        self.copy__moz_orient_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_orient(&self) -> longhands::_moz_orient::computed_value::T {
        use crate::properties::longhands::_moz_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mOrient {
            structs::StyleOrient::Inline => Keyword::Inline,
            structs::StyleOrient::Block => Keyword::Block,
            structs::StyleOrient::Horizontal => Keyword::Horizontal,
            structs::StyleOrient::Vertical => Keyword::Vertical,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_will_change(&mut self, v: longhands::will_change::computed_value::T) {
        self.mWillChange = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_will_change_from(&mut self, other: &Self) {
        self.mWillChange = other.mWillChange.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_will_change(&mut self, other: &Self) {
        self.copy_will_change_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_will_change(&self) -> longhands::will_change::computed_value::T {
        From::from(self.mWillChange.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_image_threshold(&mut self, v: longhands::shape_image_threshold::computed_value::T) {
        self.mShapeImageThreshold = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_image_threshold_from(&mut self, other: &Self) {
        self.mShapeImageThreshold = other.mShapeImageThreshold.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_image_threshold(&mut self, other: &Self) {
        self.copy_shape_image_threshold_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_image_threshold(&self) -> longhands::shape_image_threshold::computed_value::T {
        From::from(self.mShapeImageThreshold.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_margin(&mut self, v: longhands::shape_margin::computed_value::T) {
        self.mShapeMargin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_margin_from(&mut self, other: &Self) {
        self.mShapeMargin = other.mShapeMargin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_margin(&mut self, other: &Self) {
        self.copy_shape_margin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_margin(&self) -> longhands::shape_margin::computed_value::T {
        From::from(self.mShapeMargin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_outside(&mut self, v: longhands::shape_outside::computed_value::T) {
        self.mShapeOutside = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_outside_from(&mut self, other: &Self) {
        self.mShapeOutside = other.mShapeOutside.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_outside(&mut self, other: &Self) {
        self.copy_shape_outside_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_outside(&self) -> longhands::shape_outside::computed_value::T {
        From::from(self.mShapeOutside.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_touch_action(&mut self, v: longhands::touch_action::computed_value::T) {
        self.mTouchAction = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_touch_action_from(&mut self, other: &Self) {
        self.mTouchAction = other.mTouchAction.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_touch_action(&mut self, other: &Self) {
        self.copy_touch_action_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_touch_action(&self) -> longhands::touch_action::computed_value::T {
        From::from(self.mTouchAction.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_line_clamp(&mut self, v: longhands::_webkit_line_clamp::computed_value::T) {
        self.mWebkitLineClamp = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_line_clamp_from(&mut self, other: &Self) {
        self.mWebkitLineClamp = other.mWebkitLineClamp.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_line_clamp(&mut self, other: &Self) {
        self.copy__webkit_line_clamp_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_line_clamp(&self) -> longhands::_webkit_line_clamp::computed_value::T {
        From::from(self.mWebkitLineClamp.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_gutter(&mut self, v: longhands::scrollbar_gutter::computed_value::T) {
        self.mScrollbarGutter = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_gutter_from(&mut self, other: &Self) {
        self.mScrollbarGutter = other.mScrollbarGutter.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_gutter(&mut self, other: &Self) {
        self.copy_scrollbar_gutter_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scrollbar_gutter(&self) -> longhands::scrollbar_gutter::computed_value::T {
        From::from(self.mScrollbarGutter.clone())
    }


}










// TODO: Gecko accepts lists in most background-related properties. We just use
// the first element (which is the common case), but at some point we want to
// add support for parsing these lists in servo and pushing to nsTArray's.



impl GeckoBackground {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    
    
    pub fn copy_background_repeat_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mImage.mRepeatCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mImage.mLayers.iter_mut()
                                  .zip(other.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mRepeat = other.mRepeat.clone();
        }
        self.mImage.mRepeatCount = count;
    }

    pub fn reset_background_repeat(&mut self, other: &Self) {
        self.copy_background_repeat_from(other)
    }


    pub fn set_background_repeat<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::background_repeat::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mImage, v.len(),
                                        LayerType::Background);
        }

        self.mImage.mRepeatCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mImage.mLayers.iter_mut()) {
            geckolayer.mRepeat = {
                
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Repeat;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_ns(repeat: BackgroundRepeatKeyword) -> StyleImageLayerRepeat {
            match repeat {
                BackgroundRepeatKeyword::Repeat => StyleImageLayerRepeat::Repeat,
                BackgroundRepeatKeyword::Space => StyleImageLayerRepeat::Space,
                BackgroundRepeatKeyword::Round => StyleImageLayerRepeat::Round,
                BackgroundRepeatKeyword::NoRepeat => StyleImageLayerRepeat::NoRepeat,
            }
        }

        let repeat_x = to_ns(servo.0);
        let repeat_y = to_ns(servo.1);
        nsStyleImageLayers_Repeat {
              mXRepeat: repeat_x,
              mYRepeat: repeat_y,
        }
    
            };
        }
    }


    pub fn clone_background_repeat(&self) -> longhands::background_repeat::computed_value::T {
        use crate::properties::longhands::background_repeat::single_value::computed_value::T;
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_servo(repeat: StyleImageLayerRepeat) -> BackgroundRepeatKeyword {
            match repeat {
                StyleImageLayerRepeat::Repeat => BackgroundRepeatKeyword::Repeat,
                StyleImageLayerRepeat::Space => BackgroundRepeatKeyword::Space,
                StyleImageLayerRepeat::Round => BackgroundRepeatKeyword::Round,
                StyleImageLayerRepeat::NoRepeat => BackgroundRepeatKeyword::NoRepeat,
                _ => panic!("Found unexpected value in style struct for background_repeat property"),
            }
        }

        longhands::background_repeat::computed_value::List(
            self.mImage.mLayers.iter()
                .take(self.mImage.mRepeatCount as usize)
                .map(|ref layer| {
                    T(to_servo(layer.mRepeat.mXRepeat), to_servo(layer.mRepeat.mYRepeat))
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_clip_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mImage.mClipCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mImage.mLayers.iter_mut()
                                  .zip(other.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mClip = other.mClip.clone();
        }
        self.mImage.mClipCount = count;
    }

    pub fn reset_background_clip(&mut self, other: &Self) {
        self.copy_background_clip_from(other)
    }


    pub fn set_background_clip<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_clip::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_clip::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mImage, v.len(),
                                        LayerType::Background);
        }

        self.mImage.mClipCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mImage.mLayers.iter_mut()) {
            geckolayer.mClip = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::Text =>
                        structs::StyleGeometryBox::Text ,
                }
            };
        }
    }

    pub fn clone_background_clip(&self) -> longhands::background_clip::computed_value::T {
        use crate::properties::longhands::background_clip::single_value::computed_value::T as Keyword;


        longhands::background_clip::computed_value::List(
            self.mImage.mLayers.iter()
                .take(self.mImage.mClipCount as usize)
                .map(|ref layer| {
                    match layer.mClip {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::Text
                            => Keyword::Text,
                        _ => panic!("Found unexpected value in style struct for background_clip property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_origin_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mImage.mOriginCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mImage.mLayers.iter_mut()
                                  .zip(other.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mOrigin = other.mOrigin.clone();
        }
        self.mImage.mOriginCount = count;
    }

    pub fn reset_background_origin(&mut self, other: &Self) {
        self.copy_background_origin_from(other)
    }


    pub fn set_background_origin<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_origin::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_origin::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mImage, v.len(),
                                        LayerType::Background);
        }

        self.mImage.mOriginCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mImage.mLayers.iter_mut()) {
            geckolayer.mOrigin = {
                match servo {
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                }
            };
        }
    }

    pub fn clone_background_origin(&self) -> longhands::background_origin::computed_value::T {
        use crate::properties::longhands::background_origin::single_value::computed_value::T as Keyword;


        longhands::background_origin::computed_value::List(
            self.mImage.mLayers.iter()
                .take(self.mImage.mOriginCount as usize)
                .map(|ref layer| {
                    match layer.mOrigin {
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        _ => panic!("Found unexpected value in style struct for background_origin property"),
                    }
                }).collect()
        )
    }


    pub fn copy_background_position_x_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mImage.mPositionXCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);
        }

        for (layer, other) in self.mImage.mLayers.iter_mut()
                                  .zip(other.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.horizontal = other.mPosition.horizontal.clone();
        }
        self.mImage.mPositionXCount = count;
    }

    pub fn reset_background_position_x(&mut self, other: &Self) {
        self.copy_background_position_x_from(other)
    }

    pub fn clone_background_position_x(&self)
        -> longhands::background_position_x::computed_value::T {
        longhands::background_position_x::computed_value::List(
            self.mImage.mLayers.iter()
                .take(self.mImage.mPositionXCount as usize)
                .map(|position| position.mPosition.horizontal.clone())
                .collect()
        )
    }

    pub fn set_background_position_x<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::background_position_x
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage, v.len(),
                                        LayerType::Background);
        }

        self.mImage.mPositionXCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mImage
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.horizontal = servo;
        }
    }
    pub fn copy_background_position_y_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mImage.mPositionYCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);
        }

        for (layer, other) in self.mImage.mLayers.iter_mut()
                                  .zip(other.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.vertical = other.mPosition.vertical.clone();
        }
        self.mImage.mPositionYCount = count;
    }

    pub fn reset_background_position_y(&mut self, other: &Self) {
        self.copy_background_position_y_from(other)
    }

    pub fn clone_background_position_y(&self)
        -> longhands::background_position_y::computed_value::T {
        longhands::background_position_y::computed_value::List(
            self.mImage.mLayers.iter()
                .take(self.mImage.mPositionYCount as usize)
                .map(|position| position.mPosition.vertical.clone())
                .collect()
        )
    }

    pub fn set_background_position_y<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::background_position_y
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage, v.len(),
                                        LayerType::Background);
        }

        self.mImage.mPositionYCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mImage
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.vertical = servo;
        }
    }

    
    
    pub fn copy_background_size_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mImage.mSizeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mImage.mLayers.iter_mut()
                                  .zip(other.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mSize = other.mSize.clone();
        }
        self.mImage.mSizeCount = count;
    }

    pub fn reset_background_size(&mut self, other: &Self) {
        self.copy_background_size_from(other)
    }


    pub fn set_background_size<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::background_size::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mImage, v.len(),
                                        LayerType::Background);
        }

        self.mImage.mSizeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mImage.mLayers.iter_mut()) {
            geckolayer.mSize = {
                
        servo
    
            };
        }
    }


    pub fn clone_background_size(&self) -> longhands::background_size::computed_value::T {
        longhands::background_size::computed_value::List(
            self.mImage.mLayers.iter().map(|layer| layer.mSize.clone()).collect()
        )
    }

    pub fn copy_background_image_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        unsafe {
            let count = other.mImage.mImageCount;
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);

            for (layer, other) in self.mImage.mLayers.iter_mut()
                                      .zip(other.mImage.mLayers.iter())
                                      .take(count as usize) {
                layer.mImage = other.mImage.clone();
            }
            self.mImage.mImageCount = count;
        }
    }

    pub fn reset_background_image(&mut self, other: &Self) {
        self.copy_background_image_from(other)
    }

    #[allow(unused_variables)]
    pub fn set_background_image<I>(&mut self, images: I)
        where I: IntoIterator<Item = longhands::background_image::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let images = images.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(
                &mut self.mImage,
                images.len(),
                LayerType::Background,
            );
        }

        self.mImage.mImageCount = images.len() as u32;
        for (image, geckoimage) in images.zip(self.mImage
                                                  .mLayers.iter_mut()) {
            geckoimage.mImage = image;
        }
    }

    pub fn clone_background_image(&self) -> longhands::background_image::computed_value::T {
        longhands::background_image::computed_value::List(
            self.mImage.mLayers.iter()
                .take(self.mImage.mImageCount as usize)
                .map(|layer| layer.mImage.clone())
                .collect()
        )
    }

    
    pub fn fill_arrays(&mut self) {
        use crate::gecko_bindings::bindings::Gecko_FillAllImageLayers;
        use std::cmp;
        let mut max_len = 1;
            max_len = cmp::max(max_len, self.mImage.mRepeatCount);
            max_len = cmp::max(max_len, self.mImage.mClipCount);
            max_len = cmp::max(max_len, self.mImage.mOriginCount);
            max_len = cmp::max(max_len, self.mImage.mPositionXCount);
            max_len = cmp::max(max_len, self.mImage.mPositionYCount);
            max_len = cmp::max(max_len, self.mImage.mImageCount);
            max_len = cmp::max(max_len, self.mImage.mSizeCount);
            max_len = cmp::max(max_len, self.mImage.mAttachmentCount);
            max_len = cmp::max(max_len, self.mImage.mBlendModeCount);
        unsafe {
            // While we could do this manually, we'd need to also manually
            // run all the copy constructors, so we just delegate to gecko
            Gecko_FillAllImageLayers(&mut self.mImage, max_len);
        }
    }

    
    

    
    pub fn copy_background_attachment_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mImage.mAttachmentCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mImage.mLayers.iter_mut()
                                  .zip(other.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mAttachment = other.mAttachment.clone();
        }
        self.mImage.mAttachmentCount = count;
    }

    pub fn reset_background_attachment(&mut self, other: &Self) {
        self.copy_background_attachment_from(other)
    }


    pub fn set_background_attachment<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_attachment::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_attachment::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mImage, v.len(),
                                        LayerType::Background);
        }

        self.mImage.mAttachmentCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mImage.mLayers.iter_mut()) {
            geckolayer.mAttachment = {
                match servo {
                    Keyword::Scroll =>
                        structs::StyleImageLayerAttachment::Scroll ,
                    Keyword::Fixed =>
                        structs::StyleImageLayerAttachment::Fixed ,
                    Keyword::Local =>
                        structs::StyleImageLayerAttachment::Local ,
                }
            };
        }
    }

    pub fn clone_background_attachment(&self) -> longhands::background_attachment::computed_value::T {
        use crate::properties::longhands::background_attachment::single_value::computed_value::T as Keyword;


        longhands::background_attachment::computed_value::List(
            self.mImage.mLayers.iter()
                .take(self.mImage.mAttachmentCount as usize)
                .map(|ref layer| {
                    match layer.mAttachment {
                        structs::StyleImageLayerAttachment::Scroll
                            => Keyword::Scroll,
                        structs::StyleImageLayerAttachment::Fixed
                            => Keyword::Fixed,
                        structs::StyleImageLayerAttachment::Local
                            => Keyword::Local,
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_blend_mode_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mImage.mBlendModeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mImage.mLayers.iter_mut()
                                  .zip(other.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mBlendMode = other.mBlendMode.clone();
        }
        self.mImage.mBlendModeCount = count;
    }

    pub fn reset_background_blend_mode(&mut self, other: &Self) {
        self.copy_background_blend_mode_from(other)
    }


    pub fn set_background_blend_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_blend_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_blend_mode::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mImage, v.len(),
                                        LayerType::Background);
        }

        self.mImage.mBlendModeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mImage.mLayers.iter_mut()) {
            geckolayer.mBlendMode = {
                match servo {
                    Keyword::Normal =>
                        structs::StyleBlend::Normal ,
                    Keyword::Multiply =>
                        structs::StyleBlend::Multiply ,
                    Keyword::Screen =>
                        structs::StyleBlend::Screen ,
                    Keyword::Overlay =>
                        structs::StyleBlend::Overlay ,
                    Keyword::Darken =>
                        structs::StyleBlend::Darken ,
                    Keyword::Lighten =>
                        structs::StyleBlend::Lighten ,
                    Keyword::ColorDodge =>
                        structs::StyleBlend::ColorDodge ,
                    Keyword::ColorBurn =>
                        structs::StyleBlend::ColorBurn ,
                    Keyword::HardLight =>
                        structs::StyleBlend::HardLight ,
                    Keyword::SoftLight =>
                        structs::StyleBlend::SoftLight ,
                    Keyword::Difference =>
                        structs::StyleBlend::Difference ,
                    Keyword::Exclusion =>
                        structs::StyleBlend::Exclusion ,
                    Keyword::Hue =>
                        structs::StyleBlend::Hue ,
                    Keyword::Saturation =>
                        structs::StyleBlend::Saturation ,
                    Keyword::Color =>
                        structs::StyleBlend::Color ,
                    Keyword::Luminosity =>
                        structs::StyleBlend::Luminosity ,
                }
            };
        }
    }

    pub fn clone_background_blend_mode(&self) -> longhands::background_blend_mode::computed_value::T {
        use crate::properties::longhands::background_blend_mode::single_value::computed_value::T as Keyword;


        longhands::background_blend_mode::computed_value::List(
            self.mImage.mLayers.iter()
                .take(self.mImage.mBlendModeCount as usize)
                .map(|ref layer| {
                    match layer.mBlendMode {
                        structs::StyleBlend::Normal
                            => Keyword::Normal,
                        structs::StyleBlend::Multiply
                            => Keyword::Multiply,
                        structs::StyleBlend::Screen
                            => Keyword::Screen,
                        structs::StyleBlend::Overlay
                            => Keyword::Overlay,
                        structs::StyleBlend::Darken
                            => Keyword::Darken,
                        structs::StyleBlend::Lighten
                            => Keyword::Lighten,
                        structs::StyleBlend::ColorDodge
                            => Keyword::ColorDodge,
                        structs::StyleBlend::ColorBurn
                            => Keyword::ColorBurn,
                        structs::StyleBlend::HardLight
                            => Keyword::HardLight,
                        structs::StyleBlend::SoftLight
                            => Keyword::SoftLight,
                        structs::StyleBlend::Difference
                            => Keyword::Difference,
                        structs::StyleBlend::Exclusion
                            => Keyword::Exclusion,
                        structs::StyleBlend::Hue
                            => Keyword::Hue,
                        structs::StyleBlend::Saturation
                            => Keyword::Saturation,
                        structs::StyleBlend::Color
                            => Keyword::Color,
                        structs::StyleBlend::Luminosity
                            => Keyword::Luminosity,
                        _ => panic!("Found unexpected value in style struct for background_blend_mode property"),
                    }
                }).collect()
        )
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_background_color(&mut self, v: longhands::background_color::computed_value::T) {
        self.mBackgroundColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_background_color_from(&mut self, other: &Self) {
        self.mBackgroundColor = other.mBackgroundColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_background_color(&mut self, other: &Self) {
        self.copy_background_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_background_color(&self) -> longhands::background_color::computed_value::T {
        From::from(self.mBackgroundColor.clone())
    }


}




impl GeckoList {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_list_style_type(&mut self, v: longhands::list_style_type::computed_value::T) {
        use nsstring::{nsACString, nsCStr};
        use self::longhands::list_style_type::computed_value::T;
        match v {
            T::None => unsafe {
                bindings::Gecko_SetCounterStyleToNone(&mut self.mCounterStyle)
            }
            T::CounterStyle(s) => s.to_gecko_value(&mut self.mCounterStyle),
            T::String(s) => unsafe {
                bindings::Gecko_SetCounterStyleToString(
                    &mut self.mCounterStyle,
                    &nsCStr::from(&s) as &nsACString,
                )
            }
        }
    }

    pub fn copy_list_style_type_from(&mut self, other: &Self) {
        unsafe {
            Gecko_CopyCounterStyle(&mut self.mCounterStyle, &other.mCounterStyle);
        }
    }

    pub fn reset_list_style_type(&mut self, other: &Self) {
        self.copy_list_style_type_from(other)
    }

    pub fn clone_list_style_type(&self) -> longhands::list_style_type::computed_value::T {
        use self::longhands::list_style_type::computed_value::T;
        use crate::values::Either;
        use crate::values::generics::CounterStyle;
        use crate::gecko_bindings::bindings;

        let name = unsafe {
            bindings::Gecko_CounterStyle_GetName(&self.mCounterStyle)
        };
        if !name.is_null() {
            let name = unsafe { Atom::from_raw(name) };
            if name == atom!("none") {
                return T::None;
            }
        }
        let result = CounterStyle::from_gecko_value(&self.mCounterStyle);
        match result {
            Either::First(counter_style) => T::CounterStyle(counter_style),
            Either::Second(string) => T::String(string),
        }
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_list_style_position(&mut self, v: longhands::list_style_position::computed_value::T) {
        use crate::properties::longhands::list_style_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Outside =>
                    structs::StyleListStylePosition::Outside ,
                Keyword::Inside =>
                    structs::StyleListStylePosition::Inside ,
        };
        self.mListStylePosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_list_style_position_from(&mut self, other: &Self) {
        self.mListStylePosition = other.mListStylePosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_list_style_position(&mut self, other: &Self) {
        self.copy_list_style_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_list_style_position(&self) -> longhands::list_style_position::computed_value::T {
        use crate::properties::longhands::list_style_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mListStylePosition {
            structs::StyleListStylePosition::Outside => Keyword::Outside,
            structs::StyleListStylePosition::Inside => Keyword::Inside,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_list_style_image(&mut self, v: longhands::list_style_image::computed_value::T) {
        self.mListStyleImage = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_list_style_image_from(&mut self, other: &Self) {
        self.mListStyleImage = other.mListStyleImage.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_list_style_image(&mut self, other: &Self) {
        self.copy_list_style_image_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_list_style_image(&self) -> longhands::list_style_image::computed_value::T {
        From::from(self.mListStyleImage.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_quotes(&mut self, v: longhands::quotes::computed_value::T) {
        self.mQuotes = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_quotes_from(&mut self, other: &Self) {
        self.mQuotes = other.mQuotes.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_quotes(&mut self, other: &Self) {
        self.copy_quotes_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_quotes(&self) -> longhands::quotes::computed_value::T {
        From::from(self.mQuotes.clone())
    }


}




impl GeckoTable {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_table_layout(&mut self, v: longhands::table_layout::computed_value::T) {
        use crate::properties::longhands::table_layout::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTableLayout::Auto ,
                Keyword::Fixed =>
                    structs::StyleTableLayout::Fixed ,
        };
        self.mLayoutStrategy = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_table_layout_from(&mut self, other: &Self) {
        self.mLayoutStrategy = other.mLayoutStrategy.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_table_layout(&mut self, other: &Self) {
        self.copy_table_layout_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_table_layout(&self) -> longhands::table_layout::computed_value::T {
        use crate::properties::longhands::table_layout::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mLayoutStrategy {
            structs::StyleTableLayout::Auto => Keyword::Auto,
            structs::StyleTableLayout::Fixed => Keyword::Fixed,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__x_span(&mut self, v: longhands::_x_span::computed_value::T) {
        self.mXSpan = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__x_span_from(&mut self, other: &Self) {
        self.mXSpan = other.mXSpan.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__x_span(&mut self, other: &Self) {
        self.copy__x_span_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__x_span(&self) -> longhands::_x_span::computed_value::T {
        From::from(self.mXSpan.clone())
    }


}




impl GeckoEffects {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_opacity(&mut self, v: longhands::opacity::computed_value::T) {
        self.mOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_opacity_from(&mut self, other: &Self) {
        self.mOpacity = other.mOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_opacity(&mut self, other: &Self) {
        self.copy_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_opacity(&self) -> longhands::opacity::computed_value::T {
        From::from(self.mOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_box_shadow(&mut self, v: longhands::box_shadow::computed_value::T) {
        self.mBoxShadow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_box_shadow_from(&mut self, other: &Self) {
        self.mBoxShadow = other.mBoxShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_shadow(&mut self, other: &Self) {
        self.copy_box_shadow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_box_shadow(&self) -> longhands::box_shadow::computed_value::T {
        From::from(self.mBoxShadow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_clip(&mut self, v: longhands::clip::computed_value::T) {
        self.mClip = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clip_from(&mut self, other: &Self) {
        self.mClip = other.mClip.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clip(&mut self, other: &Self) {
        self.copy_clip_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clip(&self) -> longhands::clip::computed_value::T {
        From::from(self.mClip.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_filter(&mut self, v: longhands::filter::computed_value::T) {
        self.mFilters = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_filter_from(&mut self, other: &Self) {
        self.mFilters = other.mFilters.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_filter(&mut self, other: &Self) {
        self.copy_filter_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_filter(&self) -> longhands::filter::computed_value::T {
        From::from(self.mFilters.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_backdrop_filter(&mut self, v: longhands::backdrop_filter::computed_value::T) {
        self.mBackdropFilters = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_backdrop_filter_from(&mut self, other: &Self) {
        self.mBackdropFilters = other.mBackdropFilters.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_backdrop_filter(&mut self, other: &Self) {
        self.copy_backdrop_filter_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_backdrop_filter(&self) -> longhands::backdrop_filter::computed_value::T {
        From::from(self.mBackdropFilters.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_mix_blend_mode(&mut self, v: longhands::mix_blend_mode::computed_value::T) {
        use crate::properties::longhands::mix_blend_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleBlend::Normal ,
                Keyword::Multiply =>
                    structs::StyleBlend::Multiply ,
                Keyword::Screen =>
                    structs::StyleBlend::Screen ,
                Keyword::Overlay =>
                    structs::StyleBlend::Overlay ,
                Keyword::Darken =>
                    structs::StyleBlend::Darken ,
                Keyword::Lighten =>
                    structs::StyleBlend::Lighten ,
                Keyword::ColorDodge =>
                    structs::StyleBlend::ColorDodge ,
                Keyword::ColorBurn =>
                    structs::StyleBlend::ColorBurn ,
                Keyword::HardLight =>
                    structs::StyleBlend::HardLight ,
                Keyword::SoftLight =>
                    structs::StyleBlend::SoftLight ,
                Keyword::Difference =>
                    structs::StyleBlend::Difference ,
                Keyword::Exclusion =>
                    structs::StyleBlend::Exclusion ,
                Keyword::Hue =>
                    structs::StyleBlend::Hue ,
                Keyword::Saturation =>
                    structs::StyleBlend::Saturation ,
                Keyword::Color =>
                    structs::StyleBlend::Color ,
                Keyword::Luminosity =>
                    structs::StyleBlend::Luminosity ,
                Keyword::PlusLighter =>
                    structs::StyleBlend::PlusLighter ,
        };
        self.mMixBlendMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_mix_blend_mode_from(&mut self, other: &Self) {
        self.mMixBlendMode = other.mMixBlendMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_mix_blend_mode(&mut self, other: &Self) {
        self.copy_mix_blend_mode_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_mix_blend_mode(&self) -> longhands::mix_blend_mode::computed_value::T {
        use crate::properties::longhands::mix_blend_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mMixBlendMode {
            structs::StyleBlend::Normal => Keyword::Normal,
            structs::StyleBlend::Multiply => Keyword::Multiply,
            structs::StyleBlend::Screen => Keyword::Screen,
            structs::StyleBlend::Overlay => Keyword::Overlay,
            structs::StyleBlend::Darken => Keyword::Darken,
            structs::StyleBlend::Lighten => Keyword::Lighten,
            structs::StyleBlend::ColorDodge => Keyword::ColorDodge,
            structs::StyleBlend::ColorBurn => Keyword::ColorBurn,
            structs::StyleBlend::HardLight => Keyword::HardLight,
            structs::StyleBlend::SoftLight => Keyword::SoftLight,
            structs::StyleBlend::Difference => Keyword::Difference,
            structs::StyleBlend::Exclusion => Keyword::Exclusion,
            structs::StyleBlend::Hue => Keyword::Hue,
            structs::StyleBlend::Saturation => Keyword::Saturation,
            structs::StyleBlend::Color => Keyword::Color,
            structs::StyleBlend::Luminosity => Keyword::Luminosity,
            structs::StyleBlend::PlusLighter => Keyword::PlusLighter,
        }
    }


}




impl GeckoInheritedBox {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_visibility(&mut self, v: longhands::visibility::computed_value::T) {
        use crate::properties::longhands::visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Visible =>
                    structs::StyleVisibility::Visible ,
                Keyword::Hidden =>
                    structs::StyleVisibility::Hidden ,
                Keyword::Collapse =>
                    structs::StyleVisibility::Collapse ,
        };
        self.mVisible = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_visibility_from(&mut self, other: &Self) {
        self.mVisible = other.mVisible.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_visibility(&mut self, other: &Self) {
        self.copy_visibility_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_visibility(&self) -> longhands::visibility::computed_value::T {
        use crate::properties::longhands::visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mVisible {
            structs::StyleVisibility::Visible => Keyword::Visible,
            structs::StyleVisibility::Hidden => Keyword::Hidden,
            structs::StyleVisibility::Collapse => Keyword::Collapse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_writing_mode(&mut self, v: longhands::writing_mode::computed_value::T) {
        use crate::properties::longhands::writing_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::HorizontalTb =>
                    structs::StyleWritingModeProperty::HorizontalTb ,
                Keyword::VerticalRl =>
                    structs::StyleWritingModeProperty::VerticalRl ,
                Keyword::VerticalLr =>
                    structs::StyleWritingModeProperty::VerticalLr ,
                Keyword::SidewaysRl =>
                    structs::StyleWritingModeProperty::SidewaysRl ,
                Keyword::SidewaysLr =>
                    structs::StyleWritingModeProperty::SidewaysLr ,
        };
        self.mWritingMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_writing_mode_from(&mut self, other: &Self) {
        self.mWritingMode = other.mWritingMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_writing_mode(&mut self, other: &Self) {
        self.copy_writing_mode_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_writing_mode(&self) -> longhands::writing_mode::computed_value::T {
        use crate::properties::longhands::writing_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mWritingMode {
            structs::StyleWritingModeProperty::HorizontalTb => Keyword::HorizontalTb,
            structs::StyleWritingModeProperty::VerticalRl => Keyword::VerticalRl,
            structs::StyleWritingModeProperty::VerticalLr => Keyword::VerticalLr,
            structs::StyleWritingModeProperty::SidewaysRl => Keyword::SidewaysRl,
            structs::StyleWritingModeProperty::SidewaysLr => Keyword::SidewaysLr,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_direction(&mut self, v: longhands::direction::computed_value::T) {
        use crate::properties::longhands::direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Ltr =>
                    structs::StyleDirection::Ltr ,
                Keyword::Rtl =>
                    structs::StyleDirection::Rtl ,
        };
        self.mDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_direction_from(&mut self, other: &Self) {
        self.mDirection = other.mDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_direction(&mut self, other: &Self) {
        self.copy_direction_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_direction(&self) -> longhands::direction::computed_value::T {
        use crate::properties::longhands::direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mDirection {
            structs::StyleDirection::Ltr => Keyword::Ltr,
            structs::StyleDirection::Rtl => Keyword::Rtl,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_collapse(&mut self, v: longhands::_moz_box_collapse::computed_value::T) {
        use crate::properties::longhands::_moz_box_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Flex =>
                    structs::StyleMozBoxCollapse::Flex ,
                Keyword::Legacy =>
                    structs::StyleMozBoxCollapse::Legacy ,
        };
        self.mMozBoxCollapse = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_collapse_from(&mut self, other: &Self) {
        self.mMozBoxCollapse = other.mMozBoxCollapse.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_collapse(&mut self, other: &Self) {
        self.copy__moz_box_collapse_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_collapse(&self) -> longhands::_moz_box_collapse::computed_value::T {
        use crate::properties::longhands::_moz_box_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mMozBoxCollapse {
            structs::StyleMozBoxCollapse::Flex => Keyword::Flex,
            structs::StyleMozBoxCollapse::Legacy => Keyword::Legacy,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_orientation(&mut self, v: longhands::text_orientation::computed_value::T) {
        use crate::properties::longhands::text_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Mixed =>
                    structs::StyleTextOrientation::Mixed ,
                Keyword::Upright =>
                    structs::StyleTextOrientation::Upright ,
                Keyword::Sideways =>
                    structs::StyleTextOrientation::Sideways ,
        };
        self.mTextOrientation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_orientation_from(&mut self, other: &Self) {
        self.mTextOrientation = other.mTextOrientation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_orientation(&mut self, other: &Self) {
        self.copy_text_orientation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_orientation(&self) -> longhands::text_orientation::computed_value::T {
        use crate::properties::longhands::text_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mTextOrientation {
            structs::StyleTextOrientation::Mixed => Keyword::Mixed,
            structs::StyleTextOrientation::Upright => Keyword::Upright,
            structs::StyleTextOrientation::Sideways => Keyword::Sideways,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_print_color_adjust(&mut self, v: longhands::print_color_adjust::computed_value::T) {
        self.mPrintColorAdjust = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_print_color_adjust_from(&mut self, other: &Self) {
        self.mPrintColorAdjust = other.mPrintColorAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_print_color_adjust(&mut self, other: &Self) {
        self.copy_print_color_adjust_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_print_color_adjust(&self) -> longhands::print_color_adjust::computed_value::T {
        From::from(self.mPrintColorAdjust.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_image_rendering(&mut self, v: longhands::image_rendering::computed_value::T) {
        self.mImageRendering = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_image_rendering_from(&mut self, other: &Self) {
        self.mImageRendering = other.mImageRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_image_rendering(&mut self, other: &Self) {
        self.copy_image_rendering_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_image_rendering(&self) -> longhands::image_rendering::computed_value::T {
        From::from(self.mImageRendering.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_image_orientation(&mut self, v: longhands::image_orientation::computed_value::T) {
        use crate::properties::longhands::image_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::FromImage =>
                    structs::StyleImageOrientation::FromImage ,
                Keyword::None =>
                    structs::StyleImageOrientation::None ,
        };
        self.mImageOrientation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_image_orientation_from(&mut self, other: &Self) {
        self.mImageOrientation = other.mImageOrientation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_image_orientation(&mut self, other: &Self) {
        self.copy_image_orientation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_image_orientation(&self) -> longhands::image_orientation::computed_value::T {
        use crate::properties::longhands::image_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mImageOrientation {
            structs::StyleImageOrientation::FromImage => Keyword::FromImage,
            structs::StyleImageOrientation::None => Keyword::None,
        }
    }


}




impl GeckoInheritedTable {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_border_spacing(&mut self, v: longhands::border_spacing::computed_value::T) {
        self.mBorderSpacingCol = v.horizontal().0;
        self.mBorderSpacingRow = v.vertical().0;
    }

    pub fn copy_border_spacing_from(&mut self, other: &Self) {
        self.mBorderSpacingCol = other.mBorderSpacingCol;
        self.mBorderSpacingRow = other.mBorderSpacingRow;
    }

    pub fn reset_border_spacing(&mut self, other: &Self) {
        self.copy_border_spacing_from(other)
    }

    pub fn clone_border_spacing(&self) -> longhands::border_spacing::computed_value::T {
        longhands::border_spacing::computed_value::T::new(
            Au(self.mBorderSpacingCol).into(),
            Au(self.mBorderSpacingRow).into()
        )
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_border_collapse(&mut self, v: longhands::border_collapse::computed_value::T) {
        use crate::properties::longhands::border_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Separate =>
                    structs::StyleBorderCollapse::Separate ,
                Keyword::Collapse =>
                    structs::StyleBorderCollapse::Collapse ,
        };
        self.mBorderCollapse = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_border_collapse_from(&mut self, other: &Self) {
        self.mBorderCollapse = other.mBorderCollapse.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_collapse(&mut self, other: &Self) {
        self.copy_border_collapse_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_collapse(&self) -> longhands::border_collapse::computed_value::T {
        use crate::properties::longhands::border_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mBorderCollapse {
            structs::StyleBorderCollapse::Separate => Keyword::Separate,
            structs::StyleBorderCollapse::Collapse => Keyword::Collapse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_empty_cells(&mut self, v: longhands::empty_cells::computed_value::T) {
        use crate::properties::longhands::empty_cells::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Show =>
                    structs::StyleEmptyCells::Show ,
                Keyword::Hide =>
                    structs::StyleEmptyCells::Hide ,
        };
        self.mEmptyCells = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_empty_cells_from(&mut self, other: &Self) {
        self.mEmptyCells = other.mEmptyCells.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_empty_cells(&mut self, other: &Self) {
        self.copy_empty_cells_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_empty_cells(&self) -> longhands::empty_cells::computed_value::T {
        use crate::properties::longhands::empty_cells::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mEmptyCells {
            structs::StyleEmptyCells::Show => Keyword::Show,
            structs::StyleEmptyCells::Hide => Keyword::Hide,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_caption_side(&mut self, v: longhands::caption_side::computed_value::T) {
        self.mCaptionSide = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_caption_side_from(&mut self, other: &Self) {
        self.mCaptionSide = other.mCaptionSide.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_caption_side(&mut self, other: &Self) {
        self.copy_caption_side_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_caption_side(&self) -> longhands::caption_side::computed_value::T {
        From::from(self.mCaptionSide.clone())
    }


}





impl GeckoInheritedText {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_color(&mut self, v: longhands::color::computed_value::T) {
        self.mColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_color_from(&mut self, other: &Self) {
        self.mColor = other.mColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color(&mut self, other: &Self) {
        self.copy_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color(&self) -> longhands::color::computed_value::T {
        From::from(self.mColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_line_height(&mut self, v: longhands::line_height::computed_value::T) {
        self.mLineHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_line_height_from(&mut self, other: &Self) {
        self.mLineHeight = other.mLineHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_line_height(&mut self, other: &Self) {
        self.copy_line_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_line_height(&self) -> longhands::line_height::computed_value::T {
        From::from(self.mLineHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_transform(&mut self, v: longhands::text_transform::computed_value::T) {
        self.mTextTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_transform_from(&mut self, other: &Self) {
        self.mTextTransform = other.mTextTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_transform(&mut self, other: &Self) {
        self.copy_text_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_transform(&self) -> longhands::text_transform::computed_value::T {
        From::from(self.mTextTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_hyphens(&mut self, v: longhands::hyphens::computed_value::T) {
        use crate::properties::longhands::hyphens::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Manual =>
                    structs::StyleHyphens::Manual ,
                Keyword::None =>
                    structs::StyleHyphens::None ,
                Keyword::Auto =>
                    structs::StyleHyphens::Auto ,
        };
        self.mHyphens = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_hyphens_from(&mut self, other: &Self) {
        self.mHyphens = other.mHyphens.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_hyphens(&mut self, other: &Self) {
        self.copy_hyphens_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_hyphens(&self) -> longhands::hyphens::computed_value::T {
        use crate::properties::longhands::hyphens::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mHyphens {
            structs::StyleHyphens::Manual => Keyword::Manual,
            structs::StyleHyphens::None => Keyword::None,
            structs::StyleHyphens::Auto => Keyword::Auto,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_text_size_adjust(&mut self, v: longhands::_moz_text_size_adjust::computed_value::T) {
        use crate::properties::longhands::_moz_text_size_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTextSizeAdjust::Auto ,
                Keyword::None =>
                    structs::StyleTextSizeAdjust::None ,
        };
        self.mTextSizeAdjust = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_text_size_adjust_from(&mut self, other: &Self) {
        self.mTextSizeAdjust = other.mTextSizeAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_text_size_adjust(&mut self, other: &Self) {
        self.copy__moz_text_size_adjust_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_text_size_adjust(&self) -> longhands::_moz_text_size_adjust::computed_value::T {
        use crate::properties::longhands::_moz_text_size_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mTextSizeAdjust {
            structs::StyleTextSizeAdjust::Auto => Keyword::Auto,
            structs::StyleTextSizeAdjust::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_indent(&mut self, v: longhands::text_indent::computed_value::T) {
        self.mTextIndent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_indent_from(&mut self, other: &Self) {
        self.mTextIndent = other.mTextIndent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_indent(&mut self, other: &Self) {
        self.copy_text_indent_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_indent(&self) -> longhands::text_indent::computed_value::T {
        From::from(self.mTextIndent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_wrap(&mut self, v: longhands::overflow_wrap::computed_value::T) {
        self.mOverflowWrap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_wrap_from(&mut self, other: &Self) {
        self.mOverflowWrap = other.mOverflowWrap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_wrap(&mut self, other: &Self) {
        self.copy_overflow_wrap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_wrap(&self) -> longhands::overflow_wrap::computed_value::T {
        From::from(self.mOverflowWrap.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_word_break(&mut self, v: longhands::word_break::computed_value::T) {
        self.mWordBreak = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_word_break_from(&mut self, other: &Self) {
        self.mWordBreak = other.mWordBreak.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_word_break(&mut self, other: &Self) {
        self.copy_word_break_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_word_break(&self) -> longhands::word_break::computed_value::T {
        From::from(self.mWordBreak.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_justify(&mut self, v: longhands::text_justify::computed_value::T) {
        self.mTextJustify = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_justify_from(&mut self, other: &Self) {
        self.mTextJustify = other.mTextJustify.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_justify(&mut self, other: &Self) {
        self.copy_text_justify_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_justify(&self) -> longhands::text_justify::computed_value::T {
        From::from(self.mTextJustify.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_align_last(&mut self, v: longhands::text_align_last::computed_value::T) {
        self.mTextAlignLast = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_align_last_from(&mut self, other: &Self) {
        self.mTextAlignLast = other.mTextAlignLast.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_align_last(&mut self, other: &Self) {
        self.copy_text_align_last_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_align_last(&self) -> longhands::text_align_last::computed_value::T {
        From::from(self.mTextAlignLast.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_align(&mut self, v: longhands::text_align::computed_value::T) {
        self.mTextAlign = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_align_from(&mut self, other: &Self) {
        self.mTextAlign = other.mTextAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_align(&mut self, other: &Self) {
        self.copy_text_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_align(&self) -> longhands::text_align::computed_value::T {
        From::from(self.mTextAlign.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_letter_spacing(&mut self, v: longhands::letter_spacing::computed_value::T) {
        self.mLetterSpacing = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_letter_spacing_from(&mut self, other: &Self) {
        self.mLetterSpacing = other.mLetterSpacing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_letter_spacing(&mut self, other: &Self) {
        self.copy_letter_spacing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_letter_spacing(&self) -> longhands::letter_spacing::computed_value::T {
        From::from(self.mLetterSpacing.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_word_spacing(&mut self, v: longhands::word_spacing::computed_value::T) {
        self.mWordSpacing = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_word_spacing_from(&mut self, other: &Self) {
        self.mWordSpacing = other.mWordSpacing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_word_spacing(&mut self, other: &Self) {
        self.copy_word_spacing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_word_spacing(&self) -> longhands::word_spacing::computed_value::T {
        From::from(self.mWordSpacing.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_white_space(&mut self, v: longhands::white_space::computed_value::T) {
        use crate::properties::longhands::white_space::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleWhiteSpace::Normal ,
                Keyword::Pre =>
                    structs::StyleWhiteSpace::Pre ,
                Keyword::Nowrap =>
                    structs::StyleWhiteSpace::Nowrap ,
                Keyword::PreWrap =>
                    structs::StyleWhiteSpace::PreWrap ,
                Keyword::PreLine =>
                    structs::StyleWhiteSpace::PreLine ,
                Keyword::BreakSpaces =>
                    structs::StyleWhiteSpace::BreakSpaces ,
                Keyword::MozPreSpace =>
                    structs::StyleWhiteSpace::PreSpace ,
        };
        self.mWhiteSpace = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_white_space_from(&mut self, other: &Self) {
        self.mWhiteSpace = other.mWhiteSpace.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_white_space(&mut self, other: &Self) {
        self.copy_white_space_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_white_space(&self) -> longhands::white_space::computed_value::T {
        use crate::properties::longhands::white_space::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mWhiteSpace {
            structs::StyleWhiteSpace::Normal => Keyword::Normal,
            structs::StyleWhiteSpace::Pre => Keyword::Pre,
            structs::StyleWhiteSpace::Nowrap => Keyword::Nowrap,
            structs::StyleWhiteSpace::PreWrap => Keyword::PreWrap,
            structs::StyleWhiteSpace::PreLine => Keyword::PreLine,
            structs::StyleWhiteSpace::BreakSpaces => Keyword::BreakSpaces,
            structs::StyleWhiteSpace::PreSpace => Keyword::MozPreSpace,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_shadow(&mut self, v: longhands::text_shadow::computed_value::T) {
        self.mTextShadow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_shadow_from(&mut self, other: &Self) {
        self.mTextShadow = other.mTextShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_shadow(&mut self, other: &Self) {
        self.copy_text_shadow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_shadow(&self) -> longhands::text_shadow::computed_value::T {
        From::from(self.mTextShadow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_emphasis_style(&mut self, v: longhands::text_emphasis_style::computed_value::T) {
        self.mTextEmphasisStyle = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_style_from(&mut self, other: &Self) {
        self.mTextEmphasisStyle = other.mTextEmphasisStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_style(&mut self, other: &Self) {
        self.copy_text_emphasis_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_style(&self) -> longhands::text_emphasis_style::computed_value::T {
        From::from(self.mTextEmphasisStyle.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_emphasis_position(&mut self, v: longhands::text_emphasis_position::computed_value::T) {
        self.mTextEmphasisPosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_position_from(&mut self, other: &Self) {
        self.mTextEmphasisPosition = other.mTextEmphasisPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_position(&mut self, other: &Self) {
        self.copy_text_emphasis_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_position(&self) -> longhands::text_emphasis_position::computed_value::T {
        From::from(self.mTextEmphasisPosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_emphasis_color(&mut self, v: longhands::text_emphasis_color::computed_value::T) {
        self.mTextEmphasisColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_color_from(&mut self, other: &Self) {
        self.mTextEmphasisColor = other.mTextEmphasisColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_color(&mut self, other: &Self) {
        self.copy_text_emphasis_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_color(&self) -> longhands::text_emphasis_color::computed_value::T {
        From::from(self.mTextEmphasisColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_tab_size(&mut self, v: longhands::tab_size::computed_value::T) {
        self.mTabSize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_tab_size_from(&mut self, other: &Self) {
        self.mTabSize = other.mTabSize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_tab_size(&mut self, other: &Self) {
        self.copy_tab_size_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_tab_size(&self) -> longhands::tab_size::computed_value::T {
        From::from(self.mTabSize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_line_break(&mut self, v: longhands::line_break::computed_value::T) {
        self.mLineBreak = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_line_break_from(&mut self, other: &Self) {
        self.mLineBreak = other.mLineBreak.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_line_break(&mut self, other: &Self) {
        self.copy_line_break_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_line_break(&self) -> longhands::line_break::computed_value::T {
        From::from(self.mLineBreak.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_text_fill_color(&mut self, v: longhands::_webkit_text_fill_color::computed_value::T) {
        self.mWebkitTextFillColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_fill_color_from(&mut self, other: &Self) {
        self.mWebkitTextFillColor = other.mWebkitTextFillColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_fill_color(&mut self, other: &Self) {
        self.copy__webkit_text_fill_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_fill_color(&self) -> longhands::_webkit_text_fill_color::computed_value::T {
        From::from(self.mWebkitTextFillColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_color(&mut self, v: longhands::_webkit_text_stroke_color::computed_value::T) {
        self.mWebkitTextStrokeColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_stroke_color_from(&mut self, other: &Self) {
        self.mWebkitTextStrokeColor = other.mWebkitTextStrokeColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_color(&mut self, other: &Self) {
        self.copy__webkit_text_stroke_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_color(&self) -> longhands::_webkit_text_stroke_color::computed_value::T {
        From::from(self.mWebkitTextStrokeColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_width(&mut self, v: longhands::_webkit_text_stroke_width::computed_value::T) {
        self.mWebkitTextStrokeWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_stroke_width_from(&mut self, other: &Self) {
        self.mWebkitTextStrokeWidth = other.mWebkitTextStrokeWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_width(&mut self, other: &Self) {
        self.copy__webkit_text_stroke_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_width(&self) -> longhands::_webkit_text_stroke_width::computed_value::T {
        From::from(self.mWebkitTextStrokeWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_ruby_align(&mut self, v: longhands::ruby_align::computed_value::T) {
        use crate::properties::longhands::ruby_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::SpaceAround =>
                    structs::StyleRubyAlign::SpaceAround ,
                Keyword::Start =>
                    structs::StyleRubyAlign::Start ,
                Keyword::Center =>
                    structs::StyleRubyAlign::Center ,
                Keyword::SpaceBetween =>
                    structs::StyleRubyAlign::SpaceBetween ,
        };
        self.mRubyAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ruby_align_from(&mut self, other: &Self) {
        self.mRubyAlign = other.mRubyAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ruby_align(&mut self, other: &Self) {
        self.copy_ruby_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_ruby_align(&self) -> longhands::ruby_align::computed_value::T {
        use crate::properties::longhands::ruby_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mRubyAlign {
            structs::StyleRubyAlign::SpaceAround => Keyword::SpaceAround,
            structs::StyleRubyAlign::Start => Keyword::Start,
            structs::StyleRubyAlign::Center => Keyword::Center,
            structs::StyleRubyAlign::SpaceBetween => Keyword::SpaceBetween,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_ruby_position(&mut self, v: longhands::ruby_position::computed_value::T) {
        self.mRubyPosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_ruby_position_from(&mut self, other: &Self) {
        self.mRubyPosition = other.mRubyPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ruby_position(&mut self, other: &Self) {
        self.copy_ruby_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_ruby_position(&self) -> longhands::ruby_position::computed_value::T {
        From::from(self.mRubyPosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_combine_upright(&mut self, v: longhands::text_combine_upright::computed_value::T) {
        use crate::properties::longhands::text_combine_upright::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleTextCombineUpright::None ,
                Keyword::All =>
                    structs::StyleTextCombineUpright::All ,
        };
        self.mTextCombineUpright = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_combine_upright_from(&mut self, other: &Self) {
        self.mTextCombineUpright = other.mTextCombineUpright.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_combine_upright(&mut self, other: &Self) {
        self.copy_text_combine_upright_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_combine_upright(&self) -> longhands::text_combine_upright::computed_value::T {
        use crate::properties::longhands::text_combine_upright::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mTextCombineUpright {
            structs::StyleTextCombineUpright::None => Keyword::None,
            structs::StyleTextCombineUpright::All => Keyword::All,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_rendering(&mut self, v: longhands::text_rendering::computed_value::T) {
        use crate::properties::longhands::text_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTextRendering::Auto ,
                Keyword::Optimizespeed =>
                    structs::StyleTextRendering::Optimizespeed ,
                Keyword::Optimizelegibility =>
                    structs::StyleTextRendering::Optimizelegibility ,
                Keyword::Geometricprecision =>
                    structs::StyleTextRendering::Geometricprecision ,
        };
        self.mTextRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_rendering_from(&mut self, other: &Self) {
        self.mTextRendering = other.mTextRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_rendering(&mut self, other: &Self) {
        self.copy_text_rendering_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_rendering(&self) -> longhands::text_rendering::computed_value::T {
        use crate::properties::longhands::text_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mTextRendering {
            structs::StyleTextRendering::Auto => Keyword::Auto,
            structs::StyleTextRendering::Optimizespeed => Keyword::Optimizespeed,
            structs::StyleTextRendering::Optimizelegibility => Keyword::Optimizelegibility,
            structs::StyleTextRendering::Geometricprecision => Keyword::Geometricprecision,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_control_character_visibility(&mut self, v: longhands::_moz_control_character_visibility::computed_value::T) {
        self.mMozControlCharacterVisibility = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_control_character_visibility_from(&mut self, other: &Self) {
        self.mMozControlCharacterVisibility = other.mMozControlCharacterVisibility.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_control_character_visibility(&mut self, other: &Self) {
        self.copy__moz_control_character_visibility_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_control_character_visibility(&self) -> longhands::_moz_control_character_visibility::computed_value::T {
        From::from(self.mMozControlCharacterVisibility.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_underline_offset(&mut self, v: longhands::text_underline_offset::computed_value::T) {
        self.mTextUnderlineOffset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_underline_offset_from(&mut self, other: &Self) {
        self.mTextUnderlineOffset = other.mTextUnderlineOffset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_underline_offset(&mut self, other: &Self) {
        self.copy_text_underline_offset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_underline_offset(&self) -> longhands::text_underline_offset::computed_value::T {
        From::from(self.mTextUnderlineOffset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_underline_position(&mut self, v: longhands::text_underline_position::computed_value::T) {
        self.mTextUnderlinePosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_underline_position_from(&mut self, other: &Self) {
        self.mTextUnderlinePosition = other.mTextUnderlinePosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_underline_position(&mut self, other: &Self) {
        self.copy_text_underline_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_underline_position(&self) -> longhands::text_underline_position::computed_value::T {
        From::from(self.mTextUnderlinePosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_skip_ink(&mut self, v: longhands::text_decoration_skip_ink::computed_value::T) {
        self.mTextDecorationSkipInk = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_skip_ink_from(&mut self, other: &Self) {
        self.mTextDecorationSkipInk = other.mTextDecorationSkipInk.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_skip_ink(&mut self, other: &Self) {
        self.copy_text_decoration_skip_ink_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_skip_ink(&self) -> longhands::text_decoration_skip_ink::computed_value::T {
        From::from(self.mTextDecorationSkipInk.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_hyphenate_character(&mut self, v: longhands::hyphenate_character::computed_value::T) {
        self.mHyphenateCharacter = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_hyphenate_character_from(&mut self, other: &Self) {
        self.mHyphenateCharacter = other.mHyphenateCharacter.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_hyphenate_character(&mut self, other: &Self) {
        self.copy_hyphenate_character_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_hyphenate_character(&self) -> longhands::hyphenate_character::computed_value::T {
        From::from(self.mHyphenateCharacter.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_forced_color_adjust(&mut self, v: longhands::forced_color_adjust::computed_value::T) {
        self.mForcedColorAdjust = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_forced_color_adjust_from(&mut self, other: &Self) {
        self.mForcedColorAdjust = other.mForcedColorAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_forced_color_adjust(&mut self, other: &Self) {
        self.copy_forced_color_adjust_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_forced_color_adjust(&self) -> longhands::forced_color_adjust::computed_value::T {
        From::from(self.mForcedColorAdjust.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_text_security(&mut self, v: longhands::_webkit_text_security::computed_value::T) {
        use crate::properties::longhands::_webkit_text_security::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleTextSecurity::None ,
                Keyword::Circle =>
                    structs::StyleTextSecurity::Circle ,
                Keyword::Disc =>
                    structs::StyleTextSecurity::Disc ,
                Keyword::Square =>
                    structs::StyleTextSecurity::Square ,
        };
        self.mWebkitTextSecurity = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_security_from(&mut self, other: &Self) {
        self.mWebkitTextSecurity = other.mWebkitTextSecurity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_security(&mut self, other: &Self) {
        self.copy__webkit_text_security_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_security(&self) -> longhands::_webkit_text_security::computed_value::T {
        use crate::properties::longhands::_webkit_text_security::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mWebkitTextSecurity {
            structs::StyleTextSecurity::None => Keyword::None,
            structs::StyleTextSecurity::Circle => Keyword::Circle,
            structs::StyleTextSecurity::Disc => Keyword::Disc,
            structs::StyleTextSecurity::Square => Keyword::Square,
        }
    }


}




impl GeckoText {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_initial_letter(&mut self, v: longhands::initial_letter::computed_value::T) {
        use crate::values::generics::text::InitialLetter;
        match v {
            InitialLetter::Normal => {
                self.mInitialLetterSize = 0.;
                self.mInitialLetterSink = 0;
            },
            InitialLetter::Specified(size, sink) => {
                self.mInitialLetterSize = size;
                if let Some(sink) = sink {
                    self.mInitialLetterSink = sink;
                } else {
                    self.mInitialLetterSink = size.floor() as i32;
                }
            }
        }
    }

    pub fn copy_initial_letter_from(&mut self, other: &Self) {
        self.mInitialLetterSize = other.mInitialLetterSize;
        self.mInitialLetterSink = other.mInitialLetterSink;
    }

    pub fn reset_initial_letter(&mut self, other: &Self) {
        self.copy_initial_letter_from(other)
    }

    pub fn clone_initial_letter(&self) -> longhands::initial_letter::computed_value::T {
        use crate::values::generics::text::InitialLetter;

        if self.mInitialLetterSize == 0. && self.mInitialLetterSink == 0 {
            InitialLetter::Normal
        } else if self.mInitialLetterSize.floor() as i32 == self.mInitialLetterSink {
            InitialLetter::Specified(self.mInitialLetterSize, None)
        } else {
            InitialLetter::Specified(self.mInitialLetterSize, Some(self.mInitialLetterSink))
        }
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_text_overflow(&mut self, v: longhands::text_overflow::computed_value::T) {
        self.mTextOverflow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_overflow_from(&mut self, other: &Self) {
        self.mTextOverflow = other.mTextOverflow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_overflow(&mut self, other: &Self) {
        self.copy_text_overflow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_overflow(&self) -> longhands::text_overflow::computed_value::T {
        From::from(self.mTextOverflow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_unicode_bidi(&mut self, v: longhands::unicode_bidi::computed_value::T) {
        use crate::properties::longhands::unicode_bidi::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleUnicodeBidi::Normal ,
                Keyword::Embed =>
                    structs::StyleUnicodeBidi::Embed ,
                Keyword::Isolate =>
                    structs::StyleUnicodeBidi::Isolate ,
                Keyword::BidiOverride =>
                    structs::StyleUnicodeBidi::BidiOverride ,
                Keyword::IsolateOverride =>
                    structs::StyleUnicodeBidi::IsolateOverride ,
                Keyword::Plaintext =>
                    structs::StyleUnicodeBidi::Plaintext ,
        };
        self.mUnicodeBidi = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_unicode_bidi_from(&mut self, other: &Self) {
        self.mUnicodeBidi = other.mUnicodeBidi.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_unicode_bidi(&mut self, other: &Self) {
        self.copy_unicode_bidi_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_unicode_bidi(&self) -> longhands::unicode_bidi::computed_value::T {
        use crate::properties::longhands::unicode_bidi::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mUnicodeBidi {
            structs::StyleUnicodeBidi::Normal => Keyword::Normal,
            structs::StyleUnicodeBidi::Embed => Keyword::Embed,
            structs::StyleUnicodeBidi::Isolate => Keyword::Isolate,
            structs::StyleUnicodeBidi::BidiOverride => Keyword::BidiOverride,
            structs::StyleUnicodeBidi::IsolateOverride => Keyword::IsolateOverride,
            structs::StyleUnicodeBidi::Plaintext => Keyword::Plaintext,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_line(&mut self, v: longhands::text_decoration_line::computed_value::T) {
        self.mTextDecorationLine = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_line_from(&mut self, other: &Self) {
        self.mTextDecorationLine = other.mTextDecorationLine.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_line(&mut self, other: &Self) {
        self.copy_text_decoration_line_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_line(&self) -> longhands::text_decoration_line::computed_value::T {
        From::from(self.mTextDecorationLine.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_style(&mut self, v: longhands::text_decoration_style::computed_value::T) {
        use crate::properties::longhands::text_decoration_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Solid =>
                    structs::StyleTextDecorationStyle::Solid ,
                Keyword::Double =>
                    structs::StyleTextDecorationStyle::Double ,
                Keyword::Dotted =>
                    structs::StyleTextDecorationStyle::Dotted ,
                Keyword::Dashed =>
                    structs::StyleTextDecorationStyle::Dashed ,
                Keyword::Wavy =>
                    structs::StyleTextDecorationStyle::Wavy ,
                Keyword::MozNone =>
                    structs::StyleTextDecorationStyle::None ,
        };
        self.mTextDecorationStyle = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_style_from(&mut self, other: &Self) {
        self.mTextDecorationStyle = other.mTextDecorationStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_style(&mut self, other: &Self) {
        self.copy_text_decoration_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_style(&self) -> longhands::text_decoration_style::computed_value::T {
        use crate::properties::longhands::text_decoration_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mTextDecorationStyle {
            structs::StyleTextDecorationStyle::Solid => Keyword::Solid,
            structs::StyleTextDecorationStyle::Double => Keyword::Double,
            structs::StyleTextDecorationStyle::Dotted => Keyword::Dotted,
            structs::StyleTextDecorationStyle::Dashed => Keyword::Dashed,
            structs::StyleTextDecorationStyle::Wavy => Keyword::Wavy,
            structs::StyleTextDecorationStyle::None => Keyword::MozNone,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_color(&mut self, v: longhands::text_decoration_color::computed_value::T) {
        self.mTextDecorationColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_color_from(&mut self, other: &Self) {
        self.mTextDecorationColor = other.mTextDecorationColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_color(&mut self, other: &Self) {
        self.copy_text_decoration_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_color(&self) -> longhands::text_decoration_color::computed_value::T {
        From::from(self.mTextDecorationColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_thickness(&mut self, v: longhands::text_decoration_thickness::computed_value::T) {
        self.mTextDecorationThickness = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_thickness_from(&mut self, other: &Self) {
        self.mTextDecorationThickness = other.mTextDecorationThickness.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_thickness(&mut self, other: &Self) {
        self.copy_text_decoration_thickness_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_thickness(&self) -> longhands::text_decoration_thickness::computed_value::T {
        From::from(self.mTextDecorationThickness.clone())
    }


}





impl GeckoSVG {
    /*
     * Manually-Implemented Methods.
     */
    
    
    

    
    
    pub fn copy_mask_repeat_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mMask.mRepeatCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mMask.mLayers.iter_mut()
                                  .zip(other.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mRepeat = other.mRepeat.clone();
        }
        self.mMask.mRepeatCount = count;
    }

    pub fn reset_mask_repeat(&mut self, other: &Self) {
        self.copy_mask_repeat_from(other)
    }


    pub fn set_mask_repeat<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::mask_repeat::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.mMask.mRepeatCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mMask.mLayers.iter_mut()) {
            geckolayer.mRepeat = {
                
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Repeat;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_ns(repeat: BackgroundRepeatKeyword) -> StyleImageLayerRepeat {
            match repeat {
                BackgroundRepeatKeyword::Repeat => StyleImageLayerRepeat::Repeat,
                BackgroundRepeatKeyword::Space => StyleImageLayerRepeat::Space,
                BackgroundRepeatKeyword::Round => StyleImageLayerRepeat::Round,
                BackgroundRepeatKeyword::NoRepeat => StyleImageLayerRepeat::NoRepeat,
            }
        }

        let repeat_x = to_ns(servo.0);
        let repeat_y = to_ns(servo.1);
        nsStyleImageLayers_Repeat {
              mXRepeat: repeat_x,
              mYRepeat: repeat_y,
        }
    
            };
        }
    }


    pub fn clone_mask_repeat(&self) -> longhands::mask_repeat::computed_value::T {
        use crate::properties::longhands::mask_repeat::single_value::computed_value::T;
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_servo(repeat: StyleImageLayerRepeat) -> BackgroundRepeatKeyword {
            match repeat {
                StyleImageLayerRepeat::Repeat => BackgroundRepeatKeyword::Repeat,
                StyleImageLayerRepeat::Space => BackgroundRepeatKeyword::Space,
                StyleImageLayerRepeat::Round => BackgroundRepeatKeyword::Round,
                StyleImageLayerRepeat::NoRepeat => BackgroundRepeatKeyword::NoRepeat,
                _ => panic!("Found unexpected value in style struct for mask_repeat property"),
            }
        }

        longhands::mask_repeat::computed_value::List(
            self.mMask.mLayers.iter()
                .take(self.mMask.mRepeatCount as usize)
                .map(|ref layer| {
                    T(to_servo(layer.mRepeat.mXRepeat), to_servo(layer.mRepeat.mYRepeat))
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_clip_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mMask.mClipCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mMask.mLayers.iter_mut()
                                  .zip(other.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mClip = other.mClip.clone();
        }
        self.mMask.mClipCount = count;
    }

    pub fn reset_mask_clip(&mut self, other: &Self) {
        self.copy_mask_clip_from(other)
    }


    pub fn set_mask_clip<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_clip::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_clip::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.mMask.mClipCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mMask.mLayers.iter_mut()) {
            geckolayer.mClip = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::FillBox =>
                        structs::StyleGeometryBox::FillBox ,
                    Keyword::StrokeBox =>
                        structs::StyleGeometryBox::StrokeBox ,
                    Keyword::ViewBox =>
                        structs::StyleGeometryBox::ViewBox ,
                    Keyword::NoClip =>
                        structs::StyleGeometryBox::NoClip ,
                }
            };
        }
    }

    pub fn clone_mask_clip(&self) -> longhands::mask_clip::computed_value::T {
        use crate::properties::longhands::mask_clip::single_value::computed_value::T as Keyword;


        longhands::mask_clip::computed_value::List(
            self.mMask.mLayers.iter()
                .take(self.mMask.mClipCount as usize)
                .map(|ref layer| {
                    match layer.mClip {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::FillBox
                            => Keyword::FillBox,
                        structs::StyleGeometryBox::StrokeBox
                            => Keyword::StrokeBox,
                        structs::StyleGeometryBox::ViewBox
                            => Keyword::ViewBox,
                        structs::StyleGeometryBox::NoClip
                            => Keyword::NoClip,
                        _ => panic!("Found unexpected value in style struct for mask_clip property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_origin_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mMask.mOriginCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mMask.mLayers.iter_mut()
                                  .zip(other.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mOrigin = other.mOrigin.clone();
        }
        self.mMask.mOriginCount = count;
    }

    pub fn reset_mask_origin(&mut self, other: &Self) {
        self.copy_mask_origin_from(other)
    }


    pub fn set_mask_origin<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_origin::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_origin::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.mMask.mOriginCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mMask.mLayers.iter_mut()) {
            geckolayer.mOrigin = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::FillBox =>
                        structs::StyleGeometryBox::FillBox ,
                    Keyword::StrokeBox =>
                        structs::StyleGeometryBox::StrokeBox ,
                    Keyword::ViewBox =>
                        structs::StyleGeometryBox::ViewBox ,
                }
            };
        }
    }

    pub fn clone_mask_origin(&self) -> longhands::mask_origin::computed_value::T {
        use crate::properties::longhands::mask_origin::single_value::computed_value::T as Keyword;


        longhands::mask_origin::computed_value::List(
            self.mMask.mLayers.iter()
                .take(self.mMask.mOriginCount as usize)
                .map(|ref layer| {
                    match layer.mOrigin {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::FillBox
                            => Keyword::FillBox,
                        structs::StyleGeometryBox::StrokeBox
                            => Keyword::StrokeBox,
                        structs::StyleGeometryBox::ViewBox
                            => Keyword::ViewBox,
                        _ => panic!("Found unexpected value in style struct for mask_origin property"),
                    }
                }).collect()
        )
    }


    pub fn copy_mask_position_x_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mMask.mPositionXCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }

        for (layer, other) in self.mMask.mLayers.iter_mut()
                                  .zip(other.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.horizontal = other.mPosition.horizontal.clone();
        }
        self.mMask.mPositionXCount = count;
    }

    pub fn reset_mask_position_x(&mut self, other: &Self) {
        self.copy_mask_position_x_from(other)
    }

    pub fn clone_mask_position_x(&self)
        -> longhands::mask_position_x::computed_value::T {
        longhands::mask_position_x::computed_value::List(
            self.mMask.mLayers.iter()
                .take(self.mMask.mPositionXCount as usize)
                .map(|position| position.mPosition.horizontal.clone())
                .collect()
        )
    }

    pub fn set_mask_position_x<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::mask_position_x
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.mMask.mPositionXCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mMask
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.horizontal = servo;
        }
    }
    pub fn copy_mask_position_y_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mMask.mPositionYCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }

        for (layer, other) in self.mMask.mLayers.iter_mut()
                                  .zip(other.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.vertical = other.mPosition.vertical.clone();
        }
        self.mMask.mPositionYCount = count;
    }

    pub fn reset_mask_position_y(&mut self, other: &Self) {
        self.copy_mask_position_y_from(other)
    }

    pub fn clone_mask_position_y(&self)
        -> longhands::mask_position_y::computed_value::T {
        longhands::mask_position_y::computed_value::List(
            self.mMask.mLayers.iter()
                .take(self.mMask.mPositionYCount as usize)
                .map(|position| position.mPosition.vertical.clone())
                .collect()
        )
    }

    pub fn set_mask_position_y<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::mask_position_y
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.mMask.mPositionYCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mMask
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.vertical = servo;
        }
    }

    
    
    pub fn copy_mask_size_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mMask.mSizeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mMask.mLayers.iter_mut()
                                  .zip(other.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mSize = other.mSize.clone();
        }
        self.mMask.mSizeCount = count;
    }

    pub fn reset_mask_size(&mut self, other: &Self) {
        self.copy_mask_size_from(other)
    }


    pub fn set_mask_size<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::mask_size::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.mMask.mSizeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mMask.mLayers.iter_mut()) {
            geckolayer.mSize = {
                
        servo
    
            };
        }
    }


    pub fn clone_mask_size(&self) -> longhands::mask_size::computed_value::T {
        longhands::mask_size::computed_value::List(
            self.mMask.mLayers.iter().map(|layer| layer.mSize.clone()).collect()
        )
    }

    pub fn copy_mask_image_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        unsafe {
            let count = other.mMask.mImageCount;
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);

            for (layer, other) in self.mMask.mLayers.iter_mut()
                                      .zip(other.mMask.mLayers.iter())
                                      .take(count as usize) {
                layer.mImage = other.mImage.clone();
            }
            self.mMask.mImageCount = count;
        }
    }

    pub fn reset_mask_image(&mut self, other: &Self) {
        self.copy_mask_image_from(other)
    }

    #[allow(unused_variables)]
    pub fn set_mask_image<I>(&mut self, images: I)
        where I: IntoIterator<Item = longhands::mask_image::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let images = images.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(
                &mut self.mMask,
                images.len(),
                LayerType::Mask,
            );
        }

        self.mMask.mImageCount = images.len() as u32;
        for (image, geckoimage) in images.zip(self.mMask
                                                  .mLayers.iter_mut()) {
            geckoimage.mImage = image;
        }
    }

    pub fn clone_mask_image(&self) -> longhands::mask_image::computed_value::T {
        longhands::mask_image::computed_value::List(
            self.mMask.mLayers.iter()
                .take(self.mMask.mImageCount as usize)
                .map(|layer| layer.mImage.clone())
                .collect()
        )
    }

    
    pub fn fill_arrays(&mut self) {
        use crate::gecko_bindings::bindings::Gecko_FillAllImageLayers;
        use std::cmp;
        let mut max_len = 1;
            max_len = cmp::max(max_len, self.mMask.mRepeatCount);
            max_len = cmp::max(max_len, self.mMask.mClipCount);
            max_len = cmp::max(max_len, self.mMask.mOriginCount);
            max_len = cmp::max(max_len, self.mMask.mPositionXCount);
            max_len = cmp::max(max_len, self.mMask.mPositionYCount);
            max_len = cmp::max(max_len, self.mMask.mImageCount);
            max_len = cmp::max(max_len, self.mMask.mSizeCount);
            max_len = cmp::max(max_len, self.mMask.mMaskModeCount);
            max_len = cmp::max(max_len, self.mMask.mCompositeCount);
        unsafe {
            // While we could do this manually, we'd need to also manually
            // run all the copy constructors, so we just delegate to gecko
            Gecko_FillAllImageLayers(&mut self.mMask, max_len);
        }
    }

    
    

    
    pub fn copy_mask_mode_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mMask.mMaskModeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mMask.mLayers.iter_mut()
                                  .zip(other.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mMaskMode = other.mMaskMode.clone();
        }
        self.mMask.mMaskModeCount = count;
    }

    pub fn reset_mask_mode(&mut self, other: &Self) {
        self.copy_mask_mode_from(other)
    }


    pub fn set_mask_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_mode::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.mMask.mMaskModeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mMask.mLayers.iter_mut()) {
            geckolayer.mMaskMode = {
                match servo {
                    Keyword::MatchSource =>
                        structs::StyleMaskMode::MatchSource ,
                    Keyword::Alpha =>
                        structs::StyleMaskMode::Alpha ,
                    Keyword::Luminance =>
                        structs::StyleMaskMode::Luminance ,
                }
            };
        }
    }

    pub fn clone_mask_mode(&self) -> longhands::mask_mode::computed_value::T {
        use crate::properties::longhands::mask_mode::single_value::computed_value::T as Keyword;


        longhands::mask_mode::computed_value::List(
            self.mMask.mLayers.iter()
                .take(self.mMask.mMaskModeCount as usize)
                .map(|ref layer| {
                    match layer.mMaskMode {
                        structs::StyleMaskMode::MatchSource
                            => Keyword::MatchSource,
                        structs::StyleMaskMode::Alpha
                            => Keyword::Alpha,
                        structs::StyleMaskMode::Luminance
                            => Keyword::Luminance,
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_composite_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.mMask.mCompositeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.mMask.mLayers.iter_mut()
                                  .zip(other.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mComposite = other.mComposite.clone();
        }
        self.mMask.mCompositeCount = count;
    }

    pub fn reset_mask_composite(&mut self, other: &Self) {
        self.copy_mask_composite_from(other)
    }


    pub fn set_mask_composite<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_composite::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_composite::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.mMask.mCompositeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.mMask.mLayers.iter_mut()) {
            geckolayer.mComposite = {
                match servo {
                    Keyword::Add =>
                        structs::StyleMaskComposite::Add ,
                    Keyword::Subtract =>
                        structs::StyleMaskComposite::Subtract ,
                    Keyword::Intersect =>
                        structs::StyleMaskComposite::Intersect ,
                    Keyword::Exclude =>
                        structs::StyleMaskComposite::Exclude ,
                }
            };
        }
    }

    pub fn clone_mask_composite(&self) -> longhands::mask_composite::computed_value::T {
        use crate::properties::longhands::mask_composite::single_value::computed_value::T as Keyword;


        longhands::mask_composite::computed_value::List(
            self.mMask.mLayers.iter()
                .take(self.mMask.mCompositeCount as usize)
                .map(|ref layer| {
                    match layer.mComposite {
                        structs::StyleMaskComposite::Add
                            => Keyword::Add,
                        structs::StyleMaskComposite::Subtract
                            => Keyword::Subtract,
                        structs::StyleMaskComposite::Intersect
                            => Keyword::Intersect,
                        structs::StyleMaskComposite::Exclude
                            => Keyword::Exclude,
                    }
                }).collect()
        )
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_vector_effect(&mut self, v: longhands::vector_effect::computed_value::T) {
        use crate::properties::longhands::vector_effect::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleVectorEffect::None ,
                Keyword::NonScalingStroke =>
                    structs::StyleVectorEffect::NonScalingStroke ,
        };
        self.mVectorEffect = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_vector_effect_from(&mut self, other: &Self) {
        self.mVectorEffect = other.mVectorEffect.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_vector_effect(&mut self, other: &Self) {
        self.copy_vector_effect_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_vector_effect(&self) -> longhands::vector_effect::computed_value::T {
        use crate::properties::longhands::vector_effect::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mVectorEffect {
            structs::StyleVectorEffect::None => Keyword::None,
            structs::StyleVectorEffect::NonScalingStroke => Keyword::NonScalingStroke,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stop_color(&mut self, v: longhands::stop_color::computed_value::T) {
        self.mStopColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stop_color_from(&mut self, other: &Self) {
        self.mStopColor = other.mStopColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stop_color(&mut self, other: &Self) {
        self.copy_stop_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stop_color(&self) -> longhands::stop_color::computed_value::T {
        From::from(self.mStopColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stop_opacity(&mut self, v: longhands::stop_opacity::computed_value::T) {
        self.mStopOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stop_opacity_from(&mut self, other: &Self) {
        self.mStopOpacity = other.mStopOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stop_opacity(&mut self, other: &Self) {
        self.copy_stop_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stop_opacity(&self) -> longhands::stop_opacity::computed_value::T {
        From::from(self.mStopOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flood_color(&mut self, v: longhands::flood_color::computed_value::T) {
        self.mFloodColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flood_color_from(&mut self, other: &Self) {
        self.mFloodColor = other.mFloodColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flood_color(&mut self, other: &Self) {
        self.copy_flood_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flood_color(&self) -> longhands::flood_color::computed_value::T {
        From::from(self.mFloodColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flood_opacity(&mut self, v: longhands::flood_opacity::computed_value::T) {
        self.mFloodOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flood_opacity_from(&mut self, other: &Self) {
        self.mFloodOpacity = other.mFloodOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flood_opacity(&mut self, other: &Self) {
        self.copy_flood_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flood_opacity(&self) -> longhands::flood_opacity::computed_value::T {
        From::from(self.mFloodOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_lighting_color(&mut self, v: longhands::lighting_color::computed_value::T) {
        self.mLightingColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_lighting_color_from(&mut self, other: &Self) {
        self.mLightingColor = other.mLightingColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_lighting_color(&mut self, other: &Self) {
        self.copy_lighting_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_lighting_color(&self) -> longhands::lighting_color::computed_value::T {
        From::from(self.mLightingColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_mask_type(&mut self, v: longhands::mask_type::computed_value::T) {
        use crate::properties::longhands::mask_type::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Luminance =>
                    structs::StyleMaskType::Luminance ,
                Keyword::Alpha =>
                    structs::StyleMaskType::Alpha ,
        };
        self.mMaskType = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_mask_type_from(&mut self, other: &Self) {
        self.mMaskType = other.mMaskType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_mask_type(&mut self, other: &Self) {
        self.copy_mask_type_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_mask_type(&self) -> longhands::mask_type::computed_value::T {
        use crate::properties::longhands::mask_type::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mMaskType {
            structs::StyleMaskType::Luminance => Keyword::Luminance,
            structs::StyleMaskType::Alpha => Keyword::Alpha,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_clip_path(&mut self, v: longhands::clip_path::computed_value::T) {
        self.mClipPath = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clip_path_from(&mut self, other: &Self) {
        self.mClipPath = other.mClipPath.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clip_path(&mut self, other: &Self) {
        self.copy_clip_path_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clip_path(&self) -> longhands::clip_path::computed_value::T {
        From::from(self.mClipPath.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_x(&mut self, v: longhands::x::computed_value::T) {
        self.mX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_x_from(&mut self, other: &Self) {
        self.mX = other.mX.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_x(&mut self, other: &Self) {
        self.copy_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_x(&self) -> longhands::x::computed_value::T {
        From::from(self.mX.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_y(&mut self, v: longhands::y::computed_value::T) {
        self.mY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_y_from(&mut self, other: &Self) {
        self.mY = other.mY.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_y(&mut self, other: &Self) {
        self.copy_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_y(&self) -> longhands::y::computed_value::T {
        From::from(self.mY.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_cx(&mut self, v: longhands::cx::computed_value::T) {
        self.mCx = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_cx_from(&mut self, other: &Self) {
        self.mCx = other.mCx.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_cx(&mut self, other: &Self) {
        self.copy_cx_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_cx(&self) -> longhands::cx::computed_value::T {
        From::from(self.mCx.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_cy(&mut self, v: longhands::cy::computed_value::T) {
        self.mCy = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_cy_from(&mut self, other: &Self) {
        self.mCy = other.mCy.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_cy(&mut self, other: &Self) {
        self.copy_cy_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_cy(&self) -> longhands::cy::computed_value::T {
        From::from(self.mCy.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_rx(&mut self, v: longhands::rx::computed_value::T) {
        self.mRx = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_rx_from(&mut self, other: &Self) {
        self.mRx = other.mRx.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_rx(&mut self, other: &Self) {
        self.copy_rx_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_rx(&self) -> longhands::rx::computed_value::T {
        From::from(self.mRx.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_ry(&mut self, v: longhands::ry::computed_value::T) {
        self.mRy = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_ry_from(&mut self, other: &Self) {
        self.mRy = other.mRy.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ry(&mut self, other: &Self) {
        self.copy_ry_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_ry(&self) -> longhands::ry::computed_value::T {
        From::from(self.mRy.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_r(&mut self, v: longhands::r::computed_value::T) {
        self.mR = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_r_from(&mut self, other: &Self) {
        self.mR = other.mR.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_r(&mut self, other: &Self) {
        self.copy_r_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_r(&self) -> longhands::r::computed_value::T {
        From::from(self.mR.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_d(&mut self, v: longhands::d::computed_value::T) {
        self.mD = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_d_from(&mut self, other: &Self) {
        self.mD = other.mD.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_d(&mut self, other: &Self) {
        self.copy_d_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_d(&self) -> longhands::d::computed_value::T {
        From::from(self.mD.clone())
    }


}




impl GeckoInheritedSVG {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_dominant_baseline(&mut self, v: longhands::dominant_baseline::computed_value::T) {
        use crate::properties::longhands::dominant_baseline::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleDominantBaseline::Auto ,
                Keyword::Ideographic =>
                    structs::StyleDominantBaseline::Ideographic ,
                Keyword::Alphabetic =>
                    structs::StyleDominantBaseline::Alphabetic ,
                Keyword::Hanging =>
                    structs::StyleDominantBaseline::Hanging ,
                Keyword::Mathematical =>
                    structs::StyleDominantBaseline::Mathematical ,
                Keyword::Central =>
                    structs::StyleDominantBaseline::Central ,
                Keyword::Middle =>
                    structs::StyleDominantBaseline::Middle ,
                Keyword::TextAfterEdge =>
                    structs::StyleDominantBaseline::TextAfterEdge ,
                Keyword::TextBeforeEdge =>
                    structs::StyleDominantBaseline::TextBeforeEdge ,
        };
        self.mDominantBaseline = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_dominant_baseline_from(&mut self, other: &Self) {
        self.mDominantBaseline = other.mDominantBaseline.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_dominant_baseline(&mut self, other: &Self) {
        self.copy_dominant_baseline_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_dominant_baseline(&self) -> longhands::dominant_baseline::computed_value::T {
        use crate::properties::longhands::dominant_baseline::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mDominantBaseline {
            structs::StyleDominantBaseline::Auto => Keyword::Auto,
            structs::StyleDominantBaseline::Ideographic => Keyword::Ideographic,
            structs::StyleDominantBaseline::Alphabetic => Keyword::Alphabetic,
            structs::StyleDominantBaseline::Hanging => Keyword::Hanging,
            structs::StyleDominantBaseline::Mathematical => Keyword::Mathematical,
            structs::StyleDominantBaseline::Central => Keyword::Central,
            structs::StyleDominantBaseline::Middle => Keyword::Middle,
            structs::StyleDominantBaseline::TextAfterEdge => Keyword::TextAfterEdge,
            structs::StyleDominantBaseline::TextBeforeEdge => Keyword::TextBeforeEdge,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_anchor(&mut self, v: longhands::text_anchor::computed_value::T) {
        use crate::properties::longhands::text_anchor::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::StyleTextAnchor::Start ,
                Keyword::Middle =>
                    structs::StyleTextAnchor::Middle ,
                Keyword::End =>
                    structs::StyleTextAnchor::End ,
        };
        self.mTextAnchor = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_anchor_from(&mut self, other: &Self) {
        self.mTextAnchor = other.mTextAnchor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_anchor(&mut self, other: &Self) {
        self.copy_text_anchor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_anchor(&self) -> longhands::text_anchor::computed_value::T {
        use crate::properties::longhands::text_anchor::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mTextAnchor {
            structs::StyleTextAnchor::Start => Keyword::Start,
            structs::StyleTextAnchor::Middle => Keyword::Middle,
            structs::StyleTextAnchor::End => Keyword::End,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_interpolation(&mut self, v: longhands::color_interpolation::computed_value::T) {
        use crate::properties::longhands::color_interpolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Srgb =>
                    structs::StyleColorInterpolation::Srgb ,
                Keyword::Auto =>
                    structs::StyleColorInterpolation::Auto ,
                Keyword::Linearrgb =>
                    structs::StyleColorInterpolation::Linearrgb ,
        };
        self.mColorInterpolation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_interpolation_from(&mut self, other: &Self) {
        self.mColorInterpolation = other.mColorInterpolation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_interpolation(&mut self, other: &Self) {
        self.copy_color_interpolation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color_interpolation(&self) -> longhands::color_interpolation::computed_value::T {
        use crate::properties::longhands::color_interpolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mColorInterpolation {
            structs::StyleColorInterpolation::Srgb => Keyword::Srgb,
            structs::StyleColorInterpolation::Auto => Keyword::Auto,
            structs::StyleColorInterpolation::Linearrgb => Keyword::Linearrgb,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_interpolation_filters(&mut self, v: longhands::color_interpolation_filters::computed_value::T) {
        use crate::properties::longhands::color_interpolation_filters::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Linearrgb =>
                    structs::StyleColorInterpolation::Linearrgb ,
                Keyword::Auto =>
                    structs::StyleColorInterpolation::Auto ,
                Keyword::Srgb =>
                    structs::StyleColorInterpolation::Srgb ,
        };
        self.mColorInterpolationFilters = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_interpolation_filters_from(&mut self, other: &Self) {
        self.mColorInterpolationFilters = other.mColorInterpolationFilters.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_interpolation_filters(&mut self, other: &Self) {
        self.copy_color_interpolation_filters_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color_interpolation_filters(&self) -> longhands::color_interpolation_filters::computed_value::T {
        use crate::properties::longhands::color_interpolation_filters::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mColorInterpolationFilters {
            structs::StyleColorInterpolation::Linearrgb => Keyword::Linearrgb,
            structs::StyleColorInterpolation::Auto => Keyword::Auto,
            structs::StyleColorInterpolation::Srgb => Keyword::Srgb,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_fill(&mut self, v: longhands::fill::computed_value::T) {
        self.mFill = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_fill_from(&mut self, other: &Self) {
        self.mFill = other.mFill.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_fill(&mut self, other: &Self) {
        self.copy_fill_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_fill(&self) -> longhands::fill::computed_value::T {
        From::from(self.mFill.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_fill_opacity(&mut self, v: longhands::fill_opacity::computed_value::T) {
        self.mFillOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_fill_opacity_from(&mut self, other: &Self) {
        self.mFillOpacity = other.mFillOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_fill_opacity(&mut self, other: &Self) {
        self.copy_fill_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_fill_opacity(&self) -> longhands::fill_opacity::computed_value::T {
        From::from(self.mFillOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_fill_rule(&mut self, v: longhands::fill_rule::computed_value::T) {
        self.mFillRule = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_fill_rule_from(&mut self, other: &Self) {
        self.mFillRule = other.mFillRule.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_fill_rule(&mut self, other: &Self) {
        self.copy_fill_rule_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_fill_rule(&self) -> longhands::fill_rule::computed_value::T {
        From::from(self.mFillRule.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_rendering(&mut self, v: longhands::shape_rendering::computed_value::T) {
        use crate::properties::longhands::shape_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleShapeRendering::Auto ,
                Keyword::Optimizespeed =>
                    structs::StyleShapeRendering::Optimizespeed ,
                Keyword::Crispedges =>
                    structs::StyleShapeRendering::Crispedges ,
                Keyword::Geometricprecision =>
                    structs::StyleShapeRendering::Geometricprecision ,
        };
        self.mShapeRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_rendering_from(&mut self, other: &Self) {
        self.mShapeRendering = other.mShapeRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_rendering(&mut self, other: &Self) {
        self.copy_shape_rendering_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_rendering(&self) -> longhands::shape_rendering::computed_value::T {
        use crate::properties::longhands::shape_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mShapeRendering {
            structs::StyleShapeRendering::Auto => Keyword::Auto,
            structs::StyleShapeRendering::Optimizespeed => Keyword::Optimizespeed,
            structs::StyleShapeRendering::Crispedges => Keyword::Crispedges,
            structs::StyleShapeRendering::Geometricprecision => Keyword::Geometricprecision,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke(&mut self, v: longhands::stroke::computed_value::T) {
        self.mStroke = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_from(&mut self, other: &Self) {
        self.mStroke = other.mStroke.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke(&mut self, other: &Self) {
        self.copy_stroke_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke(&self) -> longhands::stroke::computed_value::T {
        From::from(self.mStroke.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_width(&mut self, v: longhands::stroke_width::computed_value::T) {
        self.mStrokeWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_width_from(&mut self, other: &Self) {
        self.mStrokeWidth = other.mStrokeWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_width(&mut self, other: &Self) {
        self.copy_stroke_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_width(&self) -> longhands::stroke_width::computed_value::T {
        From::from(self.mStrokeWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_linecap(&mut self, v: longhands::stroke_linecap::computed_value::T) {
        use crate::properties::longhands::stroke_linecap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Butt =>
                    structs::StyleStrokeLinecap::Butt ,
                Keyword::Round =>
                    structs::StyleStrokeLinecap::Round ,
                Keyword::Square =>
                    structs::StyleStrokeLinecap::Square ,
        };
        self.mStrokeLinecap = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_linecap_from(&mut self, other: &Self) {
        self.mStrokeLinecap = other.mStrokeLinecap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_linecap(&mut self, other: &Self) {
        self.copy_stroke_linecap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_linecap(&self) -> longhands::stroke_linecap::computed_value::T {
        use crate::properties::longhands::stroke_linecap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mStrokeLinecap {
            structs::StyleStrokeLinecap::Butt => Keyword::Butt,
            structs::StyleStrokeLinecap::Round => Keyword::Round,
            structs::StyleStrokeLinecap::Square => Keyword::Square,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_linejoin(&mut self, v: longhands::stroke_linejoin::computed_value::T) {
        use crate::properties::longhands::stroke_linejoin::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Miter =>
                    structs::StyleStrokeLinejoin::Miter ,
                Keyword::Round =>
                    structs::StyleStrokeLinejoin::Round ,
                Keyword::Bevel =>
                    structs::StyleStrokeLinejoin::Bevel ,
        };
        self.mStrokeLinejoin = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_linejoin_from(&mut self, other: &Self) {
        self.mStrokeLinejoin = other.mStrokeLinejoin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_linejoin(&mut self, other: &Self) {
        self.copy_stroke_linejoin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_linejoin(&self) -> longhands::stroke_linejoin::computed_value::T {
        use crate::properties::longhands::stroke_linejoin::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mStrokeLinejoin {
            structs::StyleStrokeLinejoin::Miter => Keyword::Miter,
            structs::StyleStrokeLinejoin::Round => Keyword::Round,
            structs::StyleStrokeLinejoin::Bevel => Keyword::Bevel,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_miterlimit(&mut self, v: longhands::stroke_miterlimit::computed_value::T) {
        self.mStrokeMiterlimit = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_miterlimit_from(&mut self, other: &Self) {
        self.mStrokeMiterlimit = other.mStrokeMiterlimit.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_miterlimit(&mut self, other: &Self) {
        self.copy_stroke_miterlimit_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_miterlimit(&self) -> longhands::stroke_miterlimit::computed_value::T {
        From::from(self.mStrokeMiterlimit.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_opacity(&mut self, v: longhands::stroke_opacity::computed_value::T) {
        self.mStrokeOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_opacity_from(&mut self, other: &Self) {
        self.mStrokeOpacity = other.mStrokeOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_opacity(&mut self, other: &Self) {
        self.copy_stroke_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_opacity(&self) -> longhands::stroke_opacity::computed_value::T {
        From::from(self.mStrokeOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_dasharray(&mut self, v: longhands::stroke_dasharray::computed_value::T) {
        self.mStrokeDasharray = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_dasharray_from(&mut self, other: &Self) {
        self.mStrokeDasharray = other.mStrokeDasharray.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_dasharray(&mut self, other: &Self) {
        self.copy_stroke_dasharray_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_dasharray(&self) -> longhands::stroke_dasharray::computed_value::T {
        From::from(self.mStrokeDasharray.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_dashoffset(&mut self, v: longhands::stroke_dashoffset::computed_value::T) {
        self.mStrokeDashoffset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_dashoffset_from(&mut self, other: &Self) {
        self.mStrokeDashoffset = other.mStrokeDashoffset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_dashoffset(&mut self, other: &Self) {
        self.copy_stroke_dashoffset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_dashoffset(&self) -> longhands::stroke_dashoffset::computed_value::T {
        From::from(self.mStrokeDashoffset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_clip_rule(&mut self, v: longhands::clip_rule::computed_value::T) {
        self.mClipRule = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clip_rule_from(&mut self, other: &Self) {
        self.mClipRule = other.mClipRule.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clip_rule(&mut self, other: &Self) {
        self.copy_clip_rule_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clip_rule(&self) -> longhands::clip_rule::computed_value::T {
        From::from(self.mClipRule.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_marker_start(&mut self, v: longhands::marker_start::computed_value::T) {
        self.mMarkerStart = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_marker_start_from(&mut self, other: &Self) {
        self.mMarkerStart = other.mMarkerStart.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_marker_start(&mut self, other: &Self) {
        self.copy_marker_start_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_marker_start(&self) -> longhands::marker_start::computed_value::T {
        From::from(self.mMarkerStart.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_marker_mid(&mut self, v: longhands::marker_mid::computed_value::T) {
        self.mMarkerMid = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_marker_mid_from(&mut self, other: &Self) {
        self.mMarkerMid = other.mMarkerMid.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_marker_mid(&mut self, other: &Self) {
        self.copy_marker_mid_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_marker_mid(&self) -> longhands::marker_mid::computed_value::T {
        From::from(self.mMarkerMid.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_marker_end(&mut self, v: longhands::marker_end::computed_value::T) {
        self.mMarkerEnd = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_marker_end_from(&mut self, other: &Self) {
        self.mMarkerEnd = other.mMarkerEnd.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_marker_end(&mut self, other: &Self) {
        self.copy_marker_end_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_marker_end(&self) -> longhands::marker_end::computed_value::T {
        From::from(self.mMarkerEnd.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_paint_order(&mut self, v: longhands::paint_order::computed_value::T) {
        self.mPaintOrder = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_paint_order_from(&mut self, other: &Self) {
        self.mPaintOrder = other.mPaintOrder.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_paint_order(&mut self, other: &Self) {
        self.copy_paint_order_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_paint_order(&self) -> longhands::paint_order::computed_value::T {
        From::from(self.mPaintOrder.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_context_properties(&mut self, v: longhands::_moz_context_properties::computed_value::T) {
        self.mMozContextProperties = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_context_properties_from(&mut self, other: &Self) {
        self.mMozContextProperties = other.mMozContextProperties.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_context_properties(&mut self, other: &Self) {
        self.copy__moz_context_properties_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_context_properties(&self) -> longhands::_moz_context_properties::computed_value::T {
        From::from(self.mMozContextProperties.clone())
    }


}




impl GeckoInheritedUI {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_cursor(&mut self, v: longhands::cursor::computed_value::T) {
        self.mCursor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_cursor_from(&mut self, other: &Self) {
        self.mCursor = other.mCursor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_cursor(&mut self, other: &Self) {
        self.copy_cursor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_cursor(&self) -> longhands::cursor::computed_value::T {
        From::from(self.mCursor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_pointer_events(&mut self, v: longhands::pointer_events::computed_value::T) {
        use crate::properties::longhands::pointer_events::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StylePointerEvents::Auto ,
                Keyword::None =>
                    structs::StylePointerEvents::None ,
                Keyword::Visiblepainted =>
                    structs::StylePointerEvents::Visiblepainted ,
                Keyword::Visiblefill =>
                    structs::StylePointerEvents::Visiblefill ,
                Keyword::Visiblestroke =>
                    structs::StylePointerEvents::Visiblestroke ,
                Keyword::Visible =>
                    structs::StylePointerEvents::Visible ,
                Keyword::Painted =>
                    structs::StylePointerEvents::Painted ,
                Keyword::Fill =>
                    structs::StylePointerEvents::Fill ,
                Keyword::Stroke =>
                    structs::StylePointerEvents::Stroke ,
                Keyword::All =>
                    structs::StylePointerEvents::All ,
        };
        self.mPointerEvents = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_pointer_events_from(&mut self, other: &Self) {
        self.mPointerEvents = other.mPointerEvents.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_pointer_events(&mut self, other: &Self) {
        self.copy_pointer_events_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_pointer_events(&self) -> longhands::pointer_events::computed_value::T {
        use crate::properties::longhands::pointer_events::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mPointerEvents {
            structs::StylePointerEvents::Auto => Keyword::Auto,
            structs::StylePointerEvents::None => Keyword::None,
            structs::StylePointerEvents::Visiblepainted => Keyword::Visiblepainted,
            structs::StylePointerEvents::Visiblefill => Keyword::Visiblefill,
            structs::StylePointerEvents::Visiblestroke => Keyword::Visiblestroke,
            structs::StylePointerEvents::Visible => Keyword::Visible,
            structs::StylePointerEvents::Painted => Keyword::Painted,
            structs::StylePointerEvents::Fill => Keyword::Fill,
            structs::StylePointerEvents::Stroke => Keyword::Stroke,
            structs::StylePointerEvents::All => Keyword::All,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_inert(&mut self, v: longhands::_moz_inert::computed_value::T) {
        use crate::properties::longhands::_moz_inert::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleInert::None ,
                Keyword::Inert =>
                    structs::StyleInert::Inert ,
        };
        self.mInert = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_inert_from(&mut self, other: &Self) {
        self.mInert = other.mInert.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_inert(&mut self, other: &Self) {
        self.copy__moz_inert_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_inert(&self) -> longhands::_moz_inert::computed_value::T {
        use crate::properties::longhands::_moz_inert::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mInert {
            structs::StyleInert::None => Keyword::None,
            structs::StyleInert::Inert => Keyword::Inert,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_input(&mut self, v: longhands::_moz_user_input::computed_value::T) {
        use crate::properties::longhands::_moz_user_input::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleUserInput::Auto ,
                Keyword::None =>
                    structs::StyleUserInput::None ,
        };
        self.mUserInput = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_input_from(&mut self, other: &Self) {
        self.mUserInput = other.mUserInput.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_input(&mut self, other: &Self) {
        self.copy__moz_user_input_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_user_input(&self) -> longhands::_moz_user_input::computed_value::T {
        use crate::properties::longhands::_moz_user_input::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mUserInput {
            structs::StyleUserInput::Auto => Keyword::Auto,
            structs::StyleUserInput::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_modify(&mut self, v: longhands::_moz_user_modify::computed_value::T) {
        use crate::properties::longhands::_moz_user_modify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ReadOnly =>
                    structs::StyleUserModify::ReadOnly ,
                Keyword::ReadWrite =>
                    structs::StyleUserModify::ReadWrite ,
                Keyword::WriteOnly =>
                    structs::StyleUserModify::WriteOnly ,
        };
        self.mUserModify = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_modify_from(&mut self, other: &Self) {
        self.mUserModify = other.mUserModify.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_modify(&mut self, other: &Self) {
        self.copy__moz_user_modify_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_user_modify(&self) -> longhands::_moz_user_modify::computed_value::T {
        use crate::properties::longhands::_moz_user_modify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mUserModify {
            structs::StyleUserModify::ReadOnly => Keyword::ReadOnly,
            structs::StyleUserModify::ReadWrite => Keyword::ReadWrite,
            structs::StyleUserModify::WriteOnly => Keyword::WriteOnly,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_focus(&mut self, v: longhands::_moz_user_focus::computed_value::T) {
        use crate::properties::longhands::_moz_user_focus::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleUserFocus::None ,
                Keyword::Ignore =>
                    structs::StyleUserFocus::Ignore ,
                Keyword::Normal =>
                    structs::StyleUserFocus::Normal ,
                Keyword::SelectAfter =>
                    structs::StyleUserFocus::SelectAfter ,
                Keyword::SelectBefore =>
                    structs::StyleUserFocus::SelectBefore ,
                Keyword::SelectMenu =>
                    structs::StyleUserFocus::SelectMenu ,
                Keyword::SelectSame =>
                    structs::StyleUserFocus::SelectSame ,
                Keyword::SelectAll =>
                    structs::StyleUserFocus::SelectAll ,
        };
        self.mUserFocus = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_focus_from(&mut self, other: &Self) {
        self.mUserFocus = other.mUserFocus.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_focus(&mut self, other: &Self) {
        self.copy__moz_user_focus_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_user_focus(&self) -> longhands::_moz_user_focus::computed_value::T {
        use crate::properties::longhands::_moz_user_focus::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mUserFocus {
            structs::StyleUserFocus::None => Keyword::None,
            structs::StyleUserFocus::Ignore => Keyword::Ignore,
            structs::StyleUserFocus::Normal => Keyword::Normal,
            structs::StyleUserFocus::SelectAfter => Keyword::SelectAfter,
            structs::StyleUserFocus::SelectBefore => Keyword::SelectBefore,
            structs::StyleUserFocus::SelectMenu => Keyword::SelectMenu,
            structs::StyleUserFocus::SelectSame => Keyword::SelectSame,
            structs::StyleUserFocus::SelectAll => Keyword::SelectAll,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_caret_color(&mut self, v: longhands::caret_color::computed_value::T) {
        self.mCaretColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_caret_color_from(&mut self, other: &Self) {
        self.mCaretColor = other.mCaretColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_caret_color(&mut self, other: &Self) {
        self.copy_caret_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_caret_color(&self) -> longhands::caret_color::computed_value::T {
        From::from(self.mCaretColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_accent_color(&mut self, v: longhands::accent_color::computed_value::T) {
        self.mAccentColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_accent_color_from(&mut self, other: &Self) {
        self.mAccentColor = other.mAccentColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_accent_color(&mut self, other: &Self) {
        self.copy_accent_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_accent_color(&self) -> longhands::accent_color::computed_value::T {
        From::from(self.mAccentColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_color_scheme(&mut self, v: longhands::color_scheme::computed_value::T) {
        self.mColorScheme = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_color_scheme_from(&mut self, other: &Self) {
        self.mColorScheme = other.mColorScheme.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_scheme(&mut self, other: &Self) {
        self.copy_color_scheme_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color_scheme(&self) -> longhands::color_scheme::computed_value::T {
        From::from(self.mColorScheme.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_color(&mut self, v: longhands::scrollbar_color::computed_value::T) {
        self.mScrollbarColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_color_from(&mut self, other: &Self) {
        self.mScrollbarColor = other.mScrollbarColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_color(&mut self, other: &Self) {
        self.copy_scrollbar_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scrollbar_color(&self) -> longhands::scrollbar_color::computed_value::T {
        From::from(self.mScrollbarColor.clone())
    }


}




impl GeckoColumn {
    /*
     * Manually-Implemented Methods.
     */
    

    #[allow(unused_unsafe)]
    pub fn set_column_count(&mut self, v: longhands::column_count::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleColumn_kColumnCountAuto, nsStyleColumn_kMaxColumnCount};

        self.mColumnCount = match v {
            ColumnCount::Integer(integer) => {
                cmp::min(integer.0 as u32, unsafe { nsStyleColumn_kMaxColumnCount })
            },
            ColumnCount::Auto => nsStyleColumn_kColumnCountAuto
        };
    }

    
    #[allow(non_snake_case)]
    pub fn copy_column_count_from(&mut self, other: &Self) {
        self.mColumnCount = other.mColumnCount.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_count(&mut self, other: &Self) {
        self.copy_column_count_from(other)
    }


    pub fn clone_column_count(&self) -> longhands::column_count::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleColumn_kColumnCountAuto, nsStyleColumn_kMaxColumnCount};
        if self.mColumnCount != nsStyleColumn_kColumnCountAuto {
            debug_assert!(self.mColumnCount >= 1 &&
                          self.mColumnCount <= nsStyleColumn_kMaxColumnCount);
            ColumnCount::Integer((self.mColumnCount as i32).into())
        } else {
            ColumnCount::Auto
        }
    }

    pub fn set_column_rule_style(&mut self, v: longhands::column_rule_style::computed_value::T) {
        self.mColumnRuleStyle = v;
        // NB: This is needed to correctly handling the initial value of
        // column-rule-width when colun-rule-style changes, see the
        // update_border_left comment for more details.
        self.mActualColumnRuleWidth = self.mColumnRuleWidth;
    }

    pub fn copy_column_rule_style_from(&mut self, other: &Self) {
        self.set_column_rule_style(other.mColumnRuleStyle);
    }

    pub fn reset_column_rule_style(&mut self, other: &Self) {
        self.copy_column_rule_style_from(other)
    }

    pub fn clone_column_rule_style(&self) -> longhands::column_rule_style::computed_value::T {
        self.mColumnRuleStyle.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_column_rule_width(&mut self, v: Au) {
        let value = v.0;
        self.mColumnRuleWidth = value;
        self.mActualColumnRuleWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_column_rule_width_from(&mut self, other: &Self) {
        self.mColumnRuleWidth = other.mColumnRuleWidth;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.mActualColumnRuleWidth = other.mColumnRuleWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_width(&mut self, other: &Self) {
        self.copy_column_rule_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_column_rule_width(&self) -> Au {
        Au(self.mActualColumnRuleWidth)
    }


    pub fn column_rule_has_nonzero_width(&self) -> bool {
        self.mActualColumnRuleWidth != 0
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_column_width(&mut self, v: longhands::column_width::computed_value::T) {
        self.mColumnWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_width_from(&mut self, other: &Self) {
        self.mColumnWidth = other.mColumnWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_width(&mut self, other: &Self) {
        self.copy_column_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_width(&self) -> longhands::column_width::computed_value::T {
        From::from(self.mColumnWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_fill(&mut self, v: longhands::column_fill::computed_value::T) {
        use crate::properties::longhands::column_fill::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Balance =>
                    structs::StyleColumnFill::Balance ,
                Keyword::Auto =>
                    structs::StyleColumnFill::Auto ,
        };
        self.mColumnFill = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_column_fill_from(&mut self, other: &Self) {
        self.mColumnFill = other.mColumnFill.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_fill(&mut self, other: &Self) {
        self.copy_column_fill_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_fill(&self) -> longhands::column_fill::computed_value::T {
        use crate::properties::longhands::column_fill::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mColumnFill {
            structs::StyleColumnFill::Balance => Keyword::Balance,
            structs::StyleColumnFill::Auto => Keyword::Auto,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_column_rule_color(&mut self, v: longhands::column_rule_color::computed_value::T) {
        self.mColumnRuleColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_rule_color_from(&mut self, other: &Self) {
        self.mColumnRuleColor = other.mColumnRuleColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_color(&mut self, other: &Self) {
        self.copy_column_rule_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_rule_color(&self) -> longhands::column_rule_color::computed_value::T {
        From::from(self.mColumnRuleColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_span(&mut self, v: longhands::column_span::computed_value::T) {
        use crate::properties::longhands::column_span::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleColumnSpan::None ,
                Keyword::All =>
                    structs::StyleColumnSpan::All ,
        };
        self.mColumnSpan = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_column_span_from(&mut self, other: &Self) {
        self.mColumnSpan = other.mColumnSpan.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_span(&mut self, other: &Self) {
        self.copy_column_span_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_span(&self) -> longhands::column_span::computed_value::T {
        use crate::properties::longhands::column_span::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mColumnSpan {
            structs::StyleColumnSpan::None => Keyword::None,
            structs::StyleColumnSpan::All => Keyword::All,
        }
    }


}




impl GeckoCounters {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn ineffective_content_property(&self) -> bool {
        !self.mContent.is_items()
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_content(&mut self, v: longhands::content::computed_value::T) {
        self.mContent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_content_from(&mut self, other: &Self) {
        self.mContent = other.mContent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_content(&mut self, other: &Self) {
        self.copy_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_content(&self) -> longhands::content::computed_value::T {
        From::from(self.mContent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_counter_increment(&mut self, v: longhands::counter_increment::computed_value::T) {
        self.mCounterIncrement = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_counter_increment_from(&mut self, other: &Self) {
        self.mCounterIncrement = other.mCounterIncrement.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_counter_increment(&mut self, other: &Self) {
        self.copy_counter_increment_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_counter_increment(&self) -> longhands::counter_increment::computed_value::T {
        From::from(self.mCounterIncrement.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_counter_reset(&mut self, v: longhands::counter_reset::computed_value::T) {
        self.mCounterReset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_counter_reset_from(&mut self, other: &Self) {
        self.mCounterReset = other.mCounterReset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_counter_reset(&mut self, other: &Self) {
        self.copy_counter_reset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_counter_reset(&self) -> longhands::counter_reset::computed_value::T {
        From::from(self.mCounterReset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_counter_set(&mut self, v: longhands::counter_set::computed_value::T) {
        self.mCounterSet = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_counter_set_from(&mut self, other: &Self) {
        self.mCounterSet = other.mCounterSet.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_counter_set(&mut self, other: &Self) {
        self.copy_counter_set_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_counter_set(&self) -> longhands::counter_set::computed_value::T {
        From::from(self.mCounterSet.clone())
    }


}






impl GeckoUI {
    /*
     * Manually-Implemented Methods.
     */
    
    
    #[allow(non_snake_case)]
    pub fn set_transition_delay<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::transition_delay::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mTransitions.ensure_len(input_len);

        self.mTransitionDelayCount = input_len as u32;
        for (gecko, servo) in self.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDelay = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_delay_at(&self, index: usize)
        -> longhands::transition_delay::computed_value::SingleComputedValue {
        self.mTransitions[index % self.transition_delay_count()].mDelay.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_transition_delay_from(&mut self, other: &Self) {
        self.mTransitions.ensure_len(other.mTransitions.len());

        let count = other.mTransitionDelayCount;
        self.mTransitionDelayCount = count;

        let iter = self.mTransitions.iter_mut().take(count as usize).zip(
            other.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mDelay = others.mDelay.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_transition_delay(&mut self, other: &Self) {
        self.copy_transition_delay_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn transition_delay_count(&self) -> usize {
        self.mTransitionDelayCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_transition_duration<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::transition_duration::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mTransitions.ensure_len(input_len);

        self.mTransitionDurationCount = input_len as u32;
        for (gecko, servo) in self.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDuration = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_duration_at(&self, index: usize)
        -> longhands::transition_duration::computed_value::SingleComputedValue {
        self.mTransitions[index % self.transition_duration_count()].mDuration.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_transition_duration_from(&mut self, other: &Self) {
        self.mTransitions.ensure_len(other.mTransitions.len());

        let count = other.mTransitionDurationCount;
        self.mTransitionDurationCount = count;

        let iter = self.mTransitions.iter_mut().take(count as usize).zip(
            other.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mDuration = others.mDuration.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_transition_duration(&mut self, other: &Self) {
        self.copy_transition_duration_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn transition_duration_count(&self) -> usize {
        self.mTransitionDurationCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_transition_timing_function<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::transition_timing_function::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mTransitions.ensure_len(input_len);

        self.mTransitionTimingFunctionCount = input_len as u32;
        for (gecko, servo) in self.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimingFunction = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_timing_function_at(&self, index: usize)
        -> longhands::transition_timing_function::computed_value::SingleComputedValue {
        self.mTransitions[index % self.transition_timing_function_count()].mTimingFunction.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_transition_timing_function_from(&mut self, other: &Self) {
        self.mTransitions.ensure_len(other.mTransitions.len());

        let count = other.mTransitionTimingFunctionCount;
        self.mTransitionTimingFunctionCount = count;

        let iter = self.mTransitions.iter_mut().take(count as usize).zip(
            other.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mTimingFunction = others.mTimingFunction.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_transition_timing_function(&mut self, other: &Self) {
        self.copy_transition_timing_function_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn transition_timing_function_count(&self) -> usize {
        self.mTransitionTimingFunctionCount as usize
    }



    pub fn transition_combined_duration_at(&self, index: usize) -> Time {
        // https://drafts.csswg.org/css-transitions/#transition-combined-duration
        Time::from_seconds(
            self.transition_duration_at(index).seconds().max(0.0) +
            self.transition_delay_at(index).seconds()
        )
    }

    pub fn set_transition_property<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::transition_property::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_no_properties;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;

        let v = v.into_iter();

        if v.len() != 0 {
            self.mTransitions.ensure_len(v.len());
            self.mTransitionPropertyCount = v.len() as u32;
            for (servo, gecko) in v.zip(self.mTransitions.iter_mut()) {
                unsafe { gecko.mUnknownProperty.clear() };

                match servo {
                    TransitionProperty::Unsupported(ident) => {
                        gecko.mProperty = eCSSProperty_UNKNOWN;
                        gecko.mUnknownProperty.mRawPtr = ident.0.into_addrefed();
                    },
                    TransitionProperty::Custom(name) => {
                        gecko.mProperty = eCSSPropertyExtra_variable;
                        gecko.mUnknownProperty.mRawPtr = name.into_addrefed();
                    }
                    _ => gecko.mProperty = servo.to_nscsspropertyid().unwrap(),
                }
            }
        } else {
            // In gecko |none| is represented by eCSSPropertyExtra_no_properties.
            self.mTransitionPropertyCount = 1;
            self.mTransitions[0].mProperty = eCSSPropertyExtra_no_properties;
        }
    }

    /// Returns whether there are any transitions specified.
    pub fn specifies_transitions(&self) -> bool {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_all_properties;
        if self.mTransitionPropertyCount == 1 &&
            self.mTransitions[0].mProperty == eCSSPropertyExtra_all_properties &&
            self.transition_combined_duration_at(0).seconds() <= 0.0f32 {
            return false;
        }

        self.mTransitionPropertyCount > 0
    }

    pub fn transition_property_at(&self, index: usize)
        -> longhands::transition_property::computed_value::SingleComputedValue {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_no_properties;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;

        let property = self.mTransitions[index].mProperty;
        if property == eCSSProperty_UNKNOWN {
            let atom = self.mTransitions[index].mUnknownProperty.mRawPtr;
            debug_assert!(!atom.is_null());
            TransitionProperty::Unsupported(CustomIdent(unsafe{
                Atom::from_raw(atom)
            }))
        } else if property == eCSSPropertyExtra_variable {
            let atom = self.mTransitions[index].mUnknownProperty.mRawPtr;
            debug_assert!(!atom.is_null());
            TransitionProperty::Custom(unsafe{
                Atom::from_raw(atom)
            })
        } else if property == eCSSPropertyExtra_no_properties {
            // Actually, we don't expect TransitionProperty::Unsupported also
            // represents "none", but if the caller wants to convert it, it is
            // fine. Please use it carefully.
            //
            // FIXME(emilio): This is a hack, is this reachable?
            TransitionProperty::Unsupported(CustomIdent(atom!("none")))
        } else {
            property.into()
        }
    }

    pub fn transition_nscsspropertyid_at(&self, index: usize) -> nsCSSPropertyID {
        self.mTransitions[index].mProperty
    }

    pub fn copy_transition_property_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;
        self.mTransitions.ensure_len(other.mTransitions.len());

        let count = other.mTransitionPropertyCount;
        self.mTransitionPropertyCount = count;

        for (index, transition) in self.mTransitions.iter_mut().enumerate().take(count as usize) {
            transition.mProperty = other.mTransitions[index].mProperty;
            unsafe { transition.mUnknownProperty.clear() };
            if transition.mProperty == eCSSProperty_UNKNOWN ||
               transition.mProperty == eCSSPropertyExtra_variable {
                let atom = other.mTransitions[index].mUnknownProperty.mRawPtr;
                debug_assert!(!atom.is_null());
                transition.mUnknownProperty.mRawPtr = unsafe { Atom::from_raw(atom) }.into_addrefed();
            }
        }
    }

    pub fn reset_transition_property(&mut self, other: &Self) {
        self.copy_transition_property_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn transition_property_count(&self) -> usize {
        self.mTransitionPropertyCount as usize
    }


    pub fn animations_equals(&self, other: &Self) -> bool {
        return self.mAnimationNameCount == other.mAnimationNameCount
            && self.mAnimationDelayCount == other.mAnimationDelayCount
            && self.mAnimationDirectionCount == other.mAnimationDirectionCount
            && self.mAnimationDurationCount == other.mAnimationDurationCount
            && self.mAnimationFillModeCount == other.mAnimationFillModeCount
            && self.mAnimationIterationCountCount == other.mAnimationIterationCountCount
            && self.mAnimationPlayStateCount == other.mAnimationPlayStateCount
            && self.mAnimationTimingFunctionCount == other.mAnimationTimingFunctionCount
            && self.mAnimationCompositionCount == other.mAnimationCompositionCount
            && self.mAnimationTimelineCount == other.mAnimationTimelineCount
            && unsafe { bindings::Gecko_StyleAnimationsEquals(&self.mAnimations, &other.mAnimations) }
    }

    pub fn set_animation_name<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_name::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        self.mAnimations.ensure_len(v.len());

        self.mAnimationNameCount = v.len() as u32;
        for (servo, gecko) in v.zip(self.mAnimations.iter_mut()) {
            let atom = servo.0.as_atom().clone();
            unsafe { bindings::Gecko_SetAnimationName(gecko, atom.into_addrefed()); }
        }
    }
    pub fn animation_name_at(&self, index: usize)
        -> longhands::animation_name::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_name::single_value::SpecifiedValue as AnimationName;

        let atom = self.mAnimations[index].mName.mRawPtr;
        AnimationName(KeyframesName::from_atom(unsafe { Atom::from_raw(atom) }))
    }
    pub fn copy_animation_name_from(&mut self, other: &Self) {
        self.mAnimationNameCount = other.mAnimationNameCount;
        unsafe { bindings::Gecko_CopyAnimationNames(&mut self.mAnimations, &other.mAnimations); }
    }

    pub fn reset_animation_name(&mut self, other: &Self) {
        self.copy_animation_name_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_name_count(&self) -> usize {
        self.mAnimationNameCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn set_animation_delay<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_delay::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationDelayCount = input_len as u32;
        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDelay = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_delay_at(&self, index: usize)
        -> longhands::animation_delay::computed_value::SingleComputedValue {
        self.mAnimations[index % self.animation_delay_count()].mDelay.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_delay_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationDelayCount;
        self.mAnimationDelayCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDelay = others.mDelay.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_delay(&mut self, other: &Self) {
        self.copy_animation_delay_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_delay_count(&self) -> usize {
        self.mAnimationDelayCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_animation_duration<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_duration::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationDurationCount = input_len as u32;
        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDuration = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_duration_at(&self, index: usize)
        -> longhands::animation_duration::computed_value::SingleComputedValue {
        self.mAnimations[index % self.animation_duration_count()].mDuration.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_duration_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationDurationCount;
        self.mAnimationDurationCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDuration = others.mDuration.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_duration(&mut self, other: &Self) {
        self.copy_animation_duration_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_duration_count(&self) -> usize {
        self.mAnimationDurationCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_animation_direction<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_direction::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_direction::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationDirectionCount = input_len as u32;

        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Normal =>
                        structs::PlaybackDirection::Normal ,
                    Keyword::Reverse =>
                        structs::PlaybackDirection::Reverse ,
                    Keyword::Alternate =>
                        structs::PlaybackDirection::Alternate ,
                    Keyword::AlternateReverse =>
                        structs::PlaybackDirection::Alternate_reverse ,
            };
            gecko.mDirection = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_direction_at(&self, index: usize)
        -> longhands::animation_direction::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_direction::single_value::computed_value::T as Keyword;
        match self.mAnimations[index].mDirection  {
                structs::PlaybackDirection::Normal => Keyword::Normal,
                structs::PlaybackDirection::Reverse => Keyword::Reverse,
                structs::PlaybackDirection::Alternate => Keyword::Alternate,
                structs::PlaybackDirection::Alternate_reverse => Keyword::AlternateReverse,
            _ => panic!("Found unexpected value for animation-direction"),
        }
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_direction_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationDirectionCount;
        self.mAnimationDirectionCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDirection = others.mDirection.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_direction(&mut self, other: &Self) {
        self.copy_animation_direction_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_direction_count(&self) -> usize {
        self.mAnimationDirectionCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_animation_fill_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_fill_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_fill_mode::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationFillModeCount = input_len as u32;

        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::None =>
                        structs::FillMode::None ,
                    Keyword::Forwards =>
                        structs::FillMode::Forwards ,
                    Keyword::Backwards =>
                        structs::FillMode::Backwards ,
                    Keyword::Both =>
                        structs::FillMode::Both ,
            };
            gecko.mFillMode = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_fill_mode_at(&self, index: usize)
        -> longhands::animation_fill_mode::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_fill_mode::single_value::computed_value::T as Keyword;
        match self.mAnimations[index].mFillMode  {
                structs::FillMode::None => Keyword::None,
                structs::FillMode::Forwards => Keyword::Forwards,
                structs::FillMode::Backwards => Keyword::Backwards,
                structs::FillMode::Both => Keyword::Both,
            _ => panic!("Found unexpected value for animation-fill_mode"),
        }
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_fill_mode_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationFillModeCount;
        self.mAnimationFillModeCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mFillMode = others.mFillMode.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_fill_mode(&mut self, other: &Self) {
        self.copy_animation_fill_mode_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_fill_mode_count(&self) -> usize {
        self.mAnimationFillModeCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_animation_play_state<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_play_state::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_play_state::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationPlayStateCount = input_len as u32;

        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Running =>
                        structs::StyleAnimationPlayState::Running ,
                    Keyword::Paused =>
                        structs::StyleAnimationPlayState::Paused ,
            };
            gecko.mPlayState = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_play_state_at(&self, index: usize)
        -> longhands::animation_play_state::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_play_state::single_value::computed_value::T as Keyword;
        match self.mAnimations[index].mPlayState  {
                structs::StyleAnimationPlayState::Running => Keyword::Running,
                structs::StyleAnimationPlayState::Paused => Keyword::Paused,
        }
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_play_state_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationPlayStateCount;
        self.mAnimationPlayStateCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mPlayState = others.mPlayState.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_play_state(&mut self, other: &Self) {
        self.copy_animation_play_state_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_play_state_count(&self) -> usize {
        self.mAnimationPlayStateCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_animation_composition<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_composition::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_composition::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationCompositionCount = input_len as u32;

        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Replace =>
                        structs::CompositeOperation::Replace ,
                    Keyword::Add =>
                        structs::CompositeOperation::Add ,
                    Keyword::Accumulate =>
                        structs::CompositeOperation::Accumulate ,
            };
            gecko.mComposition = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_composition_at(&self, index: usize)
        -> longhands::animation_composition::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_composition::single_value::computed_value::T as Keyword;
        match self.mAnimations[index].mComposition  {
                structs::CompositeOperation::Replace => Keyword::Replace,
                structs::CompositeOperation::Add => Keyword::Add,
                structs::CompositeOperation::Accumulate => Keyword::Accumulate,
            _ => panic!("Found unexpected value for animation-composition"),
        }
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_composition_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationCompositionCount;
        self.mAnimationCompositionCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mComposition = others.mComposition.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_composition(&mut self, other: &Self) {
        self.copy_animation_composition_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_composition_count(&self) -> usize {
        self.mAnimationCompositionCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_animation_iteration_count<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_iteration_count::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationIterationCountCount = input_len as u32;
        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mIterationCount = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_iteration_count_at(&self, index: usize)
        -> longhands::animation_iteration_count::computed_value::SingleComputedValue {
        self.mAnimations[index % self.animation_iteration_count_count()].mIterationCount.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_iteration_count_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationIterationCountCount;
        self.mAnimationIterationCountCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mIterationCount = others.mIterationCount.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_iteration_count(&mut self, other: &Self) {
        self.copy_animation_iteration_count_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_iteration_count_count(&self) -> usize {
        self.mAnimationIterationCountCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_animation_timeline<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_timeline::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationTimelineCount = input_len as u32;
        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimeline = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_timeline_at(&self, index: usize)
        -> longhands::animation_timeline::computed_value::SingleComputedValue {
        self.mAnimations[index % self.animation_timeline_count()].mTimeline.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_timeline_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationTimelineCount;
        self.mAnimationTimelineCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mTimeline = others.mTimeline.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_timeline(&mut self, other: &Self) {
        self.copy_animation_timeline_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_timeline_count(&self) -> usize {
        self.mAnimationTimelineCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_animation_timing_function<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_timing_function::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mAnimations.ensure_len(input_len);

        self.mAnimationTimingFunctionCount = input_len as u32;
        for (gecko, servo) in self.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimingFunction = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_timing_function_at(&self, index: usize)
        -> longhands::animation_timing_function::computed_value::SingleComputedValue {
        self.mAnimations[index % self.animation_timing_function_count()].mTimingFunction.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_animation_timing_function_from(&mut self, other: &Self) {
        self.mAnimations.ensure_len(other.mAnimations.len());

        let count = other.mAnimationTimingFunctionCount;
        self.mAnimationTimingFunctionCount = count;

        let iter = self.mAnimations.iter_mut().take(count as usize).zip(
            other.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mTimingFunction = others.mTimingFunction.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_animation_timing_function(&mut self, other: &Self) {
        self.copy_animation_timing_function_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn animation_timing_function_count(&self) -> usize {
        self.mAnimationTimingFunctionCount as usize
    }



    
    #[allow(non_snake_case)]
    pub fn set_scroll_timeline_name<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::scroll_timeline_name::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mScrollTimelines.ensure_len(input_len);

        self.mScrollTimelineNameCount = input_len as u32;
        for (gecko, servo) in self.mScrollTimelines.iter_mut().take(input_len as usize).zip(v) {
            gecko.mName = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn scroll_timeline_name_at(&self, index: usize)
        -> longhands::scroll_timeline_name::computed_value::SingleComputedValue {
        self.mScrollTimelines[index % self.scroll_timeline_name_count()].mName.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_scroll_timeline_name_from(&mut self, other: &Self) {
        self.mScrollTimelines.ensure_len(other.mScrollTimelines.len());

        let count = other.mScrollTimelineNameCount;
        self.mScrollTimelineNameCount = count;

        let iter = self.mScrollTimelines.iter_mut().take(count as usize).zip(
            other.mScrollTimelines.iter()
        );

        for (ours, others) in iter {
            ours.mName = others.mName.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_timeline_name(&mut self, other: &Self) {
        self.copy_scroll_timeline_name_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn scroll_timeline_name_count(&self) -> usize {
        self.mScrollTimelineNameCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_scroll_timeline_axis<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::scroll_timeline_axis::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mScrollTimelines.ensure_len(input_len);

        self.mScrollTimelineAxisCount = input_len as u32;
        for (gecko, servo) in self.mScrollTimelines.iter_mut().take(input_len as usize).zip(v) {
            gecko.mAxis = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn scroll_timeline_axis_at(&self, index: usize)
        -> longhands::scroll_timeline_axis::computed_value::SingleComputedValue {
        self.mScrollTimelines[index % self.scroll_timeline_axis_count()].mAxis.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_scroll_timeline_axis_from(&mut self, other: &Self) {
        self.mScrollTimelines.ensure_len(other.mScrollTimelines.len());

        let count = other.mScrollTimelineAxisCount;
        self.mScrollTimelineAxisCount = count;

        let iter = self.mScrollTimelines.iter_mut().take(count as usize).zip(
            other.mScrollTimelines.iter()
        );

        for (ours, others) in iter {
            ours.mAxis = others.mAxis.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_timeline_axis(&mut self, other: &Self) {
        self.copy_scroll_timeline_axis_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn scroll_timeline_axis_count(&self) -> usize {
        self.mScrollTimelineAxisCount as usize
    }



    pub fn scroll_timelines_equals(&self, other: &Self) -> bool {
        self.mScrollTimelineNameCount == other.mScrollTimelineNameCount
            && self.mScrollTimelineAxisCount == other.mScrollTimelineAxisCount
            && unsafe {
                bindings::Gecko_StyleScrollTimelinesEquals(
                    &self.mScrollTimelines,
                    &other.mScrollTimelines,
                )
            }
    }

    
    #[allow(non_snake_case)]
    pub fn set_view_timeline_name<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::view_timeline_name::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mViewTimelines.ensure_len(input_len);

        self.mViewTimelineNameCount = input_len as u32;
        for (gecko, servo) in self.mViewTimelines.iter_mut().take(input_len as usize).zip(v) {
            gecko.mName = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn view_timeline_name_at(&self, index: usize)
        -> longhands::view_timeline_name::computed_value::SingleComputedValue {
        self.mViewTimelines[index % self.view_timeline_name_count()].mName.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_view_timeline_name_from(&mut self, other: &Self) {
        self.mViewTimelines.ensure_len(other.mViewTimelines.len());

        let count = other.mViewTimelineNameCount;
        self.mViewTimelineNameCount = count;

        let iter = self.mViewTimelines.iter_mut().take(count as usize).zip(
            other.mViewTimelines.iter()
        );

        for (ours, others) in iter {
            ours.mName = others.mName.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_view_timeline_name(&mut self, other: &Self) {
        self.copy_view_timeline_name_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn view_timeline_name_count(&self) -> usize {
        self.mViewTimelineNameCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_view_timeline_axis<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::view_timeline_axis::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mViewTimelines.ensure_len(input_len);

        self.mViewTimelineAxisCount = input_len as u32;
        for (gecko, servo) in self.mViewTimelines.iter_mut().take(input_len as usize).zip(v) {
            gecko.mAxis = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn view_timeline_axis_at(&self, index: usize)
        -> longhands::view_timeline_axis::computed_value::SingleComputedValue {
        self.mViewTimelines[index % self.view_timeline_axis_count()].mAxis.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_view_timeline_axis_from(&mut self, other: &Self) {
        self.mViewTimelines.ensure_len(other.mViewTimelines.len());

        let count = other.mViewTimelineAxisCount;
        self.mViewTimelineAxisCount = count;

        let iter = self.mViewTimelines.iter_mut().take(count as usize).zip(
            other.mViewTimelines.iter()
        );

        for (ours, others) in iter {
            ours.mAxis = others.mAxis.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_view_timeline_axis(&mut self, other: &Self) {
        self.copy_view_timeline_axis_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn view_timeline_axis_count(&self) -> usize {
        self.mViewTimelineAxisCount as usize
    }


    
    #[allow(non_snake_case)]
    pub fn set_view_timeline_inset<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::view_timeline_inset::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.mViewTimelines.ensure_len(input_len);

        self.mViewTimelineInsetCount = input_len as u32;
        for (gecko, servo) in self.mViewTimelines.iter_mut().take(input_len as usize).zip(v) {
            gecko.mInset = servo;
        }
    }
    #[allow(non_snake_case)]
    pub fn view_timeline_inset_at(&self, index: usize)
        -> longhands::view_timeline_inset::computed_value::SingleComputedValue {
        self.mViewTimelines[index % self.view_timeline_inset_count()].mInset.clone()
    }
    
    #[allow(non_snake_case)]
    pub fn copy_view_timeline_inset_from(&mut self, other: &Self) {
        self.mViewTimelines.ensure_len(other.mViewTimelines.len());

        let count = other.mViewTimelineInsetCount;
        self.mViewTimelineInsetCount = count;

        let iter = self.mViewTimelines.iter_mut().take(count as usize).zip(
            other.mViewTimelines.iter()
        );

        for (ours, others) in iter {
            ours.mInset = others.mInset.clone();
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_view_timeline_inset(&mut self, other: &Self) {
        self.copy_view_timeline_inset_from(other)
    }

    
    #[allow(non_snake_case)]
    pub fn view_timeline_inset_count(&self) -> usize {
        self.mViewTimelineInsetCount as usize
    }



    pub fn view_timelines_equals(&self, other: &Self) -> bool {
        self.mViewTimelineNameCount == other.mViewTimelineNameCount
            && self.mViewTimelineAxisCount == other.mViewTimelineAxisCount
            && self.mViewTimelineInsetCount == other.mViewTimelineInsetCount
            && unsafe {
                bindings::Gecko_StyleViewTimelinesEquals(
                    &self.mViewTimelines,
                    &other.mViewTimelines,
                )
            }
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_ime_mode(&mut self, v: longhands::ime_mode::computed_value::T) {
        use crate::properties::longhands::ime_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleImeMode::Auto ,
                Keyword::Normal =>
                    structs::StyleImeMode::Normal ,
                Keyword::Active =>
                    structs::StyleImeMode::Active ,
                Keyword::Disabled =>
                    structs::StyleImeMode::Disabled ,
                Keyword::Inactive =>
                    structs::StyleImeMode::Inactive ,
        };
        self.mIMEMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ime_mode_from(&mut self, other: &Self) {
        self.mIMEMode = other.mIMEMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ime_mode(&mut self, other: &Self) {
        self.copy_ime_mode_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_ime_mode(&self) -> longhands::ime_mode::computed_value::T {
        use crate::properties::longhands::ime_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mIMEMode {
            structs::StyleImeMode::Auto => Keyword::Auto,
            structs::StyleImeMode::Normal => Keyword::Normal,
            structs::StyleImeMode::Active => Keyword::Active,
            structs::StyleImeMode::Disabled => Keyword::Disabled,
            structs::StyleImeMode::Inactive => Keyword::Inactive,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_width(&mut self, v: longhands::scrollbar_width::computed_value::T) {
        use crate::properties::longhands::scrollbar_width::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleScrollbarWidth::Auto ,
                Keyword::Thin =>
                    structs::StyleScrollbarWidth::Thin ,
                Keyword::None =>
                    structs::StyleScrollbarWidth::None ,
        };
        self.mScrollbarWidth = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_width_from(&mut self, other: &Self) {
        self.mScrollbarWidth = other.mScrollbarWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_width(&mut self, other: &Self) {
        self.copy_scrollbar_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scrollbar_width(&self) -> longhands::scrollbar_width::computed_value::T {
        use crate::properties::longhands::scrollbar_width::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mScrollbarWidth {
            structs::StyleScrollbarWidth::Auto => Keyword::Auto,
            structs::StyleScrollbarWidth::Thin => Keyword::Thin,
            structs::StyleScrollbarWidth::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_user_select(&mut self, v: longhands::user_select::computed_value::T) {
        self.mUserSelect = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_user_select_from(&mut self, other: &Self) {
        self.mUserSelect = other.mUserSelect.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_user_select(&mut self, other: &Self) {
        self.copy_user_select_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_user_select(&self) -> longhands::user_select::computed_value::T {
        From::from(self.mUserSelect.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_dragging(&mut self, v: longhands::_moz_window_dragging::computed_value::T) {
        use crate::properties::longhands::_moz_window_dragging::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Default =>
                    structs::StyleWindowDragging::Default ,
                Keyword::Drag =>
                    structs::StyleWindowDragging::Drag ,
                Keyword::NoDrag =>
                    structs::StyleWindowDragging::NoDrag ,
        };
        self.mWindowDragging = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_dragging_from(&mut self, other: &Self) {
        self.mWindowDragging = other.mWindowDragging.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_dragging(&mut self, other: &Self) {
        self.copy__moz_window_dragging_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_dragging(&self) -> longhands::_moz_window_dragging::computed_value::T {
        use crate::properties::longhands::_moz_window_dragging::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mWindowDragging {
            structs::StyleWindowDragging::Default => Keyword::Default,
            structs::StyleWindowDragging::Drag => Keyword::Drag,
            structs::StyleWindowDragging::NoDrag => Keyword::NoDrag,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_shadow(&mut self, v: longhands::_moz_window_shadow::computed_value::T) {
        use crate::properties::longhands::_moz_window_shadow::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Default =>
                    structs::StyleWindowShadow::Default ,
                Keyword::None =>
                    structs::StyleWindowShadow::None ,
        };
        self.mWindowShadow = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_shadow_from(&mut self, other: &Self) {
        self.mWindowShadow = other.mWindowShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_shadow(&mut self, other: &Self) {
        self.copy__moz_window_shadow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_shadow(&self) -> longhands::_moz_window_shadow::computed_value::T {
        use crate::properties::longhands::_moz_window_shadow::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mWindowShadow {
            structs::StyleWindowShadow::Default => Keyword::Default,
            structs::StyleWindowShadow::None => Keyword::None,
            _ => panic!("Found unexpected value in style struct for _moz_window_shadow property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_opacity(&mut self, v: longhands::_moz_window_opacity::computed_value::T) {
        self.mWindowOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_opacity_from(&mut self, other: &Self) {
        self.mWindowOpacity = other.mWindowOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_opacity(&mut self, other: &Self) {
        self.copy__moz_window_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_opacity(&self) -> longhands::_moz_window_opacity::computed_value::T {
        From::from(self.mWindowOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_transform(&mut self, v: longhands::_moz_window_transform::computed_value::T) {
        self.mMozWindowTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_transform_from(&mut self, other: &Self) {
        self.mMozWindowTransform = other.mMozWindowTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_transform(&mut self, other: &Self) {
        self.copy__moz_window_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform(&self) -> longhands::_moz_window_transform::computed_value::T {
        From::from(self.mMozWindowTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_transform_origin(&mut self, v: longhands::_moz_window_transform_origin::computed_value::T) {
        self.mWindowTransformOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_transform_origin_from(&mut self, other: &Self) {
        self.mWindowTransformOrigin = other.mWindowTransformOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_transform_origin(&mut self, other: &Self) {
        self.copy__moz_window_transform_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform_origin(&self) -> longhands::_moz_window_transform_origin::computed_value::T {
        From::from(self.mWindowTransformOrigin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_input_region_margin(&mut self, v: longhands::_moz_window_input_region_margin::computed_value::T) {
        self.mMozWindowInputRegionMargin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_input_region_margin_from(&mut self, other: &Self) {
        self.mMozWindowInputRegionMargin = other.mMozWindowInputRegionMargin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_input_region_margin(&mut self, other: &Self) {
        self.copy__moz_window_input_region_margin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_input_region_margin(&self) -> longhands::_moz_window_input_region_margin::computed_value::T {
        From::from(self.mMozWindowInputRegionMargin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_subtree_hidden_only_visually(&mut self, v: longhands::_moz_subtree_hidden_only_visually::computed_value::T) {
        self.mMozSubtreeHiddenOnlyVisually = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_subtree_hidden_only_visually_from(&mut self, other: &Self) {
        self.mMozSubtreeHiddenOnlyVisually = other.mMozSubtreeHiddenOnlyVisually.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_subtree_hidden_only_visually(&mut self, other: &Self) {
        self.copy__moz_subtree_hidden_only_visually_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_subtree_hidden_only_visually(&self) -> longhands::_moz_subtree_hidden_only_visually::computed_value::T {
        From::from(self.mMozSubtreeHiddenOnlyVisually.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_force_broken_image_icon(&mut self, v: longhands::_moz_force_broken_image_icon::computed_value::T) {
        self.mMozForceBrokenImageIcon = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_force_broken_image_icon_from(&mut self, other: &Self) {
        self.mMozForceBrokenImageIcon = other.mMozForceBrokenImageIcon.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_force_broken_image_icon(&mut self, other: &Self) {
        self.copy__moz_force_broken_image_icon_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_force_broken_image_icon(&self) -> longhands::_moz_force_broken_image_icon::computed_value::T {
        From::from(self.mMozForceBrokenImageIcon.clone())
    }


}




impl GeckoXUL {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set__moz_box_align(&mut self, v: longhands::_moz_box_align::computed_value::T) {
        use crate::properties::longhands::_moz_box_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Stretch =>
                    structs::StyleBoxAlign::Stretch ,
                Keyword::Start =>
                    structs::StyleBoxAlign::Start ,
                Keyword::Center =>
                    structs::StyleBoxAlign::Center ,
                Keyword::Baseline =>
                    structs::StyleBoxAlign::Baseline ,
                Keyword::End =>
                    structs::StyleBoxAlign::End ,
        };
        self.mBoxAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_align_from(&mut self, other: &Self) {
        self.mBoxAlign = other.mBoxAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_align(&mut self, other: &Self) {
        self.copy__moz_box_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_align(&self) -> longhands::_moz_box_align::computed_value::T {
        use crate::properties::longhands::_moz_box_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mBoxAlign {
            structs::StyleBoxAlign::Stretch => Keyword::Stretch,
            structs::StyleBoxAlign::Start => Keyword::Start,
            structs::StyleBoxAlign::Center => Keyword::Center,
            structs::StyleBoxAlign::Baseline => Keyword::Baseline,
            structs::StyleBoxAlign::End => Keyword::End,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_direction(&mut self, v: longhands::_moz_box_direction::computed_value::T) {
        use crate::properties::longhands::_moz_box_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleBoxDirection::Normal ,
                Keyword::Reverse =>
                    structs::StyleBoxDirection::Reverse ,
        };
        self.mBoxDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_direction_from(&mut self, other: &Self) {
        self.mBoxDirection = other.mBoxDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_direction(&mut self, other: &Self) {
        self.copy__moz_box_direction_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_direction(&self) -> longhands::_moz_box_direction::computed_value::T {
        use crate::properties::longhands::_moz_box_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mBoxDirection {
            structs::StyleBoxDirection::Normal => Keyword::Normal,
            structs::StyleBoxDirection::Reverse => Keyword::Reverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_flex(&mut self, v: longhands::_moz_box_flex::computed_value::T) {
        self.mBoxFlex = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_flex_from(&mut self, other: &Self) {
        self.mBoxFlex = other.mBoxFlex.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_flex(&mut self, other: &Self) {
        self.copy__moz_box_flex_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_flex(&self) -> longhands::_moz_box_flex::computed_value::T {
        From::from(self.mBoxFlex.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_orient(&mut self, v: longhands::_moz_box_orient::computed_value::T) {
        use crate::properties::longhands::_moz_box_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Horizontal =>
                    structs::StyleBoxOrient::Horizontal ,
                Keyword::Vertical =>
                    structs::StyleBoxOrient::Vertical ,
        };
        self.mBoxOrient = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_orient_from(&mut self, other: &Self) {
        self.mBoxOrient = other.mBoxOrient.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_orient(&mut self, other: &Self) {
        self.copy__moz_box_orient_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_orient(&self) -> longhands::_moz_box_orient::computed_value::T {
        use crate::properties::longhands::_moz_box_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mBoxOrient {
            structs::StyleBoxOrient::Horizontal => Keyword::Horizontal,
            structs::StyleBoxOrient::Vertical => Keyword::Vertical,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_pack(&mut self, v: longhands::_moz_box_pack::computed_value::T) {
        use crate::properties::longhands::_moz_box_pack::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::StyleBoxPack::Start ,
                Keyword::Center =>
                    structs::StyleBoxPack::Center ,
                Keyword::End =>
                    structs::StyleBoxPack::End ,
                Keyword::Justify =>
                    structs::StyleBoxPack::Justify ,
        };
        self.mBoxPack = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_pack_from(&mut self, other: &Self) {
        self.mBoxPack = other.mBoxPack.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_pack(&mut self, other: &Self) {
        self.copy__moz_box_pack_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_pack(&self) -> longhands::_moz_box_pack::computed_value::T {
        use crate::properties::longhands::_moz_box_pack::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.mBoxPack {
            structs::StyleBoxPack::Start => Keyword::Start,
            structs::StyleBoxPack::Center => Keyword::Center,
            structs::StyleBoxPack::End => Keyword::End,
            structs::StyleBoxPack::Justify => Keyword::Justify,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_ordinal_group(&mut self, v: longhands::_moz_box_ordinal_group::computed_value::T) {
        self.mBoxOrdinal = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_ordinal_group_from(&mut self, other: &Self) {
        self.mBoxOrdinal = other.mBoxOrdinal.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_ordinal_group(&mut self, other: &Self) {
        self.copy__moz_box_ordinal_group_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_ordinal_group(&self) -> longhands::_moz_box_ordinal_group::computed_value::T {
        From::from(self.mBoxOrdinal.clone())
    }


}



/// A wrapper for nsStyleBackground, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoBackground(ManuallyDrop<structs::nsStyleBackground>);

impl ops::Deref for GeckoBackground {
    type Target = structs::nsStyleBackground;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoBackground {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoBackground {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleBackground(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoBackground {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleBackground(&mut **self);
        }
    }
}
impl Clone for GeckoBackground {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleBackground(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleBorder, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoBorder(ManuallyDrop<structs::nsStyleBorder>);

impl ops::Deref for GeckoBorder {
    type Target = structs::nsStyleBorder;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoBorder {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoBorder {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleBorder(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoBorder {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleBorder(&mut **self);
        }
    }
}
impl Clone for GeckoBorder {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleBorder(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleDisplay, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoBox(ManuallyDrop<structs::nsStyleDisplay>);

impl ops::Deref for GeckoBox {
    type Target = structs::nsStyleDisplay;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoBox {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoBox {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleDisplay(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoBox {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleDisplay(&mut **self);
        }
    }
}
impl Clone for GeckoBox {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleDisplay(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleColumn, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoColumn(ManuallyDrop<structs::nsStyleColumn>);

impl ops::Deref for GeckoColumn {
    type Target = structs::nsStyleColumn;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoColumn {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoColumn {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleColumn(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoColumn {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleColumn(&mut **self);
        }
    }
}
impl Clone for GeckoColumn {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleColumn(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleContent, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoCounters(ManuallyDrop<structs::nsStyleContent>);

impl ops::Deref for GeckoCounters {
    type Target = structs::nsStyleContent;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoCounters {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoCounters {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleContent(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoCounters {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleContent(&mut **self);
        }
    }
}
impl Clone for GeckoCounters {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleContent(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleEffects, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoEffects(ManuallyDrop<structs::nsStyleEffects>);

impl ops::Deref for GeckoEffects {
    type Target = structs::nsStyleEffects;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoEffects {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoEffects {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleEffects(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoEffects {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleEffects(&mut **self);
        }
    }
}
impl Clone for GeckoEffects {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleEffects(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleFont, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoFont(ManuallyDrop<structs::nsStyleFont>);

impl ops::Deref for GeckoFont {
    type Target = structs::nsStyleFont;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoFont {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoFont {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleFont(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoFont {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleFont(&mut **self);
        }
    }
}
impl Clone for GeckoFont {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleFont(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleVisibility, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoInheritedBox(ManuallyDrop<structs::nsStyleVisibility>);

impl ops::Deref for GeckoInheritedBox {
    type Target = structs::nsStyleVisibility;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoInheritedBox {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoInheritedBox {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleVisibility(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoInheritedBox {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleVisibility(&mut **self);
        }
    }
}
impl Clone for GeckoInheritedBox {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleVisibility(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleSVG, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoInheritedSVG(ManuallyDrop<structs::nsStyleSVG>);

impl ops::Deref for GeckoInheritedSVG {
    type Target = structs::nsStyleSVG;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoInheritedSVG {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoInheritedSVG {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleSVG(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoInheritedSVG {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleSVG(&mut **self);
        }
    }
}
impl Clone for GeckoInheritedSVG {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleSVG(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleTableBorder, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoInheritedTable(ManuallyDrop<structs::nsStyleTableBorder>);

impl ops::Deref for GeckoInheritedTable {
    type Target = structs::nsStyleTableBorder;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoInheritedTable {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoInheritedTable {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleTableBorder(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoInheritedTable {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTableBorder(&mut **self);
        }
    }
}
impl Clone for GeckoInheritedTable {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleTableBorder(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleText, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoInheritedText(ManuallyDrop<structs::nsStyleText>);

impl ops::Deref for GeckoInheritedText {
    type Target = structs::nsStyleText;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoInheritedText {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoInheritedText {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleText(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoInheritedText {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleText(&mut **self);
        }
    }
}
impl Clone for GeckoInheritedText {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleText(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleUI, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoInheritedUI(ManuallyDrop<structs::nsStyleUI>);

impl ops::Deref for GeckoInheritedUI {
    type Target = structs::nsStyleUI;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoInheritedUI {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoInheritedUI {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleUI(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoInheritedUI {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleUI(&mut **self);
        }
    }
}
impl Clone for GeckoInheritedUI {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleUI(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleList, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoList(ManuallyDrop<structs::nsStyleList>);

impl ops::Deref for GeckoList {
    type Target = structs::nsStyleList;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoList {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoList {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleList(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoList {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleList(&mut **self);
        }
    }
}
impl Clone for GeckoList {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleList(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleMargin, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoMargin(ManuallyDrop<structs::nsStyleMargin>);

impl ops::Deref for GeckoMargin {
    type Target = structs::nsStyleMargin;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoMargin {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoMargin {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleMargin(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoMargin {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleMargin(&mut **self);
        }
    }
}
impl Clone for GeckoMargin {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleMargin(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleOutline, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoOutline(ManuallyDrop<structs::nsStyleOutline>);

impl ops::Deref for GeckoOutline {
    type Target = structs::nsStyleOutline;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoOutline {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoOutline {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleOutline(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoOutline {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleOutline(&mut **self);
        }
    }
}
impl Clone for GeckoOutline {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleOutline(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStylePage, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoPage(ManuallyDrop<structs::nsStylePage>);

impl ops::Deref for GeckoPage {
    type Target = structs::nsStylePage;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoPage {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoPage {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStylePage(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoPage {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePage(&mut **self);
        }
    }
}
impl Clone for GeckoPage {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStylePage(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStylePadding, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoPadding(ManuallyDrop<structs::nsStylePadding>);

impl ops::Deref for GeckoPadding {
    type Target = structs::nsStylePadding;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoPadding {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoPadding {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStylePadding(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoPadding {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePadding(&mut **self);
        }
    }
}
impl Clone for GeckoPadding {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStylePadding(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStylePosition, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoPosition(ManuallyDrop<structs::nsStylePosition>);

impl ops::Deref for GeckoPosition {
    type Target = structs::nsStylePosition;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoPosition {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoPosition {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStylePosition(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoPosition {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePosition(&mut **self);
        }
    }
}
impl Clone for GeckoPosition {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStylePosition(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleSVGReset, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoSVG(ManuallyDrop<structs::nsStyleSVGReset>);

impl ops::Deref for GeckoSVG {
    type Target = structs::nsStyleSVGReset;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoSVG {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoSVG {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleSVGReset(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoSVG {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleSVGReset(&mut **self);
        }
    }
}
impl Clone for GeckoSVG {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleSVGReset(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleTable, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoTable(ManuallyDrop<structs::nsStyleTable>);

impl ops::Deref for GeckoTable {
    type Target = structs::nsStyleTable;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoTable {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoTable {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleTable(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoTable {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTable(&mut **self);
        }
    }
}
impl Clone for GeckoTable {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleTable(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleTextReset, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoText(ManuallyDrop<structs::nsStyleTextReset>);

impl ops::Deref for GeckoText {
    type Target = structs::nsStyleTextReset;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoText {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoText {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleTextReset(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoText {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTextReset(&mut **self);
        }
    }
}
impl Clone for GeckoText {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleTextReset(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleUIReset, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoUI(ManuallyDrop<structs::nsStyleUIReset>);

impl ops::Deref for GeckoUI {
    type Target = structs::nsStyleUIReset;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoUI {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoUI {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleUIReset(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoUI {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleUIReset(&mut **self);
        }
    }
}
impl Clone for GeckoUI {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleUIReset(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// A wrapper for nsStyleXUL, to be able to manually construct / destruct /
/// clone it.
#[repr(transparent)]
pub struct GeckoXUL(ManuallyDrop<structs::nsStyleXUL>);

impl ops::Deref for GeckoXUL {
    type Target = structs::nsStyleXUL;
    #[inline]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl ops::DerefMut for GeckoXUL {
    #[inline]
    fn deref_mut(&mut self) -> &mut <Self as ops::Deref>::Target {
        &mut self.0
    }
}

impl GeckoXUL {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleXUL(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}

impl Drop for GeckoXUL {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleXUL(&mut **self);
        }
    }
}
impl Clone for GeckoXUL {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleXUL(result.as_mut_ptr() as *mut _, &**self);
            result.assume_init()
        }
    }
}


/// Assert that the initial values set in Gecko style struct constructors
/// match the values returned by `get_initial_value()` for each longhand.
#[cfg(feature = "gecko")]
#[inline]
pub fn assert_initial_values_match(data: &PerDocumentStyleData) {
    if cfg!(debug_assertions) {
        let data = data.borrow();
        let cv = data.stylist.device().default_computed_values();
        
        assert_eq!(
            cv.clone_align_content(),
            longhands::align_content::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(align_content),
                " must match longhands::",
                stringify!(align_content),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_align_items(),
            longhands::align_items::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(align_items),
                " must match longhands::",
                stringify!(align_items),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_align_self(),
            longhands::align_self::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(align_self),
                " must match longhands::",
                stringify!(align_self),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_aspect_ratio(),
            longhands::aspect_ratio::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(aspect_ratio),
                " must match longhands::",
                stringify!(aspect_ratio),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_backface_visibility(),
            longhands::backface_visibility::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(backface_visibility),
                " must match longhands::",
                stringify!(backface_visibility),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_baseline_source(),
            longhands::baseline_source::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(baseline_source),
                " must match longhands::",
                stringify!(baseline_source),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_collapse(),
            longhands::border_collapse::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_collapse),
                " must match longhands::",
                stringify!(border_collapse),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_repeat(),
            longhands::border_image_repeat::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_repeat),
                " must match longhands::",
                stringify!(border_image_repeat),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_box_decoration_break(),
            longhands::box_decoration_break::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(box_decoration_break),
                " must match longhands::",
                stringify!(box_decoration_break),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_box_sizing(),
            longhands::box_sizing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(box_sizing),
                " must match longhands::",
                stringify!(box_sizing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_break_inside(),
            longhands::break_inside::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(break_inside),
                " must match longhands::",
                stringify!(break_inside),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_caption_side(),
            longhands::caption_side::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(caption_side),
                " must match longhands::",
                stringify!(caption_side),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_clear(),
            longhands::clear::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(clear),
                " must match longhands::",
                stringify!(clear),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_color_interpolation(),
            longhands::color_interpolation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(color_interpolation),
                " must match longhands::",
                stringify!(color_interpolation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_color_interpolation_filters(),
            longhands::color_interpolation_filters::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(color_interpolation_filters),
                " must match longhands::",
                stringify!(color_interpolation_filters),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_count(),
            longhands::column_count::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_count),
                " must match longhands::",
                stringify!(column_count),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_fill(),
            longhands::column_fill::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_fill),
                " must match longhands::",
                stringify!(column_fill),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_span(),
            longhands::column_span::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_span),
                " must match longhands::",
                stringify!(column_span),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_contain(),
            longhands::contain::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(contain),
                " must match longhands::",
                stringify!(contain),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_container_type(),
            longhands::container_type::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(container_type),
                " must match longhands::",
                stringify!(container_type),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_content_visibility(),
            longhands::content_visibility::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(content_visibility),
                " must match longhands::",
                stringify!(content_visibility),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_direction(),
            longhands::direction::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(direction),
                " must match longhands::",
                stringify!(direction),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_display(),
            longhands::display::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(display),
                " must match longhands::",
                stringify!(display),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_dominant_baseline(),
            longhands::dominant_baseline::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(dominant_baseline),
                " must match longhands::",
                stringify!(dominant_baseline),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_empty_cells(),
            longhands::empty_cells::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(empty_cells),
                " must match longhands::",
                stringify!(empty_cells),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_direction(),
            longhands::flex_direction::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_direction),
                " must match longhands::",
                stringify!(flex_direction),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_wrap(),
            longhands::flex_wrap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_wrap),
                " must match longhands::",
                stringify!(flex_wrap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_float(),
            longhands::float::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(float),
                " must match longhands::",
                stringify!(float),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_kerning(),
            longhands::font_kerning::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_kerning),
                " must match longhands::",
                stringify!(font_kerning),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_language_override(),
            longhands::font_language_override::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_language_override),
                " must match longhands::",
                stringify!(font_language_override),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_optical_sizing(),
            longhands::font_optical_sizing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_optical_sizing),
                " must match longhands::",
                stringify!(font_optical_sizing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_size_adjust(),
            longhands::font_size_adjust::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_size_adjust),
                " must match longhands::",
                stringify!(font_size_adjust),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_stretch(),
            longhands::font_stretch::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_stretch),
                " must match longhands::",
                stringify!(font_stretch),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_style(),
            longhands::font_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_style),
                " must match longhands::",
                stringify!(font_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_caps(),
            longhands::font_variant_caps::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_caps),
                " must match longhands::",
                stringify!(font_variant_caps),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_east_asian(),
            longhands::font_variant_east_asian::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_east_asian),
                " must match longhands::",
                stringify!(font_variant_east_asian),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_emoji(),
            longhands::font_variant_emoji::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_emoji),
                " must match longhands::",
                stringify!(font_variant_emoji),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_ligatures(),
            longhands::font_variant_ligatures::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_ligatures),
                " must match longhands::",
                stringify!(font_variant_ligatures),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_numeric(),
            longhands::font_variant_numeric::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_numeric),
                " must match longhands::",
                stringify!(font_variant_numeric),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_position(),
            longhands::font_variant_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_position),
                " must match longhands::",
                stringify!(font_variant_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_weight(),
            longhands::font_weight::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_weight),
                " must match longhands::",
                stringify!(font_weight),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_forced_color_adjust(),
            longhands::forced_color_adjust::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(forced_color_adjust),
                " must match longhands::",
                stringify!(forced_color_adjust),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_auto_flow(),
            longhands::grid_auto_flow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_auto_flow),
                " must match longhands::",
                stringify!(grid_auto_flow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_hyphens(),
            longhands::hyphens::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(hyphens),
                " must match longhands::",
                stringify!(hyphens),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_image_orientation(),
            longhands::image_orientation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(image_orientation),
                " must match longhands::",
                stringify!(image_orientation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_image_rendering(),
            longhands::image_rendering::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(image_rendering),
                " must match longhands::",
                stringify!(image_rendering),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_ime_mode(),
            longhands::ime_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(ime_mode),
                " must match longhands::",
                stringify!(ime_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_initial_letter(),
            longhands::initial_letter::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(initial_letter),
                " must match longhands::",
                stringify!(initial_letter),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_isolation(),
            longhands::isolation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(isolation),
                " must match longhands::",
                stringify!(isolation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_justify_content(),
            longhands::justify_content::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(justify_content),
                " must match longhands::",
                stringify!(justify_content),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_justify_items(),
            longhands::justify_items::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(justify_items),
                " must match longhands::",
                stringify!(justify_items),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_justify_self(),
            longhands::justify_self::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(justify_self),
                " must match longhands::",
                stringify!(justify_self),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_line_break(),
            longhands::line_break::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(line_break),
                " must match longhands::",
                stringify!(line_break),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_list_style_position(),
            longhands::list_style_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(list_style_position),
                " must match longhands::",
                stringify!(list_style_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_type(),
            longhands::mask_type::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_type),
                " must match longhands::",
                stringify!(mask_type),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_masonry_auto_flow(),
            longhands::masonry_auto_flow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(masonry_auto_flow),
                " must match longhands::",
                stringify!(masonry_auto_flow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_math_depth(),
            longhands::math_depth::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(math_depth),
                " must match longhands::",
                stringify!(math_depth),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_math_style(),
            longhands::math_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(math_style),
                " must match longhands::",
                stringify!(math_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mix_blend_mode(),
            longhands::mix_blend_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mix_blend_mode),
                " must match longhands::",
                stringify!(mix_blend_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_align(),
            longhands::_moz_box_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_align),
                " must match longhands::",
                stringify!(_moz_box_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_collapse(),
            longhands::_moz_box_collapse::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_collapse),
                " must match longhands::",
                stringify!(_moz_box_collapse),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_direction(),
            longhands::_moz_box_direction::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_direction),
                " must match longhands::",
                stringify!(_moz_box_direction),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_orient(),
            longhands::_moz_box_orient::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_orient),
                " must match longhands::",
                stringify!(_moz_box_orient),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_pack(),
            longhands::_moz_box_pack::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_pack),
                " must match longhands::",
                stringify!(_moz_box_pack),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_control_character_visibility(),
            longhands::_moz_control_character_visibility::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_control_character_visibility),
                " must match longhands::",
                stringify!(_moz_control_character_visibility),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_float_edge(),
            longhands::_moz_float_edge::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_float_edge),
                " must match longhands::",
                stringify!(_moz_float_edge),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_inert(),
            longhands::_moz_inert::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_inert),
                " must match longhands::",
                stringify!(_moz_inert),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_min_font_size_ratio(),
            longhands::_moz_min_font_size_ratio::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_min_font_size_ratio),
                " must match longhands::",
                stringify!(_moz_min_font_size_ratio),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_orient(),
            longhands::_moz_orient::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_orient),
                " must match longhands::",
                stringify!(_moz_orient),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_osx_font_smoothing(),
            longhands::_moz_osx_font_smoothing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_osx_font_smoothing),
                " must match longhands::",
                stringify!(_moz_osx_font_smoothing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_text_size_adjust(),
            longhands::_moz_text_size_adjust::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_text_size_adjust),
                " must match longhands::",
                stringify!(_moz_text_size_adjust),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_top_layer(),
            longhands::_moz_top_layer::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_top_layer),
                " must match longhands::",
                stringify!(_moz_top_layer),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_user_focus(),
            longhands::_moz_user_focus::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_user_focus),
                " must match longhands::",
                stringify!(_moz_user_focus),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_user_input(),
            longhands::_moz_user_input::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_user_input),
                " must match longhands::",
                stringify!(_moz_user_input),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_user_modify(),
            longhands::_moz_user_modify::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_user_modify),
                " must match longhands::",
                stringify!(_moz_user_modify),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_dragging(),
            longhands::_moz_window_dragging::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_dragging),
                " must match longhands::",
                stringify!(_moz_window_dragging),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_shadow(),
            longhands::_moz_window_shadow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_shadow),
                " must match longhands::",
                stringify!(_moz_window_shadow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_object_fit(),
            longhands::object_fit::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(object_fit),
                " must match longhands::",
                stringify!(object_fit),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_rotate(),
            longhands::offset_rotate::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_rotate),
                " must match longhands::",
                stringify!(offset_rotate),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_outline_style(),
            longhands::outline_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(outline_style),
                " must match longhands::",
                stringify!(outline_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_anchor(),
            longhands::overflow_anchor::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_anchor),
                " must match longhands::",
                stringify!(overflow_anchor),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_wrap(),
            longhands::overflow_wrap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_wrap),
                " must match longhands::",
                stringify!(overflow_wrap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_page_orientation(),
            longhands::page_orientation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(page_orientation),
                " must match longhands::",
                stringify!(page_orientation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_paint_order(),
            longhands::paint_order::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(paint_order),
                " must match longhands::",
                stringify!(paint_order),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_pointer_events(),
            longhands::pointer_events::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(pointer_events),
                " must match longhands::",
                stringify!(pointer_events),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_position(),
            longhands::position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(position),
                " must match longhands::",
                stringify!(position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_print_color_adjust(),
            longhands::print_color_adjust::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(print_color_adjust),
                " must match longhands::",
                stringify!(print_color_adjust),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_resize(),
            longhands::resize::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(resize),
                " must match longhands::",
                stringify!(resize),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_ruby_align(),
            longhands::ruby_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(ruby_align),
                " must match longhands::",
                stringify!(ruby_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_ruby_position(),
            longhands::ruby_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(ruby_position),
                " must match longhands::",
                stringify!(ruby_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_behavior(),
            longhands::scroll_behavior::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_behavior),
                " must match longhands::",
                stringify!(scroll_behavior),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_snap_align(),
            longhands::scroll_snap_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_snap_align),
                " must match longhands::",
                stringify!(scroll_snap_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_snap_stop(),
            longhands::scroll_snap_stop::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_snap_stop),
                " must match longhands::",
                stringify!(scroll_snap_stop),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_snap_type(),
            longhands::scroll_snap_type::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_snap_type),
                " must match longhands::",
                stringify!(scroll_snap_type),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scrollbar_gutter(),
            longhands::scrollbar_gutter::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scrollbar_gutter),
                " must match longhands::",
                stringify!(scrollbar_gutter),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scrollbar_width(),
            longhands::scrollbar_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scrollbar_width),
                " must match longhands::",
                stringify!(scrollbar_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_shape_rendering(),
            longhands::shape_rendering::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(shape_rendering),
                " must match longhands::",
                stringify!(shape_rendering),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_linecap(),
            longhands::stroke_linecap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_linecap),
                " must match longhands::",
                stringify!(stroke_linecap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_linejoin(),
            longhands::stroke_linejoin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_linejoin),
                " must match longhands::",
                stringify!(stroke_linejoin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_table_layout(),
            longhands::table_layout::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(table_layout),
                " must match longhands::",
                stringify!(table_layout),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_align(),
            longhands::text_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_align),
                " must match longhands::",
                stringify!(text_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_align_last(),
            longhands::text_align_last::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_align_last),
                " must match longhands::",
                stringify!(text_align_last),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_anchor(),
            longhands::text_anchor::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_anchor),
                " must match longhands::",
                stringify!(text_anchor),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_combine_upright(),
            longhands::text_combine_upright::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_combine_upright),
                " must match longhands::",
                stringify!(text_combine_upright),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_line(),
            longhands::text_decoration_line::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_line),
                " must match longhands::",
                stringify!(text_decoration_line),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_skip_ink(),
            longhands::text_decoration_skip_ink::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_skip_ink),
                " must match longhands::",
                stringify!(text_decoration_skip_ink),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_style(),
            longhands::text_decoration_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_style),
                " must match longhands::",
                stringify!(text_decoration_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_emphasis_position(),
            longhands::text_emphasis_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_emphasis_position),
                " must match longhands::",
                stringify!(text_emphasis_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_justify(),
            longhands::text_justify::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_justify),
                " must match longhands::",
                stringify!(text_justify),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_orientation(),
            longhands::text_orientation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_orientation),
                " must match longhands::",
                stringify!(text_orientation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_rendering(),
            longhands::text_rendering::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_rendering),
                " must match longhands::",
                stringify!(text_rendering),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_transform(),
            longhands::text_transform::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_transform),
                " must match longhands::",
                stringify!(text_transform),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_underline_position(),
            longhands::text_underline_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_underline_position),
                " must match longhands::",
                stringify!(text_underline_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_touch_action(),
            longhands::touch_action::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(touch_action),
                " must match longhands::",
                stringify!(touch_action),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transform_box(),
            longhands::transform_box::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transform_box),
                " must match longhands::",
                stringify!(transform_box),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transform_style(),
            longhands::transform_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transform_style),
                " must match longhands::",
                stringify!(transform_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_unicode_bidi(),
            longhands::unicode_bidi::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(unicode_bidi),
                " must match longhands::",
                stringify!(unicode_bidi),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_user_select(),
            longhands::user_select::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(user_select),
                " must match longhands::",
                stringify!(user_select),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_vector_effect(),
            longhands::vector_effect::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(vector_effect),
                " must match longhands::",
                stringify!(vector_effect),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_visibility(),
            longhands::visibility::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(visibility),
                " must match longhands::",
                stringify!(visibility),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_line_clamp(),
            longhands::_webkit_line_clamp::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_line_clamp),
                " must match longhands::",
                stringify!(_webkit_line_clamp),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_text_security(),
            longhands::_webkit_text_security::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_text_security),
                " must match longhands::",
                stringify!(_webkit_text_security),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_white_space(),
            longhands::white_space::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(white_space),
                " must match longhands::",
                stringify!(white_space),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_word_break(),
            longhands::word_break::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(word_break),
                " must match longhands::",
                stringify!(word_break),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_writing_mode(),
            longhands::writing_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(writing_mode),
                " must match longhands::",
                stringify!(writing_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_z_index(),
            longhands::z_index::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(z_index),
                " must match longhands::",
                stringify!(z_index),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_appearance(),
            longhands::appearance::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(appearance),
                " must match longhands::",
                stringify!(appearance),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_default_appearance(),
            longhands::_moz_default_appearance::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_default_appearance),
                " must match longhands::",
                stringify!(_moz_default_appearance),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_force_broken_image_icon(),
            longhands::_moz_force_broken_image_icon::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_force_broken_image_icon),
                " must match longhands::",
                stringify!(_moz_force_broken_image_icon),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_subtree_hidden_only_visually(),
            longhands::_moz_subtree_hidden_only_visually::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_subtree_hidden_only_visually),
                " must match longhands::",
                stringify!(_moz_subtree_hidden_only_visually),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_break_after(),
            longhands::break_after::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(break_after),
                " must match longhands::",
                stringify!(break_after),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_break_before(),
            longhands::break_before::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(break_before),
                " must match longhands::",
                stringify!(break_before),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_clip_rule(),
            longhands::clip_rule::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(clip_rule),
                " must match longhands::",
                stringify!(clip_rule),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_fill_rule(),
            longhands::fill_rule::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(fill_rule),
                " must match longhands::",
                stringify!(fill_rule),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_clip_box_block(),
            longhands::overflow_clip_box_block::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_clip_box_block),
                " must match longhands::",
                stringify!(overflow_clip_box_block),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_clip_box_inline(),
            longhands::overflow_clip_box_inline::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_clip_box_inline),
                " must match longhands::",
                stringify!(overflow_clip_box_inline),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_fill_opacity(),
            longhands::fill_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(fill_opacity),
                " must match longhands::",
                stringify!(fill_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_opacity(),
            longhands::stroke_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_opacity),
                " must match longhands::",
                stringify!(stroke_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_synthesis_small_caps(),
            longhands::font_synthesis_small_caps::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_synthesis_small_caps),
                " must match longhands::",
                stringify!(font_synthesis_small_caps),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_synthesis_style(),
            longhands::font_synthesis_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_synthesis_style),
                " must match longhands::",
                stringify!(font_synthesis_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_synthesis_weight(),
            longhands::font_synthesis_weight::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_synthesis_weight),
                " must match longhands::",
                stringify!(font_synthesis_weight),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_ordinal_group(),
            longhands::_moz_box_ordinal_group::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_ordinal_group),
                " must match longhands::",
                stringify!(_moz_box_ordinal_group),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_order(),
            longhands::order::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(order),
                " must match longhands::",
                stringify!(order),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_grow(),
            longhands::flex_grow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_grow),
                " must match longhands::",
                stringify!(flex_grow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_shrink(),
            longhands::flex_shrink::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_shrink),
                " must match longhands::",
                stringify!(flex_shrink),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_flex(),
            longhands::_moz_box_flex::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_flex),
                " must match longhands::",
                stringify!(_moz_box_flex),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_miterlimit(),
            longhands::stroke_miterlimit::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_miterlimit),
                " must match longhands::",
                stringify!(stroke_miterlimit),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_x(),
            longhands::overflow_x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_x),
                " must match longhands::",
                stringify!(overflow_x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_y(),
            longhands::overflow_y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_y),
                " must match longhands::",
                stringify!(overflow_y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overscroll_behavior_x(),
            longhands::overscroll_behavior_x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overscroll_behavior_x),
                " must match longhands::",
                stringify!(overscroll_behavior_x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overscroll_behavior_y(),
            longhands::overscroll_behavior_y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overscroll_behavior_y),
                " must match longhands::",
                stringify!(overscroll_behavior_y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flood_opacity(),
            longhands::flood_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flood_opacity),
                " must match longhands::",
                stringify!(flood_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_opacity(),
            longhands::_moz_window_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_opacity),
                " must match longhands::",
                stringify!(_moz_window_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_opacity(),
            longhands::opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(opacity),
                " must match longhands::",
                stringify!(opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_shape_image_threshold(),
            longhands::shape_image_threshold::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(shape_image_threshold),
                " must match longhands::",
                stringify!(shape_image_threshold),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stop_opacity(),
            longhands::stop_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stop_opacity),
                " must match longhands::",
                stringify!(stop_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_bottom_style(),
            longhands::border_bottom_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_bottom_style),
                " must match longhands::",
                stringify!(border_bottom_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_left_style(),
            longhands::border_left_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_left_style),
                " must match longhands::",
                stringify!(border_left_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_right_style(),
            longhands::border_right_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_right_style),
                " must match longhands::",
                stringify!(border_right_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_top_style(),
            longhands::border_top_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_top_style),
                " must match longhands::",
                stringify!(border_top_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_rule_style(),
            longhands::column_rule_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_rule_style),
                " must match longhands::",
                stringify!(column_rule_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_accent_color(),
            longhands::accent_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(accent_color),
                " must match longhands::",
                stringify!(accent_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_align_tracks(),
            longhands::align_tracks::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(align_tracks),
                " must match longhands::",
                stringify!(align_tracks),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_composition(),
            longhands::animation_composition::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_composition),
                " must match longhands::",
                stringify!(animation_composition),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_delay(),
            longhands::animation_delay::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_delay),
                " must match longhands::",
                stringify!(animation_delay),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_direction(),
            longhands::animation_direction::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_direction),
                " must match longhands::",
                stringify!(animation_direction),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_duration(),
            longhands::animation_duration::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_duration),
                " must match longhands::",
                stringify!(animation_duration),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_fill_mode(),
            longhands::animation_fill_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_fill_mode),
                " must match longhands::",
                stringify!(animation_fill_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_iteration_count(),
            longhands::animation_iteration_count::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_iteration_count),
                " must match longhands::",
                stringify!(animation_iteration_count),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_name(),
            longhands::animation_name::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_name),
                " must match longhands::",
                stringify!(animation_name),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_play_state(),
            longhands::animation_play_state::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_play_state),
                " must match longhands::",
                stringify!(animation_play_state),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_timeline(),
            longhands::animation_timeline::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_timeline),
                " must match longhands::",
                stringify!(animation_timeline),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_timing_function(),
            longhands::animation_timing_function::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_timing_function),
                " must match longhands::",
                stringify!(animation_timing_function),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_backdrop_filter(),
            longhands::backdrop_filter::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(backdrop_filter),
                " must match longhands::",
                stringify!(backdrop_filter),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_attachment(),
            longhands::background_attachment::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_attachment),
                " must match longhands::",
                stringify!(background_attachment),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_blend_mode(),
            longhands::background_blend_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_blend_mode),
                " must match longhands::",
                stringify!(background_blend_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_clip(),
            longhands::background_clip::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_clip),
                " must match longhands::",
                stringify!(background_clip),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_image(),
            longhands::background_image::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_image),
                " must match longhands::",
                stringify!(background_image),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_origin(),
            longhands::background_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_origin),
                " must match longhands::",
                stringify!(background_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_position_x(),
            longhands::background_position_x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_position_x),
                " must match longhands::",
                stringify!(background_position_x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_position_y(),
            longhands::background_position_y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_position_y),
                " must match longhands::",
                stringify!(background_position_y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_repeat(),
            longhands::background_repeat::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_repeat),
                " must match longhands::",
                stringify!(background_repeat),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_size(),
            longhands::background_size::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_size),
                " must match longhands::",
                stringify!(background_size),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_outset(),
            longhands::border_image_outset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_outset),
                " must match longhands::",
                stringify!(border_image_outset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_slice(),
            longhands::border_image_slice::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_slice),
                " must match longhands::",
                stringify!(border_image_slice),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_width(),
            longhands::border_image_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_width),
                " must match longhands::",
                stringify!(border_image_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_spacing(),
            longhands::border_spacing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_spacing),
                " must match longhands::",
                stringify!(border_spacing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_box_shadow(),
            longhands::box_shadow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(box_shadow),
                " must match longhands::",
                stringify!(box_shadow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_caret_color(),
            longhands::caret_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(caret_color),
                " must match longhands::",
                stringify!(caret_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_clip(),
            longhands::clip::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(clip),
                " must match longhands::",
                stringify!(clip),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_clip_path(),
            longhands::clip_path::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(clip_path),
                " must match longhands::",
                stringify!(clip_path),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_color_scheme(),
            longhands::color_scheme::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(color_scheme),
                " must match longhands::",
                stringify!(color_scheme),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_width(),
            longhands::column_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_width),
                " must match longhands::",
                stringify!(column_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_container_name(),
            longhands::container_name::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(container_name),
                " must match longhands::",
                stringify!(container_name),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_content(),
            longhands::content::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(content),
                " must match longhands::",
                stringify!(content),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_counter_increment(),
            longhands::counter_increment::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(counter_increment),
                " must match longhands::",
                stringify!(counter_increment),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_counter_reset(),
            longhands::counter_reset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(counter_reset),
                " must match longhands::",
                stringify!(counter_reset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_counter_set(),
            longhands::counter_set::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(counter_set),
                " must match longhands::",
                stringify!(counter_set),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_cursor(),
            longhands::cursor::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(cursor),
                " must match longhands::",
                stringify!(cursor),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_d(),
            longhands::d::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(d),
                " must match longhands::",
                stringify!(d),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_filter(),
            longhands::filter::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(filter),
                " must match longhands::",
                stringify!(filter),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_basis(),
            longhands::flex_basis::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_basis),
                " must match longhands::",
                stringify!(flex_basis),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_feature_settings(),
            longhands::font_feature_settings::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_feature_settings),
                " must match longhands::",
                stringify!(font_feature_settings),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_palette(),
            longhands::font_palette::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_palette),
                " must match longhands::",
                stringify!(font_palette),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_alternates(),
            longhands::font_variant_alternates::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_alternates),
                " must match longhands::",
                stringify!(font_variant_alternates),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variation_settings(),
            longhands::font_variation_settings::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variation_settings),
                " must match longhands::",
                stringify!(font_variation_settings),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_template_areas(),
            longhands::grid_template_areas::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_template_areas),
                " must match longhands::",
                stringify!(grid_template_areas),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_hyphenate_character(),
            longhands::hyphenate_character::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(hyphenate_character),
                " must match longhands::",
                stringify!(hyphenate_character),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_justify_tracks(),
            longhands::justify_tracks::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(justify_tracks),
                " must match longhands::",
                stringify!(justify_tracks),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_letter_spacing(),
            longhands::letter_spacing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(letter_spacing),
                " must match longhands::",
                stringify!(letter_spacing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_line_height(),
            longhands::line_height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(line_height),
                " must match longhands::",
                stringify!(line_height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_list_style_type(),
            longhands::list_style_type::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(list_style_type),
                " must match longhands::",
                stringify!(list_style_type),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_clip(),
            longhands::mask_clip::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_clip),
                " must match longhands::",
                stringify!(mask_clip),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_composite(),
            longhands::mask_composite::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_composite),
                " must match longhands::",
                stringify!(mask_composite),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_image(),
            longhands::mask_image::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_image),
                " must match longhands::",
                stringify!(mask_image),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_mode(),
            longhands::mask_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_mode),
                " must match longhands::",
                stringify!(mask_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_origin(),
            longhands::mask_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_origin),
                " must match longhands::",
                stringify!(mask_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_position_x(),
            longhands::mask_position_x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_position_x),
                " must match longhands::",
                stringify!(mask_position_x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_position_y(),
            longhands::mask_position_y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_position_y),
                " must match longhands::",
                stringify!(mask_position_y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_repeat(),
            longhands::mask_repeat::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_repeat),
                " must match longhands::",
                stringify!(mask_repeat),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_size(),
            longhands::mask_size::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_size),
                " must match longhands::",
                stringify!(mask_size),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_context_properties(),
            longhands::_moz_context_properties::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_context_properties),
                " must match longhands::",
                stringify!(_moz_context_properties),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_font_smoothing_background_color(),
            longhands::_moz_font_smoothing_background_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_font_smoothing_background_color),
                " must match longhands::",
                stringify!(_moz_font_smoothing_background_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_anchor(),
            longhands::offset_anchor::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_anchor),
                " must match longhands::",
                stringify!(offset_anchor),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_path(),
            longhands::offset_path::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_path),
                " must match longhands::",
                stringify!(offset_path),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_position(),
            longhands::offset_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_position),
                " must match longhands::",
                stringify!(offset_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_page(),
            longhands::page::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(page),
                " must match longhands::",
                stringify!(page),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_perspective(),
            longhands::perspective::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(perspective),
                " must match longhands::",
                stringify!(perspective),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_quotes(),
            longhands::quotes::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(quotes),
                " must match longhands::",
                stringify!(quotes),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_rotate(),
            longhands::rotate::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(rotate),
                " must match longhands::",
                stringify!(rotate),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scale(),
            longhands::scale::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scale),
                " must match longhands::",
                stringify!(scale),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_timeline_axis(),
            longhands::scroll_timeline_axis::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_timeline_axis),
                " must match longhands::",
                stringify!(scroll_timeline_axis),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_timeline_name(),
            longhands::scroll_timeline_name::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_timeline_name),
                " must match longhands::",
                stringify!(scroll_timeline_name),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scrollbar_color(),
            longhands::scrollbar_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scrollbar_color),
                " must match longhands::",
                stringify!(scrollbar_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_shape_outside(),
            longhands::shape_outside::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(shape_outside),
                " must match longhands::",
                stringify!(shape_outside),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_size(),
            longhands::size::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(size),
                " must match longhands::",
                stringify!(size),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_dasharray(),
            longhands::stroke_dasharray::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_dasharray),
                " must match longhands::",
                stringify!(stroke_dasharray),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_dashoffset(),
            longhands::stroke_dashoffset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_dashoffset),
                " must match longhands::",
                stringify!(stroke_dashoffset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_width(),
            longhands::stroke_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_width),
                " must match longhands::",
                stringify!(stroke_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_tab_size(),
            longhands::tab_size::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(tab_size),
                " must match longhands::",
                stringify!(tab_size),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_thickness(),
            longhands::text_decoration_thickness::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_thickness),
                " must match longhands::",
                stringify!(text_decoration_thickness),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_emphasis_style(),
            longhands::text_emphasis_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_emphasis_style),
                " must match longhands::",
                stringify!(text_emphasis_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_overflow(),
            longhands::text_overflow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_overflow),
                " must match longhands::",
                stringify!(text_overflow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_shadow(),
            longhands::text_shadow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_shadow),
                " must match longhands::",
                stringify!(text_shadow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transition_delay(),
            longhands::transition_delay::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transition_delay),
                " must match longhands::",
                stringify!(transition_delay),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transition_duration(),
            longhands::transition_duration::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transition_duration),
                " must match longhands::",
                stringify!(transition_duration),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transition_property(),
            longhands::transition_property::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transition_property),
                " must match longhands::",
                stringify!(transition_property),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transition_timing_function(),
            longhands::transition_timing_function::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transition_timing_function),
                " must match longhands::",
                stringify!(transition_timing_function),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_translate(),
            longhands::translate::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(translate),
                " must match longhands::",
                stringify!(translate),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_vertical_align(),
            longhands::vertical_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(vertical_align),
                " must match longhands::",
                stringify!(vertical_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_view_timeline_axis(),
            longhands::view_timeline_axis::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(view_timeline_axis),
                " must match longhands::",
                stringify!(view_timeline_axis),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_view_timeline_inset(),
            longhands::view_timeline_inset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(view_timeline_inset),
                " must match longhands::",
                stringify!(view_timeline_inset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_view_timeline_name(),
            longhands::view_timeline_name::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(view_timeline_name),
                " must match longhands::",
                stringify!(view_timeline_name),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_text_stroke_width(),
            longhands::_webkit_text_stroke_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_text_stroke_width),
                " must match longhands::",
                stringify!(_webkit_text_stroke_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_will_change(),
            longhands::will_change::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(will_change),
                " must match longhands::",
                stringify!(will_change),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_word_spacing(),
            longhands::word_spacing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(word_spacing),
                " must match longhands::",
                stringify!(word_spacing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_object_position(),
            longhands::object_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(object_position),
                " must match longhands::",
                stringify!(object_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_perspective_origin(),
            longhands::perspective_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(perspective_origin),
                " must match longhands::",
                stringify!(perspective_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_fill(),
            longhands::fill::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(fill),
                " must match longhands::",
                stringify!(fill),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke(),
            longhands::stroke::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke),
                " must match longhands::",
                stringify!(stroke),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_transform_origin(),
            longhands::_moz_window_transform_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_transform_origin),
                " must match longhands::",
                stringify!(_moz_window_transform_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transform_origin(),
            longhands::transform_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transform_origin),
                " must match longhands::",
                stringify!(transform_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_template_columns(),
            longhands::grid_template_columns::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_template_columns),
                " must match longhands::",
                stringify!(grid_template_columns),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_template_rows(),
            longhands::grid_template_rows::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_template_rows),
                " must match longhands::",
                stringify!(grid_template_rows),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_source(),
            longhands::border_image_source::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_source),
                " must match longhands::",
                stringify!(border_image_source),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_list_style_image(),
            longhands::list_style_image::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(list_style_image),
                " must match longhands::",
                stringify!(list_style_image),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_auto_columns(),
            longhands::grid_auto_columns::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_auto_columns),
                " must match longhands::",
                stringify!(grid_auto_columns),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_auto_rows(),
            longhands::grid_auto_rows::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_auto_rows),
                " must match longhands::",
                stringify!(grid_auto_rows),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_transform(),
            longhands::_moz_window_transform::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_transform),
                " must match longhands::",
                stringify!(_moz_window_transform),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transform(),
            longhands::transform::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transform),
                " must match longhands::",
                stringify!(transform),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_gap(),
            longhands::column_gap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_gap),
                " must match longhands::",
                stringify!(column_gap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_row_gap(),
            longhands::row_gap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(row_gap),
                " must match longhands::",
                stringify!(row_gap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_marker_end(),
            longhands::marker_end::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(marker_end),
                " must match longhands::",
                stringify!(marker_end),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_marker_mid(),
            longhands::marker_mid::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(marker_mid),
                " must match longhands::",
                stringify!(marker_mid),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_marker_start(),
            longhands::marker_start::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(marker_start),
                " must match longhands::",
                stringify!(marker_start),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_contain_intrinsic_height(),
            longhands::contain_intrinsic_height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(contain_intrinsic_height),
                " must match longhands::",
                stringify!(contain_intrinsic_height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_contain_intrinsic_width(),
            longhands::contain_intrinsic_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(contain_intrinsic_width),
                " must match longhands::",
                stringify!(contain_intrinsic_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_column_end(),
            longhands::grid_column_end::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_column_end),
                " must match longhands::",
                stringify!(grid_column_end),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_column_start(),
            longhands::grid_column_start::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_column_start),
                " must match longhands::",
                stringify!(grid_column_start),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_row_end(),
            longhands::grid_row_end::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_row_end),
                " must match longhands::",
                stringify!(grid_row_end),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_row_start(),
            longhands::grid_row_start::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_row_start),
                " must match longhands::",
                stringify!(grid_row_start),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_max_height(),
            longhands::max_height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(max_height),
                " must match longhands::",
                stringify!(max_height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_max_width(),
            longhands::max_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(max_width),
                " must match longhands::",
                stringify!(max_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_cx(),
            longhands::cx::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(cx),
                " must match longhands::",
                stringify!(cx),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_cy(),
            longhands::cy::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(cy),
                " must match longhands::",
                stringify!(cy),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_distance(),
            longhands::offset_distance::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_distance),
                " must match longhands::",
                stringify!(offset_distance),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_indent(),
            longhands::text_indent::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_indent),
                " must match longhands::",
                stringify!(text_indent),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_x(),
            longhands::x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(x),
                " must match longhands::",
                stringify!(x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_y(),
            longhands::y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(y),
                " must match longhands::",
                stringify!(y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_bottom_left_radius(),
            longhands::border_bottom_left_radius::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_bottom_left_radius),
                " must match longhands::",
                stringify!(border_bottom_left_radius),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_bottom_right_radius(),
            longhands::border_bottom_right_radius::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_bottom_right_radius),
                " must match longhands::",
                stringify!(border_bottom_right_radius),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_top_left_radius(),
            longhands::border_top_left_radius::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_top_left_radius),
                " must match longhands::",
                stringify!(border_top_left_radius),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_top_right_radius(),
            longhands::border_top_right_radius::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_top_right_radius),
                " must match longhands::",
                stringify!(border_top_right_radius),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_height(),
            longhands::height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(height),
                " must match longhands::",
                stringify!(height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_min_height(),
            longhands::min_height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(min_height),
                " must match longhands::",
                stringify!(min_height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_min_width(),
            longhands::min_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(min_width),
                " must match longhands::",
                stringify!(min_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_width(),
            longhands::width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(width),
                " must match longhands::",
                stringify!(width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_padding_bottom(),
            longhands::padding_bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(padding_bottom),
                " must match longhands::",
                stringify!(padding_bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_padding_left(),
            longhands::padding_left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(padding_left),
                " must match longhands::",
                stringify!(padding_left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_padding_right(),
            longhands::padding_right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(padding_right),
                " must match longhands::",
                stringify!(padding_right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_padding_top(),
            longhands::padding_top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(padding_top),
                " must match longhands::",
                stringify!(padding_top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_r(),
            longhands::r::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(r),
                " must match longhands::",
                stringify!(r),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_shape_margin(),
            longhands::shape_margin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(shape_margin),
                " must match longhands::",
                stringify!(shape_margin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_rx(),
            longhands::rx::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(rx),
                " must match longhands::",
                stringify!(rx),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_ry(),
            longhands::ry::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(ry),
                " must match longhands::",
                stringify!(ry),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_padding_bottom(),
            longhands::scroll_padding_bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_padding_bottom),
                " must match longhands::",
                stringify!(scroll_padding_bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_padding_left(),
            longhands::scroll_padding_left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_padding_left),
                " must match longhands::",
                stringify!(scroll_padding_left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_padding_right(),
            longhands::scroll_padding_right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_padding_right),
                " must match longhands::",
                stringify!(scroll_padding_right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_padding_top(),
            longhands::scroll_padding_top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_padding_top),
                " must match longhands::",
                stringify!(scroll_padding_top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_input_region_margin(),
            longhands::_moz_window_input_region_margin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_input_region_margin),
                " must match longhands::",
                stringify!(_moz_window_input_region_margin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_outline_offset(),
            longhands::outline_offset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(outline_offset),
                " must match longhands::",
                stringify!(outline_offset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_clip_margin(),
            longhands::overflow_clip_margin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_clip_margin),
                " must match longhands::",
                stringify!(overflow_clip_margin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_margin_bottom(),
            longhands::scroll_margin_bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_margin_bottom),
                " must match longhands::",
                stringify!(scroll_margin_bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_margin_left(),
            longhands::scroll_margin_left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_margin_left),
                " must match longhands::",
                stringify!(scroll_margin_left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_margin_right(),
            longhands::scroll_margin_right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_margin_right),
                " must match longhands::",
                stringify!(scroll_margin_right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_margin_top(),
            longhands::scroll_margin_top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_margin_top),
                " must match longhands::",
                stringify!(scroll_margin_top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_bottom(),
            longhands::bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(bottom),
                " must match longhands::",
                stringify!(bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_left(),
            longhands::left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(left),
                " must match longhands::",
                stringify!(left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_margin_bottom(),
            longhands::margin_bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(margin_bottom),
                " must match longhands::",
                stringify!(margin_bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_margin_left(),
            longhands::margin_left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(margin_left),
                " must match longhands::",
                stringify!(margin_left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_margin_right(),
            longhands::margin_right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(margin_right),
                " must match longhands::",
                stringify!(margin_right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_margin_top(),
            longhands::margin_top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(margin_top),
                " must match longhands::",
                stringify!(margin_top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_right(),
            longhands::right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(right),
                " must match longhands::",
                stringify!(right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_underline_offset(),
            longhands::text_underline_offset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_underline_offset),
                " must match longhands::",
                stringify!(text_underline_offset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_top(),
            longhands::top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(top),
                " must match longhands::",
                stringify!(top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_color(),
            longhands::background_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_color),
                " must match longhands::",
                stringify!(background_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_bottom_color(),
            longhands::border_bottom_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_bottom_color),
                " must match longhands::",
                stringify!(border_bottom_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_left_color(),
            longhands::border_left_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_left_color),
                " must match longhands::",
                stringify!(border_left_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_right_color(),
            longhands::border_right_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_right_color),
                " must match longhands::",
                stringify!(border_right_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_top_color(),
            longhands::border_top_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_top_color),
                " must match longhands::",
                stringify!(border_top_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_rule_color(),
            longhands::column_rule_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_rule_color),
                " must match longhands::",
                stringify!(column_rule_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flood_color(),
            longhands::flood_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flood_color),
                " must match longhands::",
                stringify!(flood_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_lighting_color(),
            longhands::lighting_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(lighting_color),
                " must match longhands::",
                stringify!(lighting_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_outline_color(),
            longhands::outline_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(outline_color),
                " must match longhands::",
                stringify!(outline_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stop_color(),
            longhands::stop_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stop_color),
                " must match longhands::",
                stringify!(stop_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_color(),
            longhands::text_decoration_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_color),
                " must match longhands::",
                stringify!(text_decoration_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_emphasis_color(),
            longhands::text_emphasis_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_emphasis_color),
                " must match longhands::",
                stringify!(text_emphasis_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_text_fill_color(),
            longhands::_webkit_text_fill_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_text_fill_color),
                " must match longhands::",
                stringify!(_webkit_text_fill_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_text_stroke_color(),
            longhands::_webkit_text_stroke_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_text_stroke_color),
                " must match longhands::",
                stringify!(_webkit_text_stroke_color),
                "::get_initial_value()"
            )
        );
    }
}
